unit GMMap;

interface
     uses OpenGl,Windows,GMVars,GMUtilite,Textures,log,math,IDX_sound;

const
    maxsparks=550;
    pic = Pi/180;
    scrBW=640;
    scrBH=320;

    isFreefly =0;
    isFlyUp   =1;
    isFlyDown =2;


type TVector=record
      x,y:single;
    end;

    TTimeBlock=record
    Hour:byte;
    Minute:byte;
    Secunde:byte;
    IntValue:integer;
    Enable:boolean;

    end;

    Tblock=record
     Active:boolean;
     x,y:integer;
     DeleteAnd:byte;
     ImageId:byte;
     SubId:byte;
    end;

 TFlyer=record
 Id:integer;
 pos,MVector:TVector;
 TimeToBoom:integer;
 Ammo:byte;
 end;

   TUfoStructure=record
   x,y:integer;
   w,h:integer;
   life:integer;
   animSleep,maxAnimSleep:integer;
   animValue:integer;
   end;

    TParticle=record
      Pos,MVector:TVector;
      life:single;
      rot:integer;
      col:integer;
      colorset:integer;
    end;

    TBall=record
      alive:boolean;
      pos,MVector:TVector;
      Angle,Speed,Animation:single;
      radius:single;
      radius2:single;
      koef:single;
      state:byte;
    end;


    TPlayer=record
      pos:TVector;
      oldpos:TVector;
      radius:single;
      speed:integer;
      ActiveShield:boolean;
      ActiveShoot:boolean;
    end;

type
  TMonsterState=(SgoLeft,SgoRight,SfreeFly);

type
  TMonster=record
  X,Y:single;
  fx,fy:single;
  Id:byte;
  State:TMonsterState;
  Speed:single;
  Life:integer;
end;

type
   TBonus=object
   sx,sy:integer;
   Id:String;
   Alpha:cardinal;
   procedure Init(Name:string;x,y:integer);
   procedure Draw;
   procedure Procces;
   end;


var
 Monsters:array of TMonster;
 Ball:array of TBall;
 Level:integer=1;
 Scores:integer=0;
 Lives:integer=0;
 Player:TPlayer;
 pauses:integer;
 texKukla:Cardinal;
 sparks:integer=0;

 FragCount:integer;
 spark:array[0..maxsparks] of TParticle;
 colorsTable:array[1..3,1..10] of record r,g,b:byte; end;

  MapArray:array[0..19,0..9] of Tblock;

  GlobalTime:TTimeBlock;
  GGTime:integer;

 SmeshX,SmeshY:integer;
 timeNextFlyAttack:integer;

 Flyer:array of TFlyer;

  TexturesBox:array[0..10] of cardinal;
  UfoTexturesBox:array[0..11] of cardinal;

  HomeTexturesBox:array[0..20] of cardinal;
  TestUfo:array[0..3] of TUfoStructure;
  TestUfoLife,TestUfoLifeMax:integer;

  MenuTexturesBox:array[0..20] of cardinal;

procedure ProccesGame;
procedure Render;
Procedure InitGame;
Procedure CloseGame;

implementation
        uses GMWindow;

procedure TimeProcedure;
begin
inc(GGTime);
if (GamePaused) then exit;
if GlobalTime.Enable=false then exit;

inc(GlobalTime.Secunde);
inc(GlobalTime.IntValue);
  if GlobalTime.Secunde=60 then
   begin
     GlobalTime.Secunde:=0;
      inc(GlobalTime.Minute);
        if GlobalTime.Minute=60 then
          begin
            GlobalTime.Minute:=0;
             inc(GlobalTime.Hour);
          end;
   end;
end;

procedure StartSparks(x, y:single; number, rot, colorset:integer);
var
i:integer;
begin
   if sparks < maxsparks then
      begin
      if sparks + number > maxsparks then number := maxsparks - sparks;
      for i:= sparks to sparks + number do
      begin
         spark[i].rot := (random(90)- 45) + rot;
         spark[i].pos.x := x;
         spark[i].pos.y := y;
         spark[i].life := 0;
         spark[i].col := random(10);
         spark[i].colorset := colorset;
      end;
      sparks := sparks + number;

   end;
end;

procedure addball(x,y:single;Anglefrom,AngleTo:integer);
var
i:integer;
theta:single;
begin
i:=high(Ball)+1;
setlength(Ball,i+1);
 Ball[i].alive:=true;
 Ball[i].radius:=16;
 Ball[i].pos.x:=x;
 Ball[i].pos.y:=y;
 Ball[i].Speed:=4;
 Ball[i].Angle:=random(abs(AngleTo-Anglefrom))+Anglefrom;
 theta:= Ball[i].Angle*(pi / 180);//(2.0 * 3.1415926 * Ball[i].Angle);
 Ball[i].MVector.x:=cos(theta)*Ball[i].Speed;
 Ball[i].MVector.y:=sin(theta)*Ball[i].Speed;
 Ball[i].state:= isFreefly;
end;

procedure DelBall(Id:integer);
var
i:integer;
begin
for i:=id to high(Ball)-1 do Ball[i]:=Ball[i+1];
setlength(Ball,high(Ball));

end;

procedure ProcBall;
var
i,k,m:integer;
ix,iy:integer;
refreshAngle:boolean;
OldPos:Tvector;
SY:single;
ggBreak:boolean;
begin
  for i:=0 to high(Ball) do
if Ball[i].alive then
begin
refreshAngle:=false;

        Ball[i].pos.x:=Ball[i].pos.x+Ball[i].MVector.x;
        Ball[i].pos.y:=Ball[i].pos.y+Ball[i].MVector.y;
        Ball[i].koef:=(Ball[i].pos.y/scrBH);
        if Ball[i].koef>1 then Ball[i].koef:=1;
        if Ball[i].state= isFlyDown then Ball[i].koef:=((Ball[i].radius*2)/scrBH);
        Ball[i].radius2:=Ball[i].radius*Ball[i].koef;

       OldPos:= Ball[i].pos;

  if (Ball[i].pos.x)<(smeshX+Ball[i].radius2) then
 begin
    Ball[i].pos.x:= smeshx+Ball[i].radius2;
    Ball[i].MVector.x:=-Ball[i].MVector.x;
    refreshAngle:=true;
 end;

   if (Ball[i].pos.Y)<(smeshY+Ball[i].radius2) then
 begin
    Ball[i].pos.Y:= smeshY+Ball[i].radius2;
    Ball[i].MVector.y:=-Ball[i].MVector.y;
    refreshAngle:=true;
    if Ball[i].state=isFlyUp then Ball[i].state:=isFlyDown;
 end;

 if (Ball[i].pos.x+Ball[i].radius2)>smeshX+scrBW then
 begin
    Ball[i].pos.x:= smeshx+scrBW-Ball[i].radius2;
    Ball[i].MVector.x:=-Ball[i].MVector.x;
    refreshAngle:=true;
 end;

  if Ball[i].state=isFlyDown then
  if (Ball[i].pos.y+Ball[i].radius2)>smeshy+scrBH then
  begin
     Ball[i].alive:=false;
  end;

 if (Ball[i].pos.y+Ball[i].radius2)>smeshy+600-40 then
 begin
  Ball[i].alive:=false;
 end;



 if Player.ActiveShield then
   if CircleVsCircle(Player.pos.x,Player.pos.y,Player.radius,
                     Ball[i].pos.x,Ball[i].pos.y,Ball[i].radius2) then
  begin
    Ball[i].MVector.y:=-5;
    Ball[i].MVector.x:=0;
    Ball[i].state:=isFlyUp;
    PlaySoundFromMEM(0);
    refreshAngle:=true;
  end;

  ggBreak:=false;
  if Ball[i].state= isFlyDown then
  begin
  for ix:=0 to 19 do
  begin
   for iy:=0 to 9 do
   if MapArray[ix,iy].Active then
       if CircRectsOverlap(SmeshX+ix*32,SmeshY+iy*32,32,32,Ball[i].pos.x,Ball[i].pos.y,Ball[i].radius2) then
        begin
         if iy<9 then MapArray[ix,iy+1].ImageId:=MapArray[ix,iy+1].SubId+5;

            if iy=9 then dec(FragCount);

         MapArray[ix,iy].Active:=false;
          for m:=0 to 10 do
           startsparks((SmeshX+ix*32)+16,(SmeshY+iy*32)+16, 1,  random(360) + 1, 1);
            PlaySoundFromMEM(3);
        Ball[i].alive:=false;
        ggBreak:=true;
          break;
        end;
        if ggBreak then break;
       end;
  end;

    for k:=0 to high(TestUfo) do
   if TestUfo[k].life>0  then
       if CircRectsOverlap(TestUfo[k].x,TestUfo[k].y,TestUfo[k].w,TestUfo[k].h,Ball[i].pos.x,Ball[i].pos.y,Ball[i].radius2) then
        begin
          dec(TestUfo[k].life);
           Ball[i].alive:=false;
            for m:=0 to 10 do
           startsparks(TestUfo[k].x+(TestUfo[k].w div 2),
                       TestUfo[k].y+(TestUfo[k].h div 2), 1,  random(360) + 1, 1);
            dec(TestUfoLife);
            PlaySoundFromMEM(1);
          break;
        end;


   if refreshAngle then
 begin
 Ball[i].Angle:=GetAngle(OldPos.x,OldPos.y,Ball[i].pos.x,Ball[i].pos.y)-90;
 end;

end;

for i:=0 to high(Ball) do
if Ball[i].alive=false then
begin
DelBall(i);
break;
end;

end;

procedure AddFlyer;
var
i,k:integer;
theta:single;
begin
i:=high(Flyer)+1;
setlength(Flyer,i+1);

k:=random(100);
if k>50 then
begin
 Flyer[i].pos.x:=SmeshX;
 Flyer[i].pos.y:=SmeshY+50;//random(50)+10;
 Flyer[i].MVector.x:=random(3)+2;
end
else
begin
 Flyer[i].pos.x:=SmeshX+scrBW;
 Flyer[i].pos.y:=SmeshY+50;//random(50)+10;
 Flyer[i].MVector.x:=-(random(3)+2);
end;

Flyer[i].TimeToBoom:=random(20)+10;
Flyer[i].Ammo:=2;
end;


procedure DelFlyer(Id:integer);
var
i:integer;
begin
for i:=id to high(Flyer)-1 do Flyer[i]:=Flyer[i+1];
setlength(Flyer,high(Flyer));
end;

procedure ProcFlayer;
var
i:integer;
begin

case Level of
1: begin

   end;
end;

if high(Flyer)<0 then AddFlyer;

    for i:=0 to high(Flyer) do
    begin
    Flyer[i].pos.x:=Flyer[i].pos.x+Flyer[i].MVector.x;

    dec(Flyer[i].TimeToBoom);

    if Flyer[i].MVector.x<0 then
     begin
     if Flyer[i].pos.x<SmeshX then begin DelFlyer(i); break; end;

       if Flyer[i].Ammo>0 then
     if Flyer[i].TimeToBoom=0 then
      begin
        PlaySoundFromMEM(2);
        addball(Flyer[i].pos.x,Flyer[i].pos.y,90,170);
        Flyer[i].TimeToBoom:=random(30)+80;
        dec(Flyer[i].Ammo);
      end;

     end
      else
     begin
     if Flyer[i].pos.x>SmeshX+scrBW then begin DelFlyer(i); break; end;

     if Flyer[i].Ammo>0 then
     if Flyer[i].TimeToBoom=0 then
      begin
      PlaySoundFromMEM(2);
      addball(Flyer[i].pos.x,Flyer[i].pos.y,10,90);
         Flyer[i].TimeToBoom:=random(30)+80;
         dec(Flyer[i].Ammo);
      end;

     end;


    end;
end;





procedure InitColorTable;
var
i,c:integer;
begin
for i:= 1 to 10 do
begin
   colorsTable[1, i].r := random(100) + 155;
   colorsTable[1, i].g := random(255) + 1;
   colorsTable[1, i].b:=0;
end;
for i:= 1 to 10 do
begin
   c := random(100) + 50;
   colorsTable[2, i].r := c;
   colorsTable[2, i].g := c;
   colorsTable[2, i].b := c;
end;
for i:= 1 to 10 do
begin
   colorsTable[1, i].r:=0;
   colorsTable[3, i].g := random(255) + 1;
   colorsTable[3, i].b := random(100) + 155;
end;

end;



procedure TrackSparks;
var
i,j,cs:integer;
s1x,s1y:single;
begin
   for i:= 1 to sparks do
   begin
      s1x := spark[i].pos.x;
      s1y := spark[i].pos.y;
      spark[i].pos.x := spark[i].pos.x + sin(spark[i].rot * pic) * 7;
      spark[i].pos.y := spark[i].pos.y + cos(spark[i].rot * pic) * 7;
      spark[i].life := spark[i].life + 1;
      cs := spark[i].colorset;
      //line(s1x,s1y)-(spark(i).x,spark(i).y), rgb(colour(cs, spark(i).col).r, colour(cs, spark(i).col).g, colour(cs, spark(i).col).b)


      DrawLine(s1x,s1y,spark[i].pos.x,spark[i].pos.y,1,colorsTable[cs, spark[i].col].r,
                                                       colorsTable[cs, spark[i].col].g,
                                                       colorsTable[cs, spark[i].col].b,
                                                       255);

      if (spark[i].pos.y < 0) or (spark[i].pos.y > scrh) then spark[i].rot := spark[i].rot + 2 * (90 - spark[i].rot);
      if (spark[i].pos.x > scrw) or (spark[i].pos.x < 0) then spark[i].rot := spark[i].rot - 2 * (90 - spark[i].rot);
      if (spark[i].rot > 360) then spark[i].rot := spark[i].rot - 360;
      if (spark[i].rot < 0) then spark[i].rot := spark[i].rot + 360;
      if (spark[i].life > 50) then
      begin
        dec(sparks);
        for j:= i to sparks do spark[j]:= spark[j+1];
      end;
   end;
end;



procedure LoadLevel;
var
i,j,k:integer;
F1: TextFile;
startHeight,heightType,randomHeight:integer;
s:string;
A,b,c:integer;
begin

FragCount:=19;
GlobalTime.Hour:=0;
GlobalTime.Minute:=0;
GlobalTime.Secunde:=0;
GlobalTime.Enable:=true;
GGTime:=0;
GameStatus:=sGame;
GamePaused:=false;
zeromemory(@Flyer,sizeof(Flyer));
zeromemory(@Ball,sizeof(Ball));
case level of
1:  begin
    startHeight:= 1;
    heightType:= 3;
    end;
2:  begin
    startHeight:= 1;
    heightType:= 4;
    end;
3,4:  begin
    startHeight:= 1;
    heightType:= 5;
    end;
5..9:  begin
    startHeight:= 2;
    heightType:= 5;
    end;
else
    begin
    startHeight:= 3;
    heightType:= 4;
    end;
end;


zeromemory(@MapArray,sizeof(MapArray));
for i:=0 to 19 do
  for j:=0 to 9 do
MapArray[i,j].Active:=false;


for i:=0 to 19 do
begin
a:=random(5);
randomHeight := random(heightType) + startHeight;
  for j:=0 to randomHeight do
  begin
        MapArray[i,9-j].Active:=true;
        MapArray[i,9-j].ImageId:=a;
        MapArray[i,9-j].SubId:=a;
  end;
  MapArray[i,9-randomHeight].ImageId:=a+10;
end;



StopMusic();
playmusic('track3.mp3');

TestUfoLife:=12;
TestUfoLifeMax:=12;
 TestUfo[0].x:=SmeshX+20;
 TestUfo[0].y:=SmeshY+600-60;
 TestUfo[0].w:=128;
 TestUfo[0].h:=64;
 TestUfo[0].animSleep:=5;
 TestUfo[0].life:=3;
 TestUfo[0].maxAnimSleep:=TestUfo[0].animSleep;
 TestUfo[0].animValue:=random(11);

 TestUfo[1].x:=SmeshX+40+128;
 TestUfo[1].y:=SmeshY+600-60;
 TestUfo[1].w:=128;
 TestUfo[1].h:=64;
 TestUfo[1].animSleep:=5;
 TestUfo[1].life:=3;
 TestUfo[1].maxAnimSleep:=TestUfo[1].animSleep;
 TestUfo[1].animValue:=random(11);

 TestUfo[2].x:=SmeshX+scrBW-40-128-128;
 TestUfo[2].y:=SmeshY+600-60;
 TestUfo[2].w:=128;
 TestUfo[2].h:=64;
 TestUfo[2].animSleep:=5;
 TestUfo[2].life:=3;
 TestUfo[2].maxAnimSleep:=TestUfo[2].animSleep;
 TestUfo[2].animValue:=random(11);

 TestUfo[3].x:=SmeshX+scrBW-20-128;
 TestUfo[3].y:=SmeshY+600-60;
 TestUfo[3].w:=128;
 TestUfo[3].h:=64;
 TestUfo[3].animSleep:=5;
 TestUfo[3].life:=3;
 TestUfo[3].maxAnimSleep:=TestUfo[3].animSleep;
 TestUfo[3].animValue:=random(11);

Player.pos.x:=SmeshX+(640 div 2);
Player.pos.y:=SmeshY+600 -106;

Player.radius:=32;

timeNextFlyAttack:=random(200)+1000;

 Lives:=20;
 
end;


procedure TBonus.Init(Name:string;x,y:integer);
begin
end;

procedure TBonus.Draw;
begin
end;

procedure TBonus.Procces;
begin
if (GamePaused) then exit;

end;



Procedure InitGame;
var
i,k:integer;
begin
 OpenLog;
InitSoundEngine;
SmeshX:=176;
SmeshY:=134;
 GlobalTime.Hour:=0;
 GlobalTime.Minute:=0;
 GlobalTime.Secunde:=0;
 GlobalTime.Enable:=false;
 StartFPS;
 //LoadLevel;
 InitColorTable;

 randomize;

 SetTimer(GWHandle, 0, 1000, @TimeProcedure);

 LoadTexture('data\Textures\Manb.png',texKukla);
 LoadTexture('data\Textures\HBullet.png',TexturesBox[0]);
 LoadTexture('data\Textures\pulse.png',TexturesBox[1]);

 LoadTexture('data\Textures\flyl.png',TexturesBox[2]);
 LoadTexture('data\Textures\flyr.png',TexturesBox[3]);


 for i:=0 to 11 do
 LoadTexture('data\Textures\UFOs'+inttostr(i)+'.png',UfoTexturesBox[i]);

 for i:=0 to 4 do
 begin
 LoadTexture('data\Textures\H'+inttostr(i+1)+'.png',HomeTexturesBox[i]);
 end;
 k:=5;
 for i:=0 to 4 do
 begin
 LoadTexture('data\Textures\H'+inttostr(i+1)+'b.png',HomeTexturesBox[k]);
 inc(k);
 end;
 for i:=0 to 4 do
 begin
 LoadTexture('data\Textures\RF'+inttostr(i+1)+'.png',HomeTexturesBox[k]);
 inc(k);
 end;

 LoadTexture('data\Textures\GameScreen.jpg',MenuTexturesBox[0]);
 LoadTexture('data\Textures\TitulMenu.jpg',MenuTexturesBox[1]);
 LoadTexture('data\Textures\Pause.png',MenuTexturesBox[2]);

 LoadTexture('data\Textures\MenuNewGame.png',MenuTexturesBox[3]);
 LoadTexture('data\Textures\MenuOptions.png',MenuTexturesBox[4]);
 LoadTexture('data\Textures\MenuRecords.png',MenuTexturesBox[5]);
 LoadTexture('data\Textures\MenuExit.png',MenuTexturesBox[6]);
 LoadTexture('data\Textures\MenuContinue.png',MenuTexturesBox[7]);
end;

Procedure CloseGame;
begin
FreeSoundEngine;
end;



procedure ProccesGame;
var
i:integer;
dx:single;
ds:integer;
 s:string;
begin
case GameStatus of
sVictory: begin
if Keys[MouseLB] then
    begin
      if PointInRect(MousePos.X,MousePos.Y,544,590,256,32) then
      begin
      inc(level);
      LoadLevel;
      end;
    end;
end;
sDeath: begin
if Keys[MouseLB] then
    begin
      if PointInRect(MousePos.X,MousePos.Y,544,590,256,32) then
      begin
      GameStatus:=sGMenu;
      end;
    end;
end;
sGMenu: begin
         if Keys[VK_ESCAPE] then PostQuitMessage(0);
   if Keys[MouseLB] then
    begin
         if PointInRect(MousePos.X,MousePos.Y,740,460,256,32) then
         begin

                Level:=1;
                Scores:=0;
                LoadLevel;
         end;

          if PointInRect(MousePos.X,MousePos.Y,760,590,128,32) then
         begin

PostQuitMessage(0);
         end;

       Keys[MouseLB]:=false;
       end;

      end;
sGame:
     begin
          if Keys[VK_F1] then
         begin
         TestUfoLife:=0;
         end;

          if Keys[VK_F2] then
         begin
         FragCount:=0;
         end;

         if Keys[VK_Space] then
         begin
         GamePaused:=not GamePaused;
         Keys[VK_Space]:=false;
         end;
         if Keys[VK_ESCAPE] then PostQuitMessage(0);

        if (GamePaused) then exit;

        Player.oldpos:=Player.pos;
        ds:=7;
        dx:=(Player.pos.x-MousePos.x)*0.2;//1.2;///ds;
        if (abs(dx) < 0.1) then dx:=0;
        Player.pos.x:=Player.pos.x-dx;//MousePos.x;

        if Player.pos.x<smeshx then Player.pos.x:=smeshx;
        if Player.pos.x>smeshx+scrBW then Player.pos.x:=smeshx+scrBW;

        if GGTime>5 then
        begin
        ProcFlayer;
        ProcBall;
        end;

        if FragCount=0 then
            begin
             GameStatus:=sVictory;
             scores:=scores+round(GlobalTime.IntValue/10)+TestUfoLife*5;
             GlobalTime.Enable:=false;
            end;

        if TestUfoLife=0 then
            begin
              GameStatus:=sDeath;
              GlobalTime.Enable:=false;
        end;

        for i:=0 to 3 do
        begin
         dec(TestUfo[i].animSleep);
         if (TestUfo[i].animSleep=0) then
          begin
          TestUfo[i].animSleep:=TestUfo[i].maxAnimSleep;
          inc(TestUfo[i].animValue);
        if TestUfo[i].animValue>11 then TestUfo[i].animValue:=0;
        end;

        end;

  Player.ActiveShield:=false;
  if Keys[MouseLB] then
 begin
  Player.ActiveShield:=true;
 end;


end;

end;

  end;

 procedure Render;
 Var
 s:string;
 i,j:integer;
 Pt: TPoint;
 ammo_remaining:integer;
 inv_place:integer;
 rads,amp:single;
 begin


  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPushMatrix;

   glDisable( GL_TEXTURE_2D );
  Enable2d(true);

case GameStatus of
sVictory: begin
       DrawTextureBox(0,0,scrw,scrh,MenuTexturesBox[0],$FFFFFF,255);
       SText2D(MySysfont,'   !!!',smeshx+50,smeshy+50,0,255);
  s:='';
  if GlobalTime.Hour<10 then s:='0'+inttostr(GlobalTime.Hour) else s:=s+ inttostr(GlobalTime.Hour);
  s:=s+':';
  if GlobalTime.Minute<10 then s:=s+'0'+inttostr(GlobalTime.Minute) else s:=s+ inttostr(GlobalTime.Minute);
  s:=s+':';
  if GlobalTime.Secunde<10 then s:=s+'0'+inttostr(GlobalTime.Secunde) else s:=s+ inttostr(GlobalTime.Secunde);

  SText2D(MySysfont,' :'+s,smeshx+50,smeshy+70,Rgb(0,0,0),255);
  SText2D(MySysfont,' :'+inttostr(scores),smeshx+50,smeshy+90,Rgb(0,0,0),255);
  SText2D(MySysfont,' :'+inttostr(Level+1),smeshx+50,smeshy+110,Rgb(0,0,0),255);

 glBlend(1);
   if PointInRect(MousePos.X,MousePos.Y,544,590,256,32) then
 DrawTextureBox(544+10,590,256,32,MenuTexturesBox[7],$FFFFFF,255)
 else
 DrawTextureBox(544,590,256,32,MenuTexturesBox[7],$FFFFFF,255);

 SText2D(MySysfont,inttostr(MousePos.X)+' : '+inttostr(MousePos.Y),0,80,Rgb(255,0,0),255);

end;
sDeath: begin
       DrawTextureBox(0,0,scrw,scrh,MenuTexturesBox[0],$FFFFFF,255);
       SText2D(MySysfont,' !!!',smeshx+50,smeshy+50,0,255);
  s:='';
  if GlobalTime.Hour<10 then s:='0'+inttostr(GlobalTime.Hour) else s:=s+ inttostr(GlobalTime.Hour);
  s:=s+':';
  if GlobalTime.Minute<10 then s:=s+'0'+inttostr(GlobalTime.Minute) else s:=s+ inttostr(GlobalTime.Minute);
  s:=s+':';
  if GlobalTime.Secunde<10 then s:=s+'0'+inttostr(GlobalTime.Secunde) else s:=s+ inttostr(GlobalTime.Secunde);

  SText2D(MySysfont,' :'+s,smeshx+50,smeshy+70,Rgb(0,0,0),255);
  SText2D(MySysfont,' :'+inttostr(scores),smeshx+50,smeshy+90,Rgb(0,0,0),255);
glBlend(1);
   if PointInRect(MousePos.X,MousePos.Y,544,590,256,32) then
 DrawTextureBox(544+10,590,256,32,MenuTexturesBox[7],$FFFFFF,255)
 else
 DrawTextureBox(544,590,256,32,MenuTexturesBox[7],$FFFFFF,255);


end;
sGMenu: begin
DrawTextureBox(0,0,scrw,scrh,MenuTexturesBox[1],$FFFFFF,255);
glBlend(1);
 if PointInRect(MousePos.X,MousePos.Y,740,460,256,32) then
 DrawTextureBox(740+10,460,256,32,MenuTexturesBox[3],$FFFFFF,255)
 else
 DrawTextureBox(740,460,256,32,MenuTexturesBox[3],$FFFFFF,255);

 if PointInRect(MousePos.X,MousePos.Y,740,500,256,32) then
 DrawTextureBox(740+10,500,256,32,MenuTexturesBox[4],$FFFFFF,255)
 else
 DrawTextureBox(740,500,256,32,MenuTexturesBox[4],$FFFFFF,255);

 if PointInRect(MousePos.X,MousePos.Y,760,540,128,32) then
DrawTextureBox(760+10,540,128,32,MenuTexturesBox[5],$FFFFFF,255)
 else
 DrawTextureBox(760,540,128,32,MenuTexturesBox[5],$FFFFFF,255);

if PointInRect(MousePos.X,MousePos.Y,760,590,128,32) then
DrawTextureBox(760+10,590,128,32,MenuTexturesBox[6],$FFFFFF,255)
else
DrawTextureBox(760,590,128,32,MenuTexturesBox[6],$FFFFFF,255);

          //SText2D(MySysfont,inttostr(MousePos.X)+' : '+inttostr(MousePos.Y),0,80,Rgb(255,0,0),255);
        end;
sGame:
     begin

    DrawTextureBox(0,0,scrw,scrh,MenuTexturesBox[0],$FFFFFF,255);
    DrawRectangle2D(smeshx,smeshy,640,320,$0);
    glcolor3ub(255,255,255);

     glBlend(1);
    DrawTextureBox(Player.pos.x,Player.pos.y,100,100,texKukla,$FFFFFF,255,true);

   if Player.ActiveShield then
    DrawTextureBox(Player.pos.x,Player.pos.y,64,64,TexturesBox[1],$FFFFFF,255,true);


   for i:=0 to 19 do
     for j:=0 to 9 do
     if MapArray[i,j].Active then
    begin
     DrawTextureBox(SmeshX+i*32,SmeshY+j*32,32,32,HomeTexturesBox[MapArray[i,j].ImageId],$FFFFFF,255,false);
    end;


        glblend(1);

      for i:=0 to 3 do
      if TestUfo[i].life>0 then
        DrawTextureBox(TestUfo[i].x,TestUfo[i].y,128,64,UfoTexturesBox[TestUfo[i].animValue],$FFFFFF,255);

    for i:=0 to high(BAll) do
    begin
       if Ball[i].state=isFreefly then glcolor3ub(255,0,0);
       if Ball[i].state=isFlyUp then glcolor3ub(255,0,255);
       if Ball[i].state=isFlyDown then glcolor3ub(255,0,255);

       glblend(1);

        DrawTextureBox(Ball[i].pos.x,Ball[i].pos.y,32,32,TexturesBox[0],$FFFFFF,255,true,round(Ball[i].Angle),Ball[i].koef);

    end;

      for i:=0 to high(Flyer) do
    begin
     if Flyer[i].MVector.x<0 then
     DrawTextureBox(Flyer[i].pos.x,Flyer[i].pos.y,128,32,TexturesBox[2],$FFFFFF,255,true)
     else
     DrawTextureBox(Flyer[i].pos.x,Flyer[i].pos.y,128,32,TexturesBox[3],$FFFFFF,255,true);
     //DrawCircle(Flyer[i].pos.x,Flyer[i].pos.y,10,25);
    end;

    TrackSparks;

       glcolor3ub(255,255,255);
   SText2D(MySysfont,inttostr(Lives),0,250,Rgb(255,255,255),255);

   SText2D(MySysfont,inttostr(g_FPS),0,50,Rgb(255,255,255),255);

   SText2D(MySysfont,inttostr(MousePos.X)+' : '+inttostr(MousePos.Y),0,80,Rgb(255,0,0),255);

 for i:=0 to 3 do
 SText2D(MySysfont,inttostr(TestUfo[i].life),0,100+i*15,Rgb(255,0,0),255);

  SText2D(MySysfont,':'+inttostr(Level),830,180,Rgb(0,0,0),255);
  s:='';
  if GlobalTime.Hour<10 then s:='0'+inttostr(GlobalTime.Hour) else s:=s+ inttostr(GlobalTime.Hour);
  s:=s+':';
  if GlobalTime.Minute<10 then s:=s+'0'+inttostr(GlobalTime.Minute) else s:=s+ inttostr(GlobalTime.Minute);
  s:=s+':';
  if GlobalTime.Secunde<10 then s:=s+'0'+inttostr(GlobalTime.Secunde) else s:=s+ inttostr(GlobalTime.Secunde);

  SText2D(MySysfont,': '+s,830,200,Rgb(0,0,0),255);

  SText2D(MySysfont,':'+inttostr((FragCount+1)*round(100/20))+'%',830,250,Rgb(0,0,0),255);
  SText2D(MySysfont,':'+inttostr((TestUfoLife)*trunc(100/TestUfoLifeMax))+'%',830,270,Rgb(0,0,0),255);

  if GamePaused then
  begin
  glBlend(1);
   glEnable( GL_TEXTURE_2D );
   DrawTextureBox(scr2w+sin(GGTime)*1.5,scr2h,256,64,MenuTexturesBox[2],$FFFFFF,255,true);
  end;


  // glblend(1); DrawTextureBox(110,110,64,64,MenTexture,true);
 end;

end;
 glPopMatrix;
 SwapBuffers(GWDC);
 CountFPS;
 end;

end.


