unit GMUtilite;

interface
      uses Windows,OpenGl,GMVars,SysUtils,HighScores;


procedure Enable2d(A:boolean);
procedure glBlend(ID: Byte);
procedure VBL2(vsync : TVSyncMode);
procedure FreeSystemFont2D(font: DWORD); stdcall;
function GetTimer: integer;
function ExtractFileDir(const FileName: string): string;
function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
procedure DrawRectangle2D(X, Y, Width, Height, Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
function IntToStr(x: integer): string;
function StrToInt(const S: string): Integer;
procedure DrawTextureBox(x,y,w,h:single;textId:cardinal;color: integer; Alpha : byte;center:boolean=false;angle:integer=0;fscale:single=1);
function ArcTan2(const Y, X: single): single;
function GetAngle(px1, py1, px2, py2:real):integer;
procedure CountFPS;
function GetTime: Integer;
procedure StartFPS;
procedure ProcessEnterName(Key: byte);
procedure ReadOptions(Name:string);
Function CircRectsOverlap(x0, y0, w0, h0, cx, cy, r:single):boolean;
function CircleVsCircle(x0, y0, r0, x1, y1, r1:single):boolean;
procedure DrawLine( ax, ay, bx, by, width:single; r,g,b,a:byte );
procedure DrawCircle(cx,cy,r:single;num_segments:integer);
function PointInRect(px,py:single;x,y,w,h:single):boolean;
implementation

function PointInRect(px,py:single;x,y,w,h:single):boolean;
begin
 Result :=
  (px >= x) and
  (px <= x+w) and
  (py >= y) and
  (py <= y+h);
end;


procedure DrawCircle(cx,cy,r:single;num_segments:integer);
var
i:integer;
theta,x,y:single;
begin
//glBegin(GL_TRIANGLE_FAN);
	glBegin(GL_LINE_LOOP);
	for i:= 0 to num_segments do
	begin
		theta:= (2.0 * 3.1415926 * i) / (num_segments);

		x := r * cos(theta);
		y := r * sin(theta);

		glVertex2f(x + cx, y + cy);

	end;
	glEnd();
end;

procedure DrawLine( ax, ay, bx, by, width:single; r,g,b,a:byte );
begin
 glPushMatrix;
    //glDisable(GL_TEXTURE_2D);
    if a<255 then
    begin
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    end;
    glColor4ub( r, g, b, a);

    glLineWidth(width);
    glBegin(GL_LINES);
    glVertex2f( ax, ay);
    glVertex2f( bx, by);
    glEnd();
   if a<255 then
    glDisable(GL_BLEND);
    //glEnable(GL_TEXTURE_2D);
 glPopMatrix;
end;


function CircleVsCircle(x0, y0, r0, x1, y1, r1:single):boolean;
var
dx,dy,dr:single;
hyp:single;
begin
 dx:=x0-x1;
 dy:=y0-y1;
 dr:=r0+r1;

 hyp:= sqrt(dx*dx + dy*dy);
 result:=false;

 if (hyp<=dr) then result:=true;

end;

Function CircRectsOverlap(x0, y0, w0, h0, cx, cy, r:single):boolean;
var
testX,testY:single;
begin
    testX:=cX;
    testY:=cY;
    If TestX < x0 Then TestX:=x0;
    If TestX > (x0+w0) Then TestX:=(x0+w0);
    If TestY < y0 Then Testy:=y0;
    If TestY > (y0+h0) Then Testy:=(y0+h0);

    Result:=((cX-TestX)*(cX-TestX)+(cY-TestY)*(cY-TestY))<r*r;
End;


procedure ReadOptions(Name:string);
var
  F1: TextFile;
  S:string;
  Loading:boolean;
  i,j,k,Myk:integer;
begin
   AssignFile(F1,Name);
    Reset(F1);
    i:=0;
    while not Eof(F1) do
      begin
        Readln(F1, s);
        if length(trim(s))=0 then continue;
        if s[1]='#' then continue;
case i of
  0:SCRW:=strtoint(s);
  1:SCRH:=strtoint(s);
  2:SCRBit:=strtoint(s);
  3:SCRHZ:=strtoint(s);
  4: if s='1' then FullScreen:=true else FullScreen:=false;
  5: if s='1' then CenterScreen:=true else CenterScreen:=false;
end;
 inc(i);
         end;
    CloseFile(F1);
 SCR2W:=SCRW div 2;
 SCR2H:=SCRH div 2;;

end;




procedure ProcessEnterName(Key: byte);
begin
if  GameStatus in [sDeath,sVictory] then
begin

  case ord(key) of
      27 : ;
      13 :  begin
              if length(EnterName)=0 then EnterName:='';
              GameStatus:=sGMenu;
              SetName(EnterName,999);
              SaveHSTable;
              Keys[VK_RETURN]:=false;
            end;
      8 :
        begin
        if(curpos>0) then
          begin
          EnterName := copy(EnterName,1,curpos-1) + copy(EnterName,curpos+1,length(EnterName));
          dec(curpos);
          end;
        end;
      else
        begin
        if(length(EnterName) < 20) then
          begin
          EnterName := copy(EnterName,1,curpos) + chr(key) + copy(EnterName,curpos+1,length(EnterName));
          inc(curpos);
          end;
        end;

    end;
 end;

end;



function GetTime: Integer;
var
  T : LARGE_INTEGER;
begin
  QueryPerformanceCounter(Int64(T));
  Result := Trunc(1000 * T.QuadPart / Timer_Freq.QuadPart);
end;

procedure StartFPS;
begin
  fps_time     := GetTime;
end;

procedure CountFPS;
begin
if fps_time <= GetTime then
  begin
    fps_time := GetTime + 1000;
    g_FPS    := fps_cur;
    fps_cur  := 0;
  end;
  inc(fps_cur);
end;


function ArcTan2(const Y, X: single): single;
asm
 FLD     Y
 FLD     X
 FPATAN
 FWAIT
end;

function GetAngle(px1, py1, px2, py2:real):integer;
var
angle:real;
begin
    angle := arctan2(px1 - px2, py1 - py2);
    angle := angle / 3.140000 * 180;
    result:= round(-angle);
end;


procedure DrawTextureBox(x,y,w,h:single;textId:cardinal;color: integer; Alpha : byte;center:boolean=false;angle:integer=0;fscale:single=1);
var
rx,ry:single;
begin
 if Alpha<>255 then
  glEnable(GL_BLEND);
  
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);

  glEnable( GL_TEXTURE_2D );
  glPushMatrix();
  glTranslatef(X,Y,0);
  if fscale<>1 then glscalef(fscale,fscale,1);

  if Angle<>0 then glrotatef(Angle,0,0,1);
  glBindTexture(GL_TEXTURE_2D, textId); // use floor

 glBegin(GL_QUADS);
 if center then
  begin
      Rx:=W/2;
      Ry:=H/2;
  glTexCoord2f(0,1);  glVertex2f(-rx,-ry);
  glTexCoord2f(1,1);  glVertex2f(rx,-ry);
  glTexCoord2f(1,0);  glVertex2f(rx,ry);
  glTexCoord2f(0,0);  glVertex2f(-rx,ry);
   end
   else
   begin
  glTexCoord2f(0,1);  glVertex2f(0, 0);
  glTexCoord2f(1,1);  glVertex2f(0+w,0);
  glTexCoord2f(1,0);  glVertex2f(0+w, 0+h);
  glTexCoord2f(0,0);  glVertex2f(0,0+h);
   end;

  glEnd();
  glPopMatrix();
  if Alpha<>255 then glDisable(GL_BLEND);
  glDisable( GL_TEXTURE_2D );
end;


//   
function IntToStr(x: integer): string;
begin
Str(x, Result);
end;

function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
end;


procedure DrawRectangle2D(X, Y, Width, Height, Color:integer; Alpha : byte=255;Angle:integer=0; Fill : boolean = false;Center:boolean=false);
var
Rx,Ry:real;
begin

glPushMatrix;

glTranslatef(X,Y,0);

if Angle<>0 then glrotatef(Angle,0,0,1);
if Alpha<>255 then glEnable(GL_BLEND);

 if fill then
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_QUADS);
  if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;
    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
 end
 else
 begin
    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
 end;

   glEnd;

 end else
 begin

  glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
   glBegin(GL_LINE_STRIP);
     if center then
  begin
      Rx:=Width/2;
      Ry:=Height/2;

    glVertex2f(-rx,-ry);
    glVertex2f(rx,-ry);
    glVertex2f(rx,ry);
    glVertex2f(-rx,ry);
    glVertex2f(-rx,-ry);
   end
   else
   begin

    glVertex2f(0,0);
    glVertex2f(0+Width,0);
    glVertex2f(0+Width,0+Height);
    glVertex2f(0,0+Height);
    glVertex2f(0,0-1);

   end;

   glEnd;

 end;
 glPopMatrix;

if Alpha<>255 then glDisable(GL_BLEND);
end;

procedure SText2D(font: DWORD; const str: string; X, Y, color: integer; Alpha : byte); stdcall;
begin
glPushMatrix();

if Alpha<>255 then
  glEnable(GL_BLEND);
 glcolor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),Alpha);
 glRasterPos2f(X, Y);
 glListBase(font);
 glCallLists(Length(str), GL_UNSIGNED_BYTE, PChar(str));
if Alpha<>255 then
  glDisable(GL_BLEND);
glPopMatrix();
end;



function CreateSystemFont2D(AD:hDC;Face: PChar; W, H: integer): DWORD; stdcall;
var
 font : HFONT;
begin
Result := glGenLists(256);
font := CreateFont(H, W, 0, 0, 0, 0, 0, 0,RUSSIAN_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                   ANTIALIASED_QUALITY, FW_BOLD {or FF_DONTCARE or DEFAULT_PITCH}, Face);
SelectObject(AD, font);
wglUseFontBitmaps(AD, 0, 256, Result);
DeleteObject(font);
end;


function ExtractFileDir(const FileName: string): string;
var
  I: Integer;
begin
  I := LastDelimiter(PathDelim + DriveDelim,Filename);
  if (I > 1) and (FileName[I] = PathDelim) and
    (((FileName[I - 1] <> PathDelim) and (FileName[I-1] <> DriveDelim)) or
    (ByteType(FileName, I-1) = mbTrailByte)) then Dec(I);
  while (ByteType(FileName, I-1) = mbTrailByte) and (I > 0) do Dec(I);
  Result := Copy(FileName, 1, I);
end;


function GetTimer: integer;
var
T : LARGE_INTEGER;
F : LARGE_INTEGER;
begin
QueryPerformanceFrequency(Int64(F));
QueryPerformanceCounter(Int64(T));
result := round(1000 * T.QuadPart / F.QuadPart);
end;



procedure FreeSystemFont2D(font: DWORD); stdcall;
begin
glDeleteLists(font, 256);
end;


procedure VBL2(vsync : TVSyncMode);
var
   i : Integer;
begin
   if WGL_EXT_swap_control then
   begin
      i := wglGetSwapIntervalEXT;
      case VSync of
         vsmSync    : if i<>1 then wglSwapIntervalEXT(1);
         vsmNoSync  : if i<>0 then wglSwapIntervalEXT(0);
      else
         Assert(False);
      end;
   end;

end;


//   //
procedure glBlend(ID: Byte);
begin
if ID = 0 then
 glDisable(GL_BLEND)
else
 begin
 glEnable(GL_BLEND);
  case ID of
   1 : glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
   2 : glBlendFunc(GL_SRC_ALPHA, GL_ONE);
   3 : glBlendFunc(GL_ZERO, GL_SRC_COLOR);
  end;
 end;
end;

procedure Enable2d(A:boolean);
begin
 if A then
 begin
  glDisable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  gluOrtho2D(0,SCRW,SCRH,0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  glLoadIdentity;
 end
 else
 begin
   glPopMatrix;
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_DEPTH_TEST);
 end;

 end;



end.
