unit uGL;

interface
uses Windows,OpenGL,sNail;

procedure RenderText24(x,y:single; Str:string; Color:integer = $ffffff; Alpha:byte = 255);
procedure RenderText32(x,y:single; Str:string; Color:integer = $ffffff; Alpha:byte = 255);
function GetTextWidth24(const Str:string):word;
function GetTextWidth32(const Str:string):word;
function GetScoreCenter(num:word):word;

procedure glEnableClientState   (_array: DWORD); stdcall; external opengl32;
procedure glDisableClientState  (_array: DWORD); stdcall; external opengl32;
procedure glDrawElements        (mode: DWORD; count: integer; _type: DWORD; const indices: pointer); stdcall; external opengl32;

procedure glNormalPointer     (type_: GLenum; stride: integer; const P: Pointer); stdcall; external opengl32;
procedure glColorPointer      (size: integer; _type: DWORD; stride: integer; const _pointer: pointer); stdcall; external opengl32;
procedure glVertexPointer     (size: integer; _type: DWORD; stride: integer; const _pointer: pointer); stdcall; external opengl32;
procedure glTexCoordPointer   (size: integer; _type: DWORD; stride: integer; const _pointer: pointer); stdcall; external opengl32;
procedure glIndexPointer      (_type: GLenum; stride: GLsizei; const _pointer: pointer); stdcall; external opengl32;
procedure glInterleavedArrays (format: DWORD; stride: integer; const _pointer: pointer); stdcall; external opengl32;
procedure glDrawArrays        (mode: DWORD; first: integer; count: integer); stdcall; external opengl32;

var
  tex_TechFnt:cardinal; 
const
 GL_NORMAL_ARRAY        = $8075;
 GL_COLOR_ARRAY         = $8076;
 GL_VERTEX_ARRAY        = $8074;
 GL_TEXTURE_COORD_ARRAY = $8078;

 GL_LIGHT_MODEL_COLOR_CONTROL_EXT = $81F8;
 GL_SINGLE_COLOR_EXT = $81F9;
 GL_SEPARATE_SPECULAR_COLOR_EXT = $81FA;

implementation

procedure RenderText(x,y:single; w,h:word; step:byte; const str:PString; color:integer; Alpha:byte);
var
  i:byte;
  ch:Char;
begin
  gl_TexEnable(tex_TechFnt);
  gl_SetColor(Color,Alpha);
  for i:=0 to Length(Str^) - 1  do
  begin
    glPushMatrix;
    ch:=Str^[i+1];
    gl_RenderSprite((i * step)+ x,y,w,h,16,16,ord(ch),0);
    glPopMatrix;
  end;
  gl_TexDisable;
end;

procedure RenderText24(x,y:single; Str:string; Color:integer = $ffffff; Alpha:byte = 255);
begin
  RenderText(x,y,24,24,16,@Str,Color,Alpha);
end;

procedure RenderText32(x,y:single; Str:string; Color:integer = $ffffff; Alpha:byte = 255);
begin
  RenderText(x,y,32,32,24,@Str,Color,Alpha);
end;

function GetTextWidth24(const Str:string):word;
begin
  Result:=Length(Str)*14;
end;

function GetTextWidth32(const Str:string):word;
begin
  Result:=Length(Str)*24;
end;

function GetScoreCenter(num:word):word;
begin
  Result:=((128-(Length(Int2Str(Num))*24)) shr 1)-4;
end;

end.
