unit uMenu;

interface
uses sNail,uMath,OpenGL,uGL;

procedure CreateMenu;
procedure UpdateMenu;
procedure RenderMenu;

type
  TButton = object
    ID:byte;
    X,Y:word;
    Caption:string;
    Click,Active:boolean;
    procedure Init(tID:byte;Capt:string;dX,dY:word);
    procedure Update;
    procedure Render;
  end;

var
  inMenu:boolean = true;
  tex_logo,tex_button,tex_controls,tex_cursor:cardinal;
  Buttons:array[0..4] of TButton;
  CurBtn:shortint = -1;
  LeftX,RightX:word;
const
  ButCapt:array[0..4] of shortstring = ('Resume','Play','Options','About','Exit');
implementation
uses uGameEngine;

{ TButton }

function PinR(X1,Y1,X,Y,Width,Height:integer):boolean;
begin
  Result:=(X1>X) and (X1<X+Width) and (Y1>Y) and (Y1<Y+Height);
end;

procedure TButton.Init(tID:byte;Capt: string; dX, dY: word);
begin
  ID:=tID;
  Caption:=Capt;
  X:=dX;
  y:=dY;
  Click:=false;
  Active:=false;
end;

procedure TButton.Render;
begin
  gl_SetColor($ffffff,255);
  gl_TexEnable(tex_button);
  glPushMatrix;
    gl_RenderSprite(X,Y,128,32,1,2,byte(Active),0);
  glPopMatrix;
  gl_TexDisable;

  RenderText24(X+3,Y+3,Caption,$ffff00,200);
end;

procedure TButton.Update;
begin
  Active:=PinR(inp_GetMousePos.X,inp_GetMousePos.Y,X,Y,128,32);

  if Active and inp_MouseClick(MOUSE_BTN_LEFT) then CurBtn:=ID;
end;

procedure CreateMenu;
var
  i:byte;
begin
  RightX:=(gl_GetResX-gl_GetResY-128) shr 1;
  RightX:=RightX+gl_GetResY+8;
  LeftX:=(gl_GetResY shr 1)-(512 shr 1)+15;
  for i:=0 to High(Buttons) do
    Buttons[i].Init(i,ButCapt[i],RightX,150+(i*64));
end;

procedure UpdateMenu;
var
  i:byte;
begin
  for i:=0 to High(Buttons) do
    Buttons[i].Update;

  case CurBtn of
    0: if not GameEng.GameOver then
    begin
      inMenu:=false;
    end;
    1:
    begin
      inMenu:=false;
      GameEng.ResetGame;
    end;
    4:snail_Stop;
  end;
end;

procedure RenderMenu;
var
  i:byte;
begin
  gl_SetColor($ffffff,255);
  glPushMatrix;
  gl_TexEnable(tex_logo);
     gl_RenderTex(LeftX+15,50,512,128,0);
  gl_TexDisable;
  glPopMatrix;

  gl_SetColor($ffd800,225);
  glPushMatrix;
    glBegin(GL_LINES);
      glVertex2i(0,30);
      glVertex2i(gl_GetResY,30);
      glVertex2i(0,200);
      glVertex2i(gl_GetResY,200);
    glEnd;
  glPopMatrix;

  case CurBtn of
   -1:begin
        glColor3f(1,1,1);
        gl_TexEnable(tex_controls);
        glPushMatrix;
          gl_RenderTex(LeftX,300,512,256,0);
        glPopMatrix;
        gl_TexDisable;
      end;
    2:
    begin
      RenderText24(120,350,'Look the "config.ini"');
    end;

    3:
    begin
      RenderText24(80,250,'Special for IGDC.ru contest');
      RenderText24(20,300,'Author:');
      RenderText24(80,350,'Kirill Hex[man] Khorobrykh');
      RenderText24(80,400,'hex.man[at]mail.ru');
      RenderText24(80,gl_GetResY-120,'2008');
    end;
    4:
    begin
      RenderText24(100,350,'Thanks for the playing!');
    end;
  end;

  for i:=0 to High(Buttons) do
    Buttons[i].Render;

  gl_SetBlend(1);
  glColor3f(1,1,1);
  gl_TexEnable(tex_cursor);
     glPushMatrix;
       gl_RenderTex(inp_GetMousePos.X,inp_GetMousePos.Y,32,32,0);
     glPopMatrix;
  gl_TexDisable;
  gl_SetBlend(2);
end;

end.
