unit Use_OpenGL;

interface

uses Windows, Messages, OpenGl, TGA2, JPeg, Graphics, Global;

type
  PRGB = record        {      }
   r,g,b:byte;
  end;
  TSline = array[0..1] of PRGB;   { }

procedure InitGL(var ghRC:HGLRC;var ghDC:HDC;var Hand:THandle;W,H:Integer);
procedure On_Resize(Width,Height:integer);        
procedure CloseGL(ghRC:HGLRC;ghDC:HDC;Hand:THandle);
procedure enable_bind_tex;
procedure disable_bind_tex;
procedure Put_Sprite(X,Y,M:single;f:single;r,g,b,a:single);
procedure Gen_Font(var ghDC:HDC);
procedure Put_Text(Str:string;X,Y:single);
procedure Change_Resolution(x, y: word);
procedure Restore_Resolution;
procedure LoadTGATexture(FileName: String; var TexIndex: Cardinal);
function LoadJPGTexture(FileName: String; var TexIndex: Cardinal):pointer;
procedure Put_Tile(X,Y,M:single;i,j:byte;f:single;r,g,b,a:single);

Var
 base_Font:integer = 1;
 Max_Font:integer = 256;

implementation

procedure Change_Resolution(x, y: word); { }
var
  dm: TDEVMODE;
begin
  ZeroMemory(@dm, sizeof(TDEVMODE));
  dm.dmSize := sizeof(TDEVMODE);
  dm.dmPelsWidth := x;
  dm.dmPelsHeight := y;
  dm.dmFields := DM_PELSWIDTH or DM_PELSHEIGHT;
  ChangeDisplaySettings(dm, 0);
end;

procedure Restore_Resolution;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
end;

procedure Put_Sprite(X,Y,M:single;f:single;r,g,b,a:single);
begin
{       ,   ,}
{ f    RGB      Modulate       }
 glcolor4f(r,g,b,a);        { }
 glbegin(GL_Quads);         {  }
  gltexcoord2f(1,1);        {}
  glvertex2f(-f/2+x*M,-f/2+y*M);    {}
  gltexcoord2f(0,1);
  glvertex2f(+f/2+x*M,-f/2+y*M);
  gltexcoord2f(0,0);
  glvertex2f(+f/2+x*M,+f/2+y*M);
  gltexcoord2f(1,0);
  glvertex2f(-f/2+x*M,+f/2+y*M);
 glend;
end;

procedure Put_Tile(X,Y,M:single;i,j:byte;f:single;r,g,b,a:single);
begin
 gltranslatef(x*M,y*M,0);
 glcolor4f(r,g,b,a);
 glbegin(GL_Quads);
  gltexcoord2f(i*0.125+0.002,j*0.125+0.002);
  glvertex2f(-f/2,+f/2);
  gltexcoord2f(i*0.125+0.125-0.002,j*0.125+0.002);
  glvertex2f(+f/2,+f/2);
  gltexcoord2f(i*0.125+0.125-0.002,j*0.125+0.125-0.002);
  glvertex2f(+f/2,-f/2);
  gltexcoord2f(i*0.125+0.002,j*0.125+0.125-0.002);
  glvertex2f(-f/2,-f/2);
 glend;
 gltranslatef(-x*M,-y*M,0);
{}
end;

procedure Put_Text(Str:string;X,Y:single);  {     }
Var
 i:integer;
 S:Array [0..255] of byte;
 AP:Pointer;
begin
 if Str='' then Exit;            {   }
 For i:=1 to Length(Str) do
  S[i-1]:=byte(Str[i]);          {    }
 AP:=@S[0];
 glPushAttrib(GL_LIST_BIT);      //    
 glListBase(base_Font);         { }
 glRasterPos2f(X, Y);// 
 glCallLists(Length(str),GL_UNSIGNED_BYTE,AP);{ }
 glPopAttrib(); //    
end;

procedure Gen_Font(var ghDC:HDC);{   }
Var Font:HFont;
begin
 Font:=createFont(      { }
  -26,0,             //H,W -   -   Windows     
  0,0,                // 
  FW_NORMAL,          //FW_DONTCARE - 0, FW_NORMAL - 400, FW_BOLD - 700,  FW_BLACK - 900.
  0,                  // 
  0,                  // 
  0,                  // 
  DEFAULT_CHARSET,    //   (CHINESEBIG5_CHARSET, GREEK_CHARSET, RUSSIAN_CHARSET, DEFAULT_CHARSET,  ..)
  OUT_TT_ONLY_PRECIS,      //   OUT_TT_PRECIS-   - truetype ,OUT_TT_ONLY_PRECIS  Truetype
  CLIP_DEFAULT_PRECIS,
  ANTIALIASED_QUALITY,
  FF_DONTCARE or DEFAULT_PITCH,  //    ( - DEFAULT_PITCH, FIXED_PITCH  VARIABLE_PITCH)( - FF_DECORATIVE, FF_MODERN, FF_ROMAN, FF_SCRIPT, FF_SWISS, FF_DONTCARE)
  'Comic Sans MS');      //    { 'Comic Sans MS' }
 base_Font:=glGenLists(Max_Font);    {   }
 SelectObject(ghDC,Font);
 wglUseFontBitmaps(ghDC, 0, Max_Font, base_Font); {   }
end;

procedure On_Resize(Width,Height:integer); {    }
begin
 glViewport(0,0,Width,Height);        
 glMatrixMode(GL_Projection);
 glLoadIdentity();
 gluPerspective(45.0, Width/Height, 0.1, 100.0);{  }
 glOrtho(-20,20,-20,20,0,50);
 gluLookAt(0,0,10, 0,0,0, 0,1,0);
 glMatrixMode(Gl_ModelView);
end;

procedure InitGL(var ghRC:HGLRC;var ghDC:HDC;var Hand:THandle;W,H:Integer);
Var
 p:TGLARRAYf4;
 d:TGLARRAYf3;
begin   {OpenGL}
 ghDC:=GetDC(HAND);       { }
 If SetupPixelFormat(ghDC,16)=False then
  Exit;
 ghRC:=wglCreateContext(ghDC);
 wglMakeCurrent(ghDC,ghRC);            {   }
 glClearColor(0.0,0.0,0.0,0.0);        {  - }
 On_Resize(W,H);                       {  }
 glEnable(GL_Color_Material);
 glEnable(GL_Depth_Test);              {Z }
 glEnable(GL_Lighting);                { }
 glEnable(GL_LIGHT0);                  { 0}
 glenable(GL_Point_Smooth);            { }
 p[0]:=2; p[1]:=-5; p[2]:=3; p[3]:=-2;      { }
 d[0]:=0; d[1]:=0; d[2]:=0;
 glLightFV(Gl_LIGHT0,Gl_Position,@p);          { }
 glLightFV(GL_LIGHT0,GL_Spot_Direction,@d);
 {Settings}
 glDepthFunc(GL_LESS);		           //  Z 
 glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //
end;

procedure CloseGL(ghRC:HGLRC;ghDC:HDC;Hand:THandle);
begin
 If ghRC<>0 then             { ,  }
  begin
  wglMakeCurrent(ghDc,0);
  wglDeleteContext(ghRC);
 end;
 If ghDC<>0 then
  ReleaseDC(Hand,ghDC);
end;

procedure enable_bind_tex;
begin
 glEnable(GL_TEXTURE_2D);         { }
 glEnable(GL_BLEND);             { }
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);{ }
end;

procedure disable_bind_tex;
begin
 glDisable(GL_BLEND);      { }
 glDisable(GL_TEXTURE_2D); { }
end;

procedure LoadTGATexture(FileName: String; var TexIndex: Cardinal);
var TGA: TTGAImage;
    TexelSize: Integer;
    TexMode: Integer;
begin
//  glGenTextures(1, @TexIndex);

  TGA := TTGAImage.Create;
  try
    TGA.LoadFromFile(FileName);
    TGA.BGRtoRGB;
    case TGA.Header.ImgSpec.Depth of
      24:
        begin
          TexelSize := 3;
          TexMode := GL_RGB;
        end;
      32:
        begin
          TexelSize := 4;
          TexMode := GL_RGBA;
        end;
      else exit;{ raise Exception.Create('Error loading ' + FileName);}
    end; // case

    glBindTexture(GL_TEXTURE_2D, TexIndex);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
    gluBuild2DMipmaps(GL_TEXTURE_2D, TexelSize, TGA.Header.ImgSpec.Width,
      TGA.Header.ImgSpec.Height, TexMode, GL_UNSIGNED_BYTE, TGA.Data);
    glTexImage2D(GL_TEXTURE_2D, 0, TexelSize, TGA.Header.ImgSpec.Width,
      TGA.Header.ImgSpec.Height, 0, TexMode, GL_UNSIGNED_BYTE, TGA.Data);
  finally
    TGA.Free;
  end;
end;

function LoadJPGTexture(FileName: String; var TexIndex: Cardinal):pointer;
Var
  i,j,BW,BH:integer;        { }
  BM:TBitMap;         {  }
  JI:TJpegImage;      {    }
  P:^TSline;          {    -    ,   RGB}
  TA:array of byte;
  S:Pointer;
begin
 BM:=TBitMap.Create;
 JI:=TJpegImage.Create;
 JI.LoadFromFile(FileName);
 BM.Assign(JI);
 JI.Destroy;
 SetLength(TA,BM.Width*BM.Height*4);
 BW:=BM.Width;     { (     )}
 BH:=BM.Height;
 For j:=0 to BH-1 do {  }
 begin
  P:=BM.ScanLine[j]; {     -  }
  For i:=0 to BW-1 do {  }
  begin
   TA[i*4+(BH-1-j)*BW*4+0]:=p[i].b;
   TA[i*4+(BH-1-j)*BW*4+1]:=p[i].g;
   TA[i*4+(BH-1-j)*BW*4+2]:=p[i].r;
   TA[i*4+(BH-1-j)*BW*4+3]:=255;
  end;
 end;
 S:=TA;
 GenTexture(S,BW,BH,TexIndex);
 //gen_Sphere_texture:=TA;      {      }
 BM:=nil;
 BM.Free;              { }
end;

end.
