unit Use_Phys;

interface

uses
  Global,
  Use_Geom,
  Use_Bass;
                     
procedure Load_Level(FileName:string);
procedure Save_Level(FileName:string);
procedure Move_objects;
procedure Move_Parts;
procedure Check_objects;  
procedure Check_Blocks;
procedure Add_Block(X,Y:single;tip,bonus:integer);
procedure add_Part(X,Y,VX,VY:Single;life,tip:byte);
procedure add_ball(X,Y,VX,VY,R:Single;tip:byte);
procedure Clear_Parts;   
procedure Clear_Balls;
procedure Set_Parts(lev:byte);

implementation
                     

procedure Load_Level(FileName:string);
Var
 i:integer;
 F:File of TSave_game_var;
 Info:TSave_game_var;
begin
 AssignFile(F,FileName);
 Reset(F);
 Read(F,Info);
 CloseFile(F);
 for i:=0 to MaxBlocks do
  Blocks[i]:=Info[i];
end;

procedure Save_Level(FileName:string);
Var
 i:integer;
 F:File of TSave_game_var;
 Info:TSave_game_var;
begin
 for i:=0 to MaxBlocks do
  Info[i]:=Blocks[i];
 AssignFile(F,FileName);
 Rewrite(F);
 write(F,Info);
 CloseFile(F);
end;

procedure Add_Block(X,Y:single;tip,bonus:integer);
Var i:integer;
begin
 for i:=0 to MaxBlocks do      {,        }
  if (Blocks[i].life>0) then
  if (X<Blocks[i].Point.X+BSX-0.1) and
     (Y<Blocks[i].Point.Y+BSY-0.1) and
     (X+BSX-0.1>Blocks[i].Point.X) and
     (Y+BSY-0.1>Blocks[i].Point.Y) then
     if (tip>=0) then begin exit;break;end else
      begin Blocks[i].life:=0;break;end;
 if (tip<0) then exit;
 for i:=0 to MaxBlocks do
 if (Blocks[i].life=0) then
 begin
  Blocks[i].Point.X:=X;
  Blocks[i].Point.Y:=Y;
  Blocks[i].life:=15;
  Blocks[i].tip:=tip;
  Blocks[i].bonus:=bonus;
  break;
 end;
end;

procedure add_Part(X,Y,VX,VY:Single;life,tip:byte);
Var i:integer;
begin
 for i:=0 to MaxParts do
  if (Parts[i].life=0) then
   begin
    Parts[i].life:=life;
    Parts[i].tip:=tip;
    Parts[i].Point.X:=X;
    Parts[i].Point.Y:=Y;
    Parts[i].Vect.X:=VX;
    Parts[i].Vect.Y:=VY;
    break;
   end;
end;

procedure add_ball(X,Y,VX,VY,R:Single;tip:byte);
Var i:byte;
begin
 for i:=0 to MaxBalls do
  if not Balls[i].real then
   begin
    Balls[i].real:=true;
    Balls[i].Point.X:=X;
    Balls[i].Point.Y:=Y;
    Balls[i].tip:=tip;
    Balls[i].Rad:=R;
    Balls[i].Vect.X:=VX;
    Balls[i].Vect.Y:=VY;
    break;
   end;
end;

procedure Clear_Parts;
Var i:integer;
begin
 for i:=0 to MaxParts do
  Parts[i].life:=0;
end;

procedure Clear_Balls;
Var i:integer;
begin
 for i:=0 to MaxBalls do
  Balls[i].real:=false;
end;

procedure boom(S:TBlock;M:byte);
Var i:byte;tip:byte;
begin
 tip:=0;
 if Fon_num=0 then tip:=1;
 if Fon_num=2 then tip:=6;
 //if Is_Clouds then tip:=2;
 for i:=0 to M do
  Add_Part(S.Point.X+0.4,S.Point.Y+0.2,Random(100)/200-0.25,Random(100)/200-0.25,5+Random(5),tip);
end;

procedure Move_objects;
Var i:integer;
begin
 Anim:=Anim+1;
 if anim>128 then anim:=-128;
 if BallSpeed>0.2 then BallSpeed:=0.2;
 if (BallTime>0) then
   BallTime:=BallTime-1
  else BallTip:=0;
 For i:=0 to MaxBalls do
  if Balls[i].real then
   begin
    {speed control}
    if (Balls[i].tip=0) and (BallTip=1) then Balls[i].tip:=1;
    if (Balls[i].tip=1) and (BallTip=0) then Balls[i].tip:=0;

    if Get_S(Vector(0,0),Balls[i].vect)<BallSpeed then
     Balls[i].vect:=Vector(Balls[i].vect.X*1.1,Balls[i].vect.Y*1.1) else
     Balls[i].vect:=Vector(Balls[i].vect.X*0.9,Balls[i].vect.Y*0.9);

    {moving}
    Balls[i].Point:=plus(Balls[i].Point,Balls[i].vect);
   end;
end;

procedure Kill_near_Blocks(X,Y:Single);
Var j:integer;
begin
 Play_Sound(Booms);
 for j:=0 to MaxBlocks do
  if Blocks[j].life>0 then
  // if (i<>j) then
    if (X<=Blocks[j].Point.X+0.9) and
       (X>=Blocks[j].Point.X-0.9) and
       (Y<=Blocks[j].Point.Y+0.5) and
       (Y>=Blocks[j].Point.Y-0.5)
     then Blocks[j].life:=2;
end;

procedure Check_Blocks;
Var i,j,z:integer;
begin
 z:=0;
 For i:=0 to MaxBlocks do
  if Blocks[i].life>0 then
  begin
   if (Blocks[i].tip<>bt_Armour) then z:=z+1;
   if Blocks[i].life=1 then                             {bonuses}
    begin
     if (Blocks[i].bonus>0) then
      Add_Part(Blocks[i].Point.X+0.4,Blocks[i].Point.Y+0.2,0,0,1,Blocks[i].bonus{Random(8)+21});
     case Blocks[i].tip of
      bt_Blowing,bt_Blowing0,bt_Blowing1,bt_Blowing2,
      bt_UArmourDB,bt_DArmourUB,bt_RadioBlowing:
        Kill_near_Blocks(Blocks[i].Point.X,Blocks[i].Point.Y);
     end;
     Blocks[i].life:=0;
     boom(Blocks[i],10);
    end;
   if Blocks[i].life=2 then
    Blocks[i].life:=1;
  end;
 if (z=0) and (Hero.tip<>99) and Is_Started and (mode=2) then
 begin
 {victory}
  Mode:=4;
  Is_Started:=false;
 end;
end;

procedure Set_Parts(lev:byte);  {  ,     }
Var i,j:integer;
begin
 case lev of
  0:begin
     for i:=0 to 100 do
      add_Part(Random(19)-2,Random(19)-2,0,0,20,12);
     for i:=0 to 100 do
      add_Part(Random(19)-2,Random(19)-2,0,0,20,11);
    end;
  1:begin
     j:=Random(20);
     for i:=0 to 8+Random(3) do
      add_Part(3+i*0.2,Random(20)/30+7.5+j/10,0,0,2,5);
     j:=Random(20);
     for i:=0 to 8+Random(3) do
      add_Part(11+i*0.2,Random(20)/30+7.5+j/10,0,0,2,5);
    end;
  2:begin
     for i:=0 to 100 do
      add_Part(Random(19)-2,Random(19)-2,0,0,20,2);
     for i:=0 to 100 do
      add_Part(Random(19)-2,Random(19)-2,0,0,20,3);
    end;
 end;
end;

procedure add_P(add:byte);
begin
 POINTS:=POINTS+add;
end;

procedure Move_Parts;
Var i,z:integer;j:byte;
begin
 if Fon_num=0 then
  if (Random(12)=1) then
   add_Part(Random(19)-2,14,0,0,20,12);{}
 if Fon_num=0 then
  if (Random(12)=1) then
   add_Part(Random(19)-2,14,0,0,20,11);{}
 if Fon_num=1 then
  if (Random(300)=1) then
   begin
    j:=Random(20);
    for i:=0 to 8+Random(3) do
     add_Part(17+i*0.2,Random(20)/30+7.5+j/10,0,0,2,5);
   end;
 if Fon_num=2 then
  if (Random(2)=1) then
   begin
    add_Part(Random(2000)/100-2,14,0,0,2,2+Random(2));
    add_Part(Random(2000)/100-2,14,0,0,2,2+Random(2));
    add_Part(Random(2000)/100-2,14,0,0,2,2+Random(2));
   end;
  {  }
 For i:=0 to MaxParts do
  if Parts[i].life>0 then
  case Parts[i].tip of
   0:begin                {blow}
      Parts[i].Point:=plus(Parts[i].Point,Parts[i].vect);
      Parts[i].life:=Parts[i].life-1;
     end;
   1:begin                {blow}
      Parts[i].Point:=plus(Parts[i].Point,Parts[i].vect);
      Parts[i].life:=Parts[i].life-1;
      if Parts[i].life<1 then
       begin
        Parts[i].tip:=12-Random(2)*Random(2);
        Parts[i].life:=20+Random(2);
       end;
     end;
   2:begin             {rain}
      Parts[i].Vect:=plus(Parts[i].Vect,Vector(0,-0.003));
      Parts[i].Point:=plus(Parts[i].Point,Parts[i].Vect);
      if Parts[i].Point.Y<-1 then
       Parts[i].life:=0;
     end;
   3:begin             {rain}
      Parts[i].Vect:=plus(Parts[i].Vect,Vector(0,-0.002));
      Parts[i].Point:=plus(Parts[i].Point,Parts[i].Vect);
      if Parts[i].Point.Y<-1 then
       Parts[i].life:=0;
     end;
   5:begin           {cloud}
      Parts[i].Point:=plus(Parts[i].Point,Vector(-0.01,0));
      if Parts[i].Point.X<-2 then
       Parts[i].life:=0;
     end;
   6:begin                {blow}
      Parts[i].Point:=plus(Parts[i].Point,Parts[i].vect);
      Parts[i].life:=Parts[i].life-1;
      if Parts[i].life<1 then
       begin
        Parts[i].tip:=3-Random(2)*Random(2);
        Parts[i].vect:=Vector(0,0);
        Parts[i].life:=20+Random(2);
       end;
     end;
   11:begin               {snow}
      if (Parts[i].life=20) then
       Parts[i].Point:=plus(Parts[i].Point,Vector(-0.005,-0.01))
        else
       Parts[i].Point:=plus(Parts[i].Point,Vector(0.005,-0.01));
      if Random(80)=1 then Parts[i].life:=10;
      if Random(80)=1 then Parts[i].life:=20;
      if Parts[i].Point.Y<-1 then
       Parts[i].life:=0;
     end;
   12:begin               {snow}
      if (Parts[i].life=20) then
       Parts[i].Point:=plus(Parts[i].Point,Vector(-0.005,-0.008))
        else
       Parts[i].Point:=plus(Parts[i].Point,Vector(0.005,-0.008));
      if Random(80)=1 then Parts[i].life:=10;
      if Random(80)=1 then Parts[i].life:=20;
      if Parts[i].Point.Y<-1 then
       Parts[i].life:=0;
     end;
   21..28:begin               {bonuses}
      Parts[i].Point:=plus(Parts[i].Point,Vector(0,-0.02));
      if Parts[i].life<10 then Parts[i].life:=Parts[i].life+1;
      if Parts[i].Point.Y<-1 then
       Parts[i].life:=0;
       {peresecheniay s plankoi}
      if (abs(Hero.Point.X-Parts[i].Point.X)<=Hero.Width+0.8) and
         (Hero.Point.Y-0.8<=Parts[i].Point.Y) and
         (Hero.Point.Y>=Parts[i].Point.Y) then
        begin {using bonuses}
         Parts[i].life:=0;
         add_P(100);
         Play_Sound(Bonus);
         Case Parts[i].tip of
         21:if (Hero.Width<=0.8) then Hero.Width:=Hero.Width+0.2;{ }
         22:begin {  - 5    }
             for z:=0 to MaxBalls do
              if Balls[z].real then
              begin
               for j:=0 to 4 do
                add_Ball(Balls[z].Point.X,Balls[z].Point.Y,
                 (Random(10)/100+0.01)*(Random(2)*2-1),(Random(10)/100+0.01)*(Random(2)*2-1),
                 Balls[z].Rad,BallTip);
               break;
              end;
            end;
         23:Hero.tip:=Hero.tip+5;{weapon}
         24:if BallSpeed>0.12 then BallSpeed:=BallSpeed+0.01;{speed down}
         25:if (Hero.Width>0.1) then Hero.Width:=Hero.Width-0.2;{ }
         26:begin BallTip:=1;BallTime:=200;end; {boom balls}
         27:begin {   - 5       }
             for z:=0 to MaxBalls do
              if Balls[z].real then
              begin
               for j:=0 to 4 do
                add_Ball(Balls[z].Point.X,Balls[z].Point.Y,
                 (Random(10)/100+0.01)*(Random(2)*2-1),(Random(10)/100+0.01)*(Random(2)*2-1),
                 Balls[z].Rad,2); {   }
               break;
              end;
            end;{crash balls}
         28:if BallSpeed<0.2 then BallSpeed:=BallSpeed+0.01;{speed up}
         end;
        end;
     end;
  end;
end;

procedure Correct_objects;
Var i:integer;
begin
 for i:=0 to MaxBalls do   {}
  if Balls[i].real then
   begin
    Balls[i].Point:=plus(Balls[i].Point,Balls[i].Correct);
    Balls[i].Correct:=Vector(0,0);
   end;
end;

procedure Set_Collision(i,j:integer;Up:boolean);
Var n:integer;
begin
 
 Case Blocks[j].tip of
  bt_usual:     begin  Play_Sound(tum);add_P(10);Blocks[j].life:=2;boom(Blocks[j],10); end;
  bt_corrupted0:begin  Play_Sound(tum);add_P(50);Blocks[j].tip:=bt_corrupted1;end;
  bt_corrupted1:begin  Play_Sound(tum);add_P(10);Blocks[j].tip:=bt_corrupted2;end;
  bt_corrupted2:begin  Play_Sound(tum);add_P(10);Blocks[j].tip:=bt_corrupted3;end;
  bt_corrupted3:begin  Play_Sound(tum);add_P(10);Blocks[j].life:=2;boom(Blocks[j],20);end;
  bt_Armour    :begin  Play_Sound(Bams);add_P(1);Blocks[j].life:=Blocks[j].life-1;end;
  bt_UArmourDU :if up then
                begin  Play_Sound(Bams);add_P(1);Blocks[j].life:=Blocks[j].life-1;end else
                begin  Play_Sound(tum);add_P(20);Blocks[j].life:=2;end;
  bt_DArmourUU :if not up then
                begin  Play_Sound(Bams);add_P(1);Blocks[j].life:=Blocks[j].life-1;end else
                begin  Play_Sound(tum);add_P(20);Blocks[j].life:=2;end;
  bt_UArmourDB :if up then
                begin  Play_Sound(Bams);add_P(1);Blocks[j].life:=Blocks[j].life-1;end else
                begin  Play_Sound(tum);add_P(30);Blocks[j].life:=2;end;
  bt_DArmourUB :if not up then
                begin  Play_Sound(Bams);add_P(1);Blocks[j].life:=Blocks[j].life-1;end else
                begin  Play_Sound(tum);add_P(30);Blocks[j].life:=2;end;
  bt_Blowing   :begin  add_P(100);Blocks[j].life:=2;boom(Blocks[j],30);end;
  bt_Blowing0  :begin  Play_Sound(beem);add_P(10);Blocks[j].tip:=bt_Blowing1;end;
  bt_Blowing1  :begin  Play_Sound(beem);add_P(10);Blocks[j].tip:=bt_Blowing2;end;
  bt_Blowing2  :begin  Play_Sound(beem);add_P(10);Blocks[j].life:=2;boom(Blocks[j],30);end;
  bt_Radio     :begin  Play_Sound(tum);add_P(100);Blocks[j].life:=2;
                for n:=0 to MaxBlocks do
                 if (Blocks[n].tip=bt_RadioBlowing) and (Blocks[n].life>0) then
                  Blocks[n].life:=1;
                end;
  bt_RadioBlowing:begin add_P(200);Blocks[j].life:=2;boom(Blocks[j],30); end;   {}
 end;
 Case Balls[i].tip of
  0:;{usual}
  1:begin
     Kill_near_Blocks(Balls[i].Point.X,Balls[i].Point.Y);
     Blocks[j].life:=1;
    end;{super}
  2:begin
     Kill_near_Blocks(Balls[i].Point.X,Balls[i].Point.Y);
     Blocks[j].life:=1;
     Balls[i].real:=false;
    end;{super but only for one collision}
 end;
end;

procedure Check_objects;
Var i,j,z:integer;r,s,d:single;HP:TVect;
begin
 {Collizions}
 For i:=0 to MaxBalls do
  if Balls[i].real then
   begin {walls;}
    if (Balls[i].Point.X+Balls[i].Rad>XMax) then begin
     if (abs(Balls[i].vect.Y)<0.01) then Balls[i].vect.Y:=Balls[i].vect.Y-0.005;
     Balls[i].Vect.X:=-abs(Balls[i].Vect.X);Balls[i].Point.X:=XMax-Balls[i].Rad;end;
    if (Balls[i].Point.X-Balls[i].Rad<XMin) then begin
     if (abs(Balls[i].vect.Y)<0.01) then Balls[i].vect.Y:=Balls[i].vect.Y-0.005;
     Balls[i].Vect.X:=abs(Balls[i].Vect.X);Balls[i].Point.X:=XMin+Balls[i].Rad;;end;
    if (Balls[i].Point.Y+Balls[i].Rad>YMax) then begin
     Balls[i].Vect.Y:=-abs(Balls[i].Vect.Y);Balls[i].Point.Y:=YMax-Balls[i].Rad;end;
    if (Balls[i].Point.Y-Balls[i].Rad<YMin) then  begin
      {Balls[i].Vect.Y:=abs(Balls[i].Vect.Y);
      Balls[i].Point.Y:=YMin+Balls[i].Rad;   }
      {  }
      Balls[i].real:=false;
      {      }
      z:=0;
      For j:=0 to MaxBalls do
       if Balls[j].real then z:=z+1;
      {  -     }
      if (z=0) and Is_Started then
       if LIVES=0  then
        begin
        {gameover}
         Mode:=5;
        end
        else
        begin
         LIVES:=LIVES-1;
         Hero.tip:=99;
        end
     end;
   end;
 {  }
 For i:=0 to MaxBalls do
 if Balls[i].real then
  for j:=0 to MaxBlocks do
  if Blocks[j].life>0 then
    { }
   if (Blocks[j].Point.X<=Balls[i].Point.X+Balls[i].Rad) and
      (Blocks[j].Point.X+BSX>=Balls[i].Point.X-Balls[i].Rad) and
      (Blocks[j].Point.Y<=Balls[i].Point.Y+Balls[i].Rad) and
      (Blocks[j].Point.Y+BSY>=Balls[i].Point.Y-Balls[i].Rad) then
    begin       {center}
     if (Blocks[j].Point.X+0.05<=Balls[i].Point.X) and
        (Blocks[j].Point.X+BSX-0.05>=Balls[i].Point.X) then
         begin
          Balls[i].Vect.Y:=-Balls[i].Vect.Y;
          if (Blocks[j].Point.Y+0.2>Balls[i].Point.Y)
           then Balls[i].Correct.Y:=Blocks[j].Point.Y-Balls[i].Point.Y-Balls[i].Rad else
            Balls[i].Correct.Y:=BSY+Blocks[j].Point.Y-Balls[i].Point.Y+Balls[i].Rad;
          Set_Collision(i,j,(Blocks[j].Point.Y+0.2<Balls[i].Point.Y));
         end else   {sides}
        if (Get_S(Balls[i].Point,Vector(Blocks[j].Point.X+0.4,Blocks[j].Point.Y+0.2))
         <Balls[i].Rad+0.4) then
         begin
          HP:=Vector(Blocks[j].Point.X+0.4,Blocks[j].Point.Y+0.2);
          r:=Get_A(Balls[i].Point,HP);
          s:=Get_A(Vector(0,0),Balls[i].Vect);
          d:=Get_S(Vector(0,0),Balls[i].Vect);
          Balls[i].Vect:=minus(Balls[i].Vect,  {    }
           Get_Vect(r,Get_X_V(Get_R(s-r),d)));
          Balls[i].Vect:=minus(Balls[i].Vect,
           Get_Vect(r,Get_X_V(Get_R(s-r),d)));
          d:=Get_S(HP,Balls[i].Point);
          d:=(0.4+Balls[i].Rad)-d;        {    }
          Balls[i].Correct:=Get_Vect(r,-d);
          Set_Collision(i,j,(Blocks[j].Point.Y+0.2<Balls[i].Point.Y));{i-ball j-block up - if true thenfrom up}
         // Blocks[j].life:=Blocks[j].life-1;
         end;
    end;
 Correct_objects;
 {  }
 HP:=plus(Hero.Point,Vector(-Hero.Width,-Hero.Rad-0.1)); {LEFT}
 For i:=0 to MaxBalls do
 if Balls[i].real then
  if (Hero.Point.X-Hero.Width-0.8<=Balls[i].Point.X+Balls[i].Rad) and
     (Hero.Point.X-Hero.Width>=Balls[i].Point.X) then
  if (Get_S(Balls[i].Point,HP)<Balls[i].Rad+Hero.Rad) then
   begin
    r:=Get_A(Balls[i].Point,HP);
    s:=Get_A(Vector(0,0),Balls[i].Vect);
    d:=Get_S(Vector(0,0),Balls[i].Vect);
    Balls[i].Vect:=minus(Balls[i].Vect,  {    }
      Get_Vect(r,Get_X_V(Get_R(s-r),d)));
    Balls[i].Vect:=minus(Balls[i].Vect,
      Get_Vect(r,Get_X_V(Get_R(s-r),d)));
    d:=Get_S(HP,Balls[i].Point);
    d:=(Hero.Rad+Balls[i].Rad)-d;        {    }
    Balls[i].Correct:=Get_Vect(r,-d);
   end;
 HP:=plus(Hero.Point,Vector(Hero.Width,-Hero.Rad-0.1)); {Rigth}
 For i:=0 to MaxBalls do
 if Balls[i].real then
  if (Hero.Point.X+Hero.Width+0.8>=Balls[i].Point.X-Balls[i].Rad) and
     (Hero.Point.X+Hero.Width<=Balls[i].Point.X) then
  if (Get_S(Balls[i].Point,HP)<Balls[i].Rad+Hero.Rad) then
   begin
    r:=Get_A(Balls[i].Point,HP);
    s:=Get_A(Vector(0,0),Balls[i].Vect);
    d:=Get_S(Vector(0,0),Balls[i].Vect);
    Balls[i].Vect:=minus(Balls[i].Vect,
      Get_Vect(r,Get_X_V(Get_R(s-r),d)));
    Balls[i].Vect:=minus(Balls[i].Vect,
      Get_Vect(r,Get_X_V(Get_R(s-r),d)));
    d:=Get_S(HP,Balls[i].Point);
    d:=(Hero.Rad+Balls[i].Rad)-d;
    Balls[i].Correct:=Get_Vect(r,-d); { }
   end;
 For i:=0 to MaxBalls do
 if Balls[i].real then
  if (Hero.Point.X-Hero.Width<=Balls[i].Point.X) and
     (Hero.Point.X+Hero.Width>=Balls[i].Point.X) then
  if (Balls[i].Point.Y-Balls[i].Rad<=Hero.Point.Y-0.095) and
     (Balls[i].Point.Y+Balls[i].Rad>Hero.Point.Y-0.3) then
   begin
    Balls[i].Vect.Y:=abs(Balls[i].Vect.Y);
   end;
 Correct_objects;
end;


end.
