#include "Ball.h"

Ball::Ball (HGE *hge, Racket *racket, float x, float y): hge(hge), racket(racket) {
    relCoords.x = x;
    relCoords.y = y;

    rad = DEF_RAD;

    if (racket) {
        relCoords.x = 0;
        relCoords.y = -(racket->getHeight()/2 + rad);
    }

    texture = hge->Texture_Load("ball.png");
    sprite = new hgeSprite (texture, 0, 0, 10, 10);
    sprite->SetHotSpot(5, 5);
    speed.x = 0;
    speed.y = 0;

}

Ball::~Ball () {
    delete sprite;
    hge->Texture_Free(texture);
}

void Ball::render () {
    sprite->Render(absCoords.x, absCoords.y);
}

void Ball::refresh(float dt) {
    if (!racket) {
        relCoords+=speed*dt;
        absCoords=relCoords;
    }
    else {
        absCoords=relCoords;
        absCoords.Rotate(-racket->getAngle());
        absCoords+=racket->getCoords();
        if (absCoords.x>800||absCoords.y>600||absCoords.x<50||absCoords.y<0) {
//            delete this;
        }
    }
}

void Ball::setCoords (float x, float y) {
    relCoords.x = x;
    relCoords.y = y;
}

void Ball::setCoords (hgeVector coords) {
    relCoords = coords;
}

void Ball::setSpeed (hgeVector speedDir) {
    speedDir.Normalize();
    speed = speedDir*SPEED;
}

float Ball::getRad () {
    return rad;
}

hgeVector Ball::getCoords() {
    return absCoords;
}

hgeVector Ball::getSpeed() {
    return speed;
}

void Ball::fire() {
    if (racket) {
        relCoords.Rotate (-racket->getAngle());
        relCoords+=racket->getCoords();
        speed.x = 0;
        speed.y = -1;
        speed.Normalize();
        speed.Rotate(-racket->getAngle());
        speed*=SPEED;

        racket = 0;
    }
}

bool Ball::isOnRacket() {
    return racket;
}


