#ifndef BALL_H_INCLUDED
#define BALL_H_INCLUDED

class Ball;

#include "hgevector.h"
#include "hgesprite.h"
#include "Racket.h"

const float DEF_RAD = 5;
const float SPEED = 250;

class Ball {
    private:
    hgeVector relCoords, absCoords, speed;
    float rad;
    HGE *hge;
    HTEXTURE texture;
    hgeSprite *sprite;

    Racket *racket;

    public:
    Ball (HGE *hge, Racket *racket = 0, float x=0, float y=0);
    ~Ball ();

    void render ();
    void refresh (float dt);

    void setCoords (float x, float y);
    void setCoords (hgeVector coords);

    void setSpeed (hgeVector speed);

    float getRad ();
    hgeVector getCoords();
    hgeVector getSpeed();

    void fire();

    bool isOnRacket();
};


#endif // BALL_H_INCLUDED
