#ifndef BRICK_H_INCLUDED
#define BRICK_H_INCLUDED

class Brick;
#include "hge.h"
#include "hgesprite.h"
#include "hgevector.h"
#include "ball.h"
#include <string>

const float BRICK_WIDTH = 20;
const float BRICK_HEIGHT = 16;

const std::string TEXTURE_NAME = "brick1.png";
const std::string BRICK_BALL_HIT_SND_NAME = "tsyk.wav";

class Brick {

    HTEXTURE texture;
    hgeSprite *sprite;
    hgeVector coords, absCoords;

    float angle;

    float timer;
    bool dying;



    public:
        Brick (Field *field, hgeVector center, float x, float y, int i, int j, float angle, const char* textureName = TEXTURE_NAME.c_str());
        ~Brick();
        void refresh (hgeVector center, float angle, float dt);
        void render ();
        Brick* collide (Ball *ball);
        virtual void die();
        void dieIn (float time);
        virtual bool isCountable();

    protected:

        HGE *hge;
        HEFFECT ballHitSnd;

        Field *field;
        int i, j;

        virtual void onHit();
};

#endif // BRICK_H_INCLUDED
