#ifndef RACKET_H_INCLUDED
#define RACKET_H_INCLUDED

class Racket;

#include "hge.h"
#include "hgesprite.h"
#include "hgeparticle.h"
#include "Math.h"
#include "vector.h"
#include "Field.h"
#include "Ball.h"

const float RACKET_SPEED = 0.5;
const float MAX_RACKET_SPEED = 0.2;

const float START_HEIGHT = 16;
const float START_LENGTH = 64;

const int HOR_CONTROL = 0;
const int CIRC_CONTROL = 1;

class Racket {

    Field *field;
    HGE *hge;
    hgeSprite *sprite;
    HTEXTURE texture;
    HEFFECT	pawSnd;

    float coord; //from 0 till 1
    float angle; //from 0 till 2Pi
    float rad; //from 0 till 1

    float height, length;
    int controlType;

    hgeVector coords;

    public:


    Racket(Field *field, HGE *hge, float angle=0, float rad=1);
    ~Racket();

    void render();
    void refresh (float dt);

    hgeVector getCoords ();
    float getAngle();
    float getHeight();

    void collide (Ball *ball);
    void setAngle (float angle);

    int getControlType();
//    float getCoord();
//    void setCoord(float coord);


};

#endif // RACKET_H_INCLUDED
