//Gen2 v1.0
//Author: Dan
//dan.mirgames.ru

unit Gen2;

{$include Gen2.inc}

interface

uses
  Windows,
  Classes,
  Controls,
  Graphics,
  {$IFNDEF VER200}
  PNGImage,
  {$ENDIF}
  SysUtils,
  SyncObjs,
  ActiveX,
  Registry,
  MMSystem,
  Forms,
  Messages,
  Math,
  Dialogs,
  DirectInput,
  DirectShow9,
  DirectMusic,
  DirectSound,
  Direct3D9,
  DXTypes,
  DXErr9,
  D3DX9,
  G2Math;

type
  TG2Class = class;
  TG2Core = class;
  TG2List = class;
  TG2Engine = class;
  TG2Timer = class;
  TG2Graphics = class;
  TG2GraphicsSpecs = class;
  TG2GraphicsInitParams = class;
  TG2GraphicsRunTimeParams = class;
  TG2Transforms = class;
  TG2Lights = class;
  TG2SwapChain = class;
  TG2Audio = class;
  TG2Input = class;
  TG2Network = class;
  TG2Module = class;
  TG2Plug = class;
  TG2PlugTimer = class;
  TG2PlugGraphics = class;
  TG2PlugAudio = class;
  TG2PlugInput = class;
  TG2PlugNetwork = class;
  TG2ResMgr = class;
  TG2Res = class;
  TG2MusicMgr = class;
  TG2Music = class;
  TG2SoundMgr = class;
  TG2Sound = class;
  TG2SoundInst = class;
  TG2TextureMgr = class;
  TG2TextureBase = class;
  TG2Texture2DBase = class;
  TG2Texture2D = class;
  TG2Texture2DRT = class;
  TG2Texture2DVideo = class;
  TG2TextureCube = class;
  TG2FontMgr = class;
  TG2Font = class;
  TG2MeshMgr = class;
  TG2Mesh = class;
  TG2MeshInstance = class;
  TG2MeshNode = class;
  TG2MeshGeom = class;
  TG2MeshSkin = class;
  TG2MeshAnim = class;
  TG2MeshMaterial = class;
  TG2MeshLoader = class;
  TG2Shared = class;
  TG2VBMgr = class;
  TG2VB = class;
  TG2IBMgr = class;
  TG2IB = class;
  TG2ScriptMgr = class;
  TG2Script = class;
  TG2GUI = class;
  TG2GUIWindow = class;
  TG2RenderStates = class;
  TG2SamplerStates = class;
  TG2TextureStageStates = class;
  TG2SharedVB2D = class;
  TG2Render = class;
  TG2Render2D = class;
  TG2Render3D = class;
  TG2Camera = class;
  TG2Primitives2D = class;
  TG2Primitives3D = class;
  TG2ShaderMgr = class;
  TG2Shader = class;
  TG2VertexShader = class;
  TG2PixelShader = class;
  TG2EffectMgr = class;
  TG2Effect = class;
  TG2ShaderLib = class;
  TG2ShaderBin = class;
  TG2App = class;

  PG2Module = ^TG2Module;
  PG2Plug = ^TG2Plug;

  TG2Proc = procedure;
  TG2ProcObj = procedure of object;

  TG2InputKeyDown = procedure (const Key: Byte) of object;
  TG2InputKeyUp = procedure (const Key: Byte) of object;
  TG2InputMouseDown = procedure (const Button: Byte) of object;
  TG2InputMouseUp = procedure (const Button: Byte) of object;
  TG2InputMouseMove = procedure (const Shift: TPoint) of object;
  TG2InputWheelMove = procedure (const Shift: Integer) of object;

  CG2ModClass = class of TG2Module;
  CG2PlugClass = class of TG2Plug;
  CG2MeshLoaderClass = class of TG2MeshLoader;
  CG2GUIWindowClass = class of TG2GUIWindow;

  TG2Result = (
    grOk,
    grFail,
    grConditionalOk,
    grNotInitialized,
    grInvalidCall,
    grRedundantCall
  );

  TG2VertexProcessing = (
    vpSoftware,
    vpHardware,
    vpMixed
  );

  TG2MeshMode = (
    mmSW,
    mmFF,
    mmSM3HLSL,
    mmSM3ASM
  );

  TG2FrustumCheck = (
    fcInside,
    fcIntersect,
    fcOutside
  );

  TG2TimerMode = (
    tmAppIdle,
    tmWinTimer,
    tmManual
  );

  TG2PrimType = (
    ptPointList,
    ptLineList,
    ptLineStrip,
    ptTriangleList,
    ptTriangleStrip,
    ptTriangleFan
  );

  PG2CompiledShader = ^TG2CompiledShader;
  TG2CompiledShader = array of Byte;

  PG2Index16 = ^TG2Index16;
  TG2Index16 = Word;
  PG2Index16Array = ^TG2Index16Array;
  TG2Index16Array = array[0..0] of TG2Index16;

  PG2Index32 = ^TG2Index32;
  TG2Index32 = DWord;
  PG2Index32Array = ^TG2Index32Array;
  TG2Index32Array = array[0..0] of TG2Index32;

//TG2Color BEGIN
  PG2Color = ^TG2Color;
  TG2Color = record
  public
    b, g, r, a: Byte;
    class operator Explicit(const c: TG2Color): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Explicit(const c: DWord): TG2Color; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Explicit(const c: TG2Color): TD3DColorValue; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Explicit(const c: TD3DColorValue): TG2Color; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Implicit(const c: TG2Color): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Implicit(const c: DWord): TG2Color; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Implicit(const c: TG2Color): TD3DColorValue; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    class operator Implicit(const c: TD3DColorValue): TG2Color; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  end;
//TG2Color END

//TG2Rect BEGIN
  PG2Rect = ^TG2Rect;
  TG2Rect = record
  public
    Left: Single;
    Top: Single;
    Right: Single;
    Bottom: Single;
    function Width: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function Height: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  end;
//TG2Rect END

//TG2Class BEGIN
  TG2Class = class (TObject)
  public
    constructor Create; virtual;
    destructor Destroy; override;
  end;
//TG2Class END

//TG2Core BEGIN
  TG2Core = class sealed (TG2Class)
  strict private
    m_Handle: HWnd;
    m_OwnWindow: Boolean;
    m_Initialized: Boolean;
    m_Timer: TG2Timer;
    m_Graphics: TG2Graphics;
    m_Audio: TG2Audio;
    m_Input: TG2Input;
    m_Network: TG2Network;
    m_Mods: TG2List;
    procedure SetHandle(const Value: HWND);
    function CreateWindow: HWnd;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Handle: HWND read m_Handle write SetHandle;
    property Timer: TG2Timer read m_Timer;
    property Graphics: TG2Graphics read m_Graphics;
    property Audio: TG2Audio read m_Audio;
    property Input: TG2Input read m_Input;
    property Network: TG2Network read m_Network;
    property Initialized: Boolean read m_Initialized;
    function Initialize: TG2Result;
    function Finalize: TG2Result;
    function RequestMod(
      const ModClass: CG2ModClass;
      const Module: PG2Module
    ): TG2Result;
    function ReleaseMod(
      const Module: PG2Module 
    ): TG2Result;
    function RequestPlug(
      const PlugClass: CG2PlugClass;
      const Plug: PG2Plug
    ): TG2Result;
    function ReleasePlug(
      const Plug: PG2Plug
    ): TG2Result;
  end;
//TG2Core END

//TG2HighClass BEGIN
  TG2HighClass = class (TG2Class)
  strict private
    m_Core: TG2Core;
  strict protected
    m_Initialized: Boolean;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Core: TG2Core read m_Core;
    property Initialized: Boolean read m_Initialized;
    function Initialize(const G2Core: TG2Core): TG2Result; virtual;
    function Finalize: TG2Result; virtual;
  end;
//TG2HighClass END

//TG2List BEGIN
  TG2List = class sealed (TList)
  public
    procedure FreeItems;
    destructor Destroy; override;
  end;
//TG2List END

//TG2SortedList BEGIN
  TG2SortedList = class sealed (TG2Class)
  strict private
    type
      PSortedItem = ^TSortedItem;
      TSortedItem = record
        Item: Pointer;
        Order: DWord;
      end;
    var
      m_List: TList;
    function GetItem(const Index: Integer): Pointer;
    function GetCount: Integer;
    function FindItemIndex(const Order: DWord): Integer;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Items[const Index: Integer]: Pointer read GetItem; default;
    property Count: Integer read GetCount;
    procedure Add(const Item: Pointer; const Order: DWord);
    procedure Clear;
  end;
//TG2SortedList END

//TG2Engine BEGIN
  TG2Engine = class (TG2HighClass)
  strict protected
    m_Plugs: TG2List;
    m_PlugClass: CG2PlugClass;
  public
    constructor Create; override;
    destructor Destroy; override;
    property PlugClass: CG2PlugClass read m_PlugClass;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function RequestPlug(
      const PlugClass: CG2PlugClass;
      const Plug: PG2Plug
    ): TG2Result;
    function ReleasePlug(
      const Plug: PG2Plug
    ): TG2Result;
  end;
//TG2Engine END

//TG2Timer BEGIN
  TG2Timer = class sealed (TG2Engine)
  strict private
    m_Mode: TG2TimerMode;
    m_Enabled: Boolean;
    m_MaxFPS: Integer;
    m_TargetUPS: Integer;
    m_FullSpeed: Boolean;
    m_QPCAvailable: boolean;
    m_FPS: Integer;
    m_FPSUpdateTime: Int64;
    m_FrameCount: Integer;
    m_Frequency: Int64;
    m_MaxRenderLag: Int64;
    m_PrevRenderTime: Int64;
    m_MaxUpdateLag: Int64;
    m_PrevUpdateTime: Int64;
    m_PrevIdle: TIdleEvent;
    m_WndHandle: HWnd;
    m_TotalFPS: Int64;
    m_TotalFPSCount: Int64;
    procedure Start;
    procedure Stop;
    procedure InitMode;
    procedure UnInitMode;
    procedure SetMode(const Value: TG2TimerMode);
    procedure SetEnabled(const Value: Boolean);
    procedure ResetTimer;
    function GetTime: Int64;
  private
    procedure OnIdle(Sender: TObject; var Done: Boolean);
    procedure WndProc(var Msg: TMessage);
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mode: TG2TimerMode read m_Mode write SetMode;
    property Enabled: Boolean read m_Enabled write SetEnabled;
    property FPS: Integer read m_FPS;
    property MaxFPS: Integer read m_MaxFPS write m_MaxFPS;
    property TargetUPS: Integer read m_TargetUPS write m_TargetUPS;
    property FullSpeed: Boolean read m_FullSpeed write m_FullSpeed;
    procedure OnTimer;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Timer END

//TG2Graphics BEGIN
  TG2Graphics = class sealed (TG2Engine)
  strict private
    m_PlugTimer: TG2PlugTimer;
    m_D3D9: IDirect3D9;
    m_Device: IDirect3DDevice9;
    m_Caps: TD3DCaps9;
    m_InitParams: TG2GraphicsInitParams;
    m_Params: TG2GraphicsRunTimeParams;
    m_Specs: TG2GraphicsSpecs;
    m_RenderStates: TG2RenderStates;
    m_SamplerStates: TG2SamplerStates;
    m_TextureStageStates: TG2TextureStageStates;
    m_Transforms: TG2Transforms;
    m_Lights: TG2Lights;
    m_Material: TD3DMaterial9;
    m_ShaderLib: TG2ShaderLib;
    m_SharedVB2D: TG2SharedVB2D;
    m_Shared: TG2Shared;
    m_SwapChains: TG2List;
    m_DefaultBackBuffer: IDirect3DSurface9;
    m_DefaultDepthStencil: IDirect3DSurface9;
    m_DefaultSwapChain: TG2SwapChain;
    m_DefaultViewPort: TD3DViewPort9;
    m_DeviceLost: Boolean;
    function InitializeDevice: TG2Result;
    function FinalizeDevice: TG2Result;
    function LostDevice: TG2Result;
    function ResetDevice: TG2Result;
    procedure UpdatePresentParams;
    procedure Update;
    function GetCanRender: Boolean;
  private
    m_InitParamsActual: TG2GraphicsInitParams;
    m_PresentParams: TD3DPresentParameters;
    m_CurSwapChain: TG2SwapChain;
    m_CurDefViewPort: PD3DViewPort9;
    procedure HardReset;
    procedure QuickReset;
    procedure ParamsChange;
  public
    constructor Create; override;
    destructor Destroy; override;
    property D3D9: IDirect3D9 read m_D3D9;
    property Device: IDirect3DDevice9 read m_Device;
    property InitParams: TG2GraphicsInitParams read m_InitParams;
    property Params: TG2GraphicsRunTimeParams read m_Params;
    property Caps: TD3DCaps9 read m_Caps;
    property Specs: TG2GraphicsSpecs read m_Specs;
    property RenderStates: TG2RenderStates read m_RenderStates;
    property SamplerStates: TG2SamplerStates read m_SamplerStates;
    property TextureStageStages: TG2TextureStageStates read m_TextureStageStates;
    property Transforms: TG2Transforms read m_Transforms;
    property Lights: TG2Lights read m_Lights;
    property ShaderLib: TG2ShaderLib read m_ShaderLib;
    property SharedVB2D: TG2SharedVB2D read m_SharedVB2D;
    property Shared: TG2Shared read m_Shared;
    property CanRender: Boolean read GetCanRender;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function SwapChainAdd(const Handle: HWND; const SurfaceWidth, SurfaceHeight: Word): TG2SwapChain;
    procedure SwapChainRemove(const SwapChain: TG2SwapChain);
    procedure SetViewPortDefault;
    procedure SetViewPort(const X, Y, Width, Height: Integer);
    function GetViewPort: TD3DViewPort9;
    procedure SetMaterialDefault;
    procedure SetMaterialFromMemory;
    procedure SetMaterial(
      const Diffuse: TG2Color;
      const Ambient: TG2Color;
      const Specular: TG2Color;
      const Emissive: TG2Color;
      const SpecPower: Single
    );
    procedure RenderToSurface(const Surface, DepthStencil: IDirect3DSurface9);
    procedure RenderToSwapChain(const SwapChain: TG2SwapChain);
    procedure RenderToTexture2D(const Texture: TG2Texture2DRT);
    procedure RenderToBackBuffer;
  end;
//TG2Graphics END

//TG2GraphicsSpecs BEGIN
  TG2GraphicsSpecs = class sealed (TG2Class)
  private
    m_G2Graphics: TG2Graphics;
    m_List: TG2SortedList;
    m_DisplayMode: TD3DDisplayMode;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure Initialize(const G2Graphics: TG2Graphics);
    function FindCompatiableTextureFormat(const Format: TD3DFormat): TD3DFormat;
    function FindCompatiableTextureRTFormat(const Format: TD3DFormat): TD3DFormat;
  end;
//TG2GRaphicsSpecs END

//TG2GraphicsInitParams BEGIN
  TG2GraphicsInitParams = class sealed (TG2Class)
  strict private
    m_Adapter: Word;
    m_DeviceType: TD3DDevType;
    m_Width: Word;
    m_Height: Word;
    m_Format: TD3DFormat;
    m_DepthStencilFormat: TD3DFormat;
    m_FullScreen: Boolean;
    m_VSync: Boolean;
    m_Antialiasing: Boolean;
    m_AntialiasingSampleCount: Word;
    m_VertexProcessing: TG2VertexProcessing;
    m_MultiThreaded: Boolean;
    m_PureDevice: Boolean;
    m_FastPresent: Boolean;
    m_DefaultTextureFormat: TD3DFormat;
    m_DefaultRenderTargetFormat: TD3DFormat;
  private
    m_G2Graphics: TG2Graphics;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Adapter: Word read m_Adapter write m_Adapter;
    property DeviceType: TD3DDevType read m_DeviceType write m_DeviceType;
    property Width: Word read m_Width write m_Width;
    property Height: Word read m_Height write m_Height;
    property Format: TD3DFormat read m_Format write m_Format;
    property DepthStencilFormat: TD3DFormat read m_DepthStencilFormat write m_DepthStencilFormat;
    property FullScreen: Boolean read m_FullScreen write m_FullScreen;
    property VSync: Boolean read m_VSync write m_VSync;
    property Antialiasing: Boolean read m_Antialiasing write m_Antialiasing;
    property AntialiasingSampleCount: Word read m_AntialiasingSampleCount write m_AntialiasingSampleCount;
    property VertexProcessing: TG2VertexProcessing read m_VertexProcessing write m_VertexProcessing;
    property MultiThreaded: Boolean read m_MultiThreaded write m_MultiThreaded;
    property PureDevice: Boolean read m_PureDevice write m_PureDevice;
    property FastPresent: Boolean read m_FastPresent write m_FastPresent;
    property DefaultTextureFormat: TD3DFormat read m_DefaultTextureFormat write m_DefaultTextureFormat;
    property DefaultRenderTargetFormat: TD3DFormat read m_DefaultRenderTargetFormat write m_DefaultRenderTargetFormat;
    function Verify: TG2Result;
    procedure Defaults;
    procedure Clone(const Params: TG2GraphicsInitParams);
  end;
//TG2GraphicsInitParams END

//TG2GraphicsRunTimeParams BEGIN
  TG2GraphicsRunTimeParams = class sealed (TG2Class)
  strict private
    m_Adapter: Word;
    m_DeviceType: TD3DDevType;
    m_Width: Word;
    m_Height: Word;
    m_Format: TD3DFormat;
    m_DepthStencilFormat: TD3DFormat;
    m_FullScreen: Boolean;
    m_VSync: Boolean;
    m_Antialiasing: Boolean;
    m_AntialiasingSampleCount: Word;
    m_VertexProcessing: TG2VertexProcessing;
    m_MultiThreaded: Boolean;
    m_PureDevice: Boolean;
    m_FastPresent: Boolean;
    m_DefaultTextureFormat: TD3DFormat;
    m_DefaultRenderTargetFormat: TD3DFormat;
  private
    m_G2Graphics: TG2Graphics;
    procedure Assign(const Params: TG2GraphicsInitParams);
  public
    constructor Create; override;
    destructor Destroy; override;
    property Adapter: Word read m_Adapter;
    property DeviceType: TD3DDevType read m_DeviceType;
    property Width: Word read m_Width write m_Width;
    property Height: Word read m_Height write m_Height;
    property Format: TD3DFormat read m_Format;
    property DepthStencilFormat: TD3DFormat read m_DepthStencilFormat;
    property FullScreen: Boolean read m_FullScreen;
    property VSync: Boolean read m_VSync;
    property Antialiasing: Boolean read m_Antialiasing;
    property AntialiasingSampleCount: Word read m_AntialiasingSampleCount;
    property VertexProcessing: TG2VertexProcessing read m_VertexProcessing;
    property MutiThreaded: Boolean read m_MultiThreaded;
    property PureDevice: Boolean read m_PureDevice;
    property FastPresent: Boolean read m_FastPresent;
    property DefaultTextureFormat: TD3DFormat read m_DefaultTextureFormat write m_DefaultTextureFormat;
    property DefaultRenderTargetFormat: TD3DFormat read m_DefaultRenderTargetFormat write m_DefaultRenderTargetFormat;
    function Apply: TG2Result;
  end;
//TG2GraphicsRunTimeParams END

//TG2Transforms BEGIB
  TG2Transforms = class sealed (TG2HighClass)
  strict private
    m_W: array[0..255] of TG2Mat;
    m_V: TG2Mat;
    m_P: TG2Mat;
    m_T: array[0..15] of TG2Mat;
    m_BufferW: array of TG2Mat;
    m_BufferV: array of TG2Mat;
    m_BufferP: array of TG2Mat;
    m_BufferT: array of TG2Mat;
    function GetW(const Index: Byte): TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetW(const Index: Byte; const m: TG2Mat); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetT(const Index: Byte): TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetT(const Index: Byte; const m: TG2Mat); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWV: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVP: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWVP: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWt: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVt: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPt: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWVt: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVPt: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWVPt: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWi: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVi: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPi: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWVi: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVPi: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWVPi: TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    property W[const Index: Byte]: TG2Mat read GetW write SetW;
    property V: TG2Mat read m_V write m_V;
    property P: TG2Mat read m_P write m_P;
    property T[const Index: Byte]: TG2Mat read GetT write SetT;
    property WV: TG2Mat read GetWV;
    property VP: TG2Mat read GetVP;
    property WVP: TG2Mat read GetWVP;
    property Wt: TG2Mat read GetWt;
    property Vt: TG2Mat read GetVt;
    property Pt: TG2Mat read GetPt;
    property WVt: TG2Mat read GetWVt;
    property VPt: TG2Mat read GetVPt;
    property WVPt: TG2Mat read GetWVPt;
    property Wi: TG2Mat read GetWi;
    property Vi: TG2Mat read GetVi;
    property Pi: TG2Mat read GetPi;
    property WVi: TG2Mat read GetWVi;
    property VPi: TG2Mat read GetVPi;
    property WVPi: TG2Mat read GetWVPi;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure ApplyW(const Index: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure ApplyV; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure ApplyP; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure ApplyT(const Index: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure UpdateW(const Index: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure UpdateV; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure UpdateP; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure UpdateT(const Index: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure PushW;
    procedure PushV;
    procedure PushP;
    procedure PushT;
    procedure PopW;
    procedure PopV;
    procedure PopP;
    procedure PopT;
  end;
//TG2Transforms END

//TG2Lights BEGIN
  TG2Lights = class sealed (TG2HighClass)
  strict private
  const
    LCount = 16;
  type
    TG2LightType = (
      ltAmbient,
      ltDirectional,
      ltPoint,
      ltSpot
    );
    PG2Light = ^TG2Light;
    TG2Light = record
    private
      m_Lights: TG2Lights;
      m_Index: Byte;
    public
      Light: TD3DLight9;
      LightType: TG2LightType;
      Enabled: Boolean;
      procedure SetAmbientLight(
        const Ambient: TG2Color
      );
      procedure SetPointLight(
        const PosX, PosY, PosZ: Single;
        const Diffuse: TG2Color;
        const Range: Single
      );
      procedure SetDirectionalLight(
        const DirX, DirY, DirZ: Single;
        const Diffuse: TG2Color
      );
      procedure SetToDevice;
    end;
  var
    m_Lights: array[0..LCount - 1] of TG2Light;
    function GetLight(const Index: Byte): PG2Light;
    function GetLightCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    m_LightsBuffer: array[0..LCount - 1] of TD3DLight9;
    m_LightsEnabled: array[0..LCount - 1] of Boolean;
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;      
    destructor Destroy; override;
    property Lights[const Index: Byte]: PG2Light read GetLight; default;
    property LightCount: Integer read GetLightCount; 
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure DisableLights;
    procedure SetToEffect(const Effect: TG2Effect);
  end;
//TG2Lights END

//TG2SwapChain BEGIN
  TG2SwapChain = class sealed (TG2Class)
  strict private
    m_SwapChain: IDirect3DSwapChain9;
    m_BackBuffer: IDirect3DSurface9;
    m_DepthStencil: IDirect3DSurface9;
    m_ViewPort: TD3DViewPort9;
    m_PresentParams: TD3DPresentParameters;
    function GetViewPort: PD3DViewPort9;
    procedure Release;
  private
    m_G2Graphics: TG2Graphics;
    procedure Initialize(
      const Handle: HWND;
      const Width, Height: Word;
      const PresentParams: TD3DPresentParameters
    );
    procedure Reset(const Width, Height: Word);
    procedure OnLostDevice;
    procedure OnResetDevice;
  public
    constructor Create; override;
    destructor Destroy; override;
    property SwapChain: IDirect3DSwapChain9 read m_SwapChain;
    property BackBuffer: IDirect3DSurface9 read m_BackBuffer;
    property DepthStencil: IDirect3DSurface9 read m_DepthStencil;
    property ViewPort: PD3DViewPort9 read GetViewPort;
  end;
//TG2SwapChain END

//TG2Audio BEGIN
  TG2Audio = class sealed (TG2Engine)
  strict private
    m_Volume: Single;
    procedure SetVolume(Value: Single);
  private
    m_Loader: IDirectMusicLoader8;
    m_Performance: IDirectMusicPerformance8;
    m_MusicMgrs: TList;
    m_SoundMgrs: TList;
  public                        
    constructor Create; override;
    destructor Destroy; override;
    property Volume: Single read m_Volume write SetVolume;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Audio END

//TG2Input BEGIN
  TG2Input = class sealed (TG2Engine)
  strict private
    m_DI: IDirectInput8;
    m_PlugTimer: TG2PlugTimer;
    m_KeyboardAquired: Boolean;
    m_MouseAquired: Boolean;
    m_Keyboard: IDirectInputDevice8;
    m_Mouse: IDirectInputDevice8;
    m_KeyState: array[0..255] of Boolean;
    m_MouseState: TDIMouseState;
    procedure Update;
    procedure KeyDown(const Key: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure KeyUp(const Key: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure MouseDown(const Button: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure MouseUp(const Button: Byte); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure MouseMove(const Shift: TPoint); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure WheelMove(const Shift: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    function GetKey(const Index: Byte): Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetButton(const Index: Byte): Boolean; {$IFDEF VER180}{$IFDEF G2_USE_INLINE} inline; {$ENDIF}{$ENDIF}
    function GetMousePos: TPoint; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMouseShift: TPoint; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWheelShift: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Input END

//TG2Network BEGIN
  TG2Network = class sealed (TG2Engine)
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Network END

//TG2Module BEGIN
  TG2Module = class (TG2HighClass)
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Module END

//TG2Plug BEGIN
  TG2Plug = class (TG2HighClass)
  strict private
    m_Engine: TG2Engine;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Engine: TG2Engine read m_Engine write m_Engine;
  end;
//TG2Plug END

//TG2PlugTimer BEGIN
  TG2PlugTimer = class sealed (TG2Plug)
  strict private
    m_OnTimer: TG2ProcObj;
    m_OnUpdate: TG2ProcObj;
    m_OnRender: TG2ProcObj;
  public
    constructor Create; override;
    destructor Destroy; override;
    property OnTimer: TG2ProcObj read m_OnTimer write m_OnTimer;
    property OnUpdate: TG2ProcObj read m_OnUpdate write m_OnUpdate;
    property OnRender: TG2ProcObj read m_OnRender write m_OnRender;
  end;
//TG2PlugTimer END

//TG2PlugGraphics BEGIN
  TG2PlugGraphics = class sealed (TG2Plug)
  strict private
    m_OnDeviceLost: TG2ProcObj;
    m_OnDeviceReset: TG2ProcObj;
    m_OnParamsChange: TG2ProcObj;
  public
    constructor Create; override;
    destructor Destroy; override;
    property OnDeviceLost: TG2ProcObj read m_OnDeviceLost write m_OnDeviceLost;
    property OnDeviceReset: TG2ProcObj read m_OnDeviceReset write m_OnDeviceReset;
    property OnParamsChange: TG2ProcObj read m_OnParamsChange write m_OnParamsChange;
  end;
//TG2PlugGraphics END

//TG2PlugAudio BEGIN
  TG2PlugAudio = class sealed (TG2Plug)
  public
    constructor Create; override;
    destructor Destroy; override;
  end;
//TG2PlugAudio END

//TG2PlugInput BEGIN
  TG2PlugInput = class sealed (TG2Plug)
  strict private
    m_Input: TG2Input;
    m_OnKeyDown: TG2InputKeyDown;
    m_OnKeyUp: TG2InputKeyUp;
    m_OnMouseDown: TG2InputMouseDown;
    m_OnMouseUp: TG2InputMouseUp;
    m_OnMouseMove: TG2InputMouseMove;
    m_OnWheelMove: TG2InputWheelMove;
    function GetKeyDown(const Index: Byte): Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMouseDown(const Index: Byte): Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMousePos: TPoint; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMouseShift: TPoint; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWheelShift: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    property OnKeyDown: TG2InputKeyDown read m_OnKeyDown write m_OnKeyDown;
    property OnKeyUp: TG2InputKeyUp read m_OnKeyUp write m_OnKeyUp;
    property OnMouseDown: TG2InputMouseDown read m_OnMouseDown write m_OnMouseDown;
    property OnMouseUp: TG2InputMouseUp read m_OnMouseUp write m_OnMouseUp;
    property OnMouseMove: TG2InputMouseMove read m_OnMouseMove write m_OnMouseMove;
    property OnWheelMove: TG2InputWheelMove read m_OnWheelMove write m_OnWheelMove;
    property KeyDown[const Index: Byte]: Boolean read GetKeyDown;
    property MouseDown[const Index: Byte]: Boolean read GetMouseDown;
    property MousePos: TPoint read GetMousePos;
    property MouseShift: TPoint read GetMouseShift;
    property WheelShift: Integer read GetWheelShift;
  end;
//TG2PlugInput END

//TG2PlugNetwork BEGIN
  TG2PlugNetwork = class sealed (TG2Plug)
  public
    constructor Create; override;
    destructor Destroy; override;
  end;
//TG2PlugNetwork END

//TG2ResMgr BEGIN
  TG2ResMgr = class (TG2Module)
  strict protected
    m_Resources: TList;
    function GetCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  protected
    function FindResourceIndex(const NameCache: DWord): Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function FindResource(const Name: AnsiString): TG2Res;
    procedure AddResource(const Res: TG2Res); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure RemoveResource(const Res: TG2Res); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure DeleteResource(const Index: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure FreeResources; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property Count: Integer read GetCount;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2ResMgr END

//TG2Res BEGIN
  TG2Res = class (TG2HighClass)
  strict private
    m_Name: AnsiString;
    procedure SetName(const Value: AnsiString);
  private
    m_NameCache: DWord;
    m_Mgrs: TList;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Name: AnsiString read m_Name write SetName;
  end;
//TG2Res END

//TG2MusicMgr BEGIN
  TG2MusicMgr = class sealed (TG2ResMgr)
  private
    procedure ResetVolume;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function FindMusic(const Name: AnsiString): TG2Music;
    function CreateMusic(const Name: AnsiString): TG2Music;
  end;
//TG2MusicMgr END

//TG2Music BEGIN
  TG2Music = class sealed (TG2Res)
  strict private
    m_G2Audio: TG2Audio;
    m_Graph: IGraphBuilder;
    m_Control: IMediaControl;
    m_Event: IMediaEventEx;
    m_Position: IMediaPosition;
    m_Seeking: IMediaSeeking;
    m_Filter: IMediaFilter;
    m_Audio: IBasicAudio;
    m_Open: Boolean;
    m_IsPlaying: Boolean;
    m_PlayTime: DWord;
    procedure ClearGraph;
    procedure SetPosition(const Value: Int64);
    function GetPosition: Int64;
    function GetDuration: Int64;
    procedure SetVolume(Value: Single);
    function GetVolume: Single;
    procedure SetPan(Value: Single);
    function GetPan: Single;
    procedure SetPlayRate(Value: Single);
    function GetPlayRate: Single;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Position: Int64 read GetPosition write SetPosition;
    property Duration: Int64 read GetDuration;
    property Volume: Single read GetVolume write SetVolume;
    property Pan: Single read GetPan write SetPan;
    property PlayRate: Single read GetPlayRate write SetPlayRate;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure OpenFile(const f: AnsiString);
    procedure Close;
    procedure Play;
    procedure Pause;
    procedure Stop;
    procedure Rewind;
    function IsPlaying: Boolean;
  end;
//TG2Music END

//TG2SoundMgr BEGIN
  TG2SoundMgr = class sealed (TG2ResMgr)
  private
    procedure ResetVolume;
  public                           
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function FindSound(const Name: AnsiString): TG2Sound;
    function CreateSound(const Name: AnsiString): TG2Sound;
  end;
//TG2SoundMgr END

//TG2Sound BEGIN
  TG2Sound = class sealed (TG2Res)
  strict private
    m_Buffer3D: IDirectSound3DBuffer8;
    m_Buffer: IDirectSoundBuffer;
    m_Listener: IDirectSound3DListener8;
    m_AudioPath: IDirectMusicAudioPath;
    m_Volume: Single;
    m_Frequency: DWORD;
    procedure SetVolume(Value: Single);
    procedure SetSoundPosition(Value: TG2Vec3);
    function GetSoundPosition: TG2Vec3;
    procedure SetSoundVelocity(Value: TG2Vec3);
    function GetSoundVelocity: TG2Vec3;
    procedure SetSoundDirection(Value: TG2Vec3);
    function GetSoundDirection: TG2Vec3;
    procedure SetListenerPosition(Value: TG2Vec3);
    function GetListenerPosition: TG2Vec3;
    procedure SetListenerVelocity(Value: TG2Vec3);
    function GetListenerVelocity: TG2Vec3;
    procedure SetListenerDirection(Value: TG2Vec3);
    function GetListenerDirection: TG2Vec3;
    procedure SetMinDistance(Value: Single);
    function GetMinDistance: Single;
    procedure SetMaxDistance(Value: Single);
    function GetMaxDistance: Single;
    procedure SetDistanceFactor(Value: Single);
    function GetDistanceFactor: Single;
    procedure SetDopplerFactor(Value: Single);
    function GetDopplerFactor: Single;
    procedure SetRollOffFactor(Value: Single);
    function GetRollOffFactor: Single;
    procedure SetPlayRate(Value: Single);
    function GetPlayRate: Single;
  private                     
    m_G2Audio: TG2Audio;
    m_Loaded: Boolean;
    m_Segment: IDirectMusicSegment8;
    m_Instances: TList;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Volume: Single read m_Volume write SetVolume;
    property SoundPosition: TG2Vec3 read GetSoundPosition write SetSoundPosition;
    property SoundVelocity: TG2Vec3 read GetSoundVelocity write SetSoundVelocity;
    property SoundDirection: TG2Vec3 read GetSoundDirection write SetSoundDirection;
    property ListenerPosition: TG2Vec3 read GetListenerPosition write SetListenerPosition;
    property ListenerVelocity: TG2Vec3 read GetListenerVelocity write SetListenerVelocity;
    property ListenerDirection: TG2Vec3 read GetListenerDirection write SetListenerDirection;
    property MinDistance: Single read GetMinDistance write SetMinDistance;
    property MaxDistance: Single read GetMaxDistance write SetMaxDistance;
    property DistanceFactor: Single read GetDistanceFactor write SetDistanceFactor;
    property DopplerFactor: Single read GetDopplerFactor write SetDopplerFactor;
    property RollOffFactor: Single read GetRollOffFactor write SetRollOffFactor;
    property PlayRate: Single read GetPlayRate write SetPlayRate;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure LoadFile(const f: AnsiString);
    procedure UnLoad;
    procedure Play;
    procedure Stop;
    function IsPlaying: Boolean;
    function CreateInstance: TG2SoundInst;
  end;
//TG2Sound END

//TG2SoundInst BEGIN
  TG2SoundInst = class sealed (TG2Class)
  strict private
    m_Buffer3D: IDirectSound3DBuffer8;
    m_Buffer: IDirectSoundBuffer;
    m_Listener: IDirectSound3DListener8;
    m_AudioPath: IDirectMusicAudioPath;
    m_Loaded: Boolean;
    m_Volume: Single;
    m_Frequency: DWORD;
    procedure SetVolume(Value: Single);
    procedure SetSoundPosition(Value: TG2Vec3);
    function GetSoundPosition: TG2Vec3;
    procedure SetSoundVelocity(Value: TG2Vec3);
    function GetSoundVelocity: TG2Vec3;
    procedure SetSoundDirection(Value: TG2Vec3);
    function GetSoundDirection: TG2Vec3;
    procedure SetListenerPosition(Value: TG2Vec3);
    function GetListenerPosition: TG2Vec3;
    procedure SetListenerVelocity(Value: TG2Vec3);
    function GetListenerVelocity: TG2Vec3;
    procedure SetListenerDirection(Value: TG2Vec3);
    function GetListenerDirection: TG2Vec3;
    procedure SetMinDistance(Value: Single);
    function GetMinDistance: Single;
    procedure SetMaxDistance(Value: Single);
    function GetMaxDistance: Single;
    procedure SetDistanceFactor(Value: Single);
    function GetDistanceFactor: Single;
    procedure SetDopplerFactor(Value: Single);
    function GetDopplerFactor: Single;
    procedure SetRollOffFactor(Value: Single);
    function GetRollOffFactor: Single;
    procedure SetPlayRate(Value: Single);
    function GetPlayRate: Single;
  private
    m_G2Sound: TG2Sound;
    procedure Initialize;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Volume: Single read m_Volume write SetVolume;
    property SoundPosition: TG2Vec3 read GetSoundPosition write SetSoundPosition;
    property SoundVelocity: TG2Vec3 read GetSoundVelocity write SetSoundVelocity;
    property SoundDirection: TG2Vec3 read GetSoundDirection write SetSoundDirection;
    property ListenerPosition: TG2Vec3 read GetListenerPosition write SetListenerPosition;
    property ListenerVelocity: TG2Vec3 read GetListenerVelocity write SetListenerVelocity;
    property ListenerDirection: TG2Vec3 read GetListenerDirection write SetListenerDirection;
    property MinDistance: Single read GetMinDistance write SetMinDistance;
    property MaxDistance: Single read GetMaxDistance write SetMaxDistance;
    property DistanceFactor: Single read GetDistanceFactor write SetDistanceFactor;
    property DopplerFactor: Single read GetDopplerFactor write SetDopplerFactor;
    property RollOffFactor: Single read GetRollOffFactor write SetRollOffFactor;
    property PlayRate: Single read GetPlayRate write SetPlayRate;
    procedure Play;
    procedure Stop;
    function IsPlaying: Boolean;
  end;
//TG2SoundInst END

//TG2TextureMgr BEGIN
  TG2TextureMgr = class sealed (TG2ResMgr)
  strict private
    m_PlugGraphics: TG2PlugGraphics;
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function CreateTexture2DFromFile(
      const Name: AnsiString;
      const f: AnsiString;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
    function CreateTexture2DFromStream(
      const Name: AnsiString;
      const s: TMemoryStream;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
    function CreateTexture2DFromBuffer(
      const Name: AnsiString;
      const b: Pointer;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
    function CreateTexture2DFromGraphic(
      const Name: AnsiString;
      const g: TGraphic;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
    function CreateTexture2DRenderTarget(
      const Name: AnsiString;
      const Width, Height: Integer
    ): TG2Texture2DRT;
    function CreateTexture2DVideo(
      const Name: AnsiString;
      const f: AnsiString
    ): TG2Texture2DVideo;
    function CreateCubeTextureFromFile(
      const Name: AnsiString;
      const f: AnsiString;
      const MipLevels: Integer = 1;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2TextureCube;
    procedure DeleteTexture(const Index: Integer);
    procedure RemoveTexture(const Texture: TG2TextureBase);
  end;
//TG2TextureMgr END

//TG2TextureBase BEGIN
  TG2TextureBase = class (TG2Res)
  strict protected
    m_G2Graphics: TG2Graphics;
    m_Levels: Integer;
    m_Format: TD3DFormat;
    function GetTexture: IDirect3DBaseTexture9; virtual; abstract;
  protected
    procedure OnDeviceLost; virtual;
    procedure OnDeviceReset; virtual;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Texture: IDirect3DBaseTexture9 read GetTexture;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure Release; virtual; abstract;
  end;
//TG2TextureBase END

//TG2Texture2DBase BEGIN
  TG2Texture2DBase = class (TG2TextureBase)
  strict private
    function GetDrawRect: PG2Rect;
  strict protected
    m_Texture: IDirect3DTexture9;
    m_Width: Integer;
    m_Height: Integer;
    m_RealWidth: Integer;
    m_RealHeight: Integer;
    m_DrawRect: TG2Rect;
    m_Desc: TD3DSurfaceDesc;
    function GetTexture: IDirect3DBaseTexture9; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Width: Integer read m_Width write m_Width;
    property Height: Integer read m_Height write m_Height;
    property RealWidth: Integer read m_RealWidth;
    property RealHeight: Integer read m_RealHeight;
    property DrawRect: PG2Rect read GetDrawRect;
    procedure Release; override;
  end;
//TG2Texture2DBase END

//TG2Texture2D BEGIN
  TG2Texture2D = class (TG2Texture2DBase)
  strict private
  type
    TG2Tex2SetPixelProc = procedure(const X, Y: Integer; const Value: TG2Color) of object;
    TG2Tex2GetPixelProc = function(const X, Y: Integer): TG2Color of object;
    TG2Tex2DLevelSurface = class (TObject)
    strict private
      m_Texture: TG2Texture2D;
      m_Width: Integer;
      m_Height: Integer;
      m_Level: Integer;
      m_Locked: Boolean;
      m_Desc: TD3DSurfaceDesc;
      m_Lock: TD3DLockedRect;
      m_ProcSetPixel: TG2Tex2SetPixelProc;
      m_ProcGetPixel: TG2Tex2GetPixelProc;
      function GetPixelA16B16G16R16(const X, Y: Integer): TG2Color;
      procedure SetPixelA16B16G16R16(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA2B10G10R10(const X, Y: Integer): TG2Color;
      procedure SetPixelA2B10G10R10(const X, Y: Integer; const Value: TG2Color);
      function GetPixelG16R16(const X, Y: Integer): TG2Color;
      procedure SetPixelG16R16(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA2R10G10B10(const X, Y: Integer): TG2Color;
      procedure SetPixelA2R10G10B10(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA8R3G3B2(const X, Y: Integer): TG2Color;
      procedure SetPixelA8R3G3B2(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA8(const X, Y: Integer): TG2Color;
      procedure SetPixelA8(const X, Y: Integer; const Value: TG2Color);
      function GetPixelR3G3B2(const X, Y: Integer): TG2Color;
      procedure SetPixelR3G3B2(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA1R5G5B5(const X, Y: Integer): TG2Color;
      procedure SetPixelA1R5G5B5(const X, Y: Integer; const Value: TG2Color);
      function GetPixelR5G6B5(const X, Y: Integer): TG2Color;
      procedure SetPixelR5G6B5(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA4R4G4B4(const X, Y: Integer): TG2Color;
      procedure SetPixelA4R4G4B4(const X, Y: Integer; const Value: TG2Color);
      function GetPixelR8G8B8(const X, Y: Integer): TG2Color;
      procedure SetPixelR8G8B8(const X, Y: Integer; const Value: TG2Color);
      function GetPixelA8R8G8B8(const X, Y: Integer): TG2Color;
      procedure SetPixelA8R8G8B8(const X, Y: Integer; const Value: TG2Color);
      function GetPixelDummy(const X, Y: Integer): TG2Color;
      procedure SetPixelDummy(const X, Y: Integer; const Value: TG2Color);
      function GetPixel(const X, Y: Integer): TG2Color;
      procedure SetPixel(const X, Y: Integer; const Value: TG2Color);
      function GetSurfaceDesc: PD3DSurfaceDesc;
      function GetLockedRect: PD3DLockedRect;
    public
      constructor Create(const Texture: TG2Texture2D; const Level: Integer);
      destructor Destroy; override;
      property Locked: Boolean read m_Locked;
      property SurfaceDesc: PD3DSurfaceDesc read GetSurfaceDesc;
      property LockedRect: PD3DLockedRect read GetLockedRect;
      property Width: Integer read m_Width;
      property Height: Integer read m_Height;
      property Pixels[const X, Y: Integer]: TG2Color read GetPixel write SetPixel;
      function Lock: TG2Result;
      function UnLock: TG2Result;
    end;
  var
    m_Surfaces: array of TG2Tex2DLevelSurface;
    procedure InitLevels;
    procedure UnInitLevels;
    function GetSurface(const SurfaceLevel: Integer): TG2Tex2DLevelSurface; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  strict protected                                              
    function MaxMipLevels(const Width, Height: Integer): Integer;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Surfaces[const SurfaceLevel: Integer]: TG2Tex2DLevelSurface read GetSurface;
    function LoadFromFile(
      const f: AnsiString;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
    function LoadFromStream(
      const s: TMemoryStream;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
    function LoadFromBuffer(
      const b: Pointer;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
    function LoadFromGraphic(
      const g: TGraphic;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
    procedure Release; override;
  end;
//TG2Texture2D END

//TG2Texture2DRT BEGIN
  TG2Texture2DRT = class (TG2Texture2DBase)
  strict private
    m_ViewPort: TD3DViewPort9;
    m_DepthStencil: IDirect3DSurface9;
    function GetViewPort: PD3DViewPort9;
  protected
    procedure OnDeviceLost; override;
    procedure OnDeviceReset; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    property ViewPort: PD3DViewPort9 read GetViewPort;
    property DepthStencil: IDirect3DSurface9 read m_DepthStencil;
    function MakeRenderTarget(
      const NewWidth, NewHeight: Integer;
      const NewFormat: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
    procedure Release; override;
  end;
//TG2Texture2DRT END

//TG2VMRAllocatorPresenter BEGIN
  TG2VMRAllocatorPresenter = class (TInterfacedObject, IVMRSurfaceAllocator9, IVMRImagePresenter9)
  private
    m_Texture: TG2Texture2DVideo;
    m_Surfaces: array of IDirect3DSurface9;
    m_SurfaceAllocatorNotify: IVMRSurfaceAllocatorNotify9;
    m_CriticalSection: TCriticalSection;
    m_AllocInfo: TVMR9AllocationInfo;
    m_SurfaceCount: DWord;
  protected
    function CreateSurfaces: HRESULT;
    function CreateTexture: HRESULT;
    procedure FreeSurfaces;
  public
    constructor Create(const Texture: TG2Texture2DVideo);
    destructor Destroy; override;
    function InitializeDevice(
      dwUserID: DWORD;
      lpAllocInfo: PVMR9AllocationInfo;
      var lpNumBuffers: DWORD
    ): HResult; stdcall;
    function TerminateDevice(
      dwID: DWORD
    ): HResult; stdcall;
    function GetSurface(
      dwUserID: DWORD;
      SurfaceIndex: DWORD;
      SurfaceFlags: DWORD;
      out lplpSurface: IDirect3DSurface9
    ): HResult; stdcall;
    function AdviseNotify(
      lpIVMRSurfAllocNotify: IVMRSurfaceAllocatorNotify9
    ): HResult; stdcall;
    function StartPresenting(
      dwUserID: DWORD
    ): HResult; stdcall;                  
    function StopPresenting(
      dwUserID: DWORD
    ): HResult; stdcall;
    function PresentImage(
      dwUserID: DWORD;
      lpPresInfo: PVMR9PresentationInfo
    ): HResult; stdcall;
  end;
//TG2VMRAllocatorPresenter END

//TG2Texture2DVideo BEGIN
  TG2Texture2DVideo = class (TG2Texture2DBase)
  strict private
    m_UsrID: DWORD;
    m_Graph: IGraphBuilder;
    m_Control: IMediaControl;
    m_Event: IMediaEventEx;
    m_Position: IMediaPosition;
    m_Seeking: IMediaSeeking;
    m_VMR: IBaseFilter;
    m_PinIn, m_PinOut: IPin;
    m_AllocatorPresenter: TG2VMRAllocatorPresenter;
    m_PrevPos: Int64;
    m_FName: AnsiString;
    m_Loaded: Boolean;
    function AddFilter(         
      CLSID: TGUID;
      FilterName: WideString
    ): IBaseFilter;
    procedure ClearGraph;
    procedure SetPosition(const Value: Int64);
    function GetPosition: Int64;
    function GetDuration: Int64;
  private
    property Loaded: Boolean read m_Loaded write m_Loaded;
    function MakeTexture(const NewWidth, NewHeight: Integer): TG2Result;
    function SetSurfaceAllocator: TG2Result;
  protected
    procedure OnDeviceLost; override;
    procedure OnDeviceReset; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Position: Int64 read GetPosition write SetPosition;
    property Duration: Int64 read GetDuration;
    function StreamFile(const f: AnsiString): TG2Result;
    procedure Play;
    procedure Pause;
    procedure Stop;
    procedure Rewind;
    function IsPlaying: Boolean;
    procedure Release; override;
  end;
//TG2Texture2DVideo END

//TG2TextureCubeBase BEGIN
  TG2TextureCubeBase = class (TG2TextureBase)
  strict protected
    m_Texture: IDirect3DCubeTexture9;
    m_Width: Integer;
    m_Height: Integer;
    m_Depth: Integer;
    function GetTexture: IDirect3DBaseTexture9; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure Release; override;
  end;
//TG2TextureCubeBase END

//TG2TextureCube BEGIN
  TG2TextureCube = class (TG2TextureCubeBase)
  public
    constructor Create; override;
    destructor Destroy; override;
    function LoadFromFile(
      const f: AnsiString;
      const MipLevels: Integer = 1;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
  end;
//TG2TextureCube END

//TG2FontMgr BEGIN
  TG2FontMgr = class sealed (TG2ResMgr)
  strict private
    function GetFont(const Index: Integer): TG2Font;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Fonts[const Index: Integer]: TG2Font read GetFont;
    function CreateFont(const Name: AnsiString; const FontFace: String; const Size: Integer): TG2Font;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2FontMgr END

//TG2Font BEGIN
  TG2Font = class (TG2Res)
  strict private
  type
    TCharProps = record
      Width: Integer;
      Height: Integer;
      OffsetX: Integer;
      OffsetY: Integer;
    end;
  var
    m_G2Graphics: TG2Graphics;
    m_Texture: TG2Texture2D;
    m_Props: array[Byte] of TCharProps;
    m_CharTU: Single;
    m_CharTV: Single;
    m_CharWidth: Integer;
    m_CharHeight: Integer;
    m_FontFace: String;
    m_Size: Integer;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Texture: TG2Texture2D read m_Texture;
    property FontFace: String read m_FontFace;
    property Size: Integer read m_Size;
    function MakeFont(const NewFontFace: String; const NewSize: Integer): TG2Result;
    function Print(const X, Y: Single; const Color: TG2Color; const Text: AnsiString): TG2Result;
    function GetTextWidth(const Text: AnsiString): Integer;
    function GetTextHeight(const Text: AnsiString): Integer;
    procedure Release;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Font END

//TG2MeshLoad BEGIN
  PG2MeshLoadNode = ^TG2MeshLoadNode;
  TG2MeshLoadNode = record
    Name: AnsiString;
    Pos: TG2Vec3;
    ParentID: Integer;
    GeomID: Integer;
  end;

  PG2MeshLoadAnimKeyFrame = ^TG2MeshLoadAnimKeyFrame;
  TG2MeshLoadAnimKeyFrame = record
    FrameTime: Integer;
    FrameScaling: TG2Vec3;
    FrameTranslation: TG2Vec3;
    FrameRotation: TG2Quat;
    Transform: TG2Mat;
  end;

  PG2MeshLoadAnimNode = ^TG2MeshLoadAnimNode;
  TG2MeshLoadAnimNode = record
    NodeID: Integer;
    KeyFrameCount: Integer;
    KeyFrames: array of TG2MeshLoadAnimKeyFrame;
  end;

  PG2MeshLoadAnim = ^TG2MeshLoadAnim;
  TG2MeshLoadAnim = record
    Name: AnsiString;
    AnimStart: Integer;
    AnimEnd: Integer;
    AnimNodes: array of TG2MeshLoadAnimNode;
  end;

  PG2MeshLoadGeomFace = ^TG2MeshLoadGeomFace;
  TG2MeshLoadGeomFace = record
    FacePositions: array[0..2] of Integer;
    FaceTexCoords: array[0..2] of Integer;
    FaceGroup: Integer;
    FaceMaterial: Integer;
  end;

  PG2MeshLoadGeomVertex = ^TG2MeshLoadGeomVertex;
  TG2MeshLoadGeomVertex = record
    PositionID: Integer;
    TexCoordsID: Integer;
    GroupID: Integer;
    Normal: TG2Vec3;
    Tangent: TG2Vec3;
    Binormal: TG2Vec3;
  end;

  PG2MeshLoadGeom = ^TG2MeshLoadGeom;
  TG2MeshLoadGeom = record
    VCount: Integer;
    TVCount: Integer;
    FCount: Integer;
    MCount: Integer;
    Positions: array of TG2Vec3;
    TexCoords: array of TG2Vec3;
    Materials: array of Integer;
    Faces: array of TG2MeshLoadGeomFace;
    Vertices: array of TG2MeshLoadGeomVertex;
    Indices: array of DWord;
    SkinID: Integer;
    OptPreNormal: Boolean;
    OptPreTangent: Boolean;
  end;

  PG2MeshLoadSkinVertex = ^TG2MeshLoadSkinVertex;
  TG2MeshLoadSkinVertex = record
    BoneCount: Integer;
    BoneIndices: array of Integer;
    BoneWeights: array of Single;
  end;

  PG2MeshLoadSkin = ^TG2MeshLoadSkin;
  TG2MeshLoadSkin = record
    GeomID: Integer;
    BoneCount: Integer;
    Bones: array of Integer;
    Vertices: array of TG2MeshLoadSkinVertex;
  end;

  PG2MeshLoadMaterial = ^TG2MeshLoadMaterial;
  TG2MeshLoadMaterial = record
    Name: AnsiString;
  end;

  PG2MeshLoad = ^TG2MeshLoad;
  TG2MeshLoad = record
    NodeCount: Integer;
    Nodes: array of TG2MeshLoadNode;
    AnimCount: Integer;
    Anims: array of TG2MeshLoadAnim;
    GeomCount: Integer;
    Geoms: array of TG2MeshLoadGeom;
    SkinCount: Integer;
    Skins: array of TG2MeshLoadSkin;
    MaterialCount: Integer;
    Materials: array of TG2MeshLoadMaterial;
  end;
//TG2MeshLoad END

//TG2MeshMgr BEGIN
  TG2MeshMgr = class (TG2ResMgr)
  public
    constructor Create; override;
    destructor Destroy; override;
    function CreateMeshFromFile(const Name: AnsiString; const f: String; const Mode: TG2MeshMode = mmFF): TG2Mesh;
  end;
//TG2MeshMgr END

//TG2Mesh BEGIN
  TG2Mesh = class (TG2Res)
  strict private
    m_Mode: TG2MeshMode;
    m_Nodes: array of TG2MeshNode;
    m_Anims: array of TG2MeshAnim;
    m_Geoms: array of TG2MeshGeom;
    m_Skins: array of TG2MeshSkin;
    m_Materials: array of TG2MeshMaterial;
    m_Instances: TG2List;
    function GetNodeCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetNode(const Index: Integer): TG2MeshNode; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAnimCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAnim(const Index: Integer): TG2MeshAnim; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetGeomCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetGeom(const Index: Integer): TG2MeshGeom; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSkinCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSkin(const Index: Integer): TG2MeshSkin; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaterialCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaterial(const Index: Integer): TG2MeshMaterial; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mode: TG2MeshMode read m_Mode write m_Mode;
    property NodeCount: Integer read GetNodeCount;
    property Nodes[const Index: Integer]: TG2MeshNode read GetNode;
    property AnimCount: Integer read GetAnimCount;
    property Anims[const Index: Integer]: TG2MeshAnim read GetAnim;
    property GeomCount: Integer read GetGeomCount;
    property Geoms[const Index: Integer]: TG2MeshGeom read GetGeom;
    property SkinCount: Integer read GetSkinCount;
    property Skins[const Index: Integer]: TG2MeshSkin read GetSkin;
    property MaterialCount: Integer read GetMaterialCount;
    property Materials[const Index: Integer]: TG2MeshMaterial read GetMaterial;
    property Instances: TG2List read m_Instances;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function MaterialID(const Name: AnsiString; const MatchCase: Boolean = True): Integer;
    function LoadData(const MeshData: PG2MeshLoad): Boolean;
    function LoadFromFile(const f: String; const LoaderClass: CG2MeshLoaderClass): TG2Result;
    procedure Release;
    function CreateInstance: TG2MeshInstance;
  end;
//TG2Mesh END

//TG2MeshInstance BEGIN
  PG2MeshInstance = ^TG2MeshInstance;
  TG2MeshInstance = class (TG2Class)
  strict private
    m_Mesh: TG2Mesh;
    m_Scales: array of TG2Vec3;
    m_Rotations: array of TG2Quat;
    m_Translations: array of TG2Vec3;
    m_Transforms: array of TG2Mat;
    m_SkinTransformPointers: array of array of PD3DXMatrix;
    m_Effect: TG2Effect;
    m_VS: TG2VertexShader;
    m_PS: TG2PixelShader;
    m_AnimID: Integer;
    m_Transform: TG2Mat;
    m_RenderProc: TG2ProcObj;
    m_SWGeoms: array of ID3DXMesh;
    procedure SetMesh(const Value: TG2Mesh);
    procedure SetTransform(const Index: Integer; const Value: TG2Mat); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTransform(const Index: Integer): TG2Mat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSkinTransformPointers(const Index: Integer): PPD3DXMatrix; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure GenerateNodeMatrix(const NodeID: Integer);
    procedure UpdateSWGeoms;
    procedure RenderSW;
    procedure RenderFF;
    procedure RenderSM3HLSL;
    procedure RenderSM3ASM;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mesh: TG2Mesh read m_Mesh write SetMesh;
    property Transforms[const Index: Integer]: TG2Mat read GetTransform write SetTransform;
    property Transform: TG2Mat read m_Transform write m_Transform;
    property SkinTransformPointers[const Index: Integer]: PPD3DXMatrix read GetSkinTransformPointers;
    procedure Render;
    procedure AnimationSet(const AnimName: AnsiString; const MatchCase: Boolean = True);
    procedure FrameSet(const FrameIndex: Single);
  end;
//TG2MeshInstance END

//TG2MeshNode BEGIN
  TG2MeshNode = class (TG2Class)
  strict private
    m_Mesh: TG2Mesh;
    m_Pos: TG2Vec3;
    m_IndexID: Integer;
    m_ParentID: Integer;
    m_GeomID: Integer;
    m_ChildIDs: array of Integer;
    function GetPos: PG2Vec3; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetChildCount(const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetChildCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetChildID(const Index: Integer; const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetChildID(const Index: Integer): Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mesh: TG2Mesh read m_Mesh write m_Mesh;
    property Pos: PG2Vec3 read GetPos;
    property IndexID: Integer read m_IndexID write m_IndexID;
    property ParentID: Integer read m_ParentID write m_ParentID;
    property GeomID: Integer read m_GeomID write m_GeomID;
    property ChildCount: Integer read GetChildCount write SetChildCount;
    property ChildIDs[const Index: Integer]: Integer read GetChildID write SetChildID;
    procedure AddChild(const ID: Integer);
  end;
//TG2MeshNode END

//TG2MeshGeom BEGIN
  TG2MeshGeom = class (TG2Class)
  strict private
  var
    m_Mesh: TG2Mesh;
    m_Geom: ID3DXMesh;
    m_NodeID: Integer;
    m_SkinID: Integer;
    m_MaterialIDs: array of Integer;
    m_Skinned: Boolean;
    m_Effect: TG2Effect;
    m_Technique: TD3DXHandle;
    m_Decl: IDirect3DVertexDeclaration9;
    procedure SetMaterialCount(const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaterialCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMaterialID(const Index: Integer; const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaterialID(const Index: Integer): Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure InitMeshSW(const GeomData: PG2MeshLoadGeom);
    procedure InitMeshFF(const GeomData: PG2MeshLoadGeom);
    procedure InitMeshSM3(const GeomData: PG2MeshLoadGeom);
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mesh: TG2Mesh read m_Mesh write m_Mesh;
    property Geom: ID3DXMesh read m_Geom write m_Geom;
    property Decl: IDirect3DVertexDeclaration9 read m_Decl;
    property NodeID: Integer read m_NodeID write m_NodeID;
    property SkinID: Integer read m_SkinID write m_SkinID;
    property Technique: TD3DXHandle read m_Technique;
    property MaterialCount: Integer read GetMaterialCount write SetMaterialCount;
    property MaterialIDs[const Index: Integer]: Integer read GetMaterialID write SetMaterialID;
    property Skinned: Boolean read m_Skinned;
    procedure InitMesh(const GeomData: PG2MeshLoadGeom);
    procedure Release;
  end;
//TG2MeshGeom END

//TG2MeshSkin BEGIN
  TG2MeshSkin = class (TG2Class)
  private
  type
    PG2SkinVertex = ^TG2SkinVertex;
    TG2SkinVertex = record
      BoneCount: Integer;
      BoneIndices: array of Integer;
      BoneWeights: array of Single;
    end;
  strict private
    m_Mesh: TG2Mesh;
    m_GeomID: Integer;
    m_Bones: array of Integer;
    m_SkinVertices: array of TG2SkinVertex;
    procedure SetBoneCount(const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBoneCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBone(const Index: Integer; const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBone(const Index: Integer): Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSkinVertexCount(const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSkinVertexCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSkinVertex(const Index: Integer): PG2SkinVertex; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mesh: TG2Mesh read m_Mesh write m_Mesh;
    property GeomID: Integer read m_GeomID write m_GeomID;
    property BoneCount: Integer read GetBoneCount write SetBoneCount;
    property Bones[const Index: Integer]: Integer read GetBone write SetBone;
    property SkinVertexCount: Integer read GetSkinVertexCount write SetSkinVertexCount;
    property SkinVertices[const Index: Integer]: PG2SkinVertex read GetSkinVertex;
  end;
//TG2MeshSkin END

//TG2MeshAnim BEGIN
  TG2MeshAnim = class (TG2Class)
  private
  type
    TG2AnimFrame = record
      Scale: TG2Vec3;
      Rotation: TG2Quat;
      Translation: TG2Vec3;
    end;
    PG2AnimNode = ^TG2AnimNode;
    TG2AnimNode = record
      NodeID: Integer;
      Frames: array of TG2AnimFrame;
    end;
  strict private
    m_Mesh: TG2Mesh;
    m_Name: AnsiString;
    m_AnimStart: Integer;
    m_AnimEnd: Integer;
    m_AnimNodes: array of TG2AnimNode;
    procedure SetAnimNodeCount(const Value: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAnimNodeCount: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAnimNode(const Index: Integer): PG2AnimNode; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mesh: TG2Mesh read m_Mesh write m_Mesh;
    property Name: AnsiString read m_Name write m_Name;
    property AnimStart: Integer read m_AnimStart write m_AnimStart;
    property AnimEnd: Integer read m_AnimEnd write m_AnimEnd;
    property AnimNodeCount: Integer read GetAnimNodeCount write SetAnimNodeCount;
    property AnimNodes[const Index: Integer]: PG2AnimNode read GetAnimNode;
  end;
//TG2MeshAnim END

//TG2MeshMaterial BEGIN
  TG2MeshMaterial = class (TG2Class)
  strict private
    m_Mesh: TG2Mesh;
    m_Name: AnsiString;
    m_Diffuse: TG2TextureBase;
    m_Specular: TG2TextureBase;
    m_Normals: TG2TextureBase;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Mesh: TG2Mesh read m_Mesh write m_Mesh;
    property Name: AnsiString read m_Name write m_Name;
    property Diffuse: TG2TextureBase read m_Diffuse write m_Diffuse;
    property Specular: TG2TextureBase read m_Specular write m_Specular;
    property Normals: TG2TextureBase read m_Normals write m_Normals;
  end;
//TG2MeshMaterial END

//TG2MeshLoader BEGIN
  TG2MeshLoader = class (TG2Class)
  strict protected
    m_Stream: TStream;
    procedure LoadProc(const s: TStream; const MeshData: PG2MeshLoad); virtual; abstract;
    function ReadString: AnsiString;
    function ReadQuaternion: TG2Quat; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadVector3: TG2Vec3; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadVector2: TG2Vec2; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadInteger: Integer; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadFloat: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadDWord: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadWord: Word; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadSmallInt: SmallInt; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadByte: Byte; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadShortInt: ShortInt; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function ReadBoolean: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure Advance(const Count: Integer); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    class function GetDifinition: AnsiString; virtual;
    class function CanLoadFile(const f: String): Boolean; virtual;
    class function CanLoadStream(const s: TStream): Boolean; virtual;
    procedure LoadFile(const f: String; const MeshData: PG2MeshLoad);
    procedure LoadStream(const s: TStream; const MeshData: PG2MeshLoad);
  end;
//TG2MeshLoader END

//TG2Shared BEGIN
  TG2Shared = class (TG2Module)
  strict private
    m_VBMgr: TG2VBMgr;
    m_IBMgr: TG2IBMgr;
    m_FontMgr: TG2FontMgr;
    m_LastVBID: DWord;
    m_LastIBID: DWord;
    m_LastFontID: DWord;
  public
    constructor Create; override;
    destructor Destroy; override;
    function RequestVB(
      const NewStride: DWord;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFVF: DWord;
      const NewPool: TD3DPool
    ): TG2VB;
    function RequestIB(
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFormat: TD3DFormat;
      const NewPool: TD3DPool
    ): TG2IB;
    function RequestFont(
      const FontFace: String;
      const Size: Integer
    ): TG2Font;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Shared END

//TG2VBMgr BEGIN
  TG2VBMgr = class (TG2ResMgr)
  strict private
    m_PlugGraphics: TG2PlugGraphics;
    procedure OnDeviceLost;
    procedure OnDeviceReset;
    function GetVB(const Index: Integer): TG2VB; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property VertexBuffers[const Index: Integer]: TG2VB read GetVB;
    function CreateVertexBuffer(
      const Name: AnsiString;
      const NewStride: DWord;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFVF: DWord;
      const NewPool: TD3DPool
    ): TG2VB;
    function FindVB(const Name: AnsiString): TG2VB;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2VBMgr END

//TG2VB BEGIN
  TG2VB = class (TG2Res)
  strict private
    m_Graphics: TG2Graphics;
    m_VB: IDirect3DVertexBuffer9;
    m_Stride: DWord;
    m_Size: DWord;
    m_Usage: DWord;
    m_FVF: DWord;
    m_Pool: TD3DPool;
    m_Suspended: Boolean;
    function InitializeVB: Boolean;
  private
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    property VB: IDirect3DVertexBuffer9 read m_VB;
    property Stride: DWord read m_Stride;
    property Size: DWord read m_Size;
    property Usage: DWord read m_Usage;
    property FVF: DWord read m_FVF;
    property Pool: TD3DPool read m_Pool;
    function Verify(
      const NewStride: DWord;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFVF: DWord;
      const NewPool: TD3DPool
    ): Boolean;
    function Lock(const LockOffset, LockSize: DWord; var Data: Pointer; const LockFlags: DWord = 0): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function UnLock: HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure Release;
    procedure SetToDevice;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2VB END

//TG2IBMgr BEGIN
  TG2IBMgr = class (TG2ResMgr)
  strict private
    m_PlugGraphics: TG2PlugGraphics;
    procedure OnDeviceLost;
    procedure OnDeviceReset;
    function GetIB(const Index: Integer): TG2IB; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property IndexBuffers[const Index: Integer]: TG2IB read GetIB;
    function CreateIndexBuffer(
      const Name: AnsiString;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFormat: TD3DFormat;
      const NewPool: TD3DPool
    ): TG2IB;
    function FindIB(const Name: AnsiString): TG2IB;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2IBMgr END

//TG2IB BEGIN
  TG2IB = class (TG2Res)
  strict private
    m_Graphics: TG2Graphics;
    m_IB: IDirect3DIndexBuffer9;
    m_Size: DWord;
    m_Usage: DWord;
    m_Format: TD3DFormat;
    m_Pool: TD3DPool;
    m_Suspended: Boolean;
    function InitializeIB: Boolean;
  private
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    property IB: IDirect3DIndexBuffer9 read m_IB;
    property Size: DWord read m_Size;
    property Usage: DWord read m_Usage;
    property Format: TD3DFormat read m_Format;
    property Pool: TD3DPool read m_Pool;
    function Verify(
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFormat: TD3DFormat;
      const NewPool: TD3DPool
    ): Boolean;
    function Lock(const LockOffset, LockSize: DWord; var Data: Pointer; const Flags: DWord = 0): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function UnLock: HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure Release;
    procedure SetToDevice;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2IB END

//TG2ScriptMgr BEGIN
  TG2ScriptMgr = class (TG2ResMgr)
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2ScriptMgr END

//TG2Script BEGIN
  TG2Script = class (TG2Res)
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Script END

//TG2GUI BEGIN
  TG2GUI = class (TG2Module)
  strict private
    m_Root: TG2GUIWindow;
    m_Focus: TG2GUIWindow;
    m_PlugInput: TG2PlugInput;
  private
    property PlugInput: TG2PlugInput read m_PlugInput;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Root: TG2GUIWindow read m_Root;
    property Focus: TG2GUIWindow read m_Focus write m_Focus;
    procedure WindowCreate(const WindowClass: CG2GUIWindowClass; const Parent: TG2GUIWindow; var Window);
    procedure WindowDestroy(var Window: TG2GUIWindow);
    procedure Render;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2GUI END

//TG2GUIWindow BEGIN
  TG2GUIWindow = class (TG2HighClass)
  strict private
  type
    TVertex0 = packed record
      x, y, z, rhw: Single;
      Col: TG2Color;
    end;
    TVertex0Array = array[Word] of TVertex0;
    PVertex0Array = ^TVertex0Array;
    TIndexArray = array[Word] of Word;
    PIndexArray = ^TIndexArray;
  const
    FVF0 = D3DFVF_XYZRHW or D3DFVF_DIFFUSE;
  var
    m_GUI: TG2GUI;
    m_Parent: TG2GUIWindow;
    m_Children: TG2List;
    m_X: Integer;
    m_Y: Integer;
    m_W: Integer;
    m_H: Integer;
    m_MarginLeft: Integer;
    m_MarginTop: Integer;
    m_MarginRight: Integer;
    m_MarginBottom: Integer;
    m_DownInRect: Boolean;
    m_OnMouseDown: TG2InputMouseDown;
    m_OnMouseUp: TG2InputMouseUp;
    m_OnMouseClick: TG2ProcObj;
    m_OnMouseMove: TG2InputMouseMove;
    m_OnWheelMove: TG2InputWheelMove;
    m_OnKeyDown: TG2InputKeyDown;
    m_OnKeyUp: TG2InputKeyUp;
    procedure SetParent(const Value: TG2GUIWindow); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetRect(const Value: TRect); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetRect: TRect; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetClientRect(const Value: TRect); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetClientRect: TRect; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDrawRect: TRect; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetClientDrawRect: TRect; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFocused: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    procedure MouseDown(const Button: Byte);
    procedure MouseUp(const Button: Byte);
    procedure MouseClick;
    procedure MouseMove(const Shift: TPoint);
    procedure MouseWheel(const Shift: Integer);
    procedure KeyDown(const Key: Byte);
    procedure KeyUp(const Key: Byte);
  strict protected
    m_VB0: TG2VB;
    m_IB: TG2IB;
    property OnMouseDown: TG2InputMouseDown read m_OnMouseDown write m_OnMouseDown;
    property OnMouseUp: TG2InputMouseUp read m_OnMouseUp write m_OnMouseUp;
    property OnMouseClick: TG2ProcObj read m_OnMouseClick write m_OnMouseClick;
    property OnMouseMove: TG2InputMouseMove read m_OnMouseMove write m_OnMouseMove;
    property OnWheelMove: TG2InputWheelMove read m_OnWheelMove write m_OnWheelMove;
    property OnKeyDown: TG2InputKeyDown read m_OnKeyDown write m_OnKeyDown;
    property OnKeyUp: TG2InputKeyUp read m_OnKeyUp write m_OnKeyUp;
    function GetGlobalRect: TRect; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure PreRender;
    procedure Render; virtual;
    procedure PostRender;
    procedure RenderBox(
      const DrawRect: TRect;
      const Lowered: Boolean = False;
      const ColNormal: DWord = $ffcccccc;
      const ColHighlight: DWord = $ffffffff;
      const ColShadow: DWord = $ff555555
    );
    function IsPressed: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function IsMouseOver: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function IsMouseDown: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure CustomMouseDown(const Button: Byte); virtual;
    procedure CustomMouseUp(const Button: Byte); virtual;
    procedure CustomMouseClick; virtual;
    procedure CustomMouseMove(const Shift: TPoint); virtual;
    procedure CustomMouseWheel(const Shift: Integer); virtual;
    procedure CustomKeyDown(const Key: Byte); virtual;
    procedure CustomKeyUp(const Key: Byte); virtual;
  public
    constructor Create; override;
    destructor Destroy; override;
    property GUI: TG2GUI read m_GUI write m_GUI;
    property Parent: TG2GUIWindow read m_Parent write SetParent;
    property X: Integer read m_X write m_X;
    property Y: Integer read m_Y write m_Y;
    property W: Integer read m_W write m_W;
    property H: Integer read m_H write m_H;
    property MarginLeft: Integer read m_MarginLeft write m_MarginLeft;
    property MarginTop: Integer read m_MarginTop write m_MarginTop;
    property MarginRight: Integer read m_MarginRight write m_MarginRight;
    property MarginBottom: Integer read m_MarginBottom write m_MarginBottom;
    property Rect: TRect read GetRect write SetRect;
    property ClientRect: TRect read GetClientRect write SetClientRect;
    property DrawRect: TRect read GetDrawRect;
    property ClientDrawRect: TRect read GetClientDrawRect;
    property Focused: Boolean read GetFocused;
    procedure Draw; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2GUIWindow END

//TG2GUIPanel BEGIN
  TG2GUIPanel = class (TG2GUIWindow)
  strict protected
    procedure Render; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2GUIPanel END

//TG2GUIButton BEGIN
  TG2GUIButton = class (TG2GUIWindow)
  strict private
    m_Caption: AnsiString;
    m_Font: TG2Font;
    m_FontColor: TG2Color;
  strict protected
    procedure Render; override;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Caption: AnsiString read m_Caption write m_Caption;
    property Font: TG2Font read m_Font write m_Font;
    property FontColor: TG2Color read m_FontColor write m_FontColor;
    property OnMouseClick;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2GUIButton END

//TG2MeshRender BEGIN
  TG2MeshRender = class (TG2Module)
  strict private
    m_Effect: TG2Effect;
    m_VS: TG2VertexShader;
    m_PS: TG2PixelShader;
    m_HndW: TD3DXHandle;
    m_HndWV: TD3DXHandle;
    m_HndWVP: TD3DXHandle;
    m_HndSkinPallete: TD3DXHandle;
    m_HndLightAmbient: TD3DXHandle;
    m_HndLightCountPoint: TD3DXHandle;
    m_HndLightPosPoint: TD3DXHandle;
    m_HndLightColorPoint: TD3DXHandle;
    m_HndLightRangePoint: TD3DXHandle;
    m_HndLightCountDirectional: TD3DXHandle;
    m_HndLightDirDirectional: TD3DXHandle;
    m_HndLightColorDirectional: TD3DXHandle;
    m_HndTexDiffuse: TD3DXHandle;
    m_HndTexSpecular: TD3DXHandle;
    m_HndTexNormals: TD3DXHandle;
    procedure SetGlobals;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure RenderArraySM3HLSL(const FirstInstance: PG2MeshInstance; const Count: Integer);
    procedure RenderArraySM3ASM(const FirstInstance: PG2MeshInstance; const Count: Integer);
  end;
//TG2MeshRender END

//TG2RenderStates BEGIN
  TG2RenderStates = class (TG2Class)
  strict private
    m_States: array[0..255] of DWord;
    function GetBoolean(const StateType: TD3DRenderStateType): Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBoolean(const StateType: TD3DRenderStateType; const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDWord(const StateType: TD3DRenderStateType): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDWord(const StateType: TD3DRenderStateType; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSingle(const StateType: TD3DRenderStateType): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSingle(const StateType: TD3DRenderStateType; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetZEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetZEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFillMode: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFillMode(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetShadeMode: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetShadeMode(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetZWriteEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetZWriteEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaTestEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaTestEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetLastPixel: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetLastPixel(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSrcBlend: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSrcBlend(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDestBlend: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDestBlend(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetCullMode: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetCullMode(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetZFunc: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetZFunc(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaRef: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaRef(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaFunc: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaFunc(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDitherEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDitherEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaBlendEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaBlendEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSpecularEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSpecularEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogColor: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogColor(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogTableMode: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogTableMode(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogVertexMode: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogVertexMode(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogStart: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogStart(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogEnd: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogEnd(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFogDensity: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetFogDensity(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetRangeFogEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetRangeFogEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilFail: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilFail(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilZFail: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilZFail(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilPass: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilPass(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilFunc: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilFunc(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilRef: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilRef(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilMask: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilMask(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetStencilWriteMask: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetStencilWriteMask(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTwoSidedStencilMode: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetTwoSidedStencilMode(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetCCWStencilFail: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetCCWStencilFail(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetCCWStencilZFail: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetCCWStencilZFail(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetCCWStencilPass: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetCCWStencilPass(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetCCWStencilFunc: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetCCWStencilFunc(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTextureFactor: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetTextureFactor(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap0: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap0(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap1: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap1(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap2: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap2(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap3: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap3(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap4: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap4(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap5: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap5(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap6: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap6(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap7: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap7(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap8: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap8(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap9: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap9(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap10: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap10(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap11: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap11(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap12: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap12(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap13: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap13(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap14: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap14(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetWrap15: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetWrap15(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetClipping: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetClipping(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetLighting: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetLighting(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAmbient: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAmbient(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorVertex: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorVertex(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetLocalViewer: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetLocalViewer(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetNormalizeNormals: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetNormalizeNormals(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDiffuseMaterialSource: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDiffuseMaterialSource(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSpecularMaterialSource: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSpecularMaterialSource(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAmbientMaterialSource: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAmbientMaterialSource(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetEmissiveMaterialSource: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetEmissiveMaterialSource(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVertexBlend: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetVertexBlend(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetClipPlaneEnable: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetClipPlaneEnable(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointSize: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointSize(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointSizeMin: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointSizeMin(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointSizeMax: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointSizeMax(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointSpriteEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointSpriteEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointScaleEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointScaleEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointScaleA: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointScaleA(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointScaleB: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointScaleB(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPointScaleC: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPointScaleC(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMultisampleAntialias: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMultisampleAntialias(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMultisampleMask: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMultisampleMask(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPatchEdgeStyle: TD3DPatchEdgeStyle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPatchEdgeStyle(const Value: TD3DPatchEdgeStyle); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDebugMonitorToken: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDebugMonitorToken(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetIndexedVertexBlendEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetIndexedVertexBlendEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorWriteEnable: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorWriteEnable(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTweenFactor: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetTweenFactor(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBlendOp: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBlendOp(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPositionDegree: TD3DDegreeType; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetPositionDegree(const Value: TD3DDegreeType); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetNormalDegree: TD3DDegreeType; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetNormalDegree(const Value: TD3DDegreeType); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetScissorTestEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetScissorTestEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSlopeScaleDepthBias: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSlopeScaleDepthBias(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAntialiasedLineEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAntialiasedLineEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMinTessellationLevel: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMinTessellationLevel(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaxTessellationLevel: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMaxTessellationLevel(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAdaptiveTessX: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAdaptiveTessX(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAdaptiveTessY: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAdaptiveTessY(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAdaptiveTessZ: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAdaptiveTessZ(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAdaptiveTessW: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAdaptiveTessW(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetEnableAdaptiveTessellation: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetEnableAdaptiveTessellation(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorWriteEnable1: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorWriteEnable1(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorWriteEnable2: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorWriteEnable2(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorWriteEnable3: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorWriteEnable3(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBlendFactor: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBlendFactor(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSRGBWriteEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSRGBWriteEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDepthBias: Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDepthBias(const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSeparateAlphaBlendEnable: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSeparateAlphaBlendEnable(const Value: Boolean); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSrcBlendAlpha: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSrcBlendAlpha(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDestBlendAlpha: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDestBlendAlpha(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBlendOpAlpha: DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBlendOpAlpha(const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    m_G2Graphics: TG2Graphics;
  public
    constructor Create; override;
    destructor Destroy; override;
    property ZEnable: Boolean read GetZEnable write SetZEnable;
    property FillMode: DWord read GetFillMode write SetFillMode;
    property ShadeMode: DWord read GetShadeMode write SetShadeMode;
    property ZWriteEnable: Boolean read GetZWriteEnable write SetZWriteEnable;
    property AlphaTestEnable: Boolean read GetAlphaTestEnable write SetAlphaTestEnable;
    property LastPixel: Boolean read GetLastPixel write SetLastPixel;
    property SrcBlend: DWord read GetSrcBlend write SetSrcBlend;
    property DestBlend: DWord read GetDestBlend write SetDestBlend;
    property CullMode: DWord read GetCullMode write SetCullMode;
    property ZFunc: DWord read GetZFunc write SetZFunc;
    property AlphaRef: DWord read GetAlphaRef write SetAlphaRef;
    property AlphaFunc: DWord read GetAlphaFunc write SetAlphaFunc;
    property DitherEnable: Boolean read GetDitherEnable write SetDitherEnable;
    property AlphaBlendEnable: Boolean read GetAlphaBlendEnable write SetAlphaBlendEnable;
    property FogEnable: Boolean read GetFogEnable write SetFogEnable;
    property SpecularEnable: Boolean read GetSpecularEnable write SetSpecularEnable;
    property FogColor: DWord read GetFogColor write SetFogColor;
    property FogTableMode: DWord read GetFogTableMode write SetFogTableMode;
    property FogVertexMode: DWord read GetFogVertexMode write SetFogVertexMode;
    property FogStart: Single read GetFogStart write SetFogStart;
    property FogEnd: Single read GetFogEnd write SetFogEnd;
    property FogDensity: Single read GetFogDensity write SetFogDensity;
    property RangeFogEnable: Boolean read GetRangeFogEnable write SetRangeFogEnable;
    property StencilEnable: Boolean read GetStencilEnable write SetStencilEnable;
    property StencilFail: DWord read GetStencilFail write SetStencilFail;
    property StencilZFail: DWord read GetStencilZFail write SetStencilZFail;
    property StencilPass: DWord read GetStencilPass write SetStencilPass;
    property StencilFunc: DWord read GetStencilFunc write SetStencilFunc;
    property StencilRef: DWord read GetStencilRef write SetStencilRef;
    property StencilMask: DWord read GetStencilMask write SetStencilMask;
    property StencilWriteMask: DWord read GetStencilWriteMask write SetStencilWriteMask;
    property TwoSidedStencilMode: Boolean read GetTwoSidedStencilMode write SetTwoSidedStencilMode;
    property CCWStencilFail: DWord read GetCCWStencilFail write SetCCWStencilFail;
    property CCWStencilZFail: DWord read GetCCWStencilZFail write SetCCWStencilZFail;
    property CCWStencilPass: DWord read GetCCWStencilPass write SetCCWStencilPass;
    property CCWStencilFunc: DWord read GetCCWStencilFunc write SetCCWStencilFunc;
    property TextureFactor: DWord read GetTextureFactor write SetTextureFactor;
    property Wrap0: DWord read GetWrap0 write SetWrap0;
    property Wrap1: DWord read GetWrap1 write SetWrap1;
    property Wrap2: DWord read GetWrap2 write SetWrap2;
    property Wrap3: DWord read GetWrap3 write SetWrap3;
    property Wrap4: DWord read GetWrap4 write SetWrap4;
    property Wrap5: DWord read GetWrap5 write SetWrap5;
    property Wrap6: DWord read GetWrap6 write SetWrap6;
    property Wrap7: DWord read GetWrap7 write SetWrap7;
    property Wrap8: DWord read GetWrap8 write SetWrap8;
    property Wrap9: DWord read GetWrap9 write SetWrap9;
    property Wrap10: DWord read GetWrap10 write SetWrap10;
    property Wrap11: DWord read GetWrap11 write SetWrap11;
    property Wrap12: DWord read GetWrap12 write SetWrap12;
    property Wrap13: DWord read GetWrap13 write SetWrap13;
    property Wrap14: DWord read GetWrap14 write SetWrap14;
    property Wrap15: DWord read GetWrap15 write SetWrap15;
    property Clipping: Boolean read GetClipping write SetClipping;
    property Lighting: Boolean read GetLighting write SetLighting;
    property Ambient: DWord read GetAmbient write SetAmbient;
    property ColorVertex: Boolean read GetColorVertex write SetColorVertex;
    property LocalViewer: Boolean read GetLocalViewer write SetLocalViewer;
    property NormalizeNormals: Boolean read GetNormalizeNormals write SetNormalizeNormals;
    property DiffuseMaterialSource: DWord read GetDiffuseMaterialSource write SetDiffuseMaterialSource;
    property SpecularMaterialSource: DWord read GetSpecularMaterialSource write SetSpecularMaterialSource;
    property AmbientMaterialSource: DWord read GetAmbientMaterialSource write SetAmbientMaterialSource;
    property EmissiveMaterialSource: DWord read GetEmissiveMaterialSource write SetEmissiveMaterialSource;
    property VertexBlend: DWord read GetVertexBlend write SetVertexBlend;
    property ClipPlaneEnable: DWord read GetClipPlaneEnable write SetClipPlaneEnable;
    property PointSize: Single read GetPointSize write SetPointSize;
    property PointSizeMin: Single read GetPointSizeMin write SetPointSizeMin;
    property PointSizeMax: Single read GetPointSizeMax write SetPointSizeMax;
    property PointSpriteEnable: Boolean read GetPointSpriteEnable write SetPointSpriteEnable;
    property PointScaleEnable: Boolean read GetPointScaleEnable write SetPointScaleEnable;
    property PointScaleA: Single read GetPointScaleA write SetPointScaleA;
    property PointScaleB: Single read GetPointScaleB write SetPointScaleB;
    property PointScaleC: Single read GetPointScaleC write SetPointScaleC;
    property MultisampleAntialias: Boolean read GetMultisampleAntialias write SetMultisampleAntialias;
    property MultisampleMask: DWord read GetMultisampleMask write SetMultisampleMask;
    property PatchEdgeStyle: TD3DPatchEdgeStyle read GetPatchEdgeStyle write SetPatchEdgeStyle;
    property DebugMonitorToken: DWord read GetDebugMonitorToken write SetDebugMonitorToken;
    property IndexedVertexBlendEnable: Boolean read GetIndexedVertexBlendEnable write SetIndexedVertexBlendEnable;
    property ColorWriteEnable: DWord read GetColorWriteEnable write SetColorWriteEnable;
    property TweenFactor: Single read GetTweenFactor write SetTweenFactor;
    property BlendOp: DWord read GetBlendOp write SetBlendOp;
    property PositionDegree: TD3DDegreeType read GetPositionDegree write SetPositionDegree;
    property NormalDegree: TD3DDegreeType read GetNormalDegree write SetNormalDegree;
    property ScissorTestEnable: Boolean read GetScissorTestEnable write SetScissorTestEnable;
    property SlopeScaleDepthBias: Single read GetSlopeScaleDepthBias write SetSlopeScaleDepthBias;
    property AntialiasedLineEnable: Boolean read GetAntialiasedLineEnable write SetAntialiasedLineEnable;
    property MinTessellationLevel: Single read GetMinTessellationLevel write SetMinTessellationLevel;
    property MaxTessellationLevel: Single read GetMaxTessellationLevel write SetMaxTessellationLevel;
    property AdaptiveTessX: Single read GetAdaptiveTessX write SetAdaptiveTessX;
    property AdaptiveTessY: Single read GetAdaptiveTessY write SetAdaptiveTessY;
    property AdaptiveTessZ: Single read GetAdaptiveTessZ write SetAdaptiveTessZ;
    property AdaptiveTessW: Single read GetAdaptiveTessW write SetAdaptiveTessW;
    property EnableAdaptiveTessellation: Boolean read GetEnableAdaptiveTessellation write SetEnableAdaptiveTessellation;
    property ColorWriteEnable1: DWord read GetColorWriteEnable1 write SetColorWriteEnable1;
    property ColorWriteEnable2: DWord read GetColorWriteEnable2 write SetColorWriteEnable2;
    property ColorWriteEnable3: DWord read GetColorWriteEnable3 write SetColorWriteEnable3;
    property BlendFactor: DWord read GetBlendFactor write SetBlendFactor;
    property SRGBWriteEnable: Boolean read GetSRGBWriteEnable write SetSRGBWriteEnable;
    property DepthBias: Single read GetDepthBias write SetDepthBias;
    property SeparateAlphaBlendEnable: Boolean read GetSeparateAlphaBlendEnable write SetSeparateAlphaBlendEnable;
    property SrcBlendAlpha: DWord read GetSrcBlendAlpha write SetSrcBlendAlpha;
    property DestBlendAlpha: DWord read GetDestBlendAlpha write SetDestBlendAlpha;
    property BlendOpAlpha: DWord read GetBlendOpAlpha write SetBlendOpAlpha;
    procedure SetDefaults;
    procedure SetFromMemory;
  end;
//TG2RenderStates END

//TG2SamplerStates BEGIN
  TG2SamplerStates = class (TG2Class)
  strict private
    m_States: array[0..15, 1..13] of DWord;
    function GetDWord(const Sampler: Byte; const StateType: TD3DSamplerStateType): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDWord(const Sampler: Byte; const StateType: TD3DSamplerStateType; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSingle(const Sampler: Byte; const StateType: TD3DSamplerStateType): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSingle(const Sampler: Byte; const StateType: TD3DSamplerStateType; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAddressU(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAddressU(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAddressV(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAddressV(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAddressW(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAddressW(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBorderColor(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBorderColor(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMagFilter(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMagFilter(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMinFilter(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMinFilter(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMipFilter(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMipFilter(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMipMapLODBias(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMipMapLODBias(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaxMipLevel(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMaxMipLevel(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMaxAnisotropy(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetMaxAnisotropy(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSRGBTexture(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSRGBTexture(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetElementIndex(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetElementIndex(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDMapOffset(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDMapOffset(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    m_G2Graphics: TG2Graphics;
  public
    constructor Create; override;
    destructor Destroy; override;
    property AddressU[const Index: Byte]: DWord read GetAddressU write SetAddressU;
    property AddressV[const Index: Byte]: DWord read GetAddressV write SetAddressV;
    property AddressW[const Index: Byte]: DWord read GetAddressW write SetAddressW;
    property BorderColor[const Index: Byte]: DWord read GetBorderColor write SetBorderColor;
    property MagFilter[const Index: Byte]: DWord read GetMagFilter write SetMagFilter;
    property MinFilter[const Index: Byte]: DWord read GetMinFilter write SetMinFilter;
    property MipFilter[const Index: Byte]: DWord read GetMipFilter write SetMipFilter;
    property MipMapLODBias[const Index: Byte]: Single read GetMipMapLODBias write SetMipMapLODBias;
    property MaxMipLevel[const Index: Byte]: DWord read GetMaxMipLevel write SetMaxMipLevel;
    property MaxAnisotropy[const Index: Byte]: DWord read GetMaxAnisotropy write SetMaxAnisotropy;
    property SRGBTexture[const Index: Byte]: DWord read GetSRGBTexture write SetSRGBTexture;
    property ElementIndex[const Index: Byte]: DWord read GetElementIndex write SetElementIndex;
    property DMapOffset[const Index: Byte]: DWord read GetDMapOffset write SetDMapOffset;
    procedure SetDefaults;
    procedure SetFromMemory;
  end;
//TG2SamplerStates END

//TG2TextureStageStates BEGIN
  TG2TextureStageStates = class (TG2Class)
  strict private
    m_States: array[0..15, 1..32] of DWord;
    function GetDWord(const Index: Byte; const StageType: TD3DTextureStageStateType): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetDWord(const Index: Byte; const StageType: TD3DTextureStageStateType; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetSingle(const Index: Byte; const StageType: TD3DTextureStageStateType): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetSingle(const Index: Byte; const StageType: TD3DTextureStageStateType; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorOp(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorOp(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorArg0(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorArg0(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorArg1(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorArg1(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetColorArg2(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetColorArg2(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaOp(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaOp(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaArg0(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaArg0(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaArg1(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaArg1(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAlphaArg2(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetAlphaArg2(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBumpEnvMat00(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBumpEnvMat00(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBumpEnvMat01(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBumpEnvMat01(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBumpEnvMat10(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBumpEnvMat10(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBumpEnvMat11(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBumpEnvMat11(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTexCoordIndex(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetTexCoordIndex(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBumpEnvLScale(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBumpEnvLScale(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBumpEnvLOffset(const Index: Byte): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetBumpEnvLOffset(const Index: Byte; const Value: Single); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTextureTransformFlags(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetTextureTransformFlags(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetResultArg(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetResultArg(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetConstant(const Index: Byte): DWord; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure SetConstant(const Index: Byte; const Value: DWord); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  private
    m_G2Graphics: TG2Graphics;
  public
    constructor Create; override;
    destructor Destroy; override;
    property ColorOp[const Index: Byte]: DWord read GetColorOp write SetColorOp;
    property ColorArg0[const Index: Byte]: DWord read GetColorArg0 write SetColorArg0;
    property ColorArg1[const Index: Byte]: DWord read GetColorArg1 write SetColorArg1;
    property ColorArg2[const Index: Byte]: DWord read GetColorArg2 write SetColorArg2;
    property AlphaOp[const Index: Byte]: DWord read GetAlphaOp write SetAlphaOp;
    property AlphaArg0[const Index: Byte]: DWord read GetAlphaArg0 write SetAlphaArg0;
    property AlphaArg1[const Index: Byte]: DWord read GetAlphaArg1 write SetAlphaArg1;
    property AlphaArg2[const Index: Byte]: DWord read GetAlphaArg2 write SetAlphaArg2;
    property BumpEnvMat00[const Index: Byte]: Single read GetBumpEnvMat00 write SetBumpEnvMat00;
    property BumpEnvMat01[const Index: Byte]: Single read GetBumpEnvMat01 write SetBumpEnvMat01;
    property BumpEnvMat10[const Index: Byte]: Single read GetBumpEnvMat10 write SetBumpEnvMat10;
    property BumpEnvMat11[const Index: Byte]: Single read GetBumpEnvMat11 write SetBumpEnvMat11;
    property TexCoordIndex[const Index: Byte]: DWord read GetTexCoordIndex write SetTexCoordIndex;
    property BumpEnvLScale[const Index: Byte]: Single read GetBumpEnvLScale write SetBumpEnvLScale;
    property BumpEnvLOffset[const Index: Byte]: Single read GetBumpEnvLOffset write SetBumpEnvLOffset;
    property TextureTransformFlags[const Index: Byte]: DWord read GetTextureTransformFlags write SetTextureTransformFlags;
    property ResultArg[const Index: Byte]: DWord read GetResultArg write SetResultArg;
    property Constant[const Index: Byte]: DWord read GetConstant write SetConstant;
    procedure SetDefaults;
    procedure SetFromMemory;
  end;
//TG2TextureStageStates END

//TG2SharedVB2D BEGIN
  TG2SharedVertex2D = packed record
  public
    x, y, z, rhw: Single;
    Color: TG2Color;
    tu, tv: Single;
  end;
  PG2SharedVertex2DArray = ^TG2SharedVertex2DArray;
  TG2SharedVertex2DArray = array[0..0] of TG2SharedVertex2D;
  
  TG2SharedVB2D = class (TG2Class)
  strict private
    m_G2Graphics: TG2Graphics;
    m_VB: IDirect3DVertexBuffer9;
    m_Size: Integer;
    function InitializeBuffer(const Size: Integer): TG2Result;
  private
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    property VB: IDirect3DVertexBuffer9 read m_VB;
    procedure Initialize(const G2Graphics: TG2Graphics);
    procedure Finalize;
    procedure SetToDevice;
    function VerifySize(const Size: Integer): TG2Result;
  end;
//TG2SharedVB2D END

//TG2Render BEGIN
  TG2Render = class (TG2Module)
  strict private
    m_G2Graphics: TG2Graphics;
    function GetCanRender: Boolean; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property CanRender: Boolean read GetCanRender;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function RenderStart: TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function RenderStop: TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function Present: TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure Clear(
      ClearStencil: Boolean;
      ClearZBuffer: Boolean;
      ClearTarget: Boolean;
      Color: TG2Color;
      Depth: Single = 1;
      Stencil: DWord = 0
    ); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure TextureClear(const Stage: Byte = 0); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure TextureSet(const Texture: TG2TextureBase; const Stage: Byte = 0); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  end;
//TG2Render END

//TG2RenderModes BEGIN
  TG2RenderModes = class (TG2Module)
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure BlendModeNormal;
    procedure BlendModeAdd;
    procedure FilteringPoint(const Stage: Byte = 0);
    procedure FilteringLinear(const Stage: Byte = 0);
    procedure FilteringAnisotropic(const Stage: Byte = 0; const MaxAnisotropy: Integer = 8);
    procedure TexAddressClamp(const Stage: Byte = 0);
    procedure TexAddressWrap(const Stage: Byte = 0);
    procedure TexAddressBorder(const Stage: Byte = 0);
    procedure TexAddressMirror(const Stage: Byte = 0);
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2RenderModes END

//TG2Render2D BEGIN
  TG2Render2D = class (TG2Module)
  strict private
  type
    TVertex = packed record
    public
      x, y, z, rhw: Single;
      Color: TG2Color;
      tu, tv: Single;
    end;
    PVertexArray = ^TVertexArray;
    TVertexArray = array[0..3] of TVertex;
    TVertex2 = packed record
    public
      x, y, z, rhw: Single;
      Color: TG2Color;
      tu1, tv1: Single;
      tu2, tv2: Single;
    end;
    PVertex2Array = ^TVertex2Array;
    TVertex2Array = array[0..3] of TVertex2;
  var
    m_G2Graphics: TG2Graphics;
    m_PlugGraphics: TG2PlugGraphics;
    m_VB: IDirect3DVertexBuffer9;
    m_VBSize: Integer;
    m_VB2: IDirect3DVertexBuffer9;
    m_VB2Size: Integer;
    m_IB: IDirect3DIndexBuffer9;
    m_IBSize: Integer;
    m_Drawing: Boolean;
    m_PrimType: TG2PrimType;
    m_PosArr: array of TG2Vec2;
    m_ColArr: array of TG2Color;
    m_TexArr: array of TG2Vec2;
    m_IndArr: array of Word;
    m_CurPos: DWord;
    m_CurCol: DWord;
    m_CurTex: DWord;
    m_CurInd: DWord;
  const
    FVF = D3DFVF_XYZRHW or D3DFVF_DIFFUSE or D3DFVF_TEX1;
    FVF2 = D3DFVF_XYZRHW or D3DFVF_DIFFUSE or D3DFVF_TEX2;
    function VerifyBuffer(const Size: Integer): TG2Result;
    function VerifyBuffer2(const Size: Integer): TG2Result;
    function VerifyIndices(const Size: Integer): TG2Result;
    procedure OnDeviceLost;
    procedure OnDeviceReset;
    function LoadBuffers: TG2Result;
    function DrawPointList: TG2Result;
    function DrawLineList: TG2Result;
    function DrawLineStrip: TG2Result;
    function DrawTriangleList: TG2Result;
    function DrawTriangleStrip: TG2Result;
    function DrawTriangleFan: TG2Result;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function DrawQuad(
      const v1, v2, v3, v4: TG2Vec2;
      const c1, c2, c3, c4: TG2Color;
      const Texture: TG2Texture2DBase;
      const tc1, tc2, tc3, tc4: TG2Vec2
    ): TG2Result;
    function DrawRect(
      const X, Y, Width, Height: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase
    ): TG2Result; overload; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawRect(
      const X, Y, Width, Height: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const Rotation: Single;
      const ScaleX, ScaleY: Single;
      const FlipLeftRight: Boolean;
      const FlipTopBottom: Boolean
    ): TG2Result; overload; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawQuad2(
      const v1, v2, v3, v4: TG2Vec2;
      const c1, c2, c3, c4: TG2Color;
      const Texture0: TG2Texture2DBase;
      const t0c1, t0c2, t0c3, t0c4: TG2Vec2;
      const Texture1: TG2Texture2DBase;
      const t1c1, t1c2, t1c3, t1c4: TG2Vec2
    ): TG2Result;
    function DrawBegin(const PrimType: TG2PrimType): TG2Result;
    procedure AddPos(const p: TG2Vec2);
    procedure AddCol(const c: TG2Color);
    procedure AddTex(const t: TG2Vec2);
    procedure AddInd(const i: Word);
    function DrawEnd: TG2Result;
  end;
//TG2Render2D END

//TG2Render3D BEGIN
  TG2Render3D = class (TG2Module)
  strict private
  type
    TVertex = packed record
    public
      x, y, z: Single;
      nx, ny, nz: Single;
      Color: TG2Color;
      tu, tv: Single;
    end;
    PVertexArray = ^TVertexArray;
    TVertexArray = array[Word] of TVertex;
    TIndex = type Word;
    PIndexArray = ^TIndexArray;
    TIndexArray = array[Word] of TIndex;
  const
    FVF = D3DFVF_XYZ or D3DFVF_DIFFUSE or D3DFVF_NORMAL or D3DFVF_TEX1;
  var
    m_PlugGraphics: TG2PlugGraphics;
    m_VB: IDirect3DVertexBuffer9;
    m_IB: IDirect3DIndexBuffer9;
    m_VBSize: Integer;
    m_IBSize: Integer;
    m_CurV: Word;
    m_CurI: DWord;
    m_Vertices: PVertexArray;
    m_Indices: PIndexArray;
    m_Drawing: Boolean;
    m_PrimType: TG2PrimType;
    m_PosArr: array of TG2Vec3;
    m_ColArr: array of TG2Color;
    m_TexArr: array of TG2Vec2;
    m_NrmArr: array of TG2Vec3;
    m_IndArr: array of Word;
    m_CurPos: DWord;
    m_CurCol: DWord;
    m_CurTex: DWord;
    m_CurNrm: DWord;
    m_CurInd: DWord;
    m_BaseVertexIndex: DWord;
    function VerifyVB(const Size: Integer): TG2Result;
    function VerifyIB(const Size: Integer): TG2Result;
    function AddVertex(
      const X, Y, Z: Single;
      const Color: TG2Color;
      const NX, NY, NZ: Single;
      const TU: Single = 0;
      const TV: Single = 0
    ): Word;
    procedure AddFace(
      const v1, v2, v3: Word
    );
    procedure OnDeviceLost;
    procedure OnDeviceReset;
    function LoadBuffers: TG2Result;
    function DrawPointList: TG2Result;
    function DrawLineList: TG2Result;
    function DrawLineStrip: TG2Result;
    function DrawTriangleList: TG2Result;
    function DrawTriangleStrip: TG2Result;
    function DrawTriangleFan: TG2Result;
  public
    constructor Create; override;
    destructor Destroy; override;
    property BaseVertexIndex: DWord read m_BaseVertexIndex write m_BaseVertexIndex;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function DrawTriangle(
      const v1, v2, v3: TG2Vec3;
      const Color: TG2Color;
      const tc1, tc2, tc3: TG2Vec2
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawTriangle3Col(
      const v1, v2, v3: TG2Vec3;
      const c1, c2, c3: TG2Color;
      const tc1, tc2, tc3: TG2Vec2
    ): TG2Result;
    function DrawQuad(
      const v1, v2, v3, v4: TG2Vec3;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const TextureRect: PG2Rect = nil
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawQuad4Col(
      const v1, v2, v3, v4: TG2Vec3;
      const c1, c2, c3, c4: TG2Color;
      const Texture: TG2Texture2DBase;
      const TextureRect: PG2Rect = nil
    ): TG2Result;
    function DrawBox(
      const X, Y, Z: Single;
      const SizeX, SizeY, SizeZ: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase
    ): TG2Result;
    function DrawSphere(
      const X, Y, Z: Single;
      const Radius: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const VSegments: Integer = 32;
      const HSegments: Integer = 32
    ): TG2Result;
    function DrawCylinder(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const Segments: Integer = 32
    ): TG2Result;
    function DrawCapsule(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const VCapSegments: Integer = 8;
      const HSegments: Integer = 32
    ): TG2Result;
    function DrawTorus(
      const X, Y, Z: Single;
      const RadiusInt, RadiusExt: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const Sides: Integer = 16;
      const Segments: Integer = 32
    ): TG2Result;
    function DrawBegin(const PrimType: TG2PrimType): TG2Result;
    procedure AddPos(const p: TG2Vec3);
    procedure AddCol(const c: TG2Color);
    procedure AddTex(const t: TG2Vec2);
    procedure AddNrm(const n: TG2Vec3);
    procedure AddInd(const i: Word);
    function DrawEnd: TG2Result;
  end;
//TG2Render3D END

//TG2Camera BEGIN
  TG2Camera = class (TG2Module)
  strict private
    m_Src: TG2Vec3;
    m_Dst: TG2Vec3;
    m_Up: TG2Vec3;
    m_FOV: Single;
    m_Aspect: Single;
    m_Near: Single;
    m_Far: Single;
    function GetView: TG2Mat;
    function GetProj: TG2Mat;
  public
    constructor Create; override;
    destructor Destroy; override;
    property View: TG2Mat read GetView;
    property Proj: TG2Mat read GetProj;
    property CamPos: TG2Vec3 read m_Src write m_Src;
    property Target: TG2Vec3 read m_Dst write m_Dst;
    property UpVec: TG2Vec3 read m_Up write m_Up;
    property FOV: Single read m_FOV write m_FOV;
    property Aspect: Single read m_Aspect write m_Aspect;
    property ZNear: Single read m_Near write m_Near;
    property ZFar: Single read m_Far write m_Far;
    procedure SetPerspective(const NewFOV, NewAspect, NewNear, NewFar: Single); overload;
    procedure SetPerspective; overload;
    procedure SetView(const PosX, PosY, PosZ, TargetX, TargetY, TargetZ, UpX, UpY, UpZ: Single);
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Camera END

//TG2Frastum BEGIN
  TG2Frastum = class (TG2Module)
  strict private
  type
    PG2FrustumPlane = ^TG2FrustumPlane;
    TG2FrustumPlane = record
      N: TG2Vec3;
      D: Single;
    end;
  var
    m_Planes: array[0..5] of TG2FrustumPlane;
    m_RefV: PG2Mat;
    m_RefP: PG2Mat;
    function GetPlane(const Index: integer): PG2FrustumPlane; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    procedure Normalize; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property RefV: PG2Mat read m_RefV write m_RefV;
    property RefP: PG2Mat read m_RefP write m_RefP;
    property Planes[const Index: Integer]: PG2FrustumPlane read GetPlane;
    procedure Update;
    function PointInFrustum(const V: TG2Vec3): Boolean;
    function BoxInFrustum(const MinV, MaxV: TG2Vec3): Boolean;
    function SphereInFrustum(const C: TG2Vec3; const R: Single): Boolean;
    function FrustumCheckBox(const MinV, MaxV: TG2Vec3): TG2FrustumCheck;
    function FrustumCheckSphere(const C: TG2Vec3; const R: Single): TG2FrustumCheck;
    function DistanceToPoint(const PlaneIndex: Integer; Pt: TG2Vec3): Single; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Frastum END

//TG2Primitives2D BEGIN
  TG2Primitives2D = class (TG2Module)
  strict private
  type
    TG2Vertex = packed record
    public
      x, y, z, rhw: Single;
      Color: TG2Color
    end;
    PG2VertexArray = ^TG2VertexArray;
    TG2VertexArray = array[Word] of TG2Vertex;
  const
    FVF = D3DFVF_XYZRHW or D3DFVF_DIFFUSE;
  var
    m_PlugGraphics: TG2PlugGraphics;
    m_VB: IDirect3DVertexBuffer9;
    m_VBSize: Integer;
    function VerifyBuffer(const Size: Integer): TG2Result;
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function DrawLine(
      const v1, v2: TG2Vec2;
      const Color: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawLine2Col(
      const v1, v2: TG2Vec2;
      const c1, c2: TG2Color
    ): TG2Result;
    function DrawLineStrip(
      const VArr: PG2Vec2Array;
      const VCount: Word;
      const Color: TG2Color
    ): TG2Result;
    function DrawTriangle(
      const v1, v2, v3: TG2Vec2;
      const Color: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawTriangle3Col(
      const v1, v2, v3: TG2Vec2;
      const c1, c2, c3: TG2Color
    ): TG2Result;
    function DrawRect(
      const X, Y, Width, Height: Single;
      const Color: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawRect4Col(
      const X, Y, Width, Height: Single;
      const c1, c2, c3, c4: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawQuad(
      const v1, v2, v3, v4: TG2Vec2;
      const Color: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawQuad4Col(
      const v1, v2, v3, v4: TG2Vec2;
      const c1, c2, c3, c4: TG2Color
    ): TG2Result;
    function DrawCircle(
      const Center: TG2Vec2;
      const Radius: Single;
      const Color: TG2Color;
      const Segments: Word = 32
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawCircle2Col(
      const Center: TG2Vec2;
      const Radius: Single;
      const ColInt, ColExt: TG2Color;
      const Segments: Word = 32
    ): TG2Result;
    function DrawCircleHollow(
      const Center: TG2Vec2;
      const RadiusInt, RadiusExt: Single;
      const Color: TG2Color;
      const Segments: Word = 32
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawCircleHollow2Col(
      const Center: TG2Vec2;
      const RadiusInt, RadiusExt: Single;
      const ColInt, ColExt: TG2Color;
      const Segments: Word = 32
    ): TG2Result;
    function DrawPolyConvex(
      const VArr: PG2Vec2Array;
      const VCount: Word;
      const Color: TG2Color
    ): TG2Result;
  end;
//TG2Primitives2D END

//TG2Primitives3D BEGIN
  TG2Primitives3D = class (TG2Module)
  strict private
  type
    TG2Vertex = packed record
    public
      x, y, z: Single;
      nx, ny, nz: Single;
      Color: TG2Color
    end;
    PG2VertexArray = ^TG2VertexArray;
    TG2VertexArray = array[Word] of TG2Vertex;
    TG2Index = type Word;
    PG2IndexArray = ^TG2IndexArray;
    TG2IndexArray = array[Word] of TG2Index;
  const
    FVF = D3DFVF_XYZ or D3DFVF_DIFFUSE or D3DFVF_NORMAL;
  var
    m_PlugGraphics: TG2PlugGraphics;
    m_VB: IDirect3DVertexBuffer9;
    m_IB: IDirect3DIndexBuffer9;
    m_VBSize: Integer;
    m_IBSize: Integer;
    m_CurV: Word;
    m_CurI: DWord;
    m_Vertices: PG2VertexArray;
    m_Indices: PG2IndexArray;
    function VerifyVB(const Size: Integer): TG2Result;
    function VerifyIB(const Size: Integer): TG2Result;
    function AddVertex(
      const X, Y, Z: Single;
      const Color: TG2Color;
      const NX, NY, NZ: Single
    ): Word;
    procedure AddFace(
      const v1, v2, v3: Word
    );
    procedure OnDeviceLost;
    procedure OnDeviceReset;
  public
    constructor Create; override;
    destructor Destroy; override;
    function DrawTriangle(
      const v1, v2, v3: TG2Vec3;
      const Color: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawTriangle3Col(
      const v1, v2, v3: TG2Vec3;
      const c1, c2, c3: TG2Color
    ): TG2Result;
    function DrawQuad(
      const v1, v2, v3, v4: TG2Vec3;
      const Color: TG2Color
    ): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function DrawQuad4Col(
      const v1, v2, v3, v4: TG2Vec3;
      const c1, c2, c3, c4: TG2Color
    ): TG2Result;
    function DrawBox(
      const X, Y, Z: Single;
      const SizeX, SizeY, SizeZ: Single;
      const Color: TG2Color
    ): TG2Result;
    function DrawSphere(
      const X, Y, Z: Single;
      const Radius: Single;
      const Color: TG2Color;
      const VSegments: Integer = 32;
      const HSegments: Integer = 32
    ): TG2Result;
    function DrawCylinder(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const Segments: Integer = 32
    ): TG2Result;
    function DrawCapsule(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const VCapSegments: Integer = 8;
      const HSegments: Integer = 32
    ): TG2Result;
    function DrawTorus(
      const X, Y, Z: Single;
      const RadiusInt, RadiusExt: Single;
      const Color: TG2Color;
      const Sides: Integer = 16;
      const Segments: Integer = 32
    ): TG2Result;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
  end;
//TG2Primitives3D END

//TG2ShaderMgr BEGIN
  TG2ShaderMgr = class (TG2ResMgr)
  strict private
    m_PlugGraphics: TG2PlugGraphics;
    procedure OnLostDevice;
    procedure OnResetDevice;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function CreateVertexShaderFromFile(const Name: AnsiString; const f: AnsiString): TG2VertexShader;
    function CreateVertexShaderFromFileCompiled(const Name: AnsiString; const f: String): TG2VertexShader;
    function CreateVertexShaderFromMemory(const Name: AnsiString; const Ptr: Pointer; const Size: DWord): TG2VertexShader;
    function CreateVertexShaderFromFunction(const Name: AnsiString; const Func: PDWord): TG2VertexShader;
    function CreatePixelShaderFromFile(const Name: AnsiString; const f: AnsiString): TG2PixelShader;
    function CreatePixelShaderFromFileCompiled(const Name: AnsiString; const f: String): TG2PixelShader;
    function CreatePixelShaderFromMemory(const Name: AnsiString; const Ptr: Pointer; const Size: DWord): TG2PixelShader;
    function CreatePixelShaderFromFunction(const Name: AnsiString; const Func: PDWord): TG2PixelShader;
    function FindShader(const Name: AnsiString): TG2Shader;
  end;
//TG2ShaderMgr END

//TG2Shader BEGIN
  TG2Shader = class (TG2Res)
  strict protected
    m_CompiledShader: PG2CompiledShader;
    m_ShaderFunction: PDWord;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function LoadFromFile(const f: AnsiString): TG2Result; virtual;
    function LoadFromFileCompiled(const f: String): TG2Result; virtual;
    function LoadFromMemory(const Ptr: Pointer; const Size: DWord): TG2Result; virtual;
    function LoadFromFunction(const Func: PDWord): TG2Result; virtual;
    procedure Release; virtual;
    procedure OnLostDevice; virtual;
    procedure OnResetDevice; virtual;
  end;
//TG2Shader END

//TG2VertexShader BEGIN
  TG2VertexShader = class (TG2Shader)
  strict private
    m_Shader: IDirect3DVertexShader9;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Shader: IDirect3DVertexShader9 read m_Shader;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function LoadFromFile(const f: AnsiString): TG2Result; override;
    function LoadFromFileCompiled(const f: String): TG2Result; override;
    function LoadFromMemory(const Ptr: Pointer; const Size: DWord): TG2Result; override;
    function LoadFromFunction(const Func: PDWord): TG2Result; override;
    procedure SetConstantF(const r: DWord; const c: PSingle; const F4Count: DWord); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetConstantI(const r: DWord; const c: PInteger; const I4Count: DWord); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetConstantB(const r: DWord; const c: PBool; const BCount: DWord); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetToDevice; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure Release; override;
    procedure OnLostDevice; override;
    procedure OnResetDevice; override;
  end;
//TG2VertexShader END

//TG2PixelShader BEGIN
  TG2PixelShader = class (TG2Shader)
  strict private
    m_Shader: IDirect3DPixelShader9;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Shader: IDirect3DPixelShader9 read m_Shader;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function LoadFromFile(const f: AnsiString): TG2Result; override;
    function LoadFromFileCompiled(const f: String): TG2Result; override;
    function LoadFromMemory(const Ptr: Pointer; const Size: DWord): TG2Result; override;
    function LoadFromFunction(const Func: PDWord): TG2Result; override;
    procedure SetConstantF(const c: DWord; const Value: PSingle; const F4Count: DWord); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetConstantI(const c: DWord; const Value: PInteger; const I4Count: DWord); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetConstantB(const c: DWord; const Value: PBool; const BCount: DWord); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetToDevice; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure Release; override;
    procedure OnLostDevice; override;
    procedure OnResetDevice; override;
  end;
//TG2PixelShader END

//TG2EffectMgr BEGIN
  TG2EffectMgr = class (TG2ResMgr)
  strict private
    m_PlugGraphics: TG2PlugGraphics;
    procedure OnLostDevice;
    procedure OnResetDevice;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function CreateEffectFromFile(const Name: AnsiString; f: AnsiString): TG2Effect;
    function CreateEffectFromMemory(const Name: AnsiString; const Ptr: Pointer; const Size: Integer): TG2Effect;
    function FindEffect(const Name: AnsiString): TG2Effect;
  end;
//TG2EffectMgr END

//TG2Effect BEGIN
  TG2Effect = class (TG2Res)
  strict private
    m_Effect: ID3DXEffect;
    function GetCurTechnique: TD3DXHandle;  {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure SetCurTechnique(const Value: TD3DXHandle);  {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
  public
    constructor Create; override;
    destructor Destroy; override;
    property Effect: ID3DXEffect read m_Effect;
    property Technique: TD3DXHandle read GetCurTechnique write SetCurTechnique;
    function BeginEffect(Passes: PLongWord; const Flags: DWORD = 0): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function EndEffect: TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function BeginPass(const Pass: LongWord): TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function EndPass: TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function CommitChanges: TG2Result; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetValue(hParameter: TD3DXHandle; pData: Pointer; Bytes: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetValue(hParameter: TD3DXHandle; pData: Pointer; Bytes: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetBool(hParameter: TD3DXHandle; b: BOOL): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBool(hParameter: TD3DXHandle; out pb: BOOL): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetBoolArray(hParameter: TD3DXHandle; pb: PBOOL; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetBoolArray(hParameter: TD3DXHandle; pb: PBOOL; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetInt(hParameter: TD3DXHandle; n: Integer): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetInt(hParameter: TD3DXHandle; out pn: Integer): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetIntArray(hParameter: TD3DXHandle; pn: PInteger; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetIntArray(hParameter: TD3DXHandle; pn: PInteger; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetFloat(hParameter: TD3DXHandle; f: Single): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFloat(hParameter: TD3DXHandle; out pf: Single): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetFloatArray(hParameter: TD3DXHandle; pf: PSingle; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFloatArray(hParameter: TD3DXHandle; pf: PSingle; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetVector(hParameter: TD3DXHandle; const pVector: TD3DXVector4): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVector(hParameter: TD3DXHandle; out pVector: TD3DXVector4): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetVectorArray(hParameter: TD3DXHandle; pVector: PD3DXVector4; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVectorArray(hParameter: TD3DXHandle; pVector: PD3DXVector4; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetMatrix(hParameter: TD3DXHandle; const pMatrix: TD3DXMatrix): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMatrix(hParameter: TD3DXHandle; out pMatrix: TD3DXMatrix): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetMatrixArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMatrixArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetMatrixPointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMatrixPointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetMatrixTranspose(hParameter: TD3DXHandle; const pMatrix: TD3DXMatrix): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMatrixTranspose(hParameter: TD3DXHandle; out pMatrix: TD3DXMatrix): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetMatrixTransposeArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMatrixTransposeArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetMatrixTransposePointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetMatrixTransposePointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetString(hParameter: TD3DXHandle; pString: PAnsiChar): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetString(hParameter: TD3DXHandle; out ppString: PAnsiChar): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetTexture(hParameter: TD3DXHandle; pTexture: IDirect3DBaseTexture9): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTexture(hParameter: TD3DXHandle; out ppTexture: IDirect3DBaseTexture9): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPixelShader(hParameter: TD3DXHandle; out ppPShader: IDirect3DPixelShader9): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetVertexShader(hParameter: TD3DXHandle; out ppVShader: IDirect3DVertexShader9): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function SetArrayRange(hParameter: TD3DXHandle; uStart, uEnd: LongWord): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetDesc(out pDesc: TD3DXEffectDesc): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetParameterDesc(hParameter: TD3DXHandle; out pDesc: TD3DXParameterDesc): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTechniqueDesc(hTechnique: TD3DXHandle; out pDesc: TD3DXTechniqueDesc): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPassDesc(hPass: TD3DXHandle; out pDesc: TD3DXPassDesc): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFunctionDesc(hShader: TD3DXHandle; out pDesc: TD3DXFunctionDesc): HResult; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetParameter(hParameter: TD3DXHandle; Index: LongWord): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetParameterByName(hParameter: TD3DXHandle; pName: PAnsiChar): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetParameterBySemantic(hParameter: TD3DXHandle; pSemantic: PAnsiChar): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetParameterElement(hParameter: TD3DXHandle; Index: LongWord): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTechnique(Index: LongWord): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetTechniqueByName(pName: PAnsiChar): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPass(hTechnique: TD3DXHandle; Index: LongWord): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetPassByName(hTechnique: TD3DXHandle; pName: PAnsiChar): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    function GetFunction(Index: LongWord): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetFunctionByName(pName: PAnsiChar): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAnnotation(hObject: TD3DXHandle; Index: LongWord): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function GetAnnotationByName(hObject: TD3DXHandle; pName: PAnsiChar): TD3DXHandle; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    function LoadFromFile(f: AnsiString): TG2Result;
    function LoadFromMemory(const Ptr: Pointer; const Size: Integer): TG2Result;
    procedure Release;  {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure OnLostDevice; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
    procedure OnResetDevice; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
  end;
//TG2Effect END

//TG2ShaderLib BEGIN
  TG2ShaderLib = class (TG2ResMgr)
  strict private
    m_VertexShaders: TG2ShaderMgr;
    m_PixelShaders: TG2ShaderMgr;
    m_Effects: TG2EffectMgr;
  public
    constructor Create; override;
    destructor Destroy; override;
    function Initialize(const G2Core: TG2Core): TG2Result; override;
    function Finalize: TG2Result; override;
    procedure CreateShaderBin(const Name: AnsiString; const Ptr: Pointer; const Size: DWord); overload;
    procedure CreateShaderBin(const Name: AnsiString; const Func: PDWord); overload;
    function RequestVertexShader(const Name: AnsiString): TG2VertexShader;
    function RequestPixelShader(const Name: AnsiString): TG2PixelShader;
    function RequestEffect(const Name: AnsiString): TG2Effect;
  end;
//TG2ShaderLib END

//TG2ShaderBin BEGIN
  TG2ShaderBin = class (TG2Res)
  strict private
    m_Buffer: array of Byte;
    m_Func: PDWord;
    function GetBuffer: Pointer; inline;
    function GetSize: Integer; inline;
  public
    constructor Create; override;
    destructor Destroy; override;
    property Buffer: Pointer read GetBuffer;
    property Size: Integer read GetSize;
    property Func: PDWord read m_Func;
    procedure LoadBuffer(const Ptr: Pointer; const Size: DWord);
    procedure LoadFunction(const NewFunc: PDWord);
  end;
//TG2ShaderBin END

//TG2App BEGIN
  TG2App = class (TObject)
  strict private
    m_g2: TG2Core;
    m_Gfx: TG2Graphics;
    m_Sfx: TG2Audio;
    m_Inp: TG2Input;
    m_Net: TG2Network;
    m_Tmr: TG2Timer;
    m_PlugTimer: TG2PlugTimer;
    m_PlugGraphics: TG2PlugGraphics;
    m_PlugInput: TG2PlugInput;
    m_Render: TG2Render;
    m_Render2D: TG2Render2D;
    m_Render3D: TG2Render3D;
    m_Prim2D: TG2Primitives2D;
    m_Prim3D: TG2Primitives3D;
    m_RenderModes: TG2RenderModes;
    m_Cam: TG2Camera;
    m_AppTime: DWord;
    m_Pause: Boolean;
    procedure SetHandle(const Value: HWnd);
    function GetHandle: HWnd;
    procedure AppTimer;
    procedure AppRender;
    procedure AppUpdate;
    procedure AppDeviceLost;
    procedure AppDeviceReset;
    procedure AppKeyDown(const Key: Byte);
    procedure AppKeyUp(const Key: Byte);
    procedure AppMouseDown(const Button: Byte);
    procedure AppMouseUp(const Button: Byte);
    procedure AppMouseMove(const Shift: TPoint);
    procedure AppWheelMove(const Shift: Integer);
  strict protected
    procedure OnTimer; virtual;
    procedure OnRender; virtual;
    procedure OnUpdate; virtual;
    procedure OnDeviceLost; virtual;
    procedure OnDeviceReset; virtual;
    procedure OnKeyDown(const Key: Byte); virtual;
    procedure OnKeyUp(const Key: Byte); virtual;
    procedure OnMouseDown(const Button: Byte); virtual;
    procedure OnMouseUp(const Button: Byte); virtual;
    procedure OnMouseMove(const Shift: TPoint); virtual;
    procedure OnWheelMove(const Shift: Integer); virtual;
  public
    constructor Create;
    destructor Destroy; override;
    property Handle: HWnd read GetHandle write SetHandle;
    property g2: TG2Core read m_g2;
    property Gfx: TG2Graphics read m_Gfx;
    property Sfx: TG2Audio read m_Sfx;
    property Inp: TG2Input read m_Inp;
    property Net: TG2Network read m_Net;
    property Tmr: TG2Timer read m_Tmr;
    property PlugTimer: TG2PlugTimer read m_PlugTimer;
    property PlugGraphics: TG2PlugGraphics read m_PlugGraphics;
    property PlugInput: TG2PlugInput read m_PlugInput;
    property Render: TG2Render read m_Render;
    property Render2D: TG2Render2D read m_Render2D;
    property Render3D: TG2Render3D read m_Render3D;
    property Prim2D: TG2Primitives2D read m_Prim2D;
    property Prim3D: TG2Primitives3D read m_Prim3D;
    property RenderModes: TG2RenderModes read m_RenderModes;
    property Cam: TG2Camera read m_Cam;
    property AppTime: DWord read m_AppTime;
    property Pause: Boolean read m_Pause write m_Pause;
    procedure Initialize; virtual;
    procedure Finalize; virtual;
  end;
//TG2App END

//TG2SysInfo BEGIN
  TG2SysCPU = record
    Name: AnsiString;
    Identifier: AnsiString;
    Vendor: AnsiString;
    MHz: Integer;
  end;

  TG2SysInfo = record
    CPUCount: Integer;
    CPUs: array of TG2SysCPU;
    DisplayDevice: AnsiString;
    Memory: TMemoryStatus;
  end;
//TG2SysInfo END

const
  G2Version: Word = $0100;

  TG2ResSuccess: set of TG2Result = [grOk, grConditionalOk];
  
  TG2SharedVertex2DFVF = D3DFVF_XYZRHW or D3DFVF_DIFFUSE or D3DFVF_TEX1;

var
  AppTime: DWord;
  AppPath: AnsiString;
  AppCompiler: AnsiString;
  SysMMX: Boolean;
  SysSSE: Boolean;
  SysSSE2: Boolean;
  G2VMRID: DWord = 0;
  G2MeshLoaders: array of CG2MeshLoaderClass;

//Utility Functions BEGIN
function G2ResOk(const Res: TG2Result): Boolean; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2ResFail(const Res: TG2Result): Boolean; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
procedure SafeRelease(var i); {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function WideStringToString(const WS: WideString; CodePage: Word = CP_ACP): AnsiString;
function StringToWideString(const S: AnsiString; CodePage: Word = CP_ACP): WideString;
function G2Param(const Str: AnsiString; const Separator: AnsiString; const Param: Integer): AnsiString;
function G2ParamCount(const Str: AnsiString; const Separator: AnsiString): Integer;
function G2StrInStr(const Str: AnsiString; SubStr: AnsiString): Integer;
function G2Color(const R, G, B: Byte; const A: Byte = 255): TG2Color; overload; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2Color(const Color: DWord): TG2Color; overload; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2MatLerp(const Mat1, Mat2: TG2Mat; const s: Single): TG2Mat; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2MatSLerp(const Mat1, Mat2: TG2Mat; const s: Single): TG2Mat; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2MatRefine(const Pos: TG2Vec3; const MatUnref, ParentUnref: PG2Mat): TG2Mat;
function G2Rect(const Left, Top, Right, Bottom: Single): TG2Rect; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2FormatSize(const Format: TD3DFormat): DWord; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2FormatToString(const Format: TD3DFormat): AnsiString;
function G2SysInfo: TG2SysInfo;
function G2PiTime(Amp: Single = 1000): Single; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2TimeInterval(Interval: DWord = 1000): Single; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2RandomPi: Single; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2Random2Pi: Single; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function G2TriangleNormal(v1, v2, v3: TG2Vec3): TG2Vec3;{$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function D3DTS_TEXTUREMATRIX(const Index: Byte): TD3DTransformStateType; {$IFDEF G2_USE_INLINE} inline;  {$ENDIF}
function D3DVertexElement(
  Stream:     Word;
  Offset:     Word;
  _Type:      TD3DDeclType;
  Method:     TD3DDeclMethod;
  Usage:      TD3DDeclUsage;
  UsageIndex: Byte
): TD3DVertexElement9; {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
function G2DefWndProc(Wnd: HWnd; Msg: UInt; wParam: WPARAM; lParam: LPARAM): LResult; stdcall;
//Utility Functions END

//Unit Functions BEGIN
procedure G2RegMeshLoader(const LoaderClass: CG2MeshLoaderClass);
procedure G2WriteLog(const Log: AnsiString); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
procedure G2WriteLogTimed(const Log: AnsiString; const Module: AnsiString = ''); {$IFDEF G2_USE_INLINE} inline; {$ENDIF}
//Unit Functions END

implementation

//TG2Color BEGIN
class operator TG2Color.Explicit(const c: TG2Color): DWord;
begin
  Result := PDWord(@c)^;
end;

class operator TG2Color.Explicit(const c: DWord): TG2Color;
begin
  Result := PG2Color(@c)^;
end;

class operator TG2Color.Explicit(const c: TG2Color): TD3DColorValue;
const
  Rcp255 = 1 / 255;
begin
  Result.r := c.r * Rcp255;
  Result.g := c.g * Rcp255;
  Result.b := c.b * Rcp255;
  Result.a := c.a * Rcp255;
end;

class operator TG2Color.Explicit(const c: TD3DColorValue): TG2Color;
begin
  Result.r := Trunc(c.r * 255);
  Result.g := Trunc(c.g * 255);
  Result.b := Trunc(c.b * 255);
  Result.a := Trunc(c.a * 255);
end;

class operator TG2Color.Implicit(const c: TG2Color): DWord;
begin
  Result := PDWord(@c)^;
end;

class operator TG2Color.Implicit(const c: DWord): TG2Color;
begin
  Result := PG2Color(@c)^;
end;

class operator TG2Color.Implicit(const c: TG2Color): TD3DColorValue;
const
  Rcp255 = 1 / 255;
begin
  Result.r := c.r * Rcp255;
  Result.g := c.g * Rcp255;
  Result.b := c.b * Rcp255;
  Result.a := c.a * Rcp255;
end;

class operator TG2Color.Implicit(const c: TD3DColorValue): TG2Color;
begin
  Result.r := Trunc(c.r * 255);
  Result.g := Trunc(c.g * 255);
  Result.b := Trunc(c.b * 255);
  Result.a := Trunc(c.a * 255);
end;
//TG2Color END

//TG2Rect BEGIN
function TG2Rect.Width: Single;
begin
  Result := Right - Left;
end;

function TG2Rect.Height: Single;
begin
  Result := Bottom - Top;
end;
//TG2Rect END

//TG2Class BEGIN
constructor TG2Class.Create;
begin
  inherited Create;
end;

destructor TG2Class.Destroy;
begin
  inherited Destroy;
end;
//TG2Class END

//TG2Core BEGIN
constructor TG2Core.Create;
begin
  inherited Create;
  m_Handle := 0;
  m_OwnWindow := False;
  m_Initialized := False;
  m_Timer := TG2Timer.Create;
  m_Graphics := TG2Graphics.Create;
  m_Audio := TG2Audio.Create;
  m_Input := TG2Input.Create;
  m_Network := TG2Network.Create;
  m_Mods := TG2List.Create;
end;

destructor TG2Core.Destroy;
begin
  Finalize;
  m_Mods.Free;
  m_Network.Free;
  m_Input.Free;
  m_Audio.Free;
  m_Graphics.Free;
  m_Timer.Free;
  inherited Destroy;
end;

procedure TG2Core.SetHandle(const Value: HWND);
begin
  if not m_Initialized then
  m_Handle := Value;
end;

function TG2Core.CreateWindow: HWnd;
var
  WndClass: TWndClassEx;
  ClassName: String;
begin
  FillChar(WndClass, SizeOf(TWndClassEx), 0);
  WndClass.cbSize := SizeOf(TWndClassEx);
  WndClass.hIconSm := LoadIcon(0, IDI_APPLICATION);
  WndClass.hIcon := LoadIcon(0, IDI_APPLICATION);
  WndClass.hInstance := HInstance;
  WndClass.hCursor := LoadCursor(0, IDC_ARROW);
  WndClass.lpszClassName := 'Gen2';
  WndClass.style := CS_HREDRAW or CS_VREDRAW or CS_OWNDC or CS_DBLCLKS;
  WndClass.lpfnWndProc := @G2DefWndProc;

  if RegisterClassEx(WndClass) = 0 then
  ClassName := 'Static'
  else
  ClassName := WndClass.lpszClassName;

  Result := CreateWindowEx(
    0, PAnsiChar(ClassName), nil, WS_POPUP or WS_VISIBLE or WS_EX_TOPMOST, 0, 0,
    GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN),
    0, 0, HInstance, nil
  );
end;

function TG2Core.Initialize: TG2Result;
begin
  if m_Initialized then
  begin
    Result := grRedundantCall;
    Exit;
  end;
  G2WriteLogTimed('Initialization Started.', 'Core');
  if m_Handle = 0 then
  begin
    m_Handle := CreateWindow;
    m_OwnWindow := True;
  end;
  m_Initialized := True;
  m_Timer.Initialize(Self);
  m_Graphics.Initialize(Self);
  m_Audio.Initialize(Self);
  m_Input.Initialize(Self);
  m_Network.Initialize(Self);
  Result := grOk;
  G2WriteLogTimed('Initialization Finished.', 'Core');
end;

function TG2Core.Finalize: TG2Result;
begin
  if not m_Initialized then
  begin
    Result := grRedundantCall;
    Exit;
  end;
  G2WriteLogTimed('Finalization Started.', 'Core');
  m_Initialized := False;
  m_Timer.Enabled := False;
  m_Network.Finalize;
  m_Input.Finalize;
  m_Audio.Finalize;
  m_Graphics.Finalize;
  m_Timer.Finalize;
  if m_Mods.Count > 0 then
  begin
    G2WriteLogTimed('(W) ' + IntToStr(m_Mods.Count) + ' Modules are unreleased', 'Core');
    G2WriteLogTimed('Module Cleanup Started.', 'Core');
    m_Mods.FreeItems;
    G2WriteLogTimed('Module Cleanup Finished.', 'Core');
  end;
  if m_OwnWindow then
  begin
    DestroyWindow(m_Handle);
    m_Handle := 0;
    m_OwnWindow := False;
  end;
  Result := grOk;
  G2WriteLogTimed('Finalization Finished.', 'Core');
end;

function TG2Core.RequestMod(
      const ModClass: CG2ModClass;
      const Module: PG2Module
    ): TG2Result;
begin
  if not m_Initialized then
  begin
    Result := grNotInitialized;
    Exit;
  end;
  Module^ := ModClass.Create;
  Result := Module^.Initialize(Self);
  if G2ResOk(Result) then
  m_Mods.Add(Module^);
end;

function TG2Core.ReleaseMod(
      const Module: PG2Module 
    ): TG2Result;
begin
  m_Mods.Remove(Module^);
  if Module^.Initialized then
  Result := Module^.Finalize
  else
  Result := grOk;
  Module^.Free;
end;

function TG2Core.RequestPlug(
      const PlugClass: CG2PlugClass;
      const Plug: PG2Plug
    ): TG2Result;
begin
  if not m_Initialized then
  begin
    Result := grNotInitialized;
    Exit;
  end;
  Result := grInvalidCall;
  if m_Timer.PlugClass = PlugClass then
  Result := m_Timer.RequestPlug(PlugClass, Plug)
  else if m_Graphics.PlugClass = PlugClass then
  Result := m_Graphics.RequestPlug(PlugClass, Plug)
  else if m_Audio.PlugClass = PlugClass then
  Result := m_Audio.RequestPlug(PlugClass, Plug)
  else if m_Input.PlugClass = PlugClass then
  Result := m_Input.RequestPlug(PlugClass, Plug)
  else if m_Network.PlugClass = PlugClass then
  Result := m_Network.RequestPlug(PlugClass, Plug);
end;

function TG2Core.ReleasePlug(
      const Plug: PG2Plug
    ): TG2Result;
begin
  Result := grInvalidCall;
  if Plug^ is TG2PlugTimer then
  Result := m_Timer.ReleasePlug(Plug)
  else if Plug^ is TG2PlugGraphics then
  Result := m_Graphics.ReleasePlug(Plug)
  else if Plug^ is TG2PlugAudio then
  Result := m_Audio.ReleasePlug(Plug)
  else if Plug^ is TG2PlugInput then
  Result := m_Input.ReleasePlug(Plug)
  else if Plug^ is TG2PlugNetwork then
  Result := m_Network.ReleasePlug(Plug);
end;
//TG2Core END

//TG2HighClass BEGIN
constructor TG2HighClass.Create;
begin
  inherited Create;
  m_Core := nil;
  m_Initialized := False;
end;

destructor TG2HighClass.Destroy;
begin
  Finalize;
  inherited Destroy;
end;

function TG2HighClass.Initialize(const G2Core: TG2Core): TG2Result;
begin
  if not m_Initialized then
  begin
    m_Core := G2Core;
    m_Initialized := True;
    Result := grOk;
  end
  else
  Result := grRedundantCall;
end;

function TG2HighClass.Finalize: TG2Result;
begin
  if m_Initialized then
  begin
    m_Initialized := False;
    Result := grOk;
  end
  else
  Result := grRedundantCall;
end;
//TG2HighClass END

//TG2List BEGIN
destructor TG2List.Destroy;
begin
  FreeItems;
  inherited Destroy;
end;

procedure TG2List.FreeItems;
var
  i: Integer;
begin
  for i := 0 to Count - 1 do
  TObject(Items[i]).Free;
  Clear;
end;
//TG2List END

//TG2SortedList BEGIn
constructor TG2SortedList.Create;
begin
  inherited Create;
  m_List := TList.Create;
end;

destructor TG2SortedList.Destroy;
begin
  Clear;
  m_List.Free;
  inherited Destroy;
end;

function TG2SortedList.GetItem(const Index: Integer): Pointer;
begin
  Result := PSortedItem(m_List[Index])^.Item;
end;

function TG2SortedList.GetCount: Integer;
begin
  Result := m_List.Count;
end;

function TG2SortedList.FindItemIndex(const Order: DWord): Integer;
var
  l, h, m: Integer;
begin
  l := 0;
  h := m_List.Count - 1;
  while l <= h do
  begin
    m := (l + h) div 2;
    if Integer(PSortedItem(m_List[m])^.Order) - Integer(Order) < 0 then
    l := m + 1
    else
    h := m - 1;
  end;
  Result := l;
end;

procedure TG2SortedList.Add(const Item: Pointer; const Order: DWord);
var
  SortedItem: PSortedItem;
begin
  New(SortedItem);
  SortedItem^.Item := Item;
  SortedItem^.Order := Order;
  m_List.Insert(FindItemIndex(Order), SortedItem);
end;

procedure TG2SortedList.Clear;
var
  i: Integer;
begin
  for i := 0 to m_List.Count - 1 do
  Dispose(PSortedItem(m_List[i]));
  m_List.Clear;
end;
//TG2SortedList END

//TG2Engine BEGIN
constructor TG2Engine.Create;
begin
  inherited Create;
  m_Plugs := TG2List.Create;
  m_PlugClass := TG2Plug;
end;

destructor TG2Engine.Destroy;
begin
  Finalize;
  m_Plugs.Free;
  inherited Destroy;
end;

function TG2Engine.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
end;

function TG2Engine.Finalize: TG2Result;
begin
  Result := inherited Finalize;
end;

function TG2Engine.RequestPlug(
      const PlugClass: CG2PlugClass;
      const Plug: PG2Plug
    ): TG2Result;
begin
  if not Initialized then
  begin
    Result := grNotInitialized;
    Exit;
  end;
  if m_PlugClass <> PlugClass then
  begin
    Result := grInvalidCall;
    Exit;
  end;
  Plug^ := PlugClass.Create;
  Plug^.Engine := Self;
  Plug^.Initialize(Core);
  m_Plugs.Add(Plug^);
  Result := grOk;
end;

function TG2Engine.ReleasePlug(
      const Plug: PG2Plug
    ): TG2Result;
begin
  if not Initialized then
  begin
    Result := grNotInitialized;
    Exit;
  end;
  if not (Plug^ is m_PlugClass) then
  begin
    Result := grInvalidCall;
    Exit;
  end;
  m_Plugs.Remove(Plug^);
  Plug^.Finalize;
  Plug^.Free;
  Result := grOk;
end;
//TG2Engine END

//TG2Timer BEGIN
constructor TG2Timer.Create;
begin
  inherited Create;
  m_PlugClass := TG2PlugTimer;
  m_QPCAvailable := QueryPerformanceFrequency(m_Frequency);
  if not m_QPCAvailable then m_Frequency := 1000;
  m_MaxFPS := 100;
  m_TargetUPS := 100;
  m_FullSpeed := True;
  m_Mode := tmAppIdle;
end;

destructor TG2Timer.Destroy;
begin
  inherited Destroy;
end;

procedure TG2Timer.Start;
const
  TIME_KILL_SYNCHRONOUS = $0100;
begin
  ResetTimer;
  case m_Mode of
    tmAppIdle: Application.OnIdle := OnIdle;
    tmWinTimer: SetTimer(m_WndHandle, 1, 1, nil);
  end;
  m_TotalFPS := 0;
  m_TotalFPSCount := 0;
  G2WriteLogTimed('Timer Started.', 'Timer');
end;

procedure TG2Timer.Stop;
begin
  case m_Mode of
    tmAppIdle: Application.OnIdle := m_PrevIdle;
    tmWinTimer: KillTimer(m_WndHandle, 1);
  end;
  G2WriteLogTimed('Timer Stoped.', 'Timer');
  if m_TotalFPSCount > 0 then
  G2WriteLogTimed('Timer Average FPS = ' + IntToStr((m_TotalFPS div m_TotalFPSCount)), 'Timer');
end;

procedure TG2Timer.InitMode;
begin
  case m_Mode of
    tmAppIdle: m_PrevIdle := Application.OnIdle;
    tmWinTimer: m_WndHandle := AllocateHWnd(WndProc);
  end;
end;

procedure TG2Timer.UnInitMode;
begin
  case m_Mode of
    tmAppIdle: m_PrevIdle := nil;
    tmWinTimer:
    begin
      DeallocateHWnd(m_WndHandle);
      m_WndHandle := 0;
    end;
  end;
end;

procedure TG2Timer.SetMode(const Value: TG2TimerMode);
begin
  if m_Enabled then
  begin
    Enabled := False;
    UnInitMode;
    m_Mode := Value;
    InitMode;
    Enabled := True;
  end
  else
  begin
    UnInitMode;
    m_Mode := Value;
    InitMode;
  end;
end;

procedure TG2Timer.SetEnabled(const Value: Boolean);
begin
  if not Initialized
  or (Value = m_Enabled) then
  Exit;
  m_Enabled := Value;
  if m_Enabled then
  begin
    Start;
  end
  else
  begin
    Stop;
  end;
end;

procedure TG2Timer.ResetTimer;
var
  CurTime: Int64;
begin
  CurTime := GetTime;
  m_FPS := 0;
  m_FrameCount := 0;
  m_FPSUpdateTime := CurTime;
  m_PrevRenderTime := CurTime;
  m_PrevUpdateTime := CurTime;
  if m_MaxFPS = 0 then
  m_MaxRenderLag := 0
  else
  m_MaxRenderLag := m_Frequency div m_MaxFPS;
  if m_TargetUPS = 0 then
  m_MaxUpdateLag := 0
  else
  m_MaxUpdateLag := m_Frequency div m_TargetUPS;
end;

function TG2Timer.GetTime: Int64;
begin
  if m_QPCAvailable then
  QueryPerformanceCounter(Result)
  else
  Result := GetTickCount;
end;

procedure TG2Timer.OnIdle(Sender: TObject; var Done: Boolean);
begin
  if Assigned(m_PrevIdle) then
  m_PrevIdle(Sender, Done);
  OnTimer;
  Done := False;
end;

procedure TG2Timer.WndProc(var Msg: TMessage);
begin
  with Msg do
  if Msg = WM_TIMER then
  OnTimer
  else
  Result := DefWindowProc(m_WndHandle, Msg, wParam, lParam);
end;

procedure TG2Timer.OnTimer;
var
  i, j: Integer;
  CurTime: Int64;
  CurRenderLag: Int64;
  CurUpdateLag: Int64;
  UpdCount: Integer;
begin
  try
    CurTime := GetTime;

    if m_Enabled then
    for i := 0 to m_Plugs.Count - 1 do
    if Assigned(TG2PlugTimer(m_Plugs.Items[i]).OnTimer) then
    TG2PlugTimer(m_Plugs.Items[i]).OnTimer;

    CurUpdateLag := CurTime - m_PrevUpdateTime;
    if m_Enabled
    and (CurUpdateLag >= m_MaxUpdateLag) then
    begin
      UpdCount := CurUpdateLag div m_MaxUpdateLag;
      m_PrevUpdateTime := m_PrevUpdateTime + UpdCount * m_MaxUpdateLag;
      for j := 0 to UpdCount - 1 do
      for i := 0 to m_Plugs.Count - 1 do
      if Assigned(TG2PlugTimer(m_Plugs.Items[i]).OnUpdate) then
      TG2PlugTimer(m_Plugs.Items[i]).OnUpdate;
      m_PrevUpdateTime := CurTime - CurUpdateLag mod m_MaxUpdateLag;
    end;

    CurRenderLag := CurTime - m_PrevRenderTime;
    if m_Enabled
    and (
      (m_MaxFPS = 0)
      or (CurRenderLag >= m_MaxRenderLag)
    ) then
    begin
      for i := 0 to m_Plugs.Count - 1 do
      if Assigned(TG2PlugTimer(m_Plugs.Items[i]).OnRender) then
      TG2PlugTimer(m_Plugs.Items[i]).OnRender;
      Inc(m_FrameCount);
      m_PrevRenderTime := CurTime;
    end;

    if CurTime - m_FPSUpdateTime >= m_Frequency then
    begin
      m_FPS := m_FrameCount;
      m_TotalFPS := m_TotalFPS + m_FPS;
      Inc(m_TotalFPSCount);
      m_FrameCount := 0;
      m_FPSUpdateTime := CurTime;
    end;

    if not m_FullSpeed then Sleep(1);
  except
    on E : Exception do
    begin
      Enabled := False;
      G2WriteLogTimed('(E) ' + E.ClassName + ': ' + E.Message, 'Application');
      try
        Core.Free;
      finally
        Halt;
      end;
    end;
  end;
end;

function TG2Timer.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Initialization Started.', 'Timer');
  m_Enabled := False;
  InitMode;
  Result := grOk;
  G2WriteLogTimed('Initialization Finished.', 'Timer');
end;

function TG2Timer.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Finalization Started.', 'Timer');
  Enabled := False;
  UnInitMode;
  Result := grOk;
  G2WriteLogTimed('Finalization Finished.', 'Timer');
end;
//TG2Timer END

//TG2Graphics BEGIN
constructor TG2Graphics.Create;
begin
  inherited Create;
  m_PlugClass := TG2PlugGraphics;
  m_D3D9 := Direct3DCreate9(D3D_SDK_VERSION);
  m_InitParams := TG2GraphicsInitParams.Create;
  m_InitParams.m_G2Graphics := Self;
  m_InitParamsActual := TG2GraphicsInitParams.Create;
  m_InitParamsActual.m_G2Graphics := Self;
  m_Params := TG2GraphicsRunTimeParams.Create;
  m_Params.m_G2Graphics := Self;
  m_Specs := TG2GraphicsSpecs.Create;
  m_Specs.m_G2Graphics := Self;
  m_RenderStates := TG2RenderStates.Create;
  m_RenderStates.m_G2Graphics := Self;
  m_SamplerStates := TG2SamplerStates.Create;
  m_SamplerStates.m_G2Graphics := Self;
  m_TextureStageStates := TG2TextureStageStates.Create;
  m_TextureStageStates.m_G2Graphics := Self;
  m_Transforms := TG2Transforms.Create;
  m_Lights := TG2Lights.Create;
  m_SharedVB2D := TG2SharedVB2D.Create;
  m_Shared := TG2Shared.Create;
  m_SwapChains := TG2List.Create;
  m_DeviceLost := False;
end;

destructor TG2Graphics.Destroy;
begin
  m_SwapChains.Free;
  m_Shared.Free;
  m_SharedVB2D.Free;
  m_Lights.Free;
  m_Transforms.Free;
  m_TextureStageStates.Free;
  m_SamplerStates.Free;
  m_RenderStates.Free;
  m_Specs.Free;
  m_Params.Free;
  m_InitParamsActual.Free;
  m_InitParams.Free;
  SafeRelease(m_D3D9);
  inherited Destroy;
end;

function TG2Graphics.InitializeDevice: TG2Result;
var
  BehaviorFlags: DWord;
  hr: HResult;
begin
  UpdatePresentParams;
  
  BehaviorFlags := 0;
  case m_InitParamsActual.VertexProcessing of
    vpSoftware: BehaviorFlags := BehaviorFlags or D3DCREATE_SOFTWARE_VERTEXPROCESSING;
    vpHardware: BehaviorFlags := BehaviorFlags or D3DCREATE_HARDWARE_VERTEXPROCESSING;
    vpMixed: BehaviorFlags := BehaviorFlags or D3DCREATE_MIXED_VERTEXPROCESSING;
  end;

  if m_InitParamsActual.MultiThreaded then
  BehaviorFlags := BehaviorFlags or D3DCREATE_MULTITHREADED;

  if m_InitParamsActual.PureDevice then
  BehaviorFlags := BehaviorFlags or D3DCREATE_PUREDEVICE;

  hr := m_D3D9.CreateDevice(
    m_InitParamsActual.Adapter,
    m_InitParamsActual.DeviceType,
    Core.Handle,
    BehaviorFlags,
    @m_PresentParams,
    m_Device
  );

  if Succeeded(hr) then
  begin
    m_Specs.Initialize(Self);
    m_Device.GetDeviceCaps(m_Caps);
    m_Device.GetViewport(m_DefaultViewPort);
    m_Device.GetRenderTarget(0, m_DefaultBackBuffer);
    m_Device.CreateDepthStencilSurface(
      m_DefaultViewPort.Width,
      m_DefaultViewPort.Height,
      m_InitParamsActual.DepthStencilFormat,
      m_PresentParams.MultiSampleType,
      m_PresentParams.MultiSampleQuality,
      True,
      m_DefaultDepthStencil,
      nil
    );
    if not m_InitParamsActual.FullScreen then
    m_DefaultSwapChain := SwapChainAdd(
      Core.Handle,
      m_DefaultViewPort.Width,
      m_DefaultViewPort.Height
    );
    m_CurSwapChain := nil;
    RenderToBackBuffer;
    m_RenderStates.SetDefaults;
    m_SamplerStates.SetDefaults;
    m_TextureStageStates.SetDefaults;
    m_Transforms.Initialize(Core);
    m_Lights.Initialize(Core);
    m_SharedVB2D.Initialize(Self);
    m_Shared.Initialize(Core);
    SetMaterialDefault;
    Core.RequestMod(TG2ShaderLib, @m_ShaderLib);
    Result := grOk;
  end
  else
  begin
    G2WriteLogTimed('(E) InitializeDevice Failed: ' + DXGetErrorDescription9A(hr), 'Graphics');
    Result := grFail;
  end;
end;

function TG2Graphics.FinalizeDevice: TG2Result;
begin
  Core.ReleaseMod(@m_ShaderLib);
  m_Shared.Finalize;
  m_SharedVB2D.Finalize;
  m_Lights.Finalize;
  m_Transforms.Finalize;
  SafeRelease(m_DefaultBackBuffer);
  SafeRelease(m_DefaultDepthStencil);
  SwapChainRemove(m_DefaultSwapChain);
  SafeRelease(m_Device);
  Result := grOk;
end;

function TG2Graphics.LostDevice: TG2Result;
var
  i: Integer;
begin
  if m_DeviceLost then
  begin
    Result := grFail;
    Exit;
  end;
  SafeRelease(m_DefaultBackBuffer);
  SafeRelease(m_DefaultDepthStencil);

  m_SharedVB2D.OnDeviceLost;
  m_Transforms.OnDeviceLost;
  m_Lights.OnDeviceLost;

  for i := 0 to m_SwapChains.Count - 1 do
  TG2SwapChain(m_SwapChains[i]).OnLostDevice;

  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugGraphics(m_Plugs[i]).OnDeviceLost) then
  TG2PlugGraphics(m_Plugs[i]).OnDeviceLost;
  m_DeviceLost := True;
  Result := grOk;
  G2WriteLogTimed('(W) Device Lost.', 'Graphics');
end;

function TG2Graphics.ResetDevice: TG2Result;
var
  i: Integer;
  hr: HResult;
begin
  if not m_DeviceLost then LostDevice;
  if G2ResFail(m_InitParamsActual.Verify) then
  begin                                     
    Result := grFail;
    Exit;                  
  end;

  UpdatePresentParams;

  hr := m_Device.Reset(m_PresentParams);
  if Failed(hr) then
  begin
    Result := grFail;
    Exit;
  end;

  m_Device.GetRenderTarget(0, m_DefaultBackBuffer);
  m_Device.CreateDepthStencilSurface(
    m_DefaultViewPort.Width,
    m_DefaultViewPort.Height,
    m_InitParamsActual.DepthStencilFormat,
    m_PresentParams.MultiSampleType,
    m_PresentParams.MultiSampleQuality,
    True,
    m_DefaultDepthStencil,
    nil
  );

  for i := 0 to m_SwapChains.Count - 1 do
  TG2SwapChain(m_SwapChains[i]).OnResetDevice;
  if Assigned(m_CurSwapChain) then
  RenderToSwapChain(m_CurSwapChain)
  else
  RenderToBackBuffer;

  m_TextureStageStates.SetFromMemory;
  m_SamplerStates.SetFromMemory;
  m_RenderStates.SetFromMemory;
  m_Transforms.OnDeviceReset;
  m_Lights.OnDeviceReset;
  m_SharedVB2D.OnDeviceReset;
  SetMaterialFromMemory;

  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugGraphics(m_Plugs[i]).OnDeviceReset) then
  TG2PlugGraphics(m_Plugs[i]).OnDeviceReset;

  m_DeviceLost := False;
  Result := grOk;
  G2WriteLogTimed('Device Reset.', 'Graphics');
end;

procedure TG2Graphics.UpdatePresentParams;
begin
  ZeroMemory(@m_PresentParams, SizeOf(m_PresentParams));
  m_PresentParams.BackBufferWidth := m_InitParamsActual.Width;
  m_PresentParams.BackBufferHeight := m_InitParamsActual.Height;
  if m_InitParamsActual.FullScreen then
  m_PresentParams.BackBufferFormat := m_InitParamsActual.Format
  else
  m_PresentParams.BackBufferFormat := D3DFMT_UNKNOWN;
  m_PresentParams.BackBufferCount := 1;
  m_PresentParams.MultiSampleQuality := 0;
  if m_InitParamsActual.VSync
  and not m_InitParamsActual.FullScreen then
  m_PresentParams.SwapEffect := D3DSWAPEFFECT_COPY
  else
  m_PresentParams.SwapEffect := D3DSWAPEFFECT_DISCARD;
  if m_InitParamsActual.Antialiasing
  and (m_PresentParams.SwapEffect = D3DSWAPEFFECT_DISCARD) then
  m_PresentParams.MultiSampleType := TD3DMultiSampleType(m_InitParamsActual.AntialiasingSampleCount)
  else
  m_PresentParams.MultiSampleType := D3DMULTISAMPLE_NONE;
  m_PresentParams.hDeviceWindow := Core.Handle;
  m_PresentParams.Windowed := not m_InitParamsActual.FullScreen;
  m_PresentParams.EnableAutoDepthStencil := False;
  if m_InitParamsActual.VSync then
  m_PresentParams.PresentationInterval := D3DPRESENT_INTERVAL_ONE
  else
  m_PresentParams.PresentationInterval := D3DPRESENT_INTERVAL_IMMEDIATE;
  m_PresentParams.Flags := 0;
end;

procedure TG2Graphics.Update;
var
  hr: HResult;
begin
  if not m_Initialized then Exit;
  hr := m_Device.TestCooperativeLevel;
  if Failed(hr) then
  begin
    case hr of
      D3DERR_DEVICELOST:
      begin
        LostDevice;
      end;
      D3DERR_DEVICENOTRESET:
      begin
        ResetDevice;
      end;
    end;
  end;
end;

function TG2Graphics.GetCanRender: Boolean;
begin
  Result := not m_DeviceLost;
end;

procedure TG2Graphics.HardReset;
begin
  m_PresentParams.BackBufferWidth := m_InitParamsActual.Width;
  m_PresentParams.BackBufferHeight := m_InitParamsActual.Height;
  m_DefaultViewPort.X := 0;
  m_DefaultViewPort.Y := 0;
  m_DefaultViewPort.Width := m_InitParamsActual.Width;
  m_DefaultViewPort.Height := m_InitParamsActual.Height;
  LostDevice;
  ResetDevice;
  RenderToBackBuffer;
end;

procedure TG2Graphics.QuickReset;
begin
  m_PresentParams.BackBufferWidth := m_InitParamsActual.Width;
  m_PresentParams.BackBufferHeight := m_InitParamsActual.Height;
  m_DefaultViewPort.X := 0;
  m_DefaultViewPort.Y := 0;
  m_DefaultViewPort.Width := m_InitParamsActual.Width;
  m_DefaultViewPort.Height := m_InitParamsActual.Height;
  m_DefaultSwapChain.Reset(
    m_InitParamsActual.Width,
    m_InitParamsActual.Height
  );
  RenderToBackBuffer;
end;

procedure TG2Graphics.ParamsChange;
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugGraphics(m_Plugs[i]).OnParamsChange) then
  TG2PlugGraphics(m_Plugs[i]).OnParamsChange;
end;

function TG2Graphics.Initialize(const G2Core: TG2Core): TG2Result;
{$IFDEF G2_WRITE_LOG}
var
  Caps: TD3DCaps9;
  AdapterIdentifier: TD3DAdapterIdentifier9;
  DisplayMode: TD3DDisplayMode;
  ParamsString: AnsiString;
const
  Sp = '                            ';
{$ENDIF}
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Initialization Started.', 'Graphics');
  m_InitParams.Clone(m_InitParamsActual);
  Result := m_InitParamsActual.Verify;
  if G2ResFail(Result) then
  begin
    G2WriteLogTimed('(E) Initialization Failed: Unacceptable InitParams.', 'Graphics');
    m_Initialized := False;
    Exit;
  end;
  {$IFDEF G2_WRITE_LOG}
  m_D3D9.GetDeviceCaps(m_InitParamsActual.Adapter, m_InitParamsActual.DeviceType, Caps);
  m_D3D9.GetAdapterIdentifier(m_InitParamsActual.Adapter, 0, AdapterIdentifier);
  m_D3D9.GetAdapterDisplayMode(m_InitParamsActual.Adapter, DisplayMode);
  G2WriteLogTimed('Adapter: ' + AdapterIdentifier.Description, 'Graphics');
  G2WriteLogTimed('Adapter Driver: ' + AdapterIdentifier.Driver, 'Graphics');
  G2WriteLogTimed('System Display Mode: ' + IntToStr(DisplayMode.Width) + 'x' + IntToStr(DisplayMode.Height) + ' ' + IntToStr(DisplayMode.RefreshRate) + 'Hz', 'Graphics');
  ParamsString := 'Initialization Parameters:'#$D#$A#$D#$A;
  if m_InitParamsActual.FullScreen then
  ParamsString := ParamsString + Sp + 'FullScreen '
  else
  ParamsString := ParamsString + Sp + 'Windowed ';
  ParamsString := ParamsString + IntToStr(m_InitParamsActual.Width) + 'x' + IntToStr(m_InitParamsActual.Height) + #$D#$A;
  if m_InitParamsActual.Antialiasing then
  ParamsString := ParamsString + Sp + 'Antialiasing: ' + IntToStr(m_InitParamsActual.AntialiasingSampleCount) + 'x'#$D#$A;
  ParamsString := ParamsString + Sp + 'Back Buffer Format: ' + G2FormatToString(m_InitParamsActual.Format) + #$D#$A;
  ParamsString := ParamsString + Sp + 'Depth-Stencil Format: ' + G2FormatToString(m_InitParamsActual.DepthStencilFormat) + #$D#$A;
  ParamsString := ParamsString + Sp + 'Default Texture Format: ' + G2FormatToString(m_InitParamsActual.DefaultTextureFormat) + #$D#$A;
  ParamsString := ParamsString + Sp + 'Default RenderTarget Format: ' + G2FormatToString(m_InitParamsActual.DefaultRenderTargetFormat) + #$D#$A;
  ParamsString := ParamsString + Sp + 'Device Settings: ';
  if m_InitParamsActual.MultiThreaded then
  ParamsString := ParamsString + '[Multithreaded]';
  if m_InitParamsActual.PureDevice then
  ParamsString := ParamsString + '[Pure Device]';
  if m_InitParamsActual.FastPresent then
  ParamsString := ParamsString + '[Fast Present]';
  if m_InitParamsActual.VSync then
  ParamsString := ParamsString + '[VSync]';
  ParamsString := ParamsString + #$D#$A + Sp + 'Device Capabilities:'#$D#$A;
  ParamsString := ParamsString + Sp + 'Max Texture Size: ' + IntToStr(Caps.MaxTextureWidth) + 'x' + IntToStr(Caps.MaxTextureHeight) + #$D#$A;
  ParamsString := ParamsString + Sp + 'Max Texture Blend Stages: ' + IntToStr(Caps.MaxTextureBlendStages) + #$D#$A;
  ParamsString := ParamsString + Sp + 'Max Simultanious Textures: ' + IntToStr(Caps.MaxSimultaneousTextures) + #$D#$A;
  ParamsString := ParamsString + Sp + 'VertexShader Version: ' + IntToStr(D3DSHADER_VERSION_MAJOR(Caps.VertexShaderVersion)) + '.' + IntToStr(D3DSHADER_VERSION_MINOR(Caps.VertexShaderVersion)) + #$D#$A;
  ParamsString := ParamsString + Sp + 'PixelShader Version: ' + IntToStr(D3DSHADER_VERSION_MAJOR(Caps.PixelShaderVersion)) + '.' + IntToStr(D3DSHADER_VERSION_MINOR(Caps.PixelShaderVersion)) + #$D#$A;
  G2WriteLogTimed(ParamsString, 'Graphics');
  {$ENDIF}
  Result := InitializeDevice;
  if G2ResFail(Result) then
  begin
    G2WriteLogTimed('Initialization Failed.', 'Graphics');
    m_Initialized := False;
    Exit;
  end;
  m_Params.Assign(m_InitParamsActual);
  Core.RequestPlug(TG2PlugTimer, @m_PlugTimer);
  m_PlugTimer.OnTimer := Update;
  G2WriteLogTimed('Initialization Finished.', 'Graphics');
end;

function TG2Graphics.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Finalization Started.', 'Graphics');
  Core.ReleasePlug(@m_PlugTimer);
  Result := FinalizeDevice;
  G2WriteLogTimed('Finalization Finished.', 'Graphics');
end;

function TG2Graphics.SwapChainAdd(const Handle: HWND; const SurfaceWidth, SurfaceHeight: Word): TG2SwapChain;
begin
  Result := TG2SwapChain.Create;
  Result.m_G2Graphics := Self;
  Result.Initialize(Handle, SurfaceWidth, SurfaceHeight, m_PresentParams);
  m_SwapChains.Add(Result);
end;

procedure TG2Graphics.SwapChainRemove(const SwapChain: TG2SwapChain);
begin
  m_SwapChains.Remove(SwapChain);
  SwapChain.Free;
end;

procedure TG2Graphics.SetViewPortDefault;
begin
  m_Device.SetViewport(m_CurDefViewPort^);
end;

procedure TG2Graphics.SetViewPort(const X, Y, Width, Height: Integer);
var
  TmpViewPort: TD3DViewPort9;
begin
  TmpViewPort := m_CurDefViewPort^;
  TmpViewPort.X := X;
  TmpViewPort.Y := Y;
  TmpViewPort.Width := Width;
  TmpViewPort.Height := Height;
  m_Device.SetViewport(TmpViewPort);
end;

function TG2Graphics.GetViewPort: TD3DViewPort9;
begin
  m_Device.GetViewport(Result);
end;

procedure TG2Graphics.SetMaterialDefault;
begin
  SetMaterial($ffffffff, $ffffffff, $00000000, $00000000, 0);
end;

procedure TG2Graphics.SetMaterialFromMemory;
begin
  Device.SetMaterial(m_Material);
end;

procedure TG2Graphics.SetMaterial(
      const Diffuse: TG2Color;
      const Ambient: TG2Color;
      const Specular: TG2Color;
      const Emissive: TG2Color;
      const SpecPower: Single
    );
begin
  m_Material.Diffuse := Diffuse;
  m_Material.Ambient := Ambient;
  m_Material.Specular := Specular;
  m_Material.Emissive := Emissive;
  m_Material.Power := SpecPower;
  Device.SetMaterial(m_Material);
end;

procedure TG2Graphics.RenderToSurface(const Surface, DepthStencil: IDirect3DSurface9);
begin
  m_Device.SetRenderTarget(0, Surface);
  m_Device.SetDepthStencilSurface(DepthStencil);
end;

procedure TG2Graphics.RenderToSwapChain(const SwapChain: TG2SwapChain);
begin
  m_CurSwapChain := SwapChain;
  RenderToSurface(SwapChain.BackBuffer, SwapChain.DepthStencil);
  m_CurDefViewPort := SwapChain.ViewPort;
end;

procedure TG2Graphics.RenderToTexture2D(const Texture: TG2Texture2DRT);
var
  TextureSurface: IDirect3DSurface9;
begin
  m_CurSwapChain := nil;
  IDirect3DTexture9(Texture.Texture).GetSurfaceLevel(0, TextureSurface);
  RenderToSurface(TextureSurface, Texture.DepthStencil);
  m_CurDefViewPort := Texture.ViewPort;
  SafeRelease(TextureSurface);
end;

procedure TG2Graphics.RenderToBackBuffer;
begin
  m_CurSwapChain := nil;
  if m_InitParamsActual.FullScreen
  or m_InitParamsActual.FastPresent then
  begin
    RenderToSurface(m_DefaultBackBuffer, m_DefaultDepthStencil);
    m_CurDefViewPort := @m_DefaultViewPort;
  end
  else
  RenderToSwapChain(m_DefaultSwapChain);
end;
//TG2Graphics END

//TG2GraphicsSpecs BEGIN
constructor TG2GraphicsSpecs.Create;
begin
  inherited Create;
  m_List := TG2SortedList.Create;
end;

destructor TG2GraphicsSpecs.Destroy;
begin
  m_List.Free;
  inherited Destroy;
end;

procedure TG2GraphicsSpecs.Initialize(const G2Graphics: TG2Graphics);
begin
  m_G2Graphics := G2Graphics;
  m_G2Graphics.D3D9.GetAdapterDisplayMode(
    m_G2Graphics.m_InitParamsActual.Adapter,
    m_DisplayMode
  );
end;

function TG2GraphicsSpecs.FindCompatiableTextureFormat(const Format: TD3DFormat): TD3DFormat;
type
  TFormatScore = record
    Format: TD3DFormat;
    Score: DWord;
  end;
const
  FormatScores: array[0..8] of TFormatScore = (
    (Format: D3DFMT_DXT1; Score: 10),
    (Format: D3DFMT_DXT2; Score: 19),
    (Format: D3DFMT_DXT3; Score: 31),
    (Format: D3DFMT_DXT4; Score: 41),
    (Format: D3DFMT_DXT5; Score: 49),
    (Format: D3DFMT_A4R4G4B4; Score: 59),
    (Format: D3DFMT_A8R8G8B8; Score: 71),
    (Format: D3DFMT_X8R8G8B8; Score: 79),
    (Format: D3DFMT_R5G6B5; Score: 90)
  );
var
  i: Integer;
  Score: DWord;
begin
  if Succeeded(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_G2Graphics.m_InitParamsActual.Adapter,
      m_G2Graphics.m_InitParamsActual.DeviceType,
      m_DisplayMode.Format,
      0,
      D3DRTYPE_TEXTURE,
      Format
    )
  ) then
  begin
    Result := Format;
    Exit;
  end;
  Result := D3DFMT_UNKNOWN;
  Score := 60;
  for i := 0 to High(FormatScores) do
  if FormatScores[i].Format = Format then
  begin
    Score := FormatScores[i].Score;
    Break;
  end;
  for i := 0 to High(FormatScores) do
  if FormatScores[i].Format <> Format then
  m_List.Add(@FormatScores[i].Format, Abs(FormatScores[i].Score - Score));
  for i := 0 to m_List.Count - 1 do
  if Succeeded(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_G2Graphics.m_InitParamsActual.Adapter,
      m_G2Graphics.m_InitParamsActual.DeviceType,
      m_DisplayMode.Format,
      0,
      D3DRTYPE_TEXTURE,
      PD3DFormat(m_List.Items[i])^
    )
  ) then
  begin
    Result := PD3DFormat(m_List.Items[i])^;
    Break;
  end;
  m_List.Clear;
end;

function TG2GraphicsSpecs.FindCompatiableTextureRTFormat(const Format: TD3DFormat): TD3DFormat;
type
  TFormatScore = record
    Format: TD3DFormat;
    Score: DWord;
  end;
const
  FormatScores: array[0..8] of TFormatScore = (
    (Format: D3DFMT_DXT1; Score: 10),
    (Format: D3DFMT_DXT2; Score: 19),
    (Format: D3DFMT_DXT3; Score: 31),
    (Format: D3DFMT_DXT4; Score: 41),
    (Format: D3DFMT_DXT5; Score: 49),
    (Format: D3DFMT_A4R4G4B4; Score: 59),
    (Format: D3DFMT_A8R8G8B8; Score: 71),
    (Format: D3DFMT_X8R8G8B8; Score: 79),
    (Format: D3DFMT_R5G6B5; Score: 90)
  );
var
  i: Integer;
  Score: DWord;
begin
  if Succeeded(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_G2Graphics.m_InitParamsActual.Adapter,
      m_G2Graphics.m_InitParamsActual.DeviceType,
      m_DisplayMode.Format,
      D3DUSAGE_RENDERTARGET,
      D3DRTYPE_TEXTURE,
      Format
    )
  ) then
  begin
    Result := Format;
    Exit;
  end;
  Result := D3DFMT_UNKNOWN;
  Score := 60;
  for i := 0 to High(FormatScores) do
  if FormatScores[i].Format = Format then
  begin
    Score := FormatScores[i].Score;
    Break;
  end;
  for i := 0 to High(FormatScores) do
  if FormatScores[i].Format <> Format then
  m_List.Add(@FormatScores[i].Format, Abs(FormatScores[i].Score - Score));
  for i := 0 to m_List.Count - 1 do
  if Succeeded(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_G2Graphics.m_InitParamsActual.Adapter,
      m_G2Graphics.m_InitParamsActual.DeviceType,
      m_DisplayMode.Format,
      D3DUSAGE_RENDERTARGET,
      D3DRTYPE_TEXTURE,
      PD3DFormat(m_List.Items[i])^
    )
  ) then
  begin
    Result := PD3DFormat(m_List.Items[i])^;
    Break;
  end;
  m_List.Clear;
end;
//TG2GraphicsSpecs END

//TG2GraphicsInitParams BEGIN
constructor TG2GraphicsInitParams.Create;
begin
  inherited Create;
  Defaults;
end;

destructor TG2GraphicsInitParams.Destroy;
begin
  inherited Destroy;
end;

function TG2GraphicsInitParams.Verify: TG2Result;
type
  TModeScore = record
    Score: Single;
  end;
var
  i, j: Integer;
  ModeCount: DWord;
  CurMode: TD3DDisplayMode;
  ModeScore: array of TModeScore;
  Mode: Integer;
  ModeAccepted: Boolean;
  MaxScore: Single;
  Caps: TD3DCaps9;
  VertexCaps: DWord;
  RenderFormat: TD3DFormat;
  SurfaceFormats: array of TD3DFormat;
  AdapterIdentifier: TD3DAdapterIdentifier9;
const
  DepthStencilFormats: array[0..5] of TD3DFormat = (
    D3DFMT_D24S8,
    D3DFMT_D24X4S4,
    D3DFMT_D15S1,
    D3DFMT_D32,
    D3DFMT_D24X8,
    D3DFMT_D16
  );
  RTFormats: array[0..3] of TD3DFormat = (
    D3DFMT_A8R8G8B8,
    D3DFMT_X8R8G8B8,
    D3DFMT_R8G8B8,
    D3DFMT_R5G6B5
  );
  TexFormats: array[0..7] of TD3DFormat = (
    D3DFMT_DXT3,
    D3DFMT_DXT4,
    D3DFMT_DXT2,
    D3DFMT_DXT5,
    D3DFMT_DXT1,
    D3DFMT_A8R8G8B8,
    D3DFMT_A4R4G4B4,
    D3DFMT_A1R5G5B5    
  );
begin
  Result := grOk;

  {$IFDEF G2_PERFHUD}
  for i := 0 to m_G2Graphics.D3D9.GetAdapterCount - 1 do
  begin
    m_G2Graphics.D3D9.GetAdapterIdentifier(i, 0, AdapterIdentifier);
    if G2StrInStr(AdapterIdentifier.Description, 'PerfHUD') > 0 then
    begin
      m_Adapter := i;
      m_DeviceType := D3DDEVTYPE_REF;
    end;
  end;
  {$ENDIF}

  m_G2Graphics.D3D9.GetAdapterDisplayMode(m_Adapter, CurMode);
  RenderFormat := CurMode.Format;

  if m_Format = m_DefaultRenderTargetFormat then
  begin
    SetLength(SurfaceFormats, 1);
    SurfaceFormats[0] := m_Format;
    j := 1;
  end
  else
  begin
    SetLength(SurfaceFormats, 2);
    SurfaceFormats[0] := m_Format;
    SurfaceFormats[1] := m_DefaultRenderTargetFormat;
    j := 2;
  end;
  for i := 0 to High(RTFormats) do
  if (RTFormats[i] <> m_Format)
  and (RTFormats[i] <> m_DefaultRenderTargetFormat) then
  begin
    SetLength(SurfaceFormats, j + 1);
    SurfaceFormats[j] := RTFormats[i];
    Inc(j);
  end;
  
  m_G2Graphics.D3D9.GetDeviceCaps(m_Adapter, m_DeviceType, Caps);
  
  if m_FullScreen then
  begin
    ModeAccepted := False;
    ModeCount := m_G2Graphics.D3D9.GetAdapterModeCount(m_Adapter, RenderFormat);
    SetLength(ModeScore, ModeCount);
    for i := 0 to ModeCount - 1 do
    begin
      m_G2Graphics.D3D9.EnumAdapterModes(m_Adapter, RenderFormat, i, CurMode);
      if (CurMode.Width = m_Width)
      and (CurMode.Height = m_Height) then
      begin
        ModeAccepted := True;
        Break;
      end
      else
      begin
        ModeScore[i].Score := 1 - Min(
          Max(
            Abs(CurMode.Width - m_Width) * 0.001 +
            Abs(CurMode.Height - m_Height) * 0.001,
            0
          ),
          1
        );
      end;
    end;
    if not ModeAccepted then
    begin
      if ModeCount = 0 then
      begin
        Result := grFail;
        Exit;
      end;
      Mode := 0;
      MaxScore := ModeScore[Mode].Score;
      for i := 1 to High(ModeScore) do
      begin
        if ModeScore[i].Score > MaxScore then
        begin
          Mode := i;
          MaxScore := ModeScore[i].Score;
        end;
      end;
      m_G2Graphics.D3D9.EnumAdapterModes(m_Adapter, RenderFormat, Mode, CurMode);
      m_Width := CurMode.Width;
      m_Height := CurMode.Height;
    end;
  end;

  i := 0;
  while Failed(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_Adapter,
      m_DeviceType,
      RenderFormat,
      D3DUSAGE_RENDERTARGET,
      D3DRTYPE_SURFACE,
      m_Format
    )
  ) do
  begin
    if i > High(SurfaceFormats) then
    begin
      Result := grFail;
      Exit;
    end;
    m_Format := SurfaceFormats[i];
    Inc(i);
  end;

  i := 0;
  while Failed(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_Adapter,
      m_DeviceType,
      RenderFormat,
      D3DUSAGE_RENDERTARGET,
      D3DRTYPE_SURFACE,
      m_DefaultRenderTargetFormat
    )
  ) do
  begin
    if i > High(SurfaceFormats) then
    begin
      Result := grFail;
      Exit;
    end;
    m_DefaultRenderTargetFormat := SurfaceFormats[i];
    Inc(i);
  end;

  i := 0;
  while Failed(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_Adapter,
      m_DeviceType,
      RenderFormat,
      0,
      D3DRTYPE_TEXTURE,
      m_DefaultTextureFormat
    )
  ) do
  begin
    if i > High(TexFormats) then
    begin
      Result := grFail;
      Exit;
    end;
    m_DefaultTextureFormat := TexFormats[i];
    Inc(i);
  end;

  if Failed(
    m_G2Graphics.D3D9.CheckDeviceFormat(
      m_Adapter,
      m_DeviceType,
      RenderFormat,
      D3DUSAGE_DEPTHSTENCIL,
      D3DRTYPE_SURFACE,
      m_DepthStencilFormat
    )
  )
  or Failed(
    m_G2Graphics.D3D9.CheckDepthStencilMatch(
      m_Adapter,
      m_DeviceType,
      RenderFormat,
      m_Format,
      m_DepthStencilFormat
    )
  ) then
  begin
    Result := grFail;
    for i := 0 to High(DepthStencilFormats) do
    begin
      m_DepthStencilFormat := DepthStencilFormats[i];
      if Succeeded(
        m_G2Graphics.D3D9.CheckDeviceFormat(
          m_Adapter,
          m_DeviceType,
          RenderFormat,
          D3DUSAGE_DEPTHSTENCIL,
          D3DRTYPE_SURFACE,
          m_DepthStencilFormat
        )
      )
      and Succeeded(
        m_G2Graphics.D3D9.CheckDepthStencilMatch(
          m_Adapter,
          m_DeviceType,
          RenderFormat,
          m_Format,
          m_DepthStencilFormat
        )
      ) then
      begin
        Result := grConditionalOk;
        Break;
      end;
    end;
    if G2ResFail(Result) then Exit;
  end;

  if m_AntialiasingSampleCount > 16 then
  m_AntialiasingSampleCount := 16;
  if m_AntialiasingSampleCount <= 1 then
  m_Antialiasing := False;
  if m_Antialiasing then
  begin
    while Failed(
      m_G2Graphics.D3D9.CheckDeviceMultiSampleType(
        m_Adapter,
        m_DeviceType,
        m_Format,
        not m_Fullscreen,
        TD3DMultiSampleType(m_AntialiasingSampleCount),
        nil
      )
    ) do
    begin
      Result := grConditionalOk;
      Dec(m_AntialiasingSampleCount);
      if m_AntialiasingSampleCount <= 1 then
      begin
        m_Antialiasing := False;
        Break;
      end;
    end;
  end;
  
  if m_PureDevice then
  begin
    VertexCaps := D3DVTXPCAPS_DIRECTIONALLIGHTS
    or D3DVTXPCAPS_LOCALVIEWER
    or D3DVTXPCAPS_POSITIONALLIGHTS
    or D3DVTXPCAPS_TEXGEN
    or D3DVTXPCAPS_TWEENING;
    if not m_FullScreen
    or (Caps.Caps and D3DDEVCAPS_HWTRANSFORMANDLIGHT = 0)
    or (Caps.VertexProcessingCaps and VertexCaps <> VertexCaps) then
    begin
      Result := grConditionalOk;
      m_PureDevice := False;
    end;
  end;
  
  if (
    (m_VertexProcessing = vpHardware)
    or (m_VertexProcessing = vpMixed)
  )
  and (
    (Caps.Caps and D3DDEVCAPS_HWTRANSFORMANDLIGHT = 0)
    or (Caps.VertexProcessingCaps = 0)
  ) then
  begin
    Result := grConditionalOk;
    m_VertexProcessing := vpSoftware;
  end;
end;

procedure TG2GraphicsInitParams.Defaults;
begin
  m_Adapter := D3DADAPTER_DEFAULT;
  m_DeviceType := D3DDEVTYPE_HAL;
  m_Width := 800;
  m_Height := 600;
  m_Format := D3DFMT_A8R8G8B8;
  m_DepthStencilFormat := D3DFMT_D16;
  m_FullScreen := False;
  m_VSync := False;
  m_Antialiasing := False;
  m_AntialiasingSampleCount := 0;
  m_VertexProcessing := vpSoftware;
  m_MultiThreaded := True;
  m_PureDevice := False;
  m_FastPresent := False;
  m_DefaultTextureFormat := D3DFMT_DXT3;
  m_DefaultRenderTargetFormat := D3DFMT_A8R8G8B8;
end;

procedure TG2GraphicsInitParams.Clone(const Params: TG2GraphicsInitParams);
begin
  Params.m_Adapter := Self.m_Adapter;
  Params.m_DeviceType := Self.m_DeviceType;
  Params.m_Width := Self.m_Width;
  Params.m_Height := Self.m_Height;
  Params.m_Format := Self.m_Format;
  Params.m_DepthStencilFormat := Self.m_DepthStencilFormat;
  Params.m_FullScreen := Self.m_FullScreen;
  Params.m_VSync := Self.m_VSync;
  Params.m_Antialiasing := Self.m_Antialiasing;
  Params.m_AntialiasingSampleCount := Self.m_AntialiasingSampleCount;
  Params.m_VertexProcessing := Self.m_VertexProcessing;
  Params.m_MultiThreaded := Self.m_MultiThreaded;
  Params.m_PureDevice := Self.m_PureDevice;
  Params.m_FastPresent := Self.m_FastPresent;
  Params.m_DefaultTextureFormat := Self.m_DefaultTextureFormat;
  Params.m_DefaultRenderTargetFormat := Self.m_DefaultRenderTargetFormat;
end;
//TG2GraphicsInitParams END

//TG2GraphicsRunTimeParams BEGIN
constructor TG2GraphicsRunTimeParams.Create;
begin
  inherited Create;
end;

destructor TG2GraphicsRunTimeParams.Destroy;
begin
  inherited Destroy;
end;

procedure TG2GraphicsRunTimeParams.Assign(const Params: TG2GraphicsInitParams);
begin
  Self.m_Adapter := Params.Adapter;
  Self.m_DeviceType := Params.DeviceType;
  Self.m_Width := Params.Width;
  Self.m_Height := Params.Height;
  Self.m_Format := Params.Format;
  Self.m_DepthStencilFormat := Params.DepthStencilFormat;
  Self.m_FullScreen := Params.FullScreen;
  Self.m_VSync := Params.VSync;
  Self.m_Antialiasing := Params.Antialiasing;
  Self.m_AntialiasingSampleCount := Params.AntialiasingSampleCount;
  Self.m_VertexProcessing := Params.VertexProcessing;
  Self.m_MultiThreaded := Params.MultiThreaded;
  Self.m_PureDevice := Params.PureDevice;
  Self.m_FastPresent := Params.FastPresent;
  Self.m_DefaultTextureFormat := Params.DefaultTextureFormat;
  Self.m_DefaultRenderTargetFormat := Params.DefaultRenderTargetFormat;
end;

function TG2GraphicsRunTimeParams.Apply: TG2Result;
var
  SizeChange: Boolean;
  QuickFormatChange: Boolean;
  AnyChanges: Boolean;
  NeedReset: Boolean;
begin
  SizeChange := False;
  QuickFormatChange := False;
  if m_G2GRaphics.m_InitParamsActual.Width <> m_Width then SizeChange := True;
  if m_G2GRaphics.m_InitParamsActual.Height <> m_Height then SizeChange := True;
  if m_G2GRaphics.m_InitParamsActual.DefaultTextureFormat <> m_DefaultTextureFormat then QuickFormatChange := True;
  if m_G2GRaphics.m_InitParamsActual.DefaultRenderTargetFormat <> m_DefaultRenderTargetFormat then QuickFormatChange := True;
  NeedReset := SizeChange and m_FastPresent;
  AnyChanges := SizeChange;
  if AnyChanges then
  begin
    if SizeChange then
    begin
      m_G2GRaphics.m_InitParamsActual.Width := m_Width;
      m_G2GRaphics.m_InitParamsActual.Height := m_Height;
    end;
    if QuickFormatChange then
    begin
      m_G2GRaphics.m_InitParamsActual.DefaultTextureFormat := m_DefaultTextureFormat;
      m_G2GRaphics.m_InitParamsActual.DefaultRenderTargetFormat := m_DefaultRenderTargetFormat;
    end;
    if NeedReset then
    begin
      G2WriteLogTimed('New Paremeters, reset required.', 'Graphics');
      m_G2GRaphics.HardReset
    end
    else
    m_G2GRaphics.QuickReset;
    m_G2GRaphics.ParamsChange;
  end;
  Result := grOk;
end;
//TG2GraphicsRunTimeParams END

//TG2Transforms BEGIN
constructor TG2Transforms.Create;
begin
  inherited Create;
end;

destructor TG2Transforms.Destroy;
begin
  inherited Destroy;
end;

function TG2Transforms.GetW(const Index: Byte): TG2Mat;
begin
  Result := m_W[Index];
end;

procedure TG2Transforms.SetW(const Index: Byte; const m: TG2Mat);
begin
  m_W[Index] := m;
end;

function TG2Transforms.GetT(const Index: Byte): TG2Mat;
begin
  Result := m_T[Index];
end;

procedure TG2Transforms.SetT(const Index: Byte; const m: TG2Mat);
begin
  m_T[Index] := m;
end;

function TG2Transforms.GetWV: TG2Mat;
begin
  Result := m_W[0] * m_V;
end;

function TG2Transforms.GetVP: TG2Mat;  
begin
  Result := m_V * m_P;
end;

function TG2Transforms.GetWVP: TG2Mat;  
begin
  Result := m_W[0] * m_V * m_P;
end;

function TG2Transforms.GetWt: TG2Mat;  
begin
  Result := m_W[0].Transpose;
end;

function TG2Transforms.GetVt: TG2Mat;   
begin
  Result := m_V.Transpose;
end;

function TG2Transforms.GetPt: TG2Mat;  
begin
  Result := m_P.Transpose;
end;

function TG2Transforms.GetWVt: TG2Mat;  
begin
  Result := WV.Transpose;
end;

function TG2Transforms.GetVPt: TG2Mat;   
begin
  Result := VP.Transpose;
end;

function TG2Transforms.GetWVPt: TG2Mat;   
begin
  Result := WVP.Transpose;
end;

function TG2Transforms.GetWi: TG2Mat;    
begin
  Result := m_W[0].Inverse;
end;

function TG2Transforms.GetVi: TG2Mat;
begin
  Result := m_V.Inverse;
end;

function TG2Transforms.GetPi: TG2Mat;    
begin
  Result := m_P.Inverse;
end;

function TG2Transforms.GetWVi: TG2Mat;    
begin
  Result := WV.Inverse;
end;

function TG2Transforms.GetVPi: TG2Mat;    
begin
  Result := VP.Inverse;
end;

function TG2Transforms.GetWVPi: TG2Mat;   
begin
  Result := WVP.Inverse;
end;

procedure TG2Transforms.OnDeviceLost;
begin

end;

procedure TG2Transforms.OnDeviceReset;
var
  i: Integer;
begin
  for i := 0 to Core.Graphics.Caps.MaxVertexBlendMatrices - 1 do
  ApplyW(i);
  ApplyV;
  ApplyP;
  for i := 0 to Core.Graphics.Caps.MaxTextureBlendStages - 1 do
  ApplyT(i);
end;

function TG2Transforms.Initialize(const G2Core: TG2Core): TG2Result;
var
  i: Integer;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  for i := 0 to Core.Graphics.Caps.MaxVertexBlendMatrices - 1 do
  UpdateW(i);
  UpdateV;
  UpdateP;
  for i := 0 to Core.Graphics.Caps.MaxTextureBlendStages - 1 do
  UpdateT(i);
end;

function TG2Transforms.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
end;

procedure TG2Transforms.ApplyW(const Index: Byte);
begin
  Core.Graphics.Device.SetTransform(D3DTS_WORLDMATRIX(Index), m_W[Index]);
end;

procedure TG2Transforms.ApplyV;
begin
  Core.Graphics.Device.SetTransform(D3DTS_VIEW, m_V);
end;

procedure TG2Transforms.ApplyP;
begin
  Core.Graphics.Device.SetTransform(D3DTS_PROJECTION, m_P);
end;

procedure TG2Transforms.ApplyT(const Index: Byte);
begin
  Core.Graphics.Device.SetTransform(D3DTS_TEXTUREMATRIX(Index), m_T[Index]);
end;

procedure TG2Transforms.UpdateW(const Index: Byte);
begin
  Core.Graphics.Device.GetTransform(D3DTS_WORLDMATRIX(Index), PG2MatRef(@m_W[Index])^);
end;

procedure TG2Transforms.UpdateV;
begin
  Core.Graphics.Device.GetTransform(D3DTS_VIEW, PG2MatRef(@m_V)^);
end;

procedure TG2Transforms.UpdateP;
begin
  Core.Graphics.Device.GetTransform(D3DTS_PROJECTION, PG2MatRef(@m_P)^);
end;

procedure TG2Transforms.UpdateT(const Index: Byte);
begin
  Core.Graphics.Device.GetTransform(D3DTS_TEXTUREMATRIX(Index), PG2MatRef(@m_T[Index])^);
end;

procedure TG2Transforms.PushW;
begin
  SetLength(m_BufferW, Length(m_BufferW) + 1);
  m_BufferW[High(m_BufferW)] := m_W[0];
end;

procedure TG2Transforms.PushV;
begin
  SetLength(m_BufferV, Length(m_BufferV) + 1);
  m_BufferV[High(m_BufferV)] := m_V;
end;

procedure TG2Transforms.PushP;
begin
  SetLength(m_BufferP, Length(m_BufferP) + 1);
  m_BufferP[High(m_BufferP)] := m_P;
end;

procedure TG2Transforms.PushT;
begin
  SetLength(m_BufferT, Length(m_BufferT) + 1);
  m_BufferT[High(m_BufferT)] := m_T[0];
end;

procedure TG2Transforms.PopW;
begin
  m_W[0] := m_BufferW[High(m_BufferW)];
  SetLength(m_BufferW, Length(m_BufferW) - 1);
end;

procedure TG2Transforms.PopV;
begin
  m_V := m_BufferV[High(m_BufferV)];
  SetLength(m_BufferV, Length(m_BufferV) - 1);
end;

procedure TG2Transforms.PopP;
begin
  m_P := m_BufferP[High(m_BufferP)];
  SetLength(m_BufferP, Length(m_BufferP) - 1);
end;

procedure TG2Transforms.PopT;
begin
  m_T[0] := m_BufferT[High(m_BufferT)];
  SetLength(m_BufferT, Length(m_BufferT) - 1);
end;
//TG2Transforms END

//TG2Lights BEGIN
constructor TG2Lights.Create;
var
  i: Integer;
begin
  inherited Create;
  for i := 0 to High(m_Lights) do
  begin
    m_Lights[i].m_Lights := Self;
    m_Lights[i].m_Index := i;
  end;
end;

destructor TG2Lights.Destroy;
begin
  inherited Destroy;
end;

function TG2Lights.GetLight(const Index: Byte): PG2Light;
begin
  Result := @m_Lights[Index];
end;

function TG2Lights.GetLightCount: Integer;
begin
  Result := LCount;
end;

procedure TG2Lights.OnDeviceLost;
begin

end;

procedure TG2Lights.OnDeviceReset;
var
  i: Integer;
begin
  for i := 0 to High(m_LightsBuffer) do
  begin
    Core.Graphics.Device.SetLight(i, m_LightsBuffer[i]);
    Core.Graphics.Device.LightEnable(i, m_LightsEnabled[i]);
  end;
end;

function TG2Lights.Initialize(const G2Core: TG2Core): TG2Result;
var
  i: Integer;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  ZeroMemory(@m_LightsBuffer[0], SizeOf(TD3DLight9) * Length(m_LightsBuffer));
  ZeroMemory(@m_LightsEnabled[0], SizeOf(Boolean) * Length(m_LightsEnabled));
  for i := 0 to High(m_Lights) do
  begin
    ZeroMemory(@m_Lights[i].Light, SizeOf(TD3DLight9));
    m_Lights[i].Enabled := False;
  end;
end;

function TG2Lights.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
end;

procedure TG2Lights.DisableLights;
var
  i: Integer;
begin
  for i := 0 to High(m_Lights) do
  begin
    m_Lights[i].Enabled := False;
    m_Lights[i].SetToDevice;
  end;
end;

procedure TG2Lights.SetToEffect(const Effect: TG2Effect);
var
  i: Integer;
  v3: TG2Vec3;
  LightAmbient: TD3DXColor;
  LightCountPoint: Integer;
  LightPosPoint: array[0..15] of TD3DXVector4;
  LightColorPoint: array[0..15] of TD3DXColor;
  LightRangePoint: array[0..15] of Single;
  LightCountDirectional: Integer;
  LightDirDirectional: array[0..15] of TD3DXVector4;
  LightColorDirectional: array[0..15] of TD3DXColor;
begin
  LightCountPoint := 0;
  LightCountDirectional := 0;
  LightAmbient := D3DXColorFromDWord(Core.Graphics.RenderStates.Ambient);
  with Core.Graphics do
  for i := 0 to Lights.LightCount - 1 do
  if Lights[i].Enabled then
  begin
    case Lights[i].LightType of
      ltAmbient:
      begin
        D3DXColorAdd(LightAmbient, LightAmbient, Lights[i].Light.Ambient);
      end;
      ltPoint:
      begin
        v3 := Lights[i].Light.Position;
        LightPosPoint[LightCountPoint] := D3DXVector4(
          v3 * Transforms.V, 1
        );
        LightColorPoint[LightCountPoint] := Lights[i].Light.Diffuse;
        LightRangePoint[LightCountPoint] := Sqr(Lights[i].Light.Range);
        Inc(LightCountPoint);
      end;
      ltDirectional:
      begin
        v3 := Lights[i].Light.Direction;
        D3DXVec3TransformNormal(PG2Vec3Ref(@v3)^, v3, Transforms.V);
        v3 := -v3;
        v3.Normalize;
        LightDirDirectional[LightCountDirectional] := D3DXVector4(v3, 1);
        LightColorDirectional[LightCountDirectional] := Lights[i].Light.Diffuse;
        Inc(LightCountDirectional);
      end;
    end;
  end;
  Effect.SetVector('LightAmbient', PD3DXVector4(@LightAmbient)^);
  Effect.SetInt('LightCountPoint', LightCountPoint);
  Effect.SetVectorArray('LightPosPoint', @LightPosPoint[0], LightCountPoint);
  Effect.SetVectorArray('LightColorPoint', @LightColorPoint[0], LightCountPoint);
  Effect.SetFloatArray('LightRangePoint', @LightRangePoint[0], LightCountPoint);
  Effect.SetInt('LightCountDirectional', LightCountDirectional);
  Effect.SetVectorArray('LightDirDirectional', @LightDirDirectional[0], LightCountDirectional);
  Effect.SetVectorArray('LightColorDirectional', @LightColorDirectional[0], LightCountDirectional);
end;

procedure TG2Lights.TG2Light.SetAmbientLight(
      const Ambient: TG2Color
    );
begin
  ZeroMemory(@Light, SizeOf(TD3DLight9));
  Light._Type := D3DLIGHT_DIRECTIONAL;
  Light.Ambient := Ambient;
  LightType := ltAmbient;
end;

procedure TG2Lights.TG2Light.SetPointLight(
      const PosX, PosY, PosZ: Single;
      const Diffuse: TG2Color;
      const Range: Single
    );
begin
  ZeroMemory(@Light, SizeOf(TD3DLight9));
  Light._Type := D3DLIGHT_POINT;
  Light.Position := G2Vec3(PosX, PosY, PosZ);
  Light.Diffuse := Diffuse;
  Light.Specular := Diffuse;
  Light.Range := Range;
  if Range = 0 then
  Light.Attenuation1 := 9999
  else
  Light.Attenuation1 := 5 / Range;
  LightType := ltPoint;
end;

procedure TG2Lights.TG2Light.SetDirectionalLight(
      const DirX, DirY, DirZ: Single;
      const Diffuse: TG2Color
    );
begin
  ZeroMemory(@Light, SizeOf(TD3DLight9));
  Light._Type := D3DLIGHT_DIRECTIONAL;
  Light.Direction := G2Vec3(DirX, DirY, DirZ);
  Light.Diffuse := Diffuse;
  Light.Specular := Diffuse;
  LightType := ltDirectional;
end;

procedure TG2Lights.TG2Light.SetToDevice;
begin
  m_Lights.Core.Graphics.Device.SetLight(
    m_Index, Light
  );
  m_Lights.Core.Graphics.Device.LightEnable(m_Index, Enabled);
  m_Lights.m_LightsBuffer[m_Index] := Light;
  m_Lights.m_LightsEnabled[m_Index] := Enabled;
end;
//TG2Lights END

//TG2SwapChain BEGIN
constructor TG2SwapChain.Create;
begin
  inherited Create;
end;

destructor TG2SwapChain.Destroy;
begin
  Release;
  inherited Destroy;
end;

function TG2SwapChain.GetViewPort: PD3DViewPort9;
begin
  Result := @m_ViewPort;
end;

procedure TG2SwapChain.Release;
begin
  SafeRelease(m_DepthStencil);
  SafeRelease(m_BackBuffer);
  SafeRelease(m_SwapChain);
end;

procedure TG2SwapChain.Initialize(
      const Handle: HWND;
      const Width, Height: Word;
      const PresentParams: TD3DPresentParameters
    );
begin
  ZeroMemory(@m_PresentParams, SizeOf(TD3DPresentParameters));
  m_PresentParams.BackBufferWidth := Width;
  m_PresentParams.BackBufferHeight := Height;
  m_PresentParams.BackBufferFormat := PresentParams.BackBufferFormat;
  m_PresentParams.BackBufferCount := 1;
  m_PresentParams.MultiSampleType := PresentParams.MultiSampleType;
  m_PresentParams.SwapEffect := PresentParams.SwapEffect;
  m_PresentParams.hDeviceWindow := Handle;
  m_PresentParams.Windowed := PresentParams.Windowed;
  m_PresentParams.EnableAutoDepthStencil := False;
  m_PresentParams.Flags := m_PresentParams.Flags;
  m_PresentParams.PresentationInterval := m_PresentParams.PresentationInterval;
  m_G2GRaphics.Device.CreateAdditionalSwapChain(m_PresentParams, m_SwapChain);
  m_SwapChain.GetBackBuffer(0, D3DBACKBUFFER_TYPE_MONO, m_BackBuffer);
  m_ViewPort.X := 0;
  m_ViewPort.Y := 0;
  m_ViewPort.Width := Width;
  m_ViewPort.Height := Height;
  m_ViewPort.MinZ := 0;
  m_ViewPort.MaxZ := 1;
  m_G2GRaphics.Device.CreateDepthStencilSurface(
    m_PresentParams.BackBufferWidth,
    m_PresentParams.BackBufferHeight,
    m_G2Graphics.m_InitParamsActual.DepthStencilFormat,
    m_G2Graphics.m_PresentParams.MultiSampleType,
    m_G2Graphics.m_PresentParams.MultiSampleQuality,
    True,
    m_DepthStencil,
    nil
  );
end;

procedure TG2SwapChain.Reset(const Width, Height: Word);
begin
  Release;
  m_PresentParams.BackBufferWidth := Width;
  m_PresentParams.BackBufferHeight := Height;
  m_ViewPort.X := 0;
  m_ViewPort.Y := 0;
  m_ViewPort.Width := Width;
  m_ViewPort.Height := Height;
  m_G2GRaphics.Device.CreateAdditionalSwapChain(m_PresentParams, m_SwapChain);
  m_SwapChain.GetBackBuffer(0, D3DBACKBUFFER_TYPE_MONO, m_BackBuffer);
  m_G2GRaphics.Device.CreateDepthStencilSurface(
    m_PresentParams.BackBufferWidth,
    m_PresentParams.BackBufferHeight,
    m_G2Graphics.m_InitParamsActual.DepthStencilFormat,
    m_G2Graphics.m_PresentParams.MultiSampleType,
    m_G2Graphics.m_PresentParams.MultiSampleQuality,
    True,
    m_DepthStencil,
    nil
  );
end;

procedure TG2SwapChain.OnLostDevice;
begin
  Release;
end;

procedure TG2SwapChain.OnResetDevice;
begin
  m_G2GRaphics.Device.CreateAdditionalSwapChain(m_PresentParams, m_SwapChain);
  m_SwapChain.GetBackBuffer(0, D3DBACKBUFFER_TYPE_MONO, m_BackBuffer);
  m_G2GRaphics.Device.CreateDepthStencilSurface(
    m_PresentParams.BackBufferWidth,
    m_PresentParams.BackBufferHeight,
    m_G2Graphics.m_InitParamsActual.DepthStencilFormat,
    m_G2Graphics.m_PresentParams.MultiSampleType,
    m_G2Graphics.m_PresentParams.MultiSampleQuality,
    True,
    m_DepthStencil,
    nil
  );
end;
//TG2SwapChain END

//TG2Audio BEGIN
constructor TG2Audio.Create;
begin
  inherited Create;
  m_PlugClass := TG2PlugAudio;
  m_Volume := 1;
  m_MusicMgrs := TList.Create;
  m_SoundMgrs := TList.Create;
end;

destructor TG2Audio.Destroy;
begin
  m_SoundMgrs.Free;
  m_MusicMgrs.Free;
  inherited Destroy;
end;

procedure TG2Audio.SetVolume(Value: Single);
var
  i: Integer;
begin
  m_Volume := Value;
  for i := 0 to m_MusicMgrs.Count - 1 do
  begin
    TG2MusicMgr(m_MusicMgrs[i]).ResetVolume;
  end;
  for i := 0 to m_SoundMgrs.Count - 1 do
  begin
    TG2SoundMgr(m_SoundMgrs[i]).ResetVolume;
  end;
end;

function TG2Audio.Initialize(const G2Core: TG2Core): TG2Result;
begin
  G2WriteLogTimed('Initialization Started.', 'Audio');
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Volume := 1;
  if Failed(
    CoCreateInstance(
      CLSID_DirectMusicLoader,
      nil,
      CLSCTX_INPROC,
      IID_IDirectMusicLoader8,
      m_Loader
    )
  ) then
  begin
    G2WriteLogTimed('(E) Failed to create loader.', 'Audio');
    Result := grFail;
    Exit;
  end;
  if Failed(
    CoCreateInstance(
      CLSID_DirectMusicPerformance,
      nil,
      CLSCTX_INPROC,
      IID_IDirectMusicPerformance8,
      m_Performance
    )
  ) then
  begin
    G2WriteLogTimed('(E) Failed to create performance.', 'Audio');
    SafeRelease(m_Loader);
    Result := grFail;
    Exit;
  end;
  if Failed(
    m_Performance.InitAudio(
      nil,
      nil,
      Core.Handle,
      DMUS_APATH_SHARED_STEREOPLUSREVERB,
      64,
      DMUS_AUDIOF_ALL,
      nil
    )
  ) then
  begin
    G2WriteLogTimed('(E) Failed to initialize audio.', 'Audio');
    SafeRelease(m_Loader);
    SafeRelease(m_Performance);
    Result := grFail;
    Exit;
  end;
  Result := grOk;
  G2WriteLogTimed('Initialization Finished.', 'Audio');
end;

function TG2Audio.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Finalization Started', 'Audio');
  SafeRelease(m_Loader);
  SafeRelease(m_Performance);
  Result := grOk;
  G2WriteLogTimed('Finalization Finished', 'Audio');
end;
//TG2Audio END

//TG2Input BEGIN
constructor TG2Input.Create;
begin
  inherited Create;
  m_PlugClass := TG2PlugInput;
end;

destructor TG2Input.Destroy;
begin
  inherited Destroy;
end;

procedure TG2Input.Update;
var
  i: Integer;
  NewKeyState: array[0..255] of Boolean;
  NewMouseState: TDIMouseState;
  Res: HResult;
  function TryUpdateKeyboard: HResult;
  begin
    Result := m_Keyboard.Poll;
    if Succeeded(Result) then
    begin
      Result := m_Keyboard.GetDeviceState(
        SizeOf(NewKeyState),
        @NewKeyState
      );
    end;
  end;
  function TryUpdateMouse: HResult;
  begin
    Result := m_Mouse.Poll;
    if Succeeded(Result) then
    begin
      Result := m_Mouse.GetDeviceState(
        SizeOf(NewMouseState),
        @NewMouseState
      );
    end;
  end;
begin
  if not Initialized then Exit;
  if m_KeyboardAquired then
  begin
    Res := TryUpdateKeyboard;
    if Failed(Res) then
    begin
      if (Res = DIERR_INPUTLOST)
      or (Res = DIERR_NOTACQUIRED) then
      begin
        if Succeeded(m_Keyboard.Acquire) then
        begin
          Res := TryUpdateKeyboard;
        end;
      end;
    end;
    if Succeeded(Res) then
    begin
      for i := 0 to High(m_KeyState) do
      if m_KeyState[i] <> NewKeyState[i] then
      begin
        if NewKeyState[i] then
        KeyDown(i)
        else
        KeyUp(i);
      end;
      Move(NewKeyState, m_KeyState, SizeOf(m_KeyState));
    end;
  end;
  if m_MouseAquired then
  begin
    Res := TryUpdateMouse;
    if Failed(Res) then
    begin
      if (Res = DIERR_INPUTLOST)
      or (Res = DIERR_NOTACQUIRED) then
      begin
        if Succeeded(m_Mouse.Acquire) then
        begin
          Res := TryUpdateMouse;
        end;
      end;
    end;
    if Succeeded(Res) then
    begin
      for i := 0 to High(m_MouseState.rgbButtons) do
      if m_MouseState.rgbButtons[i] <> NewMouseState.rgbButtons[i] then
      begin
        if NewMouseState.rgbButtons[i] > 0 then
        MouseDown(i)
        else
        MouseUp(i);
      end;
      Move(NewMouseState, m_MouseState, SizeOf(m_MouseState));
      if (m_MouseState.lX <> 0)
      or (m_MouseState.lY <> 0) then
      MouseMove(Point(m_MouseState.lX, m_MouseState.lY));
      if m_MouseState.lZ <> 0 then
      WheelMove(m_MouseState.lZ);
    end;
  end;
end;

procedure TG2Input.KeyDown(const Key: Byte);
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugInput(m_Plugs.Items[i]).OnKeyDown) then
  TG2PlugInput(m_Plugs.Items[i]).OnKeyDown(Key);
end;

procedure TG2Input.KeyUp(const Key: Byte);
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugInput(m_Plugs.Items[i]).OnMouseUp) then
  TG2PlugInput(m_Plugs.Items[i]).OnKeyUp(Key);
end;

procedure TG2Input.MouseDown(const Button: Byte);
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugInput(m_Plugs.Items[i]).OnMouseDown) then
  TG2PlugInput(m_Plugs.Items[i]).OnMouseDown(Button);
end;

procedure TG2Input.MouseUp(const Button: Byte);
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugInput(m_Plugs.Items[i]).OnMouseUp) then
  TG2PlugInput(m_Plugs.Items[i]).OnMouseUp(Button);
end;

procedure TG2Input.MouseMove(const Shift: TPoint);
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugInput(m_Plugs.Items[i]).OnMouseMove) then
  TG2PlugInput(m_Plugs.Items[i]).OnMouseMove(Shift);
end;

procedure TG2Input.WheelMove(const Shift: Integer);
var
  i: Integer;
begin
  for i := 0 to m_Plugs.Count - 1 do
  if Assigned(TG2PlugInput(m_Plugs.Items[i]).OnWheelMove) then
  TG2PlugInput(m_Plugs.Items[i]).OnWheelMove(Shift);
end;

function TG2Input.GetKey(const Index: Byte): Boolean;
begin
  Result := m_KeyState[Index];
end;

function TG2Input.GetButton(const Index: Byte): Boolean;
begin
  Result := m_MouseState.rgbButtons[Index] > 0;
end;

function TG2Input.GetMousePos: TPoint;
var
  cRect: TRect;
  cW, cH: Integer;
begin
  Result := Mouse.CursorPos;
  if Initialized then
  begin
    ScreenToClient(Core.Handle, Result);
    if Core.Graphics.Initialized then
    begin
      GetClientRect(Core.Handle, cRect);
      cW := cRect.Right - cRect.Left;
      cH := cRect.Bottom - cRect.Top;
      Result.X := Round((Result.X / cW) * Core.Graphics.Params.Width);
      Result.Y := Round((Result.Y / cH) * Core.Graphics.Params.Height);
    end;
  end;
end;

function TG2Input.GetMouseShift: TPoint;
begin
  Result := Point(m_MouseState.lX, m_MouseState.lY);
end;

function TG2Input.GetWheelShift: Integer;
begin
  Result := m_MouseState.lZ;
end;

function TG2Input.Initialize(const G2Core: TG2Core): TG2Result;
var
  Inst: HINST;
  TopHandle: HWnd;
begin
  G2WriteLogTimed('Initialization Started.', 'Input');
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_KeyboardAquired := False;
  m_MouseAquired := False;
  TopHandle := Core.Handle;
  while GetParent(TopHandle) > 0 do
  TopHandle := GetParent(TopHandle);
  Inst := GetWindowLong(TopHandle, GWL_HINSTANCE);
  if Failed(
    DirectInput8Create(
      Inst,
      DIRECTINPUT_VERSION,
      IID_IDirectInput8,
      m_DI,
      nil
    )
  ) then
  begin
    G2WriteLogTimed('(E) Failed to initialize DirectInput8.', 'Input');
    Result := grFail;
    m_Initialized := False;
    Exit;
  end;
  if Succeeded(
    m_DI.CreateDevice(
      GUID_SysKeyboard,
      m_Keyboard,
      nil
    )
  ) then
  begin
    if Succeeded(
      m_Keyboard.SetDataFormat(c_dfDIKeyboard)
    ) then
    begin
      if Succeeded(
        m_Keyboard.SetCooperativeLevel(
          TopHandle,
          DISCL_FOREGROUND
          or DISCL_NONEXCLUSIVE
          or DISCL_NOWINKEY
        )
      ) then
      begin
        m_KeyboardAquired := True;
        ZeroMemory(@m_KeyState, SizeOf(m_KeyState));
      end
      else
      begin
        SafeRelease(m_Keyboard);
      end;
    end
    else
    begin
      SafeRelease(m_Keyboard);
    end;
  end;
  if not Assigned(m_Keyboard) then
  G2WriteLogTimed('(E) Failed to create keyboard device.', 'Input');
  if Succeeded(
    m_DI.CreateDevice(
      GUID_SysMouse,
      m_Mouse,
      nil
    )
  ) then
  begin
    if Succeeded(
      m_Mouse.SetDataFormat(c_dfDIMouse)
    ) then
    begin
      if Succeeded(
        m_Mouse.SetCooperativeLevel(
          TopHandle,
          DISCL_FOREGROUND
          or DISCL_NONEXCLUSIVE
          or DISCL_NOWINKEY
        )
      ) then
      begin
        m_MouseAquired := True;
        ZeroMemory(@m_MouseState, SizeOf(m_MouseState));
      end
      else
      begin
        SafeRelease(m_Mouse);
      end;
    end
    else
    begin
      SafeRelease(m_Mouse);
    end;
  end;
  if not Assigned(m_Mouse) then
  G2WriteLogTimed('(E) Failed to create mouse device.', 'Input');
  if G2ResFail(
    Core.RequestPlug(TG2PlugTimer, @m_PlugTimer)
  ) then
  begin
    G2WriteLogTimed('(E) Input is unable to connect to Timer.', 'Input');
    SafeRelease(m_Mouse);
    SafeRelease(m_Keyboard);
    SafeRelease(m_DI);
    m_Initialized := False;
    Result := grFail;
    Exit;
  end;
  m_PlugTimer.OnTimer := Update;
  Result := grOk;
  G2WriteLogTimed('Initialization Finished.', 'Input');
end;

function TG2Input.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugTimer);
  SafeRelease(m_Mouse);
  SafeRelease(m_Keyboard);
  SafeRelease(m_DI);
  Result := grOk;
end;
//TG2Input END

//TG2Network BEGIN
constructor TG2Network.Create;
begin
  inherited Create;
  m_PlugClass := TG2PlugNetwork;
end;

destructor TG2Network.Destroy;
begin
  inherited Destroy;
end;

function TG2Network.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Initialization Started.', 'Network');
  Result := grOk;
  G2WriteLogTimed('Initialization Finished.', 'Network');
end;

function TG2Network.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('Finalization Started.', 'Network');
  Result := grOk;
  G2WriteLogTimed('Finalization Finished.', 'Network');
end;
//TG2Network END

//TG2Module BEGIN
constructor TG2Module.Create;
begin
  inherited Create;
end;

destructor TG2Module.Destroy;
begin
  inherited Destroy;
end;

function TG2Module.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
end;

function TG2Module.Finalize: TG2Result;
begin
  Result := inherited Finalize;
end;
//TG2Module END

//TG2Plug BEGIN
constructor TG2Plug.Create;
begin
  inherited Create;
  m_Engine := nil;
end;

destructor TG2Plug.Destroy;
begin
  m_Engine := nil;
  inherited Destroy;
end;
//TG2Plug END

//TG2PlugTimer BEGIN
constructor TG2PlugTimer.Create;
begin
  inherited Create;
end;

destructor TG2PlugTimer.Destroy;
begin
  inherited Destroy;
end;
//TG2PlugTimer END

//TG2PlugGraphics BEGIN
constructor TG2PlugGraphics.Create;
begin
  inherited Create;
end;

destructor TG2PlugGraphics.Destroy;
begin
  inherited Destroy;
end;
//TG2PlugGraphics END

//TG2PlugAudio BEGIN
constructor TG2PlugAudio.Create;
begin
  inherited Create;
end;

destructor TG2PlugAudio.Destroy;
begin
  inherited Destroy;
end;
//TG2PlugAudio END

//TG2PlugInput BEGIN
constructor TG2PlugInput.Create;
begin
  inherited Create;
end;

destructor TG2PlugInput.Destroy;
begin
  inherited Destroy;
end;

function TG2PlugInput.GetKeyDown(const Index: Byte): Boolean;
begin
  Result := m_Input.GetKey(Index);
end;

function TG2PlugInput.GetMouseDown(const Index: Byte): Boolean;
begin
  Result := m_Input.GetButton(Index);
end;

function TG2PlugInput.GetMousePos: TPoint;
begin
  Result := m_Input.GetMousePos;
end;

function TG2PlugInput.GetMouseShift: TPoint;
begin
  Result := m_Input.GetMouseShift;
end;

function TG2PlugInput.GetWheelShift: Integer;
begin
  Result := m_Input.GetWheelShift;
end;

function TG2PlugInput.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Input := Core.Input;
  Result := grOk;
end;

function TG2PlugInput.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2PlugInput END

//TG2PlugNetwork BEGIN
constructor TG2PlugNetwork.Create;
begin
  inherited Create;
end;

destructor TG2PlugNetwork.Destroy;
begin
  inherited Destroy;
end;
//TG2PlugNetwork END

//TG2ResMgr BEGIN
constructor TG2ResMgr.Create;
begin
  inherited Create;
  m_Resources := TList.Create;
end;

destructor TG2ResMgr.Destroy;
begin
  Finalize;
  m_Resources.Free;
  inherited Destroy;
end;

function TG2ResMgr.GetCount: Integer;
begin
  Result := m_Resources.Count;
end;

function TG2ResMgr.FindResourceIndex(const NameCache: DWord): Integer;
var
  l, h, m: Integer;
begin
  l := 0;
  h := m_Resources.Count - 1;
  while l <= h do
  begin
    m := (l + h) div 2;
    if Integer(TG2Res(m_Resources[m]).m_NameCache) - Integer(NameCache) < 0 then
    l := m + 1
    else
    h := m - 1;
  end;
  Result := l;
end;

function TG2ResMgr.FindResource(const Name: AnsiString): TG2Res;
var
  Cache: DWord;
  Ind, i, j: Integer;
begin
  Result := nil;
  if m_Resources.Count = 0 then Exit;
  Cache := 0;
  for i := 0 to Min(Length(Name) - 1, 3) do
  Cache := Cache or ((Ord(Name[i + 1]) and $ff) shl (24 - i * 8));
  Ind := FindResourceIndex(Cache);
  i := Ind - 1;
  j := Ind;
  while
  ((i >= 0) and (Cache = TG2Res(m_Resources[i]).m_NameCache))
  or
  ((j < m_Resources.Count) and (Cache = TG2Res(m_Resources[j]).m_NameCache)) do
  begin
    if i >= 0 then
    begin
      if (TG2Res(m_Resources[i]).Name = Name) then
      begin
        Result := TG2Res(m_Resources[i]);
        Exit;
      end;
      Dec(i);
    end;
    if j < m_Resources.Count then
    begin
      if (TG2Res(m_Resources[j]).Name = Name) then
      begin
        Result := TG2Res(m_Resources[j]);
        Exit;
      end;
     Inc(j);
    end;
  end;
end;

procedure TG2ResMgr.AddResource(const Res: TG2Res);
begin
  m_Resources.Insert(FindResourceIndex(Res.m_NameCache), Res);
  Res.m_Mgrs.Add(Self);
end;

procedure TG2ResMgr.RemoveResource(const Res: TG2Res);
begin
  m_Resources.Remove(Res);
  Res.m_Mgrs.Remove(Self);
end;

procedure TG2ResMgr.DeleteResource(const Index: Integer);
begin
  TG2Res(m_Resources[Index]).m_Mgrs.Remove(Self);
  m_Resources.Delete(Index);
end;

procedure TG2ResMgr.FreeResources;
var
  i, j: Integer;
begin
  i := 0;
  j := m_Resources.Count - 1;
  while i <= j do
  if TG2Res(m_Resources[i]).m_Mgrs.Count <= 1 then
  begin
    TG2Res(m_Resources[i]).Free;
    Dec(j);
  end
  else
  Inc(i);
  m_Resources.Clear;
end;

function TG2ResMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2ResMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  FreeResources;
  Result := grOk;
end;
//TG2ResMgr END

//TG2Res BEGIN
constructor TG2Res.Create;
begin
  inherited Create;
  m_Name := '';
  m_NameCache := 0;
  m_Mgrs := TList.Create;
end;

destructor TG2Res.Destroy;
begin
  while m_Mgrs.Count > 0 do
  TG2ResMgr(m_Mgrs[0]).RemoveResource(Self);
  m_Mgrs.Free;
  Finalize;
  inherited Destroy;
end;

procedure TG2Res.SetName(const Value: AnsiString);
var
  i: Integer;
begin
  m_Name := Value;
  m_NameCache := 0;
  for i := 0 to Min(Length(m_Name) - 1, 3) do
  m_NameCache := m_NameCache or ((Ord(m_Name[i + 1]) and $ff) shl (24 - i * 8));
  for i := 0 to m_Mgrs.Count - 1 do
  begin
    TG2ResMgr(m_Mgrs[i]).RemoveResource(Self);
    TG2ResMgr(m_Mgrs[i]).AddResource(Self);
  end;
end;
//TG2Res END

//TG2MusicMgr BEGIN
constructor TG2MusicMgr.Create;
begin
  inherited Create;
end;

destructor TG2MusicMgr.Destroy;
begin
  inherited Destroy;
end;

procedure TG2MusicMgr.ResetVolume;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2Music(m_Resources[i]).Volume := TG2Music(m_Resources[i]).Volume;
end;

function TG2MusicMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.Audio.m_MusicMgrs.Add(Self);
  Result := grOk;
end;

function TG2MusicMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  FreeResources;
  Core.Audio.m_MusicMgrs.Remove(Self);
  Result := grOk;
end;

function TG2MusicMgr.FindMusic(const Name: AnsiString): TG2Music;
begin
  Result := TG2Music(FindResource(Name));
end;

function TG2MusicMgr.CreateMusic(const Name: AnsiString): TG2Music;
begin
  Result := TG2Music.Create;
  Result.Initialize(Core);
  Result.Name := Name;
  AddResource(Result);
end;
//TG2MusicMgr END

//TG2Music BEGIN
constructor TG2Music.Create;
begin
  inherited Create;
  CoCreateInstance(
    CLSID_FilterGraph,
    nil,
    CLSCTX_INPROC_SERVER,
    IID_IGraphBuilder,
    m_Graph
  );
  m_Graph.QueryInterface(IID_IMediaControl, m_Control);
  m_Graph.QueryInterface(IID_IMediaEventEx, m_Event);
  m_Graph.QueryInterface(IID_IMediaPosition, m_Position);
  m_Graph.QueryInterface(IID_IMediaSeeking, m_Seeking);
  m_Graph.QueryInterface(IID_IMediaFilter, m_Filter);
  m_Graph.QueryInterface(IID_IBasicAudio, m_Audio);
  m_Open := False;
  m_IsPlaying := False;
  m_PlayTime := GetTickCount;
end;

destructor TG2Music.Destroy;
begin
  ClearGraph;
  SafeRelease(m_Audio);
  SafeRelease(m_Filter);
  SafeRelease(m_Seeking);
  SafeRelease(m_Position);
  SafeRelease(m_Event);
  SafeRelease(m_Control);
  SafeRelease(m_Graph);
  inherited Destroy;
end;

procedure TG2Music.ClearGraph;
var
  Filter: IBaseFilter;
  Enum: IEnumFilters;
begin
  if m_Open then
  begin
    m_Control.Stop;
    if SUCCEEDED(m_Graph.EnumFilters(Enum)) then
    begin
      while (S_OK = Enum.Next(1, Filter, nil)) do
      begin
        m_Graph.RemoveFilter(Filter);
        SafeRelease(Filter);
        Enum.Reset;
      end;
    end;
  end;
  m_Open := False;
end;

procedure TG2Music.SetPosition(const Value: Int64);
var
  Pos, PosStop: Int64;
begin
  if m_Open then
  begin
    Pos := Value;
    PosStop := 0;
    m_Seeking.SetPositions(
      Pos,
      AM_SEEKING_AbsolutePositioning,
      PosStop,
      AM_SEEKING_NoPositioning
    );
  end;
end;

function TG2Music.GetPosition: Int64;
begin
  if m_Open then
  m_Seeking.GetCurrentPosition(Result)
  else
  Result := 0;
end;

function TG2Music.GetDuration: Int64;      
begin
  if m_Open then
  m_Seeking.GetDuration(Result)
  else
  Result := 0;
end;

procedure TG2Music.SetVolume(Value: Single);  
var
  Vol: Integer;
begin
  if m_Open and Assigned(m_Audio) then
  begin
    Vol := Round((m_G2Audio.Volume * Value - 1) * 10000);
    if Vol < -10000 then Vol := -10000;
    if Vol > 0 then Vol := 0;
    m_Audio.put_Volume(Vol);
  end;
end;

function TG2Music.GetVolume: Single;         
var
  Vol: Integer;
begin
  if m_Open then
  begin
    m_Audio.get_Volume(Vol);
    Result := Vol * 0.0001 + 1;
  end
  else
  Result := 0;
end;

procedure TG2Music.SetPan(Value: Single);    
var
  Pan: Integer;
begin
  if m_Open then
  begin
    Pan := Round(Value * 10000);
    if Pan < -10000 then Pan := -10000;
    if Pan > 10000 then Pan := 10000;
    m_Audio.put_Balance(Pan);
  end;
end;

function TG2Music.GetPan: Single;             
var
  Pan: Integer;
begin
  if m_Open then
  begin
    m_Audio.get_Balance(Pan);
    Result := Pan * 0.0001;
  end
  else
  Result := 0;
end;

procedure TG2Music.SetPlayRate(Value: Single);  
begin
  if m_Open then
  m_Seeking.SetRate(Value);
end;

function TG2Music.GetPlayRate: Single;        
var
  Rate: Double;
begin
  if m_Open then
  begin
    m_Seeking.GetRate(Rate);
    Result := Rate;
  end
  else
  Result := 0;
end;

function TG2Music.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_G2Audio := Core.Audio;
  G2WriteLogTimed('(+) Music Initialized: (' + Name + ').');
end;

function TG2Music.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  G2WriteLogTimed('(-) Music Finalized: (' + Name + ').');
end;

procedure TG2Music.OpenFile(const f: AnsiString);
begin
  ClearGraph;
  m_Open := Succeeded(
    m_Graph.RenderFile(PWideChar(StringToWideString(f)), nil)
  );
  if m_Open then
  begin
    Volume := 1;
    G2WriteLogTimed('(>) Music Loaded (' + Name + ').');
  end;
end;

procedure TG2Music.Close;    
begin
  if m_Open then
  G2WriteLogTimed('(<) Music Released (' + Name + ').');
  ClearGraph;
end;

procedure TG2Music.Play;   
begin
  if m_Open then
  begin
    m_Control.Run;
    m_IsPlaying := True;
    m_PlayTime := GetTickCount;
  end;
end;

procedure TG2Music.Pause;  
begin
  if m_Open then
  begin
    m_Control.Pause;
  end;
end;

procedure TG2Music.Stop;
begin
  if m_Open then
  begin
    m_Control.Stop;
    Rewind;
  end;
end;

procedure TG2Music.Rewind;     
begin
  if m_Open then
  begin
    m_Position.put_CurrentPosition(0);
  end;
end;

function TG2Music.IsPlaying: Boolean;  
var
  State: TFilterState;
  EventCode, p1, p2: Integer;
begin
  if m_Open then
  begin
    m_Event.GetEvent(EventCode, p1, p2, 0);
    if EventCode = EC_COMPLETE then
    Stop;
    m_Control.GetState(0, State);
    Result := State = State_Running;
    if not Result
    and m_IsPlaying
    and (GetTickCount - m_PlayTime < 1000) then
    Result := True;
    m_IsPlaying := Result;
  end
  else
  Result := False;
end;
//TG2Music END

//TG2SoundMgr BEGIN
constructor TG2SoundMgr.Create;
begin
  inherited Create;
end;

destructor TG2SoundMgr.Destroy;
begin
  inherited Destroy;
end;

procedure TG2SoundMgr.ResetVolume;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2Sound(m_Resources[i]).Volume := TG2Sound(m_Resources[i]).Volume;
end;  

function TG2SoundMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.Audio.m_SoundMgrs.Add(Self);
  Result := grOk;
end;

function TG2SoundMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.Audio.m_SoundMgrs.Remove(Self);
  FreeResources;
  Result := grOk;
end;

function TG2SoundMgr.FindSound(const Name: AnsiString): TG2Sound;
begin
  Result := TG2Sound(FindResource(Name));
end;

function TG2SoundMgr.CreateSound(const Name: AnsiString): TG2Sound;
begin
  Result := TG2Sound.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  AddResource(Result);
end;
//TG2SoundMgr END

//TG2Sound BEGIN
constructor TG2Sound.Create;
begin
  inherited Create;
  m_Loaded := False;
  m_Volume := 1;
  m_Instances := TList.Create;
end;

destructor TG2Sound.Destroy;
begin
  while m_Instances.Count > 0 do
  TG2SoundInst(m_Instances[0]).Free;
  m_Instances.Free;
  Finalize;
  inherited Destroy;
end;

procedure TG2Sound.SetVolume(Value: Single);
var
  i, Vol: Integer;
begin
  m_Volume := Value;
  if m_Loaded then
  begin
    Vol := Round((m_G2Audio.Volume * Value - 1) * 4000);
    if Vol < -4000 then Vol := -4000;
    if Vol > 0 then Vol := 0;
    m_AudioPath.SetVolume(Vol, 0);
  end;
  for i := 0 to m_Instances.Count - 1 do
  TG2SoundInst(m_Instances[i]).Volume := TG2SoundInst(m_Instances[i]).Volume;
end;

procedure TG2Sound.SetSoundPosition(Value: TG2Vec3);   
begin
  m_Buffer3D.SetPosition(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2Sound.GetSoundPosition: TG2Vec3;         
begin
  m_Buffer3D.GetPosition(PG2Vec3Ref(@Result)^);
end;

procedure TG2Sound.SetSoundVelocity(Value: TG2Vec3);    
begin
  m_Buffer3D.SetVelocity(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2Sound.GetSoundVelocity: TG2Vec3;           
begin
  m_Buffer3D.GetVelocity(PG2Vec3Ref(@Result)^);
end;

procedure TG2Sound.SetSoundDirection(Value: TG2Vec3);     
begin
  m_Buffer3D.SetConeOrientation(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2Sound.GetSoundDirection: TG2Vec3;             
begin
  m_Buffer3D.GetConeOrientation(PG2Vec3Ref(@Result)^);
end;

procedure TG2Sound.SetListenerPosition(Value: TG2Vec3);  
begin
  m_Listener.SetPosition(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2Sound.GetListenerPosition: TG2Vec3;              
begin
  m_Listener.GetPosition(PG2Vec3Ref(@Result)^);
end;

procedure TG2Sound.SetListenerVelocity(Value: TG2Vec3);     
begin
  m_Listener.SetVelocity(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2Sound.GetListenerVelocity: TG2Vec3;            
begin
  m_Listener.GetVelocity(PG2Vec3Ref(@Result)^);
end;

procedure TG2Sound.SetListenerDirection(Value: TG2Vec3);      
begin
  m_Listener.SetOrientation(Value.x, Value.y, Value.z, 0, 1, 0, DS3D_IMMEDIATE);
end;

function TG2Sound.GetListenerDirection: TG2Vec3;            
var
  Dummy: TD3DXVector3;
begin
  m_Listener.GetOrientation(PG2Vec3Ref(@Result)^, Dummy);
end;

procedure TG2Sound.SetMinDistance(Value: Single);                 
begin
  m_Buffer3D.SetMinDistance(Value, DS3D_IMMEDIATE);
end;

function TG2Sound.GetMinDistance: Single;                      
begin
  m_Buffer3D.GetMinDistance(Result);
end;

procedure TG2Sound.SetMaxDistance(Value: Single);            
begin
  m_Buffer3D.SetMaxDistance(Value, DS3D_IMMEDIATE);
end;

function TG2Sound.GetMaxDistance: Single;                     
begin
  m_Buffer3D.GetMaxDistance(Result);
end;

procedure TG2Sound.SetDistanceFactor(Value: Single);       
begin
  m_Listener.SetDistanceFactor(Value, DS3D_IMMEDIATE); 
end;

function TG2Sound.GetDistanceFactor: Single;               
begin
  m_Listener.GetDistanceFactor(Result);
end;

procedure TG2Sound.SetDopplerFactor(Value: Single);      
begin
  m_Listener.SetDopplerFactor(Value, DS3D_IMMEDIATE);
end;

function TG2Sound.GetDopplerFactor: Single;                
begin
  m_Listener.GetDopplerFactor(Result);
end;

procedure TG2Sound.SetRollOffFactor(Value: Single);         
begin
  m_Listener.SetRolloffFactor(Value, DS3D_IMMEDIATE);
end;

function TG2Sound.GetRollOffFactor: Single;            
begin
  m_Listener.GetRolloffFactor(Result);
end;

procedure TG2Sound.SetPlayRate(Value: Single);          
begin
  m_Buffer.SetFrequency(Round(m_Frequency * Value));
end;

function TG2Sound.GetPlayRate: Single;               
var
  Freq: DWORD;
begin
  m_Buffer.GetFrequency(Freq);
  Result := Freq / m_Frequency;
end;

function TG2Sound.Initialize(const G2Core: TG2Core): TG2Result;
var
  BufferParams: DS3DBuffer;
  ListenerParams: DS3DListener;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_G2Audio := Core.Audio;
  m_G2Audio.m_Performance.CreateStandardAudioPath(
    DMUS_APATH_DYNAMIC_3D,
    64,
    True,
    m_AudioPath
  );
  ZeroMemory(@BufferParams, SizeOf(BufferParams));
  ZeroMemory(@ListenerParams, SizeOf(ListenerParams));
  BufferParams.dwSize := SizeOf(BufferParams);
  ListenerParams.dwSize := SizeOf(ListenerParams);
  m_AudioPath.GetObjectInPath(
    0,
    DMUS_PATH_BUFFER,
    0,
    GUID_NULL,
    0,
    IID_IDirectSoundBuffer,
    m_Buffer
  );
  m_AudioPath.GetObjectInPath(
    0,
    DMUS_PATH_BUFFER,
    0,
    GUID_NULL,
    0,
    IID_IDirectSound3DBuffer8,
    m_Buffer3D
  );
  m_AudioPath.GetObjectInPath(
    0,
    DMUS_PATH_PRIMARY_BUFFER,
    0,
    GUID_NULL,
    0,
    IID_IDirectSound3Dlistener8,
    m_Listener
  );
  m_Buffer3D.GetAllParameters(BufferParams);
  BufferParams.dwMode := DS3DMODE_HEADRELATIVE;
  BufferParams.flMinDistance := 1;
  BufferParams.flMaxDistance := 100;
  m_Buffer3D.SetAllParameters(BufferParams, DS3D_IMMEDIATE);
  m_Listener.GetAllParameters(ListenerParams);
  ListenerParams.flRolloffFactor := 0.25;
  ListenerParams.flDopplerFactor := 0;
  ListenerParams.flDistanceFactor := 0;
  ListenerParams.vPosition := D3DXVector3(1000, 0, 0);
  m_Listener.SetAllParameters(ListenerParams, DS3D_IMMEDIATE);
  m_Buffer.GetFrequency(m_Frequency);
  G2WriteLogTimed('(+) Sound Initialized: (' + Name + ').', 'Sounds');
end;

function TG2Sound.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  UnLoad;
  SafeRelease(m_Listener);
  SafeRelease(m_Buffer3D);
  SafeRelease(m_Buffer);
  SafeRelease(m_AudioPath);
  G2WriteLogTimed('(+) Sound Finalized: (' + Name + ').', 'Sounds');
end;

procedure TG2Sound.LoadFile(const f: AnsiString);
begin
  if SUCCEEDED(
    m_G2Audio.m_Loader.LoadObjectFromFile(
      CLSID_DirectMusicSegment,
      IID_IDirectMusicSegment8,
      PWideChar(StringToWideString(f)),
      m_Segment
    )
  ) then
  begin
    if SUCCEEDED(
      m_Segment.Download(m_G2Audio.m_Performance)
    ) then
    begin
      m_Loaded := True;
      G2WriteLogTimed('(>) Sound Loaded (' + Name + ').', 'Sounds');
    end;
  end;
end;

procedure TG2Sound.UnLoad;     
begin
  if m_Loaded then
  begin
    m_Segment.Unload(m_AudioPath);
    SafeRelease(m_Segment);
    m_Loaded := False;
    G2WriteLogTimed('(<) Sound Released (' + Name + ').', 'Sounds');
  end;
end;

procedure TG2Sound.Play;             
begin
  if m_Loaded then
  m_G2Audio.m_Performance.PlaySegmentEx(
    m_Segment,
    nil,
    nil,
    DMUS_SEGF_SECONDARY,
    0,
    nil,
    nil,
    m_AudioPath
  );
end;

procedure TG2Sound.Stop;             
begin
  if m_Loaded then
  m_G2Audio.m_Performance.StopEx(
    m_Segment,
    0,
    0
  );
end;

function TG2Sound.IsPlaying: Boolean;   
begin
  Result := m_G2Audio.m_Performance.IsPlaying(m_Segment, nil) = S_OK;
end;

function TG2Sound.CreateInstance: TG2SoundInst;
begin
  Result := TG2SoundInst.Create;
  Result.m_G2Sound := Self;
  Result.Initialize;
  Result.Volume := 1;
  Result.SoundPosition := SoundPosition;
  Result.SoundVelocity := SoundVelocity;
  Result.SoundDirection := SoundDirection;
  Result.ListenerPosition := ListenerPosition;
  Result.ListenerVelocity := ListenerVelocity;
  Result.ListenerDirection := ListenerDirection;
  Result.MinDistance := MinDistance;
  Result.MaxDistance := MaxDistance;
  Result.DistanceFactor := DistanceFactor;
  Result.DopplerFactor := DopplerFactor;
  Result.RollOffFactor := RollOffFactor;
  Result.PlayRate := PlayRate;
  m_Instances.Add(Result);
end;
//TG2Sound END

//TG2SoundInst BEGIN
constructor TG2SoundInst.Create;
begin
  inherited Create;
  m_Loaded := False;
  m_Volume := 1;
end;

destructor TG2SoundInst.Destroy;
begin
  m_G2Sound.m_Instances.Remove(Self);
  SafeRelease(m_Listener);
  SafeRelease(m_Buffer3D);
  SafeRelease(m_Buffer);
  SafeRelease(m_AudioPath);
  inherited Destroy;
end;

procedure TG2SoundInst.SetVolume(Value: Single);
var
  Vol: Integer;
begin
  m_Volume := Value;
  if m_Loaded then
  begin
    Vol := Round((m_G2Sound.Volume * Value - 1) * 4000);
    if Vol < -4000 then Vol := -4000;
    if Vol > 0 then Vol := 0;
    m_AudioPath.SetVolume(Vol, 0);
  end;
end;

procedure TG2SoundInst.SetSoundPosition(Value: TG2Vec3);
begin
  m_Buffer3D.SetPosition(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetSoundPosition: TG2Vec3;
begin
  m_Buffer3D.GetPosition(PG2Vec3Ref(@Result)^);
end;

procedure TG2SoundInst.SetSoundVelocity(Value: TG2Vec3);
begin
  m_Buffer3D.SetVelocity(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetSoundVelocity: TG2Vec3;
begin
  m_Buffer3D.GetVelocity(PG2Vec3Ref(@Result)^);
end;

procedure TG2SoundInst.SetSoundDirection(Value: TG2Vec3);    
begin
  m_Buffer3D.SetConeOrientation(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetSoundDirection: TG2Vec3;
begin
  m_Buffer3D.GetConeOrientation(PG2Vec3Ref(@Result)^);
end;

procedure TG2SoundInst.SetListenerPosition(Value: TG2Vec3);
begin
  m_Listener.SetPosition(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetListenerPosition: TG2Vec3;
begin
  m_Listener.GetPosition(PG2Vec3Ref(@Result)^);
end;

procedure TG2SoundInst.SetListenerVelocity(Value: TG2Vec3);
begin
  m_Listener.SetVelocity(Value.x, Value.y, Value.z, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetListenerVelocity: TG2Vec3;
begin
  m_Listener.GetVelocity(PG2Vec3Ref(@Result)^);
end;

procedure TG2SoundInst.SetListenerDirection(Value: TG2Vec3);
begin
  m_Listener.SetOrientation(Value.x, Value.y, Value.z, 0, 1, 0, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetListenerDirection: TG2Vec3;
var
  Dummy: TD3DXVector3;
begin
  m_Listener.GetOrientation(PG2Vec3Ref(@Result)^, Dummy);
end;

procedure TG2SoundInst.SetMinDistance(Value: Single);
begin
  m_Buffer3D.SetMinDistance(Value, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetMinDistance: Single;
begin
  m_Buffer3D.GetMinDistance(Result);
end;

procedure TG2SoundInst.SetMaxDistance(Value: Single);
begin
  m_Buffer3D.SetMaxDistance(Value, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetMaxDistance: Single;
begin
  m_Buffer3D.GetMaxDistance(Result);
end;

procedure TG2SoundInst.SetDistanceFactor(Value: Single);
begin
  m_Listener.SetDistanceFactor(Value, DS3D_IMMEDIATE); 
end;

function TG2SoundInst.GetDistanceFactor: Single;
begin
  m_Listener.GetDistanceFactor(Result);
end;

procedure TG2SoundInst.SetDopplerFactor(Value: Single);
begin
  m_Listener.SetDopplerFactor(Value, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetDopplerFactor: Single;
begin
  m_Listener.GetDopplerFactor(Result);
end;

procedure TG2SoundInst.SetRollOffFactor(Value: Single);
begin
  m_Listener.SetRolloffFactor(Value, DS3D_IMMEDIATE);
end;

function TG2SoundInst.GetRollOffFactor: Single;
begin
  m_Listener.GetRolloffFactor(Result);
end;

procedure TG2SoundInst.SetPlayRate(Value: Single);
begin
  m_Buffer.SetFrequency(Round(m_Frequency * Value));
end;

function TG2SoundInst.GetPlayRate: Single;              
var
  Freq: DWORD;
begin
  m_Buffer.GetFrequency(Freq);
  Result := Freq / m_Frequency;
end;

procedure TG2SoundInst.Initialize;
var
  BufferParams: DS3DBuffer;
  ListenerParams: DS3DListener;
begin
  m_G2Sound.m_G2Audio.m_Performance.CreateStandardAudioPath(
    DMUS_APATH_DYNAMIC_3D,
    64,
    True,
    m_AudioPath
  );
  ZeroMemory(@BufferParams, SizeOf(BufferParams));
  ZeroMemory(@ListenerParams, SizeOf(ListenerParams));
  BufferParams.dwSize := SizeOf(BufferParams);
  ListenerParams.dwSize := SizeOf(ListenerParams);
  m_AudioPath.GetObjectInPath(
    0,
    DMUS_PATH_BUFFER,
    0,
    GUID_NULL,
    0,
    IID_IDirectSoundBuffer,
    m_Buffer
  );
  m_AudioPath.GetObjectInPath(
    0,
    DMUS_PATH_BUFFER,
    0,
    GUID_NULL,
    0,
    IID_IDirectSound3DBuffer8,
    m_Buffer3D
  );
  m_AudioPath.GetObjectInPath(
    0,
    DMUS_PATH_PRIMARY_BUFFER,
    0,
    GUID_NULL,
    0,
    IID_IDirectSound3Dlistener8,
    m_Listener
  );
  m_Buffer3D.GetAllParameters(BufferParams);
  BufferParams.dwMode := DS3DMODE_HEADRELATIVE;
  BufferParams.flMinDistance := 0.1;
  BufferParams.flMaxDistance := 100;
  m_Buffer3D.SetAllParameters(BufferParams, DS3D_IMMEDIATE);
  m_Listener.GetAllParameters(ListenerParams);
  ListenerParams.flRolloffFactor := 0;
  ListenerParams.flDopplerFactor := 0;
  m_Listener.SetAllParameters(ListenerParams, DS3D_IMMEDIATE);
  m_Buffer.GetFrequency(m_Frequency);
end;

procedure TG2SoundInst.Play;
begin
  if m_G2Sound.m_Loaded then
  m_G2Sound.m_G2Audio.m_Performance.PlaySegmentEx(
    m_G2Sound.m_Segment,
    nil,
    nil,
    DMUS_SEGF_SECONDARY,
    0,
    nil,
    nil,
    m_AudioPath
  );
end;

procedure TG2SoundInst.Stop;
begin
  if m_G2Sound.m_Loaded then
  m_G2Sound.m_G2Audio.m_Performance.StopEx(
    m_G2Sound.m_Segment,
    0,
    0
  );
end;

function TG2SoundInst.IsPlaying: Boolean;  
begin
  Result := m_G2Sound.m_G2Audio.m_Performance.IsPlaying(m_G2Sound.m_Segment, nil) = S_OK;
end;
//TG2SoundInst END

//TG2TextureMgr BEGIN
constructor TG2TextureMgr.Create;
begin
  inherited Create;
end;

destructor TG2TextureMgr.Destroy;
begin
  inherited Destroy;
end;

procedure TG2TextureMgr.OnDeviceLost;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2TextureBase(m_Resources[i]).OnDeviceLost;
end;

procedure TG2TextureMgr.OnDeviceReset;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2TextureBase(m_Resources[i]).OnDeviceReset;
end;

function TG2TextureMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  Result := grOk;
end;

function TG2TextureMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  FreeResources;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;

function TG2TextureMgr.CreateTexture2DFromFile(
      const Name: AnsiString;
      const f: AnsiString;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
begin
  Result := TG2Texture2D.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFile(f, MipLevels, Format)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2TextureMgr.CreateTexture2DFromStream(
      const Name: AnsiString;
      const s: TMemoryStream;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
begin
  Result := TG2Texture2D.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromStream(s, Size, MipLevels, Format)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2TextureMgr.CreateTexture2DFromBuffer(
      const Name: AnsiString;
      const b: Pointer;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
begin
  Result := TG2Texture2D.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromBuffer(b, Size, MipLevels, Format)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2TextureMgr.CreateTexture2DFromGraphic(
      const Name: AnsiString;
      const g: TGraphic;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Texture2D;
begin
  Result := TG2Texture2D.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromGraphic(g, MipLevels, Format)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2TextureMgr.CreateTexture2DRenderTarget(
      const Name: AnsiString;
      const Width, Height: Integer
    ): TG2Texture2DRT;
begin
  Result := TG2Texture2DRT.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.MakeRenderTarget(Width, Height)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2TextureMgr.CreateTexture2DVideo(
      const Name: AnsiString;
      const f: AnsiString
    ): TG2Texture2DVideo;
begin
  Result := TG2Texture2DVideo.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.StreamFile(f)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2TextureMgr.CreateCubeTextureFromFile(
      const Name: AnsiString;
      const f: AnsiString;
      const MipLevels: Integer = 1;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2TextureCube;
begin
  Result := TG2TextureCube.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFile(f, MipLevels, Format)) then
  AddResource(Result) else FreeAndNil(Result);
end;

procedure TG2TextureMgr.DeleteTexture(const Index: Integer);
begin
  DeleteResource(Index);
end;

procedure TG2TextureMgr.RemoveTexture(const Texture: TG2TextureBase);
begin
  RemoveResource(Texture);
end;
//TG2TextureMgr END

//TG2TextureBase BEGIN
constructor TG2TextureBase.Create;
begin
  inherited Create;
end;

destructor TG2TextureBase.Destroy;
begin
  inherited Destroy;
end;

procedure TG2TextureBase.OnDeviceLost;
begin

end;

procedure TG2TextureBase.OnDeviceReset;
begin

end;

function TG2TextureBase.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_G2Graphics := Core.Graphics;
  Result := grOk;
  G2WriteLogTimed('(+) Texture Initialized: (' + Name + ').', 'Textures');
end;

function TG2TextureBase.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Release;
  Result := grOk;
  G2WriteLogTimed('(-) Texture Finalized: (' + Name + ').', 'Textures');
end;
//TG2TextureBase END

//TG2Texture2DBase BEGIN
constructor TG2Texture2DBase.Create;
begin
  inherited Create;
  m_Width := 0;
  m_Height := 0;
  m_RealWidth := 0;
  m_RealHeight := 0;
  m_DrawRect := G2Rect(0, 0, 0, 0);
  m_Levels := 0;
  ZeroMemory(@m_Desc, SizeOf(m_Desc));
end;

destructor TG2Texture2DBase.Destroy;
begin
  inherited Destroy;
end;

function TG2Texture2DBase.GetDrawRect: PG2Rect;
begin
  Result := @m_DrawRect;
end;

function TG2Texture2DBase.GetTexture: IDirect3DBaseTexture9;
begin
  Result := m_Texture;
end;

procedure TG2Texture2DBase.Release;
begin
  if Assigned(m_Texture) then
  G2WriteLogTimed('(<) Texture Released (' + Name + ').', 'Textures');
  SafeRelease(m_Texture);
  m_Width := 0;
  m_Height := 0;
  m_RealWidth := 0;
  m_RealHeight := 0;
  m_DrawRect := G2Rect(0, 0, 0, 0);
  m_Levels := 0;
  m_Format := D3DFMT_UNKNOWN;
  ZeroMemory(@m_Desc, SizeOf(m_Desc));
end;
//TG2Texture2DBase END

//TG2Texture2D BEGIN
constructor TG2Texture2D.Create;
begin
  inherited Create;
end;

destructor TG2Texture2D.Destroy;
begin
  inherited Destroy;
end;

constructor TG2Texture2D.TG2Tex2DLevelSurface.Create(const Texture: TG2Texture2D; const Level: Integer);
begin
  inherited Create;
  m_Texture := Texture;
  m_Level := Level;
  IDirect3DTexture9(m_Texture.Texture).GetLevelDesc(m_Level, m_Desc);
  m_Width := m_Desc.Width;
  m_Height := m_Desc.Height;
  case m_Desc.Format of
    D3DFMT_A8R8G8B8, D3DFMT_X8R8G8B8:
    begin
      m_ProcGetPixel := GetPixelA8R8G8B8;
      m_ProcSetPixel := SetPixelA8R8G8B8;
    end;
    D3DFMT_R8G8B8:
    begin
      m_ProcGetPixel := GetPixelR8G8B8;
      m_ProcSetPixel := SetPixelR8G8B8;
    end;
    D3DFMT_A4R4G4B4, D3DFMT_X4R4G4B4:
    begin
      m_ProcGetPixel := GetPixelA4R4G4B4;
      m_ProcSetPixel := SetPixelA4R4G4B4;
    end;
    D3DFMT_R5G6B5:
    begin
      m_ProcGetPixel := GetPixelR5G6B5;
      m_ProcSetPixel := SetPixelR5G6B5;
    end;
    D3DFMT_A1R5G5B5, D3DFMT_X1R5G5B5:
    begin
      m_ProcGetPixel := GetPixelA1R5G5B5;
      m_ProcSetPixel := SetPixelA1R5G5B5;
    end;
    D3DFMT_R3G3B2:
    begin
      m_ProcGetPixel := GetPixelR3G3B2;
      m_ProcSetPixel := SetPixelR3G3B2;
    end;
    D3DFMT_A8:
    begin
      m_ProcGetPixel := GetPixelA8;
      m_ProcSetPixel := SetPixelA8;
    end;
    D3DFMT_A8R3G3B2:
    begin
      m_ProcGetPixel := GetPixelA8R3G3B2;
      m_ProcSetPixel := SetPixelA8R3G3B2;
    end;
    D3DFMT_A2B10G10R10:
    begin
      m_ProcGetPixel := GetPixelA2B10G10R10;
      m_ProcSetPixel := SetPixelA2B10G10R10;
    end;
    D3DFMT_G16R16:
    begin
      m_ProcGetPixel := GetPixelG16R16;
      m_ProcSetPixel := SetPixelG16R16;
    end;
    D3DFMT_A2R10G10B10:
    begin
      m_ProcGetPixel := GetPixelA2R10G10B10;
      m_ProcSetPixel := SetPixelA2R10G10B10;
    end;
    D3DFMT_A16B16G16R16:
    begin
      m_ProcGetPixel := GetPixelA16B16G16R16;
      m_ProcSetPixel := SetPixelA16B16G16R16;
    end;
    else
    begin
      m_ProcGetPixel := GetPixelDummy;
      m_ProcSetPixel := SetPixelDummy;
    end;
  end;
end;

destructor TG2Texture2D.TG2Tex2DLevelSurface.Destroy;
begin
  inherited Destroy;
end;

{$Warnings Off}
function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA16B16G16R16(const X, Y: Integer): TG2Color;
var
  c: PWordArray;
begin
  c := PWordArray(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 8);
  with Result do
  begin
    r := c^[0] shr 8;
    g := c^[1] shr 8;
    b := c^[2] shr 8;
    a := c^[3] shr 8;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA16B16G16R16(const X, Y: Integer; const Value: TG2Color);
var
  c: PWordArray;
begin
  c := PWordArray(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 8);
  with Value do
  begin
    c[0] := r shl 8;
    c[1] := g shl 8;
    c[2] := b shl 8;
    c[3] := a shl 8;
  end;
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA2B10G10R10(const X, Y: Integer): TG2Color;
var
  c: DWord;
begin
  c := PDWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^;
  with Result do
  begin
    r := (c and $3fc) shr 2;
    g := (c and $ff000) shr 12;
    b := (c and $3fc00000) shr 22;
    a := (c and $c0000000) shr 24;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA2B10G10R10(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PDWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^ := (
    (r shl 2) or (g shl 12) or (b shl 22) or ((a and $3) shl 24)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelG16R16(const X, Y: Integer): TG2Color;
var
  c: DWord;
begin
  c := PDWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^;
  with Result do
  begin
    b := $ff;
    g := (c and $ff00) shr 8;
    r := (c and $ff000000) shr 24;
    a := $ff;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelG16R16(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PDWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^ := (
    (g shl 8) or (r shl 24)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA2R10G10B10(const X, Y: Integer): TG2Color;
var
  c: DWord;
begin
  c := PDWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^;
  with Result do
  begin
    b := (c and $3fc) shr 2;
    g := (c and $ff000) shr 12;
    r := (c and $3fc00000) shr 22;
    a := (c and $c0000000) shr 24;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA2R10G10B10(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PDWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^ := (
    (b shl 2) or (g shl 12) or (r shl 22) or ((a and $3) shl 24)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA8R3G3B2(const X, Y: Integer): TG2Color;
var
  c: Word;
begin
  c := PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^;
  with Result do
  begin
    b := (c and $3) shl 7;
    g := (c and $1c) shl 3;
    r := (c and $e0);
    a := (c and $ff00) shr 8;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA8R3G3B2(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X)^ := (
    ((b and $c0) shr 7) or ((g and $e0) shr 3) or (r and $e0) or (a shl 8)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA8(const X, Y: Integer): TG2Color;
begin
  with Result do
  begin
    r := $ff; g := $ff; b := $ff;
    a := PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X)^;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA8(const X, Y: Integer; const Value: TG2Color);
begin
  PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X)^ := Value.a;
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelR3G3B2(const X, Y: Integer): TG2Color;
var
  c: Byte;
begin
  c := PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X)^;
  with Result do
  begin
    b := (c and $3) shl 7;
    g := (c and $1c) shl 3;
    r := (c and $e0);
    a := $ff;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelR3G3B2(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X)^ := (
    ((b and $c0) shr 7) or ((g and $e0) shr 3) or (r and $e0)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA1R5G5B5(const X, Y: Integer): TG2Color;
var
  c: Word;
begin
  c := PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^;
  with Result do
  begin
    b := (c and $1f) shl 3;
    g := (c and $3e0) shr 2;
    r := (c and $7c00) shr 7;
    a := (c and $8000) shr 8;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA1R5G5B5(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^ := (
    ((b and $f8) shr 3) or ((g and $f8) shl 2) or ((r and $f8) shl 7) or ((a and $80) shl 8)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelR5G6B5(const X, Y: Integer): TG2Color;
var
  c: Word;
begin
  c := PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^;
  with Result do
  begin
    b := (c and $1f) shl 3;
    g := (c and $7e0) shr 3;
    r := (c and $f800) shr 8;
    a := $ff;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelR5G6B5(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^ := (
    ((b and $f8) shr 3) or ((g and $fc) shl 3) or ((r and $f8) shl 8)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA4R4G4B4(const X, Y: Integer): TG2Color;
var
  c: Word;
begin
  c := PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^;
  with Result do
  begin
    b := (c shl 4) and $f0;
    g := (c and $f0);
    r := (c shr 4) and $f0;
    a := (c shr 8) and $f0;
  end;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA4R4G4B4(const X, Y: Integer; const Value: TG2Color);
begin
  with Value do
  PWord(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 2)^ := (
    (b shr 4) or (g and $f0) or ((r and $f0) shl 4) or ((a and $f0) shl 8)
  );
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelR8G8B8(const X, Y: Integer): TG2Color;
begin
  Move(PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 3)^, Result, 3);
  Result.a := $ff;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelR8G8B8(const X, Y: Integer; const Value: TG2Color);
begin
  Move(Value, PByte(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 3)^, 3);
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelA8R8G8B8(const X, Y: Integer): TG2Color;
begin
  Result := PG2Color(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelA8R8G8B8(const X, Y: Integer; const Value: TG2Color);
begin
  PG2Color(Cardinal(m_Lock.pBits) + Y * m_Lock.Pitch + X * 4)^ := Value;
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixelDummy(const X, Y: Integer): TG2Color;
begin
  Result := 0;
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixelDummy(const X, Y: Integer; const Value: TG2Color);
begin

end;
{$Warnings On}

function TG2Texture2D.TG2Tex2DLevelSurface.GetPixel(const X, Y: Integer): TG2Color;
begin
  if not m_Locked then Exit;
  Result := m_ProcGetPixel(X, Y);
end;

procedure TG2Texture2D.TG2Tex2DLevelSurface.SetPixel(const X, Y: Integer; const Value: TG2Color);
begin
  if not m_Locked then Exit;
  m_ProcSetPixel(X, Y, Value);
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetSurfaceDesc: PD3DSurfaceDesc;
begin
  Result := @m_Desc;
end;

function TG2Texture2D.TG2Tex2DLevelSurface.GetLockedRect: PD3DLockedRect;
begin
  Result := @m_Lock;
end;

function TG2Texture2D.TG2Tex2DLevelSurface.Lock: TG2Result;
begin
  Result := grFail;
  if m_Locked then Exit;
  if Failed(IDirect3DTexture9(m_Texture.Texture).LockRect(m_Level, m_Lock, nil, 0)) then Exit;
  m_Locked := True;
  Result := grOk; 
end;

function TG2Texture2D.TG2Tex2DLevelSurface.UnLock: TG2Result;
begin
  Result := grFail;
  if not m_Locked then Exit;
  if Failed(IDirect3DTexture9(m_Texture.Texture).UnlockRect(m_Level)) then Exit;
  m_Locked := False;
  Result := grOk;
end;

procedure TG2Texture2D.InitLevels;
var
  i: Integer;
begin
  SetLength(m_Surfaces, m_Levels);
  for i := 0 to High(m_Surfaces) do
  m_Surfaces[i] := TG2Tex2DLevelSurface.Create(Self, i);
end;

procedure TG2Texture2D.UnInitLevels;
var
  i: Integer;
begin
  for i := 0 to High(m_Surfaces) do
  begin
    m_Surfaces[i].UnLock;
    m_Surfaces[i].Free;
  end;
  m_Surfaces := nil;
end;

function TG2Texture2D.GetSurface(const SurfaceLevel: Integer): TG2Tex2DLevelSurface;
begin
  Result := m_Surfaces[SurfaceLevel];
end;

function TG2Texture2D.MaxMipLevels(const Width, Height: Integer): Integer;
var
  rw, rh, mipu, mipv: Integer;
begin
  rw := 1;
  rh := 1;
  mipu := 1;
  mipv := 1;
  while rw < Width do
  begin
    rw := rw shl 1;
    Inc(mipu);
  end;
  while rh < Height do
  begin
    rh := rh shl 1;
    Inc(mipv);
  end;
  Result := Max(mipu, mipv);
end;

function TG2Texture2D.LoadFromFile(
      const f: AnsiString;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
var
  ImageInfo: TD3DXImageInfo;
begin
  Release;

  if Format = D3DFMT_UNKNOWN then
  m_Format := m_G2Graphics.m_InitParamsActual.DefaultTextureFormat
  else
  m_Format := m_G2Graphics.Specs.FindCompatiableTextureFormat(Format);

  if Failed(
    D3DXCreateTextureFromFileExA(
      m_G2Graphics.Device,
      PAnsiChar(f),
      0, 0,
      MipLevels,
      0,
      m_Format,
      D3DPOOL_MANAGED,
      D3DX_FILTER_NONE,
      D3DX_FILTER_NONE,
      0,
      @ImageInfo,
      nil,
      m_Texture
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  
  m_Width := ImageInfo.Width;
  m_Height := ImageInfo.Height;

  m_Texture.GetLevelDesc(0, m_Desc);
  m_RealWidth := m_Desc.Width;
  m_RealHeight := m_Desc.Height;         

  if MipLevels = 0 then
  m_Levels := MaxMipLevels(Width, Height)
  else
  m_Levels := Min(MipLevels, MaxMipLevels(Width, Height));
  if m_Levels > 1 then
  D3DXFilterTexture(
    m_Texture,
    nil,
    0,
    D3DX_FILTER_BOX
  );

  m_DrawRect := G2Rect(0, 0, m_Width / m_RealWidth, m_Height / m_RealHeight);
  InitLevels;
  Result := grOk;
  G2WriteLogTimed('(>) Texture Loaded (' + Name + '): Texture2D ' + IntToStr(m_RealWidth) + 'x' + IntToStr(m_RealHeight) + ' ' + G2FormatToString(m_Format) + ' ' + IntToStr(m_Levels) + 'Mip', 'Textures');
end;

function TG2Texture2D.LoadFromStream(
      const s: TMemoryStream;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
begin
  Result := LoadFromBuffer(s.Memory, Size, MipLevels, Format);
end;

function TG2Texture2D.LoadFromBuffer(
      const b: Pointer;
      const Size: Integer;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
var
  ImageInfo: TD3DXImageInfo;
begin
  Release;

  if Format = D3DFMT_UNKNOWN then
  m_Format := m_G2Graphics.m_InitParamsActual.DefaultTextureFormat
  else
  m_Format := m_G2Graphics.Specs.FindCompatiableTextureFormat(Format);

  if Failed(
    D3DXCreateTextureFromFileInMemoryEx(
      m_G2Graphics.Device,
      b,
      Size,
      0, 0,
      MipLevels,
      0,
      m_Format,
      D3DPOOL_MANAGED,
      D3DX_FILTER_NONE,
      D3DX_FILTER_NONE,
      0,
      @ImageInfo,
      nil,
      m_Texture
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;

  m_Width := ImageInfo.Width;
  m_Height := ImageInfo.Height;

  m_Texture.GetLevelDesc(0, m_Desc);
  m_RealWidth := m_Desc.Width;
  m_RealHeight := m_Desc.Height;

  if MipLevels = 0 then
  m_Levels := MaxMipLevels(Width, Height)
  else
  m_Levels := Min(MipLevels, MaxMipLevels(Width, Height));
  if m_Levels > 1 then
  D3DXFilterTexture(
    m_Texture,
    nil,
    0,
    D3DX_FILTER_BOX
  );

  m_DrawRect := G2Rect(0, 0, m_Width / m_RealWidth, m_Height / m_RealHeight);
  InitLevels;
  Result := grOk;
  G2WriteLogTimed('(>) Texture Loaded (' + Name + '): Texture2D ' + IntToStr(m_RealWidth) + 'x' + IntToStr(m_RealHeight) + ' ' + G2FormatToString(m_Format) + ' ' + IntToStr(m_Levels) + 'Mip', 'Textures');
end;

function TG2Texture2D.LoadFromGraphic(
      const g: TGraphic;
      const MipLevels: Integer = 8;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
var
  s: TMemoryStream;
begin
  s := TMemoryStream.Create;
  g.SaveToStream(s);
  Result := LoadFromStream(s, s.Size, MipLevels, Format);
  s.Free;
end;

procedure TG2Texture2D.Release;
begin
  UnInitLevels;
  inherited Release;
end;
//TG2Texture2D END

//TG2Texture2DRT BEGIN
constructor TG2Texture2DRT.Create;
begin
  inherited Create;
  ZeroMemory(@m_ViewPort, SizeOf(m_ViewPort));
end;

destructor TG2Texture2DRT.Destroy;
begin
  inherited Destroy;
end;

function TG2Texture2DRT.GetViewPort: PD3DViewPort9;
begin
  Result := @m_ViewPort;
end;

procedure TG2Texture2DRT.OnDeviceLost;
begin
  SafeRelease(m_DepthStencil);
  SafeRelease(m_Texture);
end;

procedure TG2Texture2DRT.OnDeviceReset;
begin
  if Succeeded(
    m_G2Graphics.Device.CreateTexture(
      m_RealWidth,
      m_RealHeight,
      1,
      D3DUSAGE_RENDERTARGET,
      m_G2Graphics.m_InitParamsActual.DefaultRenderTargetFormat,
      D3DPOOL_DEFAULT,
      m_Texture,
      nil
    )
  ) then
  begin
    m_G2Graphics.Device.CreateDepthStencilSurface(
      m_RealWidth,
      m_RealHeight,
      m_G2Graphics.m_InitParamsActual.DepthStencilFormat,
      m_G2Graphics.m_PresentParams.MultiSampleType,
      m_G2Graphics.m_PresentParams.MultiSampleQuality,
      True,
      m_DepthStencil,
      nil
    );
  end;
end;

function TG2Texture2DRT.MakeRenderTarget(
      const NewWidth, NewHeight: Integer;
      const NewFormat: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
begin
  Release;

  m_Width := NewWidth;
  m_Height := NewHeight;
  m_RealWidth := 1;
  m_RealHeight := 1;
  if NewFormat = D3DFMT_UNKNOWN then
  m_Format := m_G2Graphics.m_InitParamsActual.DefaultRenderTargetFormat
  else
  m_Format := m_G2Graphics.Specs.FindCompatiableTextureRTFormat(NewFormat);
  while m_RealWidth < m_Width do m_RealWidth := m_RealWidth shl 1;
  while m_RealHeight < m_Height do m_RealHeight := m_RealHeight shl 1;

  if Failed(
    m_G2Graphics.Device.CreateTexture(
      m_RealWidth,
      m_RealHeight,
      1,
      D3DUSAGE_RENDERTARGET,
      m_Format,
      D3DPOOL_DEFAULT,
      m_Texture,
      nil
    )
  ) then
  begin
    Result := grFail;
    Release;
    Exit;
  end;

  if Failed(
    m_G2Graphics.Device.CreateDepthStencilSurface(
      m_RealWidth,
      m_RealHeight,
      m_G2Graphics.m_InitParamsActual.DepthStencilFormat,
      m_G2Graphics.m_PresentParams.MultiSampleType,
      m_G2Graphics.m_PresentParams.MultiSampleQuality,
      True,
      m_DepthStencil,
      nil
    )
  )
  then
  begin
    Result := grFail;
    Release;
    Exit;
  end;

  m_Texture.GetLevelDesc(0, m_Desc);
  m_DrawRect := G2Rect(0, 0, m_Width / m_RealWidth, m_Height / m_RealHeight);
  m_ViewPort.X := 0;
  m_ViewPort.Y := 0;
  m_ViewPort.Width := m_Width;
  m_ViewPort.Height := m_Height;
  m_ViewPort.MinZ := 0;
  m_ViewPort.MaxZ := 1;
  m_Levels := 1;
  Result := grOk;
  G2WriteLogTimed('(>) Texture RenderTarget (' + Name + '): Texture2DRT ' + IntToStr(m_RealWidth) + 'x' + IntToStr(m_RealHeight) + ' ' + G2FormatToString(m_Format) + ' ' + IntToStr(m_Levels) + 'Mip', 'Textures');
end;

procedure TG2Texture2DRT.Release;
begin
  inherited Release;
  SafeRelease(m_DepthStencil);
  ZeroMemory(@m_ViewPort, SizeOf(m_ViewPort));
end;
//TG2Texture2DRT END

//TG2VMRAllocatorPresenter BEGIN
constructor TG2VMRAllocatorPresenter.Create(const Texture: TG2Texture2DVideo);
begin
  inherited Create;
  m_Texture := Texture;
  m_CriticalSection := TCriticalSection.Create;
end;

destructor TG2VMRAllocatorPresenter.Destroy;
begin
  m_CriticalSection.Free;
  inherited Destroy;
end;

function TG2VMRAllocatorPresenter.CreateSurfaces: HResult;
begin
  FreeSurfaces;
  SetLength(m_Surfaces, m_SurfaceCount);
  Result := m_SurfaceAllocatorNotify.AllocateSurfaceHelper(
    @m_AllocInfo, m_SurfaceCount, m_Surfaces[0]
  );
end;

function TG2VMRAllocatorPresenter.CreateTexture: HResult;
var
  rt: IDirect3DSurface9;
  TextureSurface: IDirect3DSurface9;
begin
  Result := E_FAIL;
  if G2ResFail(
    m_Texture.MakeTexture(
      m_AllocInfo.dwWidth,
      m_AllocInfo.dwHeight
    )
  ) then Exit;
  m_Texture.DrawRect^ := G2Rect(0, 0, 1, 1);
  m_Texture.Core.Graphics.Device.GetRenderTarget(0, rt);
  IDirect3DTexture9(m_Texture.Texture).GetSurfaceLevel(0, TextureSurface);
  m_Texture.Core.Graphics.Device.SetRenderTarget(0, TextureSurface);
  m_Texture.Core.Graphics.Device.Clear(0, nil, D3DCLEAR_TARGET, $ff000000, 0, 0);
  m_Texture.Core.Graphics.Device.SetRenderTarget(0, rt);
  SafeRelease(TextureSurface);
  SafeRelease(rt);
  Result := S_OK;
end;

procedure TG2VMRAllocatorPresenter.FreeSurfaces;
var
  i: integer;
begin
  for i := 0 to High(m_Surfaces) do
  SafeRelease(m_Surfaces[i]);
  m_Surfaces := nil;
end;

function TG2VMRAllocatorPresenter.InitializeDevice(
      dwUserID: DWORD;
      lpAllocInfo: PVMR9AllocationInfo;
      var lpNumBuffers: DWORD
    ): HResult;
var
  Mon: HMONITOR;
begin
  m_CriticalSection.Enter;
  try
    Mon := m_Texture.Core.Graphics.D3D9.GetAdapterMonitor(D3DADAPTER_DEFAULT);
    Result := m_SurfaceAllocatorNotify.SetD3DDevice(
      m_Texture.Core.Graphics.Device,
      Mon
    );
    if Failed(Result) then Exit;
    m_SurfaceCount := lpNumBuffers;
    lpAllocInfo^.dwFlags := VMR9AllocFlag_OffscreenSurface;
    Move(lpAllocInfo^, m_AllocInfo, SizeOf(TVMRAllocationInfo));
    Result := CreateSurfaces;
    if Failed(Result) then Exit;
    Result := CreateTexture;
  finally
    m_CriticalSection.Leave;
  end;
end;

function TG2VMRAllocatorPresenter.TerminateDevice(
      dwID: DWORD
    ): HResult;
begin
  m_CriticalSection.Enter;
  try
    FreeSurfaces;
    Result := S_OK;
  finally
    m_CriticalSection.Leave;
  end;
end;

function TG2VMRAllocatorPresenter.GetSurface(
      dwUserID: DWORD;
      SurfaceIndex: DWORD;
      SurfaceFlags: DWORD;
      out lplpSurface: IDirect3DSurface9
    ): HResult;
begin
  m_CriticalSection.Enter;
  try
    try
      if m_Texture.Core.Graphics.Device.TestCooperativeLevel = S_OK then
      begin
        SafeRelease(lplpSurface);
        lplpSurface := m_Surfaces[SurfaceIndex];
        Result := S_OK;
      end
      else
      Result := E_FAIL;
    except
      Result := E_FAIL;
    end;
  finally
    m_CriticalSection.Leave;
  end;
end;

function TG2VMRAllocatorPresenter.AdviseNotify(
      lpIVMRSurfAllocNotify: IVMRSurfaceAllocatorNotify9
    ): HResult;
begin
  m_CriticalSection.Enter;
  try
    m_SurfaceAllocatorNotify := lpIVMRSurfAllocNotify;
    Result := S_OK;
  finally
    m_CriticalSection.Leave;
  end;
end;

function TG2VMRAllocatorPresenter.StartPresenting(
      dwUserID: DWORD
    ): HResult;
begin
  Result := S_OK;
end;

function TG2VMRAllocatorPresenter.StopPresenting(
      dwUserID: DWORD
    ): HResult;
begin
  Result := S_OK;
end;

function TG2VMRAllocatorPresenter.PresentImage(
      dwUserID: DWORD;
      lpPresInfo: PVMR9PresentationInfo
    ): HResult;
var
  TexSurface: IDirect3DSurface9;
begin
  m_CriticalSection.Enter;
  try
    if ((lpPresInfo.dwFlags and VMR9Sample_TimeValid) = VMR9Sample_TimeValid)
    and (lpPresInfo.rtStart > 5000000)
    and (m_Texture.Core.Graphics.Device.TestCooperativeLevel = S_OK) then
    begin
      IDirect3DTexture9(m_Texture.Texture).GetSurfaceLevel(0, TexSurface);
      m_Texture.Core.Graphics.Device.StretchRect(
        lpPresInfo^.lpSurf, nil, TexSurface, nil, D3DTEXF_NONE
      );
      SafeRelease(TexSurface);
    end;
    Result := S_OK;
  finally
    m_CriticalSection.Leave;
  end;
end;
//TG2VMRAllocatorPresenter END

//TG2Texture2DVideo BEGIN
constructor TG2Texture2DVideo.Create;
begin
  inherited Create;
  m_Loaded := False;
end;

destructor TG2Texture2DVideo.Destroy;
begin
  Release;
  inherited Destroy;
end;

function TG2Texture2DVideo.AddFilter(         
      CLSID: TGUID;
      FilterName: WideString
    ): IBaseFilter;
begin
  if Failed(
    CoCreateInstance(
      CLSID,
      nil,
      CLSCTX_INPROC_SERVER,
      IID_IBaseFilter,
      Result
    )
  ) then Exit;
  if Failed(m_Graph.AddFilter(Result, PWideChar(FilterName))) then
  SafeRelease(Result);
end;

procedure TG2Texture2DVideo.ClearGraph;
var
  Filter: IBaseFilter;
  Enum: IEnumFilters;
begin
  if Assigned(m_Control) then
  m_Control.Stop;
  if Assigned(m_Graph)
  and Succeeded(m_Graph.EnumFilters(Enum)) then
  begin
    while Enum.Next(1, Filter, nil) = S_OK do
    begin
      m_Graph.RemoveFilter(Filter);
      SafeRelease(Filter);
      Enum.Reset;
    end;
  end;
end;

procedure TG2Texture2DVideo.SetPosition(const Value: Int64);    
var
  PosCur, PosStop: Int64;
begin
  PosStop := 0;
  PosCur := Value;
  m_Seeking.SetPositions(
    PosCur,
    AM_SEEKING_AbsolutePositioning,
    PosStop,
    AM_SEEKING_NoPositioning
  );
end;

function TG2Texture2DVideo.GetPosition: Int64;  
begin
  m_Seeking.GetCurrentPosition(Result);
end;

function TG2Texture2DVideo.GetDuration: Int64;  
begin
  m_Seeking.GetDuration(Result);
end;

function TG2Texture2DVideo.MakeTexture(const NewWidth, NewHeight: Integer): TG2Result;
begin
  SafeRelease(m_Texture);

  m_Width := NewWidth;
  m_Height := NewHeight;
  m_RealWidth := 1;
  m_RealHeight := 1;
  m_Format := D3DFMT_X8R8G8B8;
  while m_RealWidth < m_Width do m_RealWidth := m_RealWidth shl 1;
  while m_RealHeight < m_Height do m_RealHeight := m_RealHeight shl 1;

  if Failed(
    m_G2Graphics.Device.CreateTexture(
      m_RealWidth,
      m_RealHeight,
      1,
      D3DUSAGE_RENDERTARGET,
      m_Format,
      D3DPOOL_DEFAULT,
      m_Texture,
      nil
    )
  ) then
  begin
    Result := grFail;
    Release;
    Exit;
  end;

  m_Texture.GetLevelDesc(0, m_Desc);
  m_DrawRect := G2Rect(0, 0, m_Width / m_RealWidth, m_Height / m_RealHeight);
  m_Levels := 1;
  Result := grOk;
  G2WriteLogTimed('(>) Texture Video(' + Name + '): Texture2DVideo ' + IntToStr(m_RealWidth) + 'x' + IntToStr(m_RealHeight), 'Textures');
end;

function TG2Texture2DVideo.SetSurfaceAllocator: TG2Result;
var
  SurfaceAllocatorNotify: IVMRSurfaceAllocatorNotify9;
  Alloc: IVMRSurfaceAllocator9;
begin
  if Failed(
    m_VMR.QueryInterface(IID_IVMRSurfaceAllocatorNotify9, SurfaceAllocatorNotify)
  ) then
  begin
    Release;
    Result := grFail;
    Exit;
  end;
  if Failed(
    m_AllocatorPresenter.QueryInterface(IID_IVMRSurfaceAllocator9, Alloc)
  ) then
  begin
    Release;
    Result := grFail;
    Exit;
  end;
  if Failed(
    SurfaceAllocatorNotify.AdviseSurfaceAllocator(m_UsrID, Alloc)
  ) then
  begin
    Release;
    Result := grFail;
    Exit;
  end;
  if Failed(
    Alloc.AdviseNotify(SurfaceAllocatorNotify)
  ) then
  begin
    Release;
    Result := grFail;
    Exit;
  end;
  SafeRelease(SurfaceAllocatorNotify);
  Result := grOk;
end;

procedure TG2Texture2DVideo.OnDeviceLost;
begin
  if m_Loaded then
  begin
    m_PrevPos := Position;
    Release;
    m_Loaded := True;
  end;
end;

procedure TG2Texture2DVideo.OnDeviceReset;
var
  PinIn: IPin;
  mt: TAMMediaType;
begin
  if m_Loaded then
  begin
    StreamFile(m_FName);
    Position := m_PrevPos;
    Play;
  end;
end;

function TG2Texture2DVideo.StreamFile(const f: AnsiString): TG2Result;
var
  FilterConfig: IVMRFilterConfig9;
  CurPin: IPin;
  EnumPins: IEnumPins;
  PinInfo: TPinInfo;
begin
  Release;
  m_FName := f;
  if not Core.Graphics.Params.MutiThreaded then
  begin
    G2WriteLogTimed('(E) Video Textures can only work with multithreaded device.', 'Textures');
    Result := grFail;
    Exit;
  end;
  try
    m_UsrID := G2VMRID; Inc(G2VMRID);
    if Failed(
      CoCreateInstance(
        CLSID_FilterGraph,
        nil,
        CLSCTX_INPROC_SERVER,
        IID_IGraphBuilder,
        m_Graph
      )
    ) then
    begin
      Result := grFail;
      Exit;
    end;
    if Failed(
      m_Graph.QueryInterface(IID_IMediaControl, m_Control)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if Failed(
      m_Graph.QueryInterface(IID_IMediaEventEx, m_Event)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if Failed(
      m_Graph.QueryInterface(IID_IMediaPosition, m_Position)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if Failed(
      m_Graph.QueryInterface(IID_IMediaSeeking, m_Seeking)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    m_AllocatorPresenter := TG2VMRAllocatorPresenter.Create(Self);
    m_VMR := AddFilter(CLSID_VideoMixingRenderer9, 'VMR9');
    if not Assigned(m_VMR) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if Failed(
      m_VMR.QueryInterface(IID_IVMRFilterConfig9, FilterConfig)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if Failed(
      FilterConfig.SetRenderingMode(VMR9Mode_Renderless)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if G2ResFail(SetSurfaceAllocator) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    if Failed(
      m_Graph.RenderFile(PWideChar(StringToWideString(f, CP_ACP)), nil)
    ) then
    begin
      Release;
      Result := grFail;
      Exit;
    end;
    m_VMR.EnumPins(EnumPins);
    while EnumPins.Next(1, CurPin, nil) = S_OK do
    begin
      CurPin.QueryPinInfo(PinInfo);
      if PinInfo.dir = PINDIR_INPUT then
      begin
        m_PinIn := CurPin;
        Break;
      end;
    end;
    if Assigned(m_PinIn) then
    m_PinIn.ConnectedTo(m_PinOut);
    m_Loaded := True;
    Result := grOk;
  except
    Release;
    Result := grFail;
    Exit;
  end;
end;

procedure TG2Texture2DVideo.Play;
begin
  if m_Loaded then
  m_Control.Run;
end;

procedure TG2Texture2DVideo.Pause;
begin
  if m_Loaded then
  m_Control.Pause;
end;

procedure TG2Texture2DVideo.Stop;
begin
  if m_Loaded then
  begin
    m_Control.Stop;
    Rewind;
  end;
end;

procedure TG2Texture2DVideo.Rewind;
begin
  if m_Loaded then
  m_Position.put_CurrentPosition(0);
end;

function TG2Texture2DVideo.IsPlaying: Boolean;
var
  State: TFilterState;
  EventCode, p1, p2: Integer;
begin
  if m_Loaded then
  begin
    m_Event.GetEvent(EventCode, p1, p2, 0);
    if EventCode = EC_COMPLETE then
    Stop;
    m_Control.GetState(0, State);
    Result := (State = State_Running);
  end
  else
  Result := False;
end;

procedure TG2Texture2DVideo.Release;
begin
  m_Loaded := False;
  SafeRelease(m_PinOut);
  SafeRelease(m_PinIn);
  ClearGraph;
  SafeRelease(m_Seeking);
  SafeRelease(m_Position);
  SafeRelease(m_Event);
  SafeRelease(m_Control);
  SafeRelease(m_Graph);
  if Assigned(m_AllocatorPresenter) then
  begin
    //m_AllocatorPresenter.Free;
    //m_AllocatorPresenter := nil;
  end;
  inherited Release;
end;
//TG2Texture2DVideo END

//TG2TextureCubeBase BEGIN
constructor TG2TextureCubeBase.Create;
begin
  inherited Create;
end;

destructor TG2TextureCubeBase.Destroy;
begin
  inherited Destroy;
end;

function TG2TextureCubeBase.GetTexture: IDirect3DBaseTexture9;
begin
  Result := m_Texture;
end;

procedure TG2TextureCubeBase.Release;
begin
  SafeRelease(m_Texture);
end;
//TG2TextureCubeBase END

//TG2TextureCube BEGIN
constructor TG2TextureCube.Create;
begin
  inherited Create;
end;

destructor TG2TextureCube.Destroy;
begin
  inherited Destroy;
end;

function TG2TextureCube.LoadFromFile(
      const f: AnsiString;
      const MipLevels: Integer = 1;
      const Format: TD3DFormat = D3DFMT_UNKNOWN
    ): TG2Result;
var
  ImageInfo: TD3DXImageInfo;
begin
  Release;

  if Format = D3DFMT_UNKNOWN then
  m_Format := m_G2Graphics.m_InitParamsActual.DefaultTextureFormat
  else
  m_Format := m_G2Graphics.Specs.FindCompatiableTextureFormat(Format);

  if Failed(
    D3DXCreateCubeTextureFromFileExA(
      m_G2Graphics.Device,
      PAnsiChar(f),
      0,
      MipLevels,
      0,
      m_Format,
      D3DPOOL_MANAGED,
      D3DX_FILTER_NONE,
      D3DX_FILTER_NONE,
      0,
      @ImageInfo,
      nil,
      m_Texture
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;

  m_Width := ImageInfo.Width;
  m_Height := ImageInfo.Height;
  m_Depth := ImageInfo.Depth;
  
  m_Levels := m_Texture.GetLevelCount;
  if m_Levels > 1 then
  begin
    m_Texture.SetAutoGenFilterType(D3DX_FILTER_BOX);
    m_Texture.GenerateMipSubLevels;
  end;

  Result := grOk;
  G2WriteLogTimed('(>) Texture Loaded (' + Name + '): TextureCube ' + IntToStr(m_Width) + 'x' + IntToStr(m_Height) + 'x' + IntToStr(m_Depth) + ' ' + G2FormatToString(m_Format) + ' ' + IntToStr(m_Levels) + 'Mip', 'Textures');
end;
//TG2TextureCube END

//TG2FontMgr BEGIN
constructor TG2FontMgr.Create;
begin
  inherited Create;
end;

destructor TG2FontMgr.Destroy;
begin
  inherited Destroy;
end;

function TG2FontMgr.GetFont(const Index: Integer): TG2Font;
begin
  Result := TG2Font(m_Resources[Index]);
end;

function TG2FontMgr.CreateFont(const Name: AnsiString; const FontFace: String; const Size: Integer): TG2Font;
begin
  Result := TG2Font.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  Result.MakeFont(FontFace, Size);
  AddResource(Result);
end;

function TG2FontMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2FontMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2FontMgr END

//TG2Font BEGIN
constructor TG2Font.Create;
begin
  inherited Create;
end;

destructor TG2Font.Destroy;
begin
  inherited Destroy;
end;

function TG2Font.MakeFont(const NewFontFace: String; const NewSize: Integer): TG2Result;
type
  TBGR = record
    b, g, r: Byte;
  end;
  PBGRArray = ^TBGRArray;
  TBGRArray = array[Word] of TBGR;
var
  bmp: TBitmap;
  png: {$IFDEF VER200}TPNGImage;{$ELSE}TPNGObject;{$ENDIF}
  CharWidth, CharHeight, w, h, cx, cy: Integer;
  MaxWidth, MaxHeight: Integer;
  i, j: Integer;
  pbc: PBGRArray;
  pba: PNGImage.PByteArray;
  XChar: Byte;
begin
  Release;
  m_FontFace := NewFontFace;
  m_Size := NewSize;
  bmp := TBitmap.Create;
  MaxWidth := Min(m_G2Graphics.Caps.MaxTextureWidth, 2048);
  MaxHeight := Min(m_G2Graphics.Caps.MaxTextureHeight, 2048);
  bmp.Canvas.Font.Name := m_FontFace;
  bmp.Canvas.Font.Size := m_Size;
  bmp.Canvas.Font.Charset := RUSSIAN_CHARSET;
  CharWidth := 1;
  CharHeight := 1;
  for i := 0 to 255 do
  begin
    w := bmp.Canvas.TextWidth(Char(i));
    h := bmp.Canvas.TextHeight(Char(i));
    m_Props[i].Width := w;
    m_Props[i].Height := h;
    if w > CharWidth then CharWidth := w;
    if h > CharHeight then CharHeight := h;
  end;
  i := Min(CharWidth * 16, MaxWidth);
  j := Min(CharHeight * 16, MaxHeight);
  w := 1; h := 1;
  while w < i do w := w shl 1;
  while h < j do h := h shl 1;
  CharWidth := w div 16;
  CharHeight := h div 16;
  bmp.Monochrome := True;
  bmp.PixelFormat := pf24bit;
  bmp.SetSize(w, h);
  bmp.Canvas.Pen.Color := clWhite;
  bmp.Canvas.Brush.Color := clWhite;
  bmp.Canvas.Rectangle(bmp.Canvas.ClipRect);
  png := {$IFDEF VER200}TPNGImage{$ELSE}TPNGObject{$ENDIF}.Create;
  png.Assign(bmp);
  bmp.Canvas.Pen.Color := clBlack;
  bmp.Canvas.Brush.Color := clBlack;
  bmp.Canvas.Rectangle(bmp.Canvas.ClipRect);
  bmp.Canvas.Brush.Style := bsClear;
  bmp.Canvas.Font.Color := clWhite;
  for j := 0 to 15 do
  for i := 0 to 15 do
  begin
    XChar := j * 16 + i;
    cx := (CharWidth - m_Props[XChar].Width) div 2;
    cy := (CharHeight - m_Props[XChar].Height) div 2;
    m_Props[XChar].OffsetX := -cx;
    m_Props[XChar].OffsetY := -cy;
    bmp.Canvas.TextOut(i * CharWidth + cx, j * CharHeight + cy, Chr(XChar));
  end;
  png.CreateAlpha;
  for j := 0 to h - 1 do
  begin
    pbc := bmp.ScanLine[j];
    pba := png.AlphaScanline[j];
    for i := 0 to w - 1 do
    pba^[i] := pbc^[i].r;
  end;
  Result := m_Texture.LoadFromGraphic(png, 1, D3DFMT_DXT2);
  png.Free;
  bmp.Free;
  m_CharTU := CharWidth / m_Texture.Width;
  m_CharTV := CharHeight / m_Texture.Height;
  m_CharWidth := CharWidth;
  m_CharHeight := CharHeight;
  G2WriteLogTimed('(>) Font Generated (' + Name + '): ' + m_FontFace + ' ' + IntToStr(m_Size) + ' Texture' + IntToStr(m_Texture.RealWidth) + 'x' + IntToStr(m_Texture.RealHeight), 'Fonts');
end;

function TG2Font.Print(const X, Y: Single; const Color: TG2Color; const Text: AnsiString): TG2Result;
var
  i, CurVertex: Integer;
  XChar: Byte;
  Width: Single;
  VBSize: Integer;
  Vertices: PG2SharedVertex2DArray;
  tu1, tv1, tu2, tv2: Single;
  x1, y1, x2, y2: Single;
begin
  VBSize := Length(Text) * 4;
  Result := m_G2Graphics.SharedVB2D.VerifySize(VBSize);
  if G2ResFail(Result) then Exit;
  Width := 0;
  m_G2Graphics.SharedVB2D.VB.Lock(0, VBSize, Pointer(Vertices), D3DLOCK_DISCARD);
  for i := 0 to Length(Text) - 1 do
  begin
    XChar := Ord(Text[i + 1]);
    CurVertex := i * 4;
    tu1 := (XChar mod 16) * m_CharTU;
    tv1 := (XChar div 16) * m_CharTV;
    tu2 := tu1 + m_CharTU;
    tv2 := tv1 + m_CharTV;
    x1 := X + Width + m_Props[XChar].OffsetX;
    y1 := Y + m_Props[XChar].OffsetY;
    x2 := x1 + m_CharWidth;
    y2 := y1 + m_CharHeight;
    Vertices^[CurVertex].x := x1;
    Vertices^[CurVertex].y := y2;
    Vertices^[CurVertex].z := 0;
    Vertices^[CurVertex].rhw := 1;
    Vertices^[CurVertex].Color := Color;
    Vertices^[CurVertex].tu := tu1;
    Vertices^[CurVertex].tv := tv2;
    Inc(CurVertex);
    Vertices^[CurVertex].x := x1;
    Vertices^[CurVertex].y := y1;
    Vertices^[CurVertex].z := 0;
    Vertices^[CurVertex].rhw := 1;
    Vertices^[CurVertex].Color := Color;
    Vertices^[CurVertex].tu := tu1;
    Vertices^[CurVertex].tv := tv1;
    Inc(CurVertex);
    Vertices^[CurVertex].x := x2;
    Vertices^[CurVertex].y := y2;
    Vertices^[CurVertex].z := 0;
    Vertices^[CurVertex].rhw := 1;
    Vertices^[CurVertex].Color := Color;
    Vertices^[CurVertex].tu := tu2;
    Vertices^[CurVertex].tv := tv2;
    Inc(CurVertex);
    Vertices^[CurVertex].x := x2;
    Vertices^[CurVertex].y := y1;
    Vertices^[CurVertex].z := 0;
    Vertices^[CurVertex].rhw := 1;
    Vertices^[CurVertex].Color := Color;
    Vertices^[CurVertex].tu := tu2;
    Vertices^[CurVertex].tv := tv1;
    Width := Width + m_Props[XChar].Width;
  end;
  m_G2Graphics.SharedVB2D.VB.Unlock;
  m_G2Graphics.Device.SetTexture(0, m_Texture.Texture);
  m_G2Graphics.SharedVB2D.SetToDevice;
  m_G2Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, Length(Text) * 4 - 2);
end;

function TG2Font.GetTextWidth(const Text: AnsiString): Integer;
var
  i: Integer;
begin
  Result := 0;
  for i := 1 to Length(Text) do
  Result := Result + m_Props[Ord(Text[i])].Width;
end;

function TG2Font.GetTextHeight(const Text: AnsiString): Integer;
var
  i: Integer;
begin
  Result := 0;                            
  for i := 1 to Length(Text) do
  Result := Max(Result, m_Props[Ord(Text[i])].Height);
end;

procedure TG2Font.Release;
begin
  if Assigned(m_Texture.Texture) then
  G2WriteLogTimed('(<) Font Released: (' + Name + ').', 'Fonts');
  m_Texture.Release;
end;

function TG2Font.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_G2Graphics := Core.Graphics;
  m_Texture := TG2Texture2D.Create;
  m_Texture.Name := 'Font_' + Name + '_Texture';
  m_Texture.Initialize(Core);
  m_FontFace := '';
  m_Size := 0;
  Result := grOk;
  G2WriteLogTimed('(+) Font Initialized: (' + Name + ')', 'Fonts');
end;

function TG2Font.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Release;
  m_Texture.Free;
  Result := grOk;
  G2WriteLogTimed('(-) Font Finalized: (' + Name + ')', 'Fonts');
end;
//TG2Font END

//TG2MeshMgr BEGIN
constructor TG2MeshMgr.Create;
begin
  inherited Create;
end;

destructor TG2MeshMgr.Destroy;
begin
  inherited Destroy;
end;

function TG2MeshMgr.CreateMeshFromFile(const Name: AnsiString; const f: String; const Mode: TG2MeshMode = mmFF): TG2Mesh;
var
  i: Integer;
  LoaderClass: CG2MeshLoaderClass;
begin
  LoaderClass := nil;
  for i := 0 to High(G2MeshLoaders) do
  if G2MeshLoaders[i].CanLoadFile(f) then
  begin
    LoaderClass := G2MeshLoaders[i];
    Break;
  end;
  if not Assigned(LoaderClass) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TG2Mesh.Create;
  Result.Name := Name;
  Result.Mode := Mode;
  Result.Initialize(Core);
  Result.LoadFromFile(f, LoaderClass);
  AddResource(Result);
end;
//TG2MeshMgr END

//TG2Mesh BEGIN
constructor TG2Mesh.Create;
begin
  inherited Create;
  m_Instances := TG2List.Create;
  m_Mode := mmSW;
end;

destructor TG2Mesh.Destroy;
begin
  Release;
  m_Instances.Free;
  inherited Destroy;
end;

function TG2Mesh.GetNodeCount: Integer;
begin
  Result := Length(m_Nodes);
end;

function TG2Mesh.GetNode(const Index: Integer): TG2MeshNode;
begin
  Result := m_Nodes[Index];
end;

function TG2Mesh.GetAnimCount: Integer;
begin
  Result := Length(m_Anims);
end;

function TG2Mesh.GetAnim(const Index: Integer): TG2MeshAnim;
begin
  Result := m_Anims[Index];
end;

function TG2Mesh.GetGeomCount: Integer;
begin
  Result := Length(m_Geoms);
end;

function TG2Mesh.GetGeom(const Index: Integer): TG2MeshGeom;
begin
  Result := m_Geoms[Index];
end;

function TG2Mesh.GetSkinCount: Integer;
begin
  Result := Length(m_Skins);
end;

function TG2Mesh.GetSkin(const Index: Integer): TG2MeshSkin;
begin
  Result := m_Skins[Index];
end;

function TG2Mesh.GetMaterialCount: Integer;
begin
  Result := Length(m_Materials);
end;

function TG2Mesh.GetMaterial(const Index: Integer): TG2MeshMaterial;
begin
  Result := m_Materials[Index];
end;

function TG2Mesh.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(+) Mesh Initialized: (' + Name + ').', 'Meshes');
end;

function TG2Mesh.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(-) Mesh Finalized: (' + Name + ').', 'Meshes');
end;

function TG2Mesh.MaterialID(const Name: AnsiString; const MatchCase: Boolean = True): Integer;
var
  i: Integer;
begin
  if MatchCase then
  begin
    for i := 0 to MaterialCount - 1 do
    if m_Materials[i].Name = Name then
    begin
      Result := i;
      Exit;
    end;
  end
  else
  begin
    for i := 0 to MaterialCount - 1 do
    if LowerCase(m_Materials[i].Name) = LowerCase(Name) then
    begin
      Result := i;
      Exit;
    end;
  end;
  Result := -1;
end;

function TG2Mesh.LoadData(const MeshData: PG2MeshLoad): Boolean;
var
  i, n, v, b, kf, zf, f, FrameCount: Integer;
  g: Single;
begin
  SetLength(m_Nodes, MeshData^.NodeCount);
  for i := 0 to MeshData^.NodeCount - 1 do
  begin
    m_Nodes[i] := TG2MeshNode.Create;
    m_Nodes[i].Mesh := Self;
    m_Nodes[i].Pos^ := MeshData^.Nodes[i].Pos;
    m_Nodes[i].IndexID := i;
    m_Nodes[i].ParentID := MeshData^.Nodes[i].ParentID;
    m_Nodes[i].GeomID := MeshData^.Nodes[i].GeomID;
  end;
  for i := 0 to MeshData^.NodeCount - 1 do
  if m_Nodes[i].ParentID >= 0 then
  m_Nodes[m_Nodes[i].ParentID].AddChild(i);
  SetLength(m_Anims, MeshData^.AnimCount);
  for i := 0 to MeshData^.AnimCount - 1 do
  begin
    m_Anims[i] := TG2MeshAnim.Create;
    m_Anims[i].Mesh := Self;
    m_Anims[i].Name := MeshData^.Anims[i].Name;
    m_Anims[i].AnimStart := MeshData^.Anims[i].AnimStart;
    m_Anims[i].AnimEnd := MeshData^.Anims[i].AnimEnd;
    m_Anims[i].AnimNodeCount := MeshData^.NodeCount;
    FrameCount := MeshData^.Anims[i].AnimEnd - MeshData^.Anims[i].AnimStart + 1;
    for n := 0 to MeshData^.NodeCount - 1 do
    begin
      m_Anims[i].AnimNodes[n]^.NodeID := MeshData^.Anims[i].AnimNodes[n].NodeID;
      SetLength(m_Anims[i].AnimNodes[n]^.Frames, FrameCount);
      zf := MeshData^.Anims[i].AnimStart;
      for kf := 1 to MeshData^.Anims[i].AnimNodes[n].KeyFrameCount - 1 do
      begin
        for f := MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf - 1].FrameTime
        to MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf].FrameTime do
        begin
          g := (f - MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf - 1].FrameTime) / (MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf].FrameTime - MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf - 1].FrameTime);
          m_Anims[i].AnimNodes[n]^.Frames[f - zf].Scale := G2LerpVec3(
            MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf - 1].FrameScaling,
            MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf].FrameScaling,
            g
          );
          m_Anims[i].AnimNodes[n]^.Frames[f - zf].Rotation := G2SLerpQuat(
            MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf - 1].FrameRotation,
            MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf].FrameRotation,
            g
          );
          m_Anims[i].AnimNodes[n]^.Frames[f - zf].Translation := G2LerpVec3(
            MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf - 1].FrameTranslation,
            MeshData^.Anims[i].AnimNodes[n].KeyFrames[kf].FrameTranslation,
            g
          );
        end;
      end;
    end;
  end;
  SetLength(m_Skins, MeshData^.SkinCount);
  for i := 0 to MeshData^.SkinCount - 1 do
  begin
    m_Skins[i] := TG2MeshSkin.Create;
    m_Skins[i].Mesh := Self;
    m_Skins[i].GeomID := MeshData^.Skins[i].GeomID;
    m_Skins[i].BoneCount := MeshData^.Skins[i].BoneCount;
    for b := 0 to MeshData^.Skins[i].BoneCount - 1 do
    m_Skins[i].Bones[b] := MeshData^.Skins[i].Bones[b];
    m_Skins[i].SkinVertexCount := MeshData^.Geoms[m_Skins[i].GeomID].VCount;
    for v := 0 to MeshData^.Geoms[m_Skins[i].GeomID].VCount - 1 do
    begin
      m_Skins[i].SkinVertices[v].BoneCount := MeshData^.Skins[i].Vertices[v].BoneCount;
      SetLength(m_Skins[i].SkinVertices[v].BoneIndices, MeshData^.Skins[i].Vertices[v].BoneCount);
      SetLength(m_Skins[i].SkinVertices[v].BoneWeights, MeshData^.Skins[i].Vertices[v].BoneCount);
      for b := 0 to MeshData^.Skins[i].Vertices[v].BoneCount - 1 do
      begin
        m_Skins[i].SkinVertices[v].BoneIndices[b] := MeshData^.Skins[i].Vertices[v].BoneIndices[b];
        m_Skins[i].SkinVertices[v].BoneWeights[b] := MeshData^.Skins[i].Vertices[v].BoneWeights[b];
      end;
    end;
  end;
  SetLength(m_Geoms, MeshData^.GeomCount);
  for i := 0 to MeshData^.GeomCount - 1 do
  begin
    m_Geoms[i] := TG2MeshGeom.Create;
    m_Geoms[i].Mesh := Self;
    m_Geoms[i].SkinID := MeshData^.Geoms[i].SkinID;
    m_Geoms[i].InitMesh(@MeshData^.Geoms[i]);
  end;
  for i := 0 to High(m_Nodes) do
  if m_Nodes[i].GeomID >= 0 then
  m_Geoms[m_Nodes[i].GeomID].NodeID := i;
  SetLength(m_Materials, MeshData^.MaterialCount);
  for i := 0 to MeshData^.MaterialCount - 1 do
  begin
    m_Materials[i] := TG2MeshMaterial.Create;
    m_Materials[i].Mesh := Self;
    m_Materials[i].Name := MeshData^.Materials[i].Name;
  end;
end;

function TG2Mesh.LoadFromFile(const f: String; const LoaderClass: CG2MeshLoaderClass): TG2Result;
var
  Loader: TG2MeshLoader;
  MeshData: TG2MeshLoad;
  LoaderDef: AnsiString;
begin
  Release;
  ZeroMemory(@MeshData, SizeOf(MeshData));
  Loader := LoaderClass.Create;
  LoaderDef := Loader.GetDifinition;
  Loader.LoadFile(f, @MeshData);
  Loader.Free;
  LoadData(@MeshData);
  Result := grOk;
  G2WriteLogTimed('(>) Mesh Loaded (' + Name + '): ' + LoaderDef, 'Meshes');
end;

procedure TG2Mesh.Release;
var
  i: Integer;
begin
  if Length(m_Nodes) > 0 then
  G2WriteLogTimed('(<) Mesh Released (' + Name + ').', 'Meshes');
  while m_Instances.Count > 0 do
  TG2MeshInstance(m_Instances[0]).Free;
  for i := 0 to High(m_Materials) do
  m_Materials[i].Free;
  SetLength(m_Materials, 0);
  for i := 0 to High(m_Skins) do
  m_Skins[i].Free;
  SetLength(m_Skins, 0);
  for i := 0 to High(m_Geoms) do
  m_Geoms[i].Free;
  SetLength(m_Geoms, 0);
  for i := 0 to High(m_Anims) do
  m_Anims[i].Free;
  SetLength(m_Anims, 0);
  for i := 0 to High(m_Nodes) do
  m_Nodes[i].Free;
  SetLength(m_Nodes, 0);
end;

function TG2Mesh.CreateInstance: TG2MeshInstance;
begin
  Result := TG2MeshInstance.Create;
  Result.Mesh := Self;
end;
//TG2Mesh END

//TG2MeshInstance BEGIN
constructor TG2MeshInstance.Create;
begin
  inherited Create;
  m_Mesh := nil;
  m_AnimID := 0;
  m_Transform.SetIdentity;
end;

destructor TG2MeshInstance.Destroy;
begin
  if Assigned(m_Mesh) then
  m_Mesh.Instances.Remove(Self);
  inherited Destroy;
end;

procedure TG2MeshInstance.SetMesh(const Value: TG2Mesh);
var
  i, b: Integer;
begin
  if Assigned(m_Mesh) then
  m_Mesh.Instances.Remove(Self);
  m_Mesh := Value;
  if Assigned(m_Mesh) then
  begin
    m_Mesh.Instances.Add(Self);
    SetLength(m_Scales, m_Mesh.NodeCount);
    SetLength(m_Rotations, m_Mesh.NodeCount);
    SetLength(m_Translations, m_Mesh.NodeCount);
    SetLength(m_Transforms, m_Mesh.NodeCount);
    for i := 0 to High(m_Transforms) do
    m_Transforms[i].SetIdentity;
    SetLength(m_SkinTransformPointers, m_Mesh.SkinCount);
    for i := 0 to m_Mesh.SkinCount - 1 do
    begin
      SetLength(m_SkinTransformPointers[i], m_Mesh.Skins[i].BoneCount);
      for b := 0 to m_Mesh.Skins[i].BoneCount - 1 do
      m_SkinTransformPointers[i][b] := @m_Transforms[m_Mesh.Skins[i].Bones[b]];
    end;
    m_Effect := m_Mesh.Core.Graphics.ShaderLib.RequestEffect('fx_Meshes');
    m_VS := m_Mesh.Core.Graphics.ShaderLib.RequestVertexShader('vs_Mesh');
    m_PS := m_Mesh.Core.Graphics.ShaderLib.RequestPixelShader('ps_Mesh');
    case m_Mesh.Mode of
      mmSW: m_RenderProc := RenderSW;
      mmFF: m_RenderProc := RenderFF;
      mmSM3HLSL: m_RenderProc := RenderSM3HLSL;
      mmSM3ASM: m_RenderProc := RenderSM3ASM;
    end;
    if m_Mesh.Mode = mmSW then
    begin
      SetLength(m_SWGeoms, m_Mesh.GeomCount);
      for i := 0 to High(m_SWGeoms) do
      begin
        m_Mesh.Geoms[i].Geom.CloneMeshFVF(
          m_Mesh.Geoms[i].Geom.GetOptions and not D3DXMESH_SYSTEMMEM or
          D3DXMESH_WRITEONLY or D3DXMESH_DYNAMIC,
          D3DFVF_XYZ or D3DFVF_NORMAL or D3DFVF_TEX1,
          m_Mesh.Core.Graphics.Device,
          m_SWGeoms[i]
        );
      end;
      UpdateSWGeoms;
    end;
  end;
end;

procedure TG2MeshInstance.SetTransform(const Index: Integer; const Value: TG2Mat);
begin
  m_Transforms[Index] := Value;
end;

function TG2MeshInstance.GetTransform(const Index: Integer): TG2Mat;
begin
  Result := m_Transforms[Index];
end;

function TG2MeshInstance.GetSkinTransformPointers(const Index: Integer): PPD3DXMatrix;
begin
  Result := @m_SkinTransformPointers[Index][0];
end;

procedure TG2MeshInstance.GenerateNodeMatrix(const NodeID: Integer);
var
  i: Integer;
  m: TG2Mat;
begin
  m.SetTranslation(-m_Mesh.Nodes[NodeID].Pos^);
  m_Transforms[NodeID].SetScaling(m_Scales[NodeID]);
  m_Transforms[NodeID].Rotate(m_Rotations[NodeID]);
  m_Transforms[NodeID].Translate(m_Translations[NodeID]);
  m_Transforms[NodeID] := m * m_Transforms[NodeID];
  m.SetTranslation(m_Mesh.Nodes[NodeID].Pos^);
  m_Transforms[NodeID] := m_Transforms[NodeID] * m;
  if m_Mesh.Nodes[NodeID].ParentID >= 0 then
  m_Transforms[NodeID] := m_Transforms[NodeID] * m_Transforms[m_Mesh.Nodes[NodeID].ParentID];
  for i := 0 to m_Mesh.Nodes[NodeID].ChildCount - 1 do
  GenerateNodeMatrix(m_Mesh.Nodes[NodeID].ChildIDs[i]);
end;

procedure TG2MeshInstance.UpdateSWGeoms;
type
  TVertexSkinned = packed record
    Position: TG2Vec3;
    BWeights: array[0..3] of Single;
    BIndices: array[0..3] of Byte;
    Normal: TG2Vec3;
    TexCoords: TG2Vec2;
  end;
  TVertexSkinnedArr = array[0..0] of TVertexSkinned;
  PVertexSkinnedArr = ^TVertexSkinnedArr;
  TVertexStatic = packed record
    Position: TG2Vec3;
    Normal: TG2Vec3;
    TexCoords: TG2Vec2;
  end;
  TVertexStaticArr = array[0..0] of TVertexStatic;
  PVertexStaticArr = ^TVertexStaticArr;
var
  i, v: Integer;
  v3: array [0..3] of TG2Vec3;
  VSkinned: PVertexSkinnedArr;
  VSW: PVertexStaticArr;
  VCount: Integer;
  SkinID: Integer;
begin
  for i := 0 to High(m_SWGeoms) do
  if m_Mesh.Geoms[i].Skinned then
  begin
    VCount := m_Mesh.Geoms[i].Geom.GetNumVertices;
    SkinID := m_Mesh.Geoms[i].SkinID;
    m_SWGeoms[i].LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VSW));
    m_Mesh.Geoms[i].Geom.LockVertexBuffer(D3DLOCK_READONLY, Pointer(VSkinned));
    for v := 0 to VCount - 1 do
    begin
      VSW^[v].Position := (
        VSkinned^[v].Position * m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[0]]^ * VSkinned^[v].BWeights[0] +
        VSkinned^[v].Position * m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[1]]^ * VSkinned^[v].BWeights[1] +
        VSkinned^[v].Position * m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[2]]^ * VSkinned^[v].BWeights[2] +
        VSkinned^[v].Position * m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[3]]^ * VSkinned^[v].BWeights[3]
      );
      D3DXVec3TransformNormal(PG2Vec3Ref(@v3[0])^, VSkinned^[v].Normal, m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[0]]^);
      D3DXVec3TransformNormal(PG2Vec3Ref(@v3[1])^, VSkinned^[v].Normal, m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[1]]^);
      D3DXVec3TransformNormal(PG2Vec3Ref(@v3[2])^, VSkinned^[v].Normal, m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[2]]^);
      D3DXVec3TransformNormal(PG2Vec3Ref(@v3[3])^, VSkinned^[v].Normal, m_SkinTransformPointers[SkinID][VSkinned^[v].BIndices[3]]^);
      VSW^[v].Normal := (
        v3[0] * VSkinned^[v].BWeights[0] +
        v3[1] * VSkinned^[v].BWeights[1] +
        v3[2] * VSkinned^[v].BWeights[2] +
        v3[3] * VSkinned^[v].BWeights[3]
      );
      VSW^[v].TexCoords := VSkinned^[v].TexCoords;
    end;
    m_Mesh.Geoms[i].Geom.UnlockVertexBuffer;
    m_SWGeoms[i].UnlockVertexBuffer;
  end;
end;

procedure TG2MeshInstance.RenderSW;
var
  i, Mat: Integer;
  Material: TG2MeshMaterial;
begin
  with m_Mesh, m_Mesh.Core.Graphics do
  for i := 0 to GeomCount - 1 do
  begin
    m_Mesh.Core.Graphics.Transforms.PushW;
    Transforms.W[0] := (
      m_Transforms[m_Mesh.Geoms[i].NodeID] * m_Transform * Transforms.W[0]
    );
    Transforms.ApplyW(0);
    if Geoms[i].MaterialCount > 0 then
    for Mat := 0 to Geoms[i].MaterialCount - 1 do
    begin
      Material := Materials[Geoms[i].MaterialIDs[Mat]];
      if Assigned(Material.Diffuse) then
      Device.SetTexture(0, Material.Diffuse.Texture)
      else
      Device.SetTexture(0, nil);
      m_SWGeoms[i].DrawSubset(Mat);
    end
    else
    begin
      Device.SetTexture(0, nil);
      m_SWGeoms[i].DrawSubset(0);
    end;
    m_Mesh.Core.Graphics.Transforms.PopW;
    m_Mesh.Core.Graphics.Transforms.ApplyW(0);
  end;
end;

procedure TG2MeshInstance.RenderFF;
var
  i, b, Mat: Integer;
  Material: TG2MeshMaterial;
  W: TG2Mat;
begin
  W := m_Transform * m_Mesh.Core.Graphics.Transforms.W[0];
  m_Mesh.Core.Graphics.Transforms.PushW;
  with m_Mesh, m_Mesh.Core.Graphics do
  for i := 0 to GeomCount - 1 do
  begin
    if Geoms[i].Skinned then
    begin
      RenderStates.IndexedVertexBlendEnable := True;
      RenderStates.VertexBlend := 4;
      for b := 0 to Skins[Geoms[i].SkinID].BoneCount - 1 do
      begin
        Transforms.W[b] := m_SkinTransformPointers[Geoms[i].SkinID][b]^ * W;
        Transforms.ApplyW(b);
      end;
    end
    else
    begin
      Transforms.W[0] := (
        m_Transforms[m_Mesh.Geoms[i].NodeID] * W
      );
      Transforms.ApplyW(0);
    end;
    if Geoms[i].MaterialCount > 0 then
    for Mat := 0 to Geoms[i].MaterialCount - 1 do
    begin
      Material := Materials[Geoms[i].MaterialIDs[Mat]];
      if Assigned(Material.Diffuse) then
      Device.SetTexture(0, Material.Diffuse.Texture)
      else
      Device.SetTexture(0, nil);
      Geoms[i].Geom.DrawSubset(Mat);
    end
    else
    begin
      Device.SetTexture(0, nil);
      Geoms[i].Geom.DrawSubset(0);
    end;
    if Geoms[i].Skinned then
    begin
      RenderStates.IndexedVertexBlendEnable := False;
      RenderStates.VertexBlend := 0;
    end;
  end;
  m_Mesh.Core.Graphics.Transforms.PopW;
  m_Mesh.Core.Graphics.Transforms.ApplyW(0);
end;

procedure TG2MeshInstance.RenderSM3HLSL;
var
  i, Mat: Integer;
  PassCount: Integer;
  Material: TG2MeshMaterial;
  v3: TG2Vec3;
  LightCountPoint: Integer;
  LightPosPoint: array[0..15] of TD3DXVector4;
  LightColorPoint: array[0..15] of TD3DXColor;
  LightRangePoint: array[0..15] of Single;
  LightCountDirectional: Integer;
  LightDirDirectional: array[0..15] of TD3DXVector4;
  LightColorDirectional: array[0..15] of TD3DXColor;
  LightAmbient: TD3DXColor;
  PrevTechnique, NewTechnique: TD3DXHandle;
  PassOpen: Boolean;
begin
  LightCountPoint := 0;
  LightCountDirectional := 0;
  LightAmbient := D3DXColorFromDWord(m_Mesh.Core.Graphics.RenderStates.Ambient);
  for i := 0 to m_Mesh.Core.Graphics.Lights.LightCount - 1 do
  if m_Mesh.Core.Graphics.Lights[i].Enabled then
  begin
    case m_Mesh.Core.Graphics.Lights[i].LightType of
      ltAmbient:
      begin
        D3DXColorAdd(LightAmbient, LightAmbient, m_Mesh.Core.Graphics.Lights[i].Light.Ambient);
      end;
      ltPoint:
      begin
        v3 := m_Mesh.Core.Graphics.Lights[i].Light.Position;
        LightPosPoint[LightCountPoint] := D3DXVector4(
          v3 * m_Mesh.Core.Graphics.Transforms.V, 1
        );
        LightColorPoint[LightCountPoint] := m_Mesh.Core.Graphics.Lights[i].Light.Diffuse;
        LightRangePoint[LightCountPoint] := Sqr(m_Mesh.Core.Graphics.Lights[i].Light.Range);
        Inc(LightCountPoint);
      end;
      ltDirectional:
      begin
        v3 := m_Mesh.Core.Graphics.Lights[i].Light.Direction;
        D3DXVec3TransformNormal(PG2Vec3Ref(@v3)^, v3, m_Mesh.Core.Graphics.Transforms.V);
        v3 := -v3;
        v3.Normalize;
        LightDirDirectional[LightCountDirectional] := D3DXVector4(v3, 1);
        LightColorDirectional[LightCountDirectional] := m_Mesh.Core.Graphics.Lights[i].Light.Diffuse;
        Inc(LightCountDirectional);
      end;
    end;
  end;
  m_Effect.SetVector('LightAmbient', PD3DXVector4(@LightAmbient)^);
  m_Effect.SetInt('LightCountPoint', LightCountPoint);
  m_Effect.SetVectorArray('LightPosPoint', @LightPosPoint[0], LightCountPoint);
  m_Effect.SetVectorArray('LightColorPoint', @LightColorPoint[0], LightCountPoint);
  m_Effect.SetFloatArray('LightRangePoint', @LightRangePoint[0], LightCountPoint);
  m_Effect.SetInt('LightCountDirectional', LightCountDirectional);
  m_Effect.SetVectorArray('LightDirDirectional', @LightDirDirectional[0], LightCountDirectional);
  m_Effect.SetVectorArray('LightColorDirectional', @LightColorDirectional[0], LightCountDirectional);
  PrevTechnique := '';
  PassOpen := False;
  for i := 0 to m_Mesh.GeomCount - 1 do
  begin
    m_Mesh.Core.Graphics.Transforms.PushW;
    NewTechnique := m_Mesh.Geoms[i].Technique;
    if NewTechnique <> PrevTechnique then
    begin
      m_Effect.Technique := NewTechnique;
      PrevTechnique := NewTechnique;
      if PassOpen then
      begin
        m_Effect.EndPass;
        m_Effect.EndEffect;
      end;
      m_Effect.BeginEffect(@PassCount, 0); //D3DXFX_DONOTSAVESTATE
      m_Effect.BeginPass(0);
      PassOpen := True;
    end;
    m_Mesh.Core.Graphics.Transforms.W[0] := (
      m_Transforms[m_Mesh.Geoms[i].NodeID] * m_Transform * m_Mesh.Core.Graphics.Transforms.W[0]
    );
    m_Effect.SetMatrix('W', m_Mesh.Core.Graphics.Transforms.W[0]);
    m_Effect.SetMatrix('WV', m_Mesh.Core.Graphics.Transforms.WV);
    m_Effect.SetMatrix('WVP', m_Mesh.Core.Graphics.Transforms.WVP);
    if m_Mesh.Geoms[i].Skinned then
    begin
      m_Effect.SetMatrixPointerArray(
        'SkinPallete',
        @m_SkinTransformPointers[m_Mesh.Geoms[i].SkinID][0],
        m_Mesh.Skins[m_Mesh.Geoms[i].SkinID].BoneCount
      );
    end;
    if m_Mesh.Geoms[i].MaterialCount > 0 then
    for Mat := 0 to m_Mesh.Geoms[i].MaterialCount - 1 do
    begin
      Material := m_Mesh.Materials[m_Mesh.Geoms[i].MaterialIDs[Mat]];
      if Assigned(Material.Diffuse) then
      m_Effect.SetTexture('TexDiffuse', Material.Diffuse.Texture)
      else
      m_Effect.SetTexture('TexDiffuse', nil);
      if Assigned(Material.Specular) then
      m_Effect.SetTexture('TexSpecular', Material.Specular.Texture)
      else
      m_Effect.SetTexture('TexSpecular', nil);
      if Assigned(Material.Normals) then
      m_Effect.SetTexture('TexNormals', Material.Normals.Texture)
      else
      m_Effect.SetTexture('TexNormals', nil);
      m_Effect.CommitChanges;
      m_Mesh.Geoms[i].Geom.DrawSubset(Mat);
    end
    else
    begin
      m_Effect.SetTexture('TexDiffuse', nil);
      m_Effect.SetTexture('TexSpecular', nil);
      m_Effect.SetTexture('TexNormals', nil);
      m_Effect.CommitChanges;
      m_Mesh.Geoms[i].Geom.DrawSubset(0);
    end;
    m_Mesh.Core.Graphics.Transforms.PopW;
  end;
  if PassOpen then
  begin
    m_Effect.EndPass;
    m_Effect.EndEffect;
  end;
end;

procedure TG2MeshInstance.RenderSM3ASM;
  procedure SetTexture(const Stage: Byte; const Tex: TG2TextureBase);
  begin
    if Assigned(Tex) then
    m_Mesh.Core.Graphics.Device.SetTexture(Stage, Tex.Texture)
    else
    m_Mesh.Core.Graphics.Device.SetTexture(Stage, nil);
  end;
var
  i, b, Mat: Integer;
  Material: TG2MeshMaterial;
  W, WV, WVP, m: TG2Mat;
  v3: TG2Vec3;
  v4: TD3DXVector4;
begin
  with m_Mesh, m_Mesh.Core.Graphics do
  begin
    for i := 0 to GeomCount - 1 do
    begin
      W := m_Transforms[m_Mesh.Geoms[i].NodeID] * m_Transform * Transforms.W[0];
      WV := W * Transforms.V;
      v3 := G2Vec3(-10, 5, -20) * WV;
      WVP := (WV * Transforms.P).Transpose;
      WV := WV.Transpose;
      m_VS.SetConstantF(10, @WVP, 4);
      m_VS.SetConstantF(14, @WV, 3);
      v4 := D3DXVector4(v3.X, v3.Y, v3.Z, 1);
      m_VS.SetConstantF(17, @v4, 1);
      if Geoms[i].SkinID >= 0 then
      for b := 0 to Skins[Geoms[i].SkinID].BoneCount - 1 do
      begin
        D3DXMatrixTranspose(PG2MatRef(@m)^, m_SkinTransformPointers[Geoms[i].SkinID][b]^);
        m_VS.SetConstantF(20 + b * 3, @m, 3);
      end;
      m_VS.SetToDevice;
      m_PS.SetToDevice;
      for Mat := 0 to Geoms[i].MaterialCount - 1 do
      begin
        Material := Materials[Geoms[i].MaterialIDs[Mat]];
        SetTexture(0, Material.Diffuse);
        SetTexture(1, Material.Specular);
        SetTexture(2, Material.Normals);
        Geoms[i].Geom.DrawSubset(Mat);
      end;
    end;
    Device.SetVertexShader(nil);
    Device.SetPixelShader(nil);
  end;
end;

procedure TG2MeshInstance.Render;
begin
  m_RenderProc();
end;

procedure TG2MeshInstance.AnimationSet(const AnimName: AnsiString; const MatchCase: Boolean = True);
var
  i: Integer;
begin
  if MatchCase then
  begin
    for i := 0 to m_Mesh.AnimCount - 1 do
    if m_Mesh.Anims[i].Name = AnimName then
    begin
      m_AnimID := i;
      Exit;
    end;
  end
  else
  begin
    for i := 0 to m_Mesh.AnimCount - 1 do
    if LowerCase(m_Mesh.Anims[i].Name) = LowerCase(AnimName) then
    begin
      m_AnimID := i;
      Exit;
    end;
  end;
end;

procedure TG2MeshInstance.FrameSet(const FrameIndex: Single);
var
  i: Integer;
  g: Single;
  f0, f1: Integer;
  FrameCount: Integer;
begin
  for i := 0 to m_Mesh.NodeCount - 1 do
  begin
    FrameCount := Length(m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames);
    f0 := Trunc(FrameIndex);
    g := FrameIndex - f0;
    f0 := f0 mod FrameCount;
    f1 := (f0 + 1) mod FrameCount;
    m_Scales[i] := G2LerpVec3(
      m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames[f0].Scale,
      m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames[f1].Scale,
      g
    );
    m_Rotations[i] := G2SLerpQuat(
      m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames[f0].Rotation,
      m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames[f1].Rotation,
      g
    );
    m_Translations[i] := G2LerpVec3(
      m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames[f0].Translation,
      m_Mesh.Anims[m_AnimID].AnimNodes[i].Frames[f1].Translation,
      g
    );
  end;
  for i := 0 to m_Mesh.NodeCount - 1 do
  if m_Mesh.Nodes[i].ParentID = -1 then
  GenerateNodeMatrix(i);
  if m_Mesh.Mode = mmSW then
  UpdateSWGeoms;
end;
//TG2MeshInstance END

//TG2MeshNode BEGIN
constructor TG2MeshNode.Create;
begin
  inherited Create;
end;

destructor TG2MeshNode.Destroy;
begin
  inherited Destroy;
end;

function TG2MeshNode.GetPos: PG2Vec3;
begin
  Result := @m_Pos;
end;

procedure TG2MeshNode.SetChildCount(const Value: Integer);
begin
  SetLength(m_ChildIDs, Value);
end;

function TG2MeshNode.GetChildCount: Integer;
begin
  Result := Length(m_ChildIDs);
end;

procedure TG2MeshNode.SetChildID(const Index: Integer; const Value: Integer);
begin
  m_ChildIDs[Index] := Value;
end;

function TG2MeshNode.GetChildID(const Index: Integer): Integer;
begin
  Result := m_ChildIDs[Index];
end;

procedure TG2MeshNode.AddChild(const ID: Integer);
begin
  SetLength(m_ChildIDs, Length(m_ChildIDs) + 1);
  m_ChildIDs[High(m_ChildIDs)] := ID;
end;
//TG2MeshNode END

//TG2MeshGeom BEGIN
constructor TG2MeshGeom.Create;
begin
  inherited Create;
  m_Skinned := False;
end;

destructor TG2MeshGeom.Destroy;
begin
  Release;
  inherited Destroy;
end;

procedure TG2MeshGeom.SetMaterialCount(const Value: Integer);
begin
  SetLength(m_MaterialIDs, Value);
end;

function TG2MeshGeom.GetMaterialCount: Integer;
begin
  Result := Length(m_MaterialIDs);
end;

procedure TG2MeshGeom.SetMaterialID(const Index: Integer; const Value: Integer);
begin
  m_MaterialIDs[Index] := Value;
end;

function TG2MeshGeom.GetMaterialID(const Index: Integer): Integer;
begin
  Result := m_MaterialIDs[Index];
end;

procedure TG2MeshGeom.InitMeshSW(const GeomData: PG2MeshLoadGeom);
type
  TVertexSkinned = packed record
    Position: TG2Vec3;
    BWeights: array[0..3] of Single;
    BIndices: array[0..3] of Byte;
    Normal: TG2Vec3;
    TexCoords: TG2Vec2;
  end;
  TVertexSkinnedArr = array[0..0] of TVertexSkinned;
  PVertexSkinnedArr = ^TVertexSkinnedArr;
  TVertexStatic = packed record
    Position: TG2Vec3;
    Normal: TG2Vec3;
    TexCoords: TG2Vec2;
  end;
  TVertexStaticArr = array[0..0] of TVertexStatic;
  PVertexStaticArr = ^TVertexStaticArr;
  PIndexArray2 = ^TIndexArray2;
  TIndexArray2 = array[0..0] of Word;
var
  FVF: DWord;
  VStatic: PVertexStaticArr;
  VSkinned: PVertexSkinnedArr;
  VCount, ICount, i, b: Integer;
  Indices: Pointer;
  Indices2: PIndexArray2;
  Attributes: PDWORDArray;
  Adj: array of DWord;
  MeshOpts: DWord;
begin
  Release;
  m_Skinned := GeomData^.SkinID >= 0;
  if m_Skinned then
  FVF := D3DFVF_XYZB5 or D3DFVF_LASTBETA_UBYTE4
  else
  FVF := D3DFVF_XYZ;
  FVF := FVF or D3DFVF_NORMAL or D3DFVF_TEX1;
  VCount := Length(GeomData^.Vertices);
  ICount := Length(GeomData^.Indices);
  MeshOpts := D3DXMESH_SYSTEMMEM;
  if ICount > High(Word) then
  MeshOpts := MeshOpts or D3DXMESH_32BIT;
  D3DXCreateMeshFVF(
    ICount div 3,
    VCount,
    MeshOpts,
    FVF,
    m_Mesh.Core.Graphics.Device,
    m_Geom
  );
  if m_Skinned then
  begin
    m_Geom.LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VSkinned));
    for i := 0 to VCount - 1 do
    begin
      VSkinned^[i].Position := GeomData^.Positions[GeomData^.Vertices[i].PositionID];
      VSkinned^[i].Normal := GeomData^.Vertices[i].Normal;
      VSkinned^[i].TexCoords.X := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].X;
      VSkinned^[i].TexCoords.Y := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].Y;
      ZeroMemory(@VSkinned^[i].BIndices[0], 4);
      ZeroMemory(@VSkinned^[i].BWeights[0], 16);
      for b := 0 to Min(3, m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneCount - 1) do
      begin
        VSkinned^[i].BIndices[b] := m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneIndices[b];
        VSkinned^[i].BWeights[b] := m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneWeights[b];
      end;
    end;
    m_Geom.UnlockVertexBuffer;
  end
  else
  begin
    m_Geom.LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VStatic));
    for i := 0 to VCount - 1 do
    begin
      VStatic^[i].Position := GeomData^.Positions[GeomData^.Vertices[i].PositionID];
      VStatic^[i].Normal := GeomData^.Vertices[i].Normal;
      VStatic^[i].TexCoords.X := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].X;
      VStatic^[i].TexCoords.Y := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].Y;
    end;
    m_Geom.UnlockVertexBuffer;
  end;
  m_Geom.LockIndexBuffer(D3DLOCK_DISCARD, Indices);
  if MeshOpts and D3DXMESH_32BIT = D3DXMESH_32BIT then
  Move(GeomData^.Indices[0], Indices^, ICount * 4)
  else
  begin
    Indices2 := Indices;
    for i := 0 to ICount - 1 do
    Indices2^[i] := GeomData^.Indices[i];
  end;
  m_Geom.UnlockIndexBuffer;
  MaterialCount := GeomData^.MCount;
  if MaterialCount > 0 then
  begin
    for i := 0 to MaterialCount - 1 do
    MaterialIDs[i] := GeomData^.Materials[i];
    m_Geom.LockAttributeBuffer(D3DLOCK_DISCARD, PDWord(Attributes));
    for i := 0 to GeomData^.FCount - 1 do
    Attributes^[i] := GeomData^.Faces[i].FaceMaterial;
    m_Geom.UnlockAttributeBuffer;
  end;
  SetLength(Adj, m_Geom.GetNumFaces * 3);
  m_Geom.GenerateAdjacency(0, @Adj[0]);
  m_Geom.OptimizeInplace(
    D3DXMESHOPT_COMPACT
    or D3DXMESHOPT_VERTEXCACHE
    or D3DXMESHOPT_ATTRSORT,
    @Adj[0], nil, nil, nil
  );
  if not GeomData^.OptPreNormal then
  D3DXComputeNormals(
    m_Geom, nil
  );
end;

procedure TG2MeshGeom.InitMeshFF(const GeomData: PG2MeshLoadGeom);
type
  TVertexSkinned = packed record
    Position: TG2Vec3;
    BWeights: array[0..3] of Single;
    BIndices: array[0..3] of Byte;
    Normal: TG2Vec3;
    TexCoords: TG2Vec2;
  end;
  TVertexSkinnedArr = array[0..0] of TVertexSkinned;
  PVertexSkinnedArr = ^TVertexSkinnedArr;
  TVertexStatic = packed record
    Position: TG2Vec3;
    Normal: TG2Vec3;
    TexCoords: TG2Vec2;
  end;
  TVertexStaticArr = array[0..0] of TVertexStatic;
  PVertexStaticArr = ^TVertexStaticArr;
  PIndexArray2 = ^TIndexArray2;
  TIndexArray2 = array[0..0] of Word;
var
  FVF: DWord;
  VStatic: PVertexStaticArr;
  VSkinned: PVertexSkinnedArr;
  VCount, ICount, i, b: Integer;
  Indices: Pointer;
  Indices2: PIndexArray2;
  Attributes: PDWORDArray;
  Adj: array of DWord;
  MeshOpts: DWord;
begin
  Release;
  m_Skinned := GeomData^.SkinID >= 0;
  if m_Skinned then
  FVF := D3DFVF_XYZB5 or D3DFVF_LASTBETA_UBYTE4
  else
  FVF := D3DFVF_XYZ;
  FVF := FVF or D3DFVF_NORMAL or D3DFVF_TEX1;
  VCount := Length(GeomData^.Vertices);
  ICount := Length(GeomData^.Indices);
  MeshOpts := D3DXMESH_MANAGED;
  if ICount > High(Word) then
  MeshOpts := MeshOpts or D3DXMESH_32BIT;
  D3DXCreateMeshFVF(
    ICount div 3,
    VCount,
    MeshOpts,
    FVF,
    m_Mesh.Core.Graphics.Device,
    m_Geom
  );
  if m_Skinned then
  begin
    m_Geom.LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VSkinned));
    for i := 0 to VCount - 1 do
    begin
      VSkinned^[i].Position := GeomData^.Positions[GeomData^.Vertices[i].PositionID];
      VSkinned^[i].Normal := GeomData^.Vertices[i].Normal;
      VSkinned^[i].TexCoords.X := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].X;
      VSkinned^[i].TexCoords.Y := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].Y;
      ZeroMemory(@VSkinned^[i].BIndices[0], 4);
      ZeroMemory(@VSkinned^[i].BWeights[0], 16);
      for b := 0 to Min(3, m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneCount - 1) do
      begin
        VSkinned^[i].BIndices[b] := m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneIndices[b];
        VSkinned^[i].BWeights[b] := m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneWeights[b];
      end;
    end;
    m_Geom.UnlockVertexBuffer;
  end
  else
  begin
    m_Geom.LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VStatic));
    for i := 0 to VCount - 1 do
    begin
      VStatic^[i].Position := GeomData^.Positions[GeomData^.Vertices[i].PositionID];
      VStatic^[i].Normal := GeomData^.Vertices[i].Normal;
      VStatic^[i].TexCoords.X := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].X;
      VStatic^[i].TexCoords.Y := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID].Y;
    end;
    m_Geom.UnlockVertexBuffer;
  end;
  m_Geom.LockIndexBuffer(D3DLOCK_DISCARD, Indices);
  if MeshOpts and D3DXMESH_32BIT = D3DXMESH_32BIT then
  Move(GeomData^.Indices[0], Indices^, ICount * 4)
  else
  begin
    Indices2 := Indices;
    for i := 0 to ICount - 1 do
    Indices2^[i] := GeomData^.Indices[i];
  end;
  m_Geom.UnlockIndexBuffer;
  MaterialCount := GeomData^.MCount;
  if MaterialCount > 0 then
  begin
    for i := 0 to MaterialCount - 1 do
    MaterialIDs[i] := GeomData^.Materials[i];
    m_Geom.LockAttributeBuffer(D3DLOCK_DISCARD, PDWord(Attributes));
    for i := 0 to GeomData^.FCount - 1 do
    Attributes^[i] := GeomData^.Faces[i].FaceMaterial;
    m_Geom.UnlockAttributeBuffer;
  end;
  SetLength(Adj, m_Geom.GetNumFaces * 3);
  m_Geom.GenerateAdjacency(0, @Adj[0]);
  m_Geom.OptimizeInplace(
    D3DXMESHOPT_COMPACT
    or D3DXMESHOPT_VERTEXCACHE
    or D3DXMESHOPT_ATTRSORT,
    @Adj[0], nil, nil, nil
  );
  if not GeomData^.OptPreNormal then
  D3DXComputeNormals(
    m_Geom, nil
  );
end;

procedure TG2MeshGeom.InitMeshSM3(const GeomData: PG2MeshLoadGeom);
type
  TG2MeshVertexStatic = packed record
    Position: TG2Vec3;
    Normal: TG2Vec3;
    Tangent: TG2Vec3;
    Binormal: TG2Vec3;
    TexCoords: TG2Vec3;
  end;
  TG2MeshVertexStaticArr = array[0..0] of TG2MeshVertexStatic;
  PG2MeshVertexStaticArr = ^TG2MeshVertexStaticArr;
  TG2MeshVertexSkinned = packed record
    Position: TG2Vec3;
    Normal: TG2Vec3;
    Tangent: TG2Vec3;
    Binormal: TG2Vec3;
    TexCoords: TG2Vec3;
    BoneWeights: array[0..3] of Single;
    BoneIndices: array[0..3] of Single;
  end;
  TG2MeshVertexSkinnedArr = array[0..0] of TG2MeshVertexSkinned;
  PG2MeshVertexSkinnedArr = ^TG2MeshVertexSkinnedArr;
  PIndexArray2 = ^TIndexArray2;
  TIndexArray2 = array[0..0] of Word;
var
  Decl: TFVFDeclaration;
  VerticesSkinned: PG2MeshVertexSkinnedArr;
  VerticesStatic: PG2MeshVertexStaticArr;
  Attributes: PDWORDArray;
  Indices: Pointer;
  Indices2: PIndexArray2;
  VCount, ICount, i, b: Integer;
  TmpGeom: ID3DXMesh;
  Adj: array of DWord;
  MeshOpts: DWord;
begin
  Release;
  m_Skinned := GeomData^.SkinID >= 0;
  m_Effect := m_Mesh.Core.Graphics.ShaderLib.RequestEffect('fx_Meshes');
  if m_Skinned then
  m_Technique := m_Effect.GetTechniqueByName('g2m02')
  else
  m_Technique := m_Effect.GetTechniqueByName('g2m01');
  Decl[0] := D3DVertexElement(0, 4 * 0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0);
  Decl[1] := D3DVertexElement(0, 4 * 3, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL, 0);
  Decl[2] := D3DVertexElement(0, 4 * 6, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TANGENT, 0);
  Decl[3] := D3DVertexElement(0, 4 * 9, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BINORMAL, 0);
  Decl[4] := D3DVertexElement(0, 4 * 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0);
  if m_Skinned then
  begin
    Decl[5] := D3DVertexElement(0, 4 * 15, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDWEIGHT, 0);
    Decl[6] := D3DVertexElement(0, 4 * 19, D3DDECLTYPE_FLOAT4, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDINDICES, 0);
    Decl[7] := D3DDECL_END;
  end
  else
  Decl[5] := D3DDECL_END;
  VCount := Length(GeomData^.Vertices);
  ICount := Length(GeomData^.Indices);
  MeshOpts := D3DXMESH_MANAGED;
  if ICount > High(Word) then
  MeshOpts := MeshOpts or D3DXMESH_32BIT;
  D3DXCreateMesh(
    ICount div 3,
    VCount,
    MeshOpts,
    @Decl[0],
    m_Mesh.Core.Graphics.Device,
    TmpGeom
  );
  if m_Skinned then
  begin
    TmpGeom.LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VerticesSkinned));
    for i := 0 to VCount - 1 do
    begin
      VerticesSkinned^[i].Position := GeomData^.Positions[GeomData^.Vertices[i].PositionID];
      VerticesSkinned^[i].Normal := GeomData^.Vertices[i].Normal;
      VerticesSkinned^[i].Tangent := GeomData^.Vertices[i].Tangent;
      VerticesSkinned^[i].Binormal := GeomData^.Vertices[i].Binormal;
      VerticesSkinned^[i].TexCoords := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID];
      VerticesSkinned^[i].TexCoords.Z := m_Mesh.Skins[m_SkinID].BoneCount;
      ZeroMemory(@VerticesSkinned^[i].BoneIndices[0], 16);
      ZeroMemory(@VerticesSkinned^[i].BoneWeights[0], 16);
      for b := 0 to Min(3, m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneCount - 1) do
      begin
        VerticesSkinned^[i].BoneIndices[b] := m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneIndices[b];
        VerticesSkinned^[i].BoneWeights[b] := m_Mesh.Skins[m_SkinID].SkinVertices[GeomData^.Vertices[i].PositionID].BoneWeights[b];
      end;
    end;
    TmpGeom.UnlockVertexBuffer;
  end
  else
  begin
    TmpGeom.LockVertexBuffer(D3DLOCK_DISCARD, Pointer(VerticesStatic));
    for i := 0 to VCount - 1 do
    begin
      VerticesStatic^[i].Position := GeomData^.Positions[GeomData^.Vertices[i].PositionID];
      VerticesStatic^[i].Normal := GeomData^.Vertices[i].Normal;
      VerticesStatic^[i].Tangent := GeomData^.Vertices[i].Tangent;
      VerticesStatic^[i].Binormal := GeomData^.Vertices[i].Binormal;
      VerticesStatic^[i].TexCoords := GeomData^.TexCoords[GeomData^.Vertices[i].TexCoordsID];
    end;
    TmpGeom.UnlockVertexBuffer;
  end;
  TmpGeom.LockIndexBuffer(D3DLOCK_DISCARD, Indices);
  if MeshOpts and D3DXMESH_32BIT = D3DXMESH_32BIT then
  Move(GeomData^.Indices[0], Indices^, ICount * 4)
  else
  begin
    Indices2 := Indices;
    for i := 0 to ICount - 1 do
    Indices2^[i] := GeomData^.Indices[i];
  end;
  TmpGeom.UnlockIndexBuffer;
  MaterialCount := GeomData^.MCount;
  if MaterialCount > 0 then
  begin
    for i := 0 to MaterialCount - 1 do
    MaterialIDs[i] := GeomData^.Materials[i];
    TmpGeom.LockAttributeBuffer(D3DLOCK_DISCARD, PDWord(Attributes));
    for i := 0 to GeomData^.FCount - 1 do
    Attributes^[i] := GeomData^.Faces[i].FaceMaterial;
    TmpGeom.UnlockAttributeBuffer;
  end;
  SetLength(Adj, TmpGeom.GetNumFaces * 3);
  TmpGeom.GenerateAdjacency(0, @Adj[0]);
  TmpGeom.OptimizeInplace(
    D3DXMESHOPT_COMPACT
    or D3DXMESHOPT_VERTEXCACHE
    or D3DXMESHOPT_ATTRSORT,
    @Adj[0], nil, nil, nil
  );
  if not GeomData^.OptPreNormal then
  D3DXComputeNormals(
    TmpGeom, nil
  );
  if GeomData^.OptPreTangent then
  m_Geom := TmpGeom
  else
  D3DXComputeTangentFrameEx(
    TmpGeom,
    DWord(D3DDECLUSAGE_TEXCOORD), 0,
    DWord(D3DDECLUSAGE_BINORMAL), 0,
    DWord(D3DDECLUSAGE_TANGENT), 0,
    DWord(D3DDECLUSAGE_NORMAL), 0,
    0,
    nil,
    0.01,
    0.25,
    0.01,
    m_Geom,
    nil
  );
  SafeRelease(TmpGeom);
end;

procedure TG2MeshGeom.InitMesh(const GeomData: PG2MeshLoadGeom);
var
  FVFDecl: TFVFDeclaration;
begin
  case m_Mesh.Mode of
    mmSW: InitMeshSW(GeomData);
    mmFF: InitMeshFF(GeomData);
    mmSM3HLSL, mmSM3ASM: InitMeshSM3(GeomData);
  end;
  m_Geom.GetDeclaration(FVFDecl);
  m_Mesh.Core.Graphics.Device.CreateVertexDeclaration(@FVFDecl[0], m_Decl);
end;

procedure TG2MeshGeom.Release;
begin
  m_Skinned := False;
  SafeRelease(m_Decl);
  SafeRelease(m_Geom);
end;
//TG2MeshGeom END

//TG2MeshSkin BEGIN
constructor TG2MeshSkin.Create;
begin
  inherited Create;
end;

destructor TG2MeshSkin.Destroy;
begin
  inherited Destroy;
end;

procedure TG2MeshSkin.SetBoneCount(const Value: Integer);
begin
  SetLength(m_Bones, Value);
end;

function TG2MeshSkin.GetBoneCount: Integer;
begin
  Result := Length(m_Bones);
end;

procedure TG2MeshSkin.SetBone(const Index: Integer; const Value: Integer);
begin
  m_Bones[Index] := Value;
end;

function TG2MeshSkin.GetBone(const Index: Integer): Integer;
begin
  Result := m_Bones[Index];
end;

procedure TG2MeshSkin.SetSkinVertexCount(const Value: Integer);
begin
  SetLength(m_SkinVertices, Value);
end;

function TG2MeshSkin.GetSkinVertexCount: Integer;
begin
  Result := Length(m_SkinVertices);
end;

function TG2MeshSkin.GetSkinVertex(const Index: Integer): PG2SkinVertex;
begin
  Result := @m_SkinVertices[Index];
end;
//TG2MeshSkin END

//TG2MeshAnim BEGIN
constructor TG2MeshAnim.Create;
begin
  inherited Create;
end;

destructor TG2MeshAnim.Destroy;
begin
  inherited Destroy;
end;

procedure TG2MeshAnim.SetAnimNodeCount(const Value: Integer);
begin
  SetLength(m_AnimNodes, Value);
end;

function TG2MeshAnim.GetAnimNodeCount: Integer;
begin
  Result := Length(m_AnimNodes);
end;

function TG2MeshAnim.GetAnimNode(const Index: Integer): PG2AnimNode;
begin
  Result := @m_AnimNodes[Index];
end;
//TG2MeshAnim END

//TG2MeshMaterial BEGIN
constructor TG2MeshMaterial.Create;
begin
  inherited Create;
end;

destructor TG2MeshMaterial.Destroy;
begin
  inherited Destroy;
end;
//TG2MeshMaterial END

//TG2MeshLoader BEGIN
constructor TG2MeshLoader.Create;
begin
  inherited Create;
end;

destructor TG2MeshLoader.Destroy;
begin
  inherited Destroy;
end;

function TG2MeshLoader.ReadString: AnsiString;
var
  Pos: Int64;
  b: Byte;
  Len: Integer;
begin
  if not Assigned(m_Stream) then Exit;
  Pos := m_Stream.Position;
  Len := 0;
  repeat
    m_Stream.Read(b, 1);
    Inc(Len);
  until b = 0;
  Dec(Len);
  m_Stream.Position := Pos;
  SetLength(Result, Len);
  m_Stream.Read(Result[1], Len);
  m_Stream.Position := m_Stream.Position + 1;
end;

function TG2MeshLoader.ReadQuaternion: TG2Quat;
begin
  m_Stream.Read(Result, 16);
end;

function TG2MeshLoader.ReadVector3: TG2Vec3;
begin
  m_Stream.Read(Result, 12);
end;

function TG2MeshLoader.ReadVector2: TG2Vec2;
begin
  m_Stream.Read(Result, 8);
end;

function TG2MeshLoader.ReadInteger: Integer;
begin
  m_Stream.Read(Result, 4);
end;

function TG2MeshLoader.ReadFloat: Single;
begin
  m_Stream.Read(Result, 4);
end;

function TG2MeshLoader.ReadDWord: DWord;
begin
  m_Stream.Read(Result, 4);
end;

function TG2MeshLoader.ReadWord: Word;
begin
  m_Stream.Read(Result, 2)
end;

function TG2MeshLoader.ReadSmallInt: SmallInt;
begin
  m_Stream.Read(Result, 2);
end;

function TG2MeshLoader.ReadByte: Byte;
begin
  m_Stream.Read(Result, 1);
end;

function TG2MeshLoader.ReadShortInt: ShortInt;
begin
  m_Stream.Read(Result, 1);
end;

function TG2MeshLoader.ReadBoolean: Boolean;
begin
  m_Stream.Read(Result, 1);
end;

procedure TG2MeshLoader.Advance(const Count: Integer);
begin
  m_Stream.Position := m_Stream.Position + Count;
end;

class function TG2MeshLoader.GetDifinition: AnsiString;
begin
  Result := 'Undifined.';
end;

class function TG2MeshLoader.CanLoadFile(const f: String): Boolean;
var
  fs: TFileStream;
begin
  fs := TFileStream.Create(f, fmOpenRead);
  Result := CanLoadStream(fs);
  fs.Free;
end;

class function TG2MeshLoader.CanLoadStream(const s: TStream): Boolean;
begin
  Result := False;
end;

procedure TG2MeshLoader.LoadFile(const f: String; const MeshData: PG2MeshLoad);
var
  fs: TFileStream;
begin
  fs := TFileStream.Create(f, fmOpenRead);
  LoadStream(fs, MeshData);
  fs.Free;
end;

procedure TG2MeshLoader.LoadStream(const s: TStream; const MeshData: PG2MeshLoad);
begin
  m_Stream := s;
  LoadProc(s, MeshData);
  m_Stream := nil;
end;
//TG2MeshLoader END

//TG2Shared BEGIN
constructor TG2Shared.Create;
begin
  inherited Create;
end;

destructor TG2Shared.Destroy;
begin
  inherited Destroy;
end;

function TG2Shared.RequestVB(
      const NewStride: DWord;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFVF: DWord;
      const NewPool: TD3DPool
    ): TG2VB;
var
  i: Integer;
begin
  for i := 0 to m_VBMgr.Count - 1 do
  if (m_VBMgr.VertexBuffers[i].Stride = NewStride)
  and (m_VBMgr.VertexBuffers[i].Usage = NewUsage)
  and (m_VBMgr.VertexBuffers[i].FVF = NewFVF)
  and (m_VBMgr.VertexBuffers[i].Pool = NewPool) then
  begin
    if m_VBMgr.VertexBuffers[i].Size < NewSize then
    m_VBMgr.VertexBuffers[i].Verify(
      NewStride, NewSize, NewUsage, NewFVF, NewPool
    );
    Result := m_VBMgr.VertexBuffers[i];
    Exit;
  end;
  Result := m_VBMgr.CreateVertexBuffer(
    'SharedVertexBuffer' + IntToStr(m_LastVBID),
    NewStride,
    NewSize,
    NewUsage,
    NewFVF,
    NewPool
  );
  Inc(m_LastVBID);
end;

function TG2Shared.RequestIB(
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFormat: TD3DFormat;
      const NewPool: TD3DPool
    ): TG2IB;
var
  i: Integer;
begin
  for i := 0 to m_IBMgr.Count - 1 do
  if (m_IBMgr.IndexBuffers[i].Usage = NewUsage)
  and (m_IBMgr.IndexBuffers[i].Format = NewFormat)
  and (m_IBMgr.IndexBuffers[i].Pool = NewPool) then
  begin
    if m_IBMgr.IndexBuffers[i].Size < NewSize then
    m_IBMgr.IndexBuffers[i].Verify(
      NewSize, NewUsage, NewFormat, NewPool
    );
    Result := m_IBMgr.IndexBuffers[i];
    Exit;
  end;
  Result := m_IBMgr.CreateIndexBuffer(
    'SharedIndexBuffer' + IntToStr(m_LastIBID),
    NewSize,
    NewUsage,
    NewFormat,
    NewPool
  );
  Inc(m_LastIBID);
end;

function TG2Shared.RequestFont(
      const FontFace: String;
      const Size: Integer
    ): TG2Font;
var
  i: Integer;
begin
  for i := 0 to m_FontMgr.Count - 1 do
  if (m_FontMgr.Fonts[i].FontFace = FontFace)
  and (m_FontMgr.Fonts[i].Size = Size) then
  begin
    Result := m_FontMgr.Fonts[i];
    Exit;
  end;
  Result := m_FontMgr.CreateFont(
    'SharedFont' + IntToStr(m_LastFontID),
    FontFace, Size
  );
  Inc(m_LastFontID);
end;

function TG2Shared.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestMod(TG2VBMgr, @m_VBMgr);
  Core.RequestMod(TG2IBMgr, @m_IBMgr);
  Core.RequestMod(TG2FontMgr, @m_FontMgr);
  m_LastVBID := 0;
  m_LastIBID := 0;
  m_LastFontID := 0;
  Result := grOk;
end;

function TG2Shared.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleaseMod(@m_FontMgr);
  Core.ReleaseMod(@m_VBMgr);
  Core.ReleaseMod(@m_IBMgr);
  Result := grOk;
end;
//TG2Shared END

//TG2VBMgr BEGIN
constructor TG2VBMgr.Create;
begin
  inherited Create;
end;

destructor TG2VBMgr.Destroy;
begin
  inherited Destroy;
end;

procedure TG2VBMgr.OnDeviceLost;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2VB(m_Resources[i]).OnDeviceLost;
end;

procedure TG2VBMgr.OnDeviceReset;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2VB(m_Resources[i]).OnDeviceReset;
end;

function TG2VBMgr.GetVB(const Index: Integer): TG2VB;
begin
  Result := TG2VB(m_Resources[Index]);
end;

function TG2VBMgr.CreateVertexBuffer(
      const Name: AnsiString;
      const NewStride: DWord;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFVF: DWord;
      const NewPool: TD3DPool
    ): TG2VB;
begin
  Result := TG2VB.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if Result.Verify(
    NewStride,
    NewSize,
    NewUsage,
    NewFVF,
    NewPool
  ) then
  AddResource(Result)
  else
  Result.Free;
end;

function TG2VBMgr.FindVB(const Name: AnsiString): TG2VB;
begin
  Result := TG2VB(FindResource(Name));
end;

function TG2VBMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  Result := grOk;
end;

function TG2VBMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;
//TG2VBMgr END

//TG2VB BEGIN
constructor TG2VB.Create;
begin
  inherited Create;
  m_Stride := 0;
  m_Size := 0;
  m_Usage := 0;
  m_FVF := 0;
  m_Pool := D3DPOOL_DEFAULT;
  m_Suspended := False;
end;

destructor TG2VB.Destroy;
begin
  inherited Destroy;
end;

function TG2VB.InitializeVB: Boolean;
begin
  Release;
  Result := Succeeded(
    m_Graphics.Device.CreateVertexBuffer(
      m_Stride * m_Size,
      m_Usage,
      m_FVF,
      m_Pool,
      m_VB,
      nil
    )
  );
end;

procedure TG2VB.OnDeviceLost;
begin
  if m_Pool <> D3DPOOL_MANAGED then
  begin
    Release;
    m_Suspended := True;
  end;
end;

procedure TG2VB.OnDeviceReset;
begin
  if m_Suspended then
  InitializeVB;
end;

function TG2VB.Verify(
      const NewStride: DWord;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFVF: DWord;
      const NewPool: TD3DPool
    ): Boolean;
begin
  if (m_Stride <> NewStride)
  or (m_Size < NewSize)
  or (m_Usage <> NewUsage)
  or (m_FVF <> NewFVF)
  or (NewPool <> NewPool) then
  begin
    m_Stride := NewStride;
    m_Size := NewSize;
    m_Usage := NewUsage;
    m_FVF := NewFVF;
    m_Pool := NewPool;
    Result := InitializeVB;
  end
  else
  Result := True;
end;

function TG2VB.Lock(const LockOffset, LockSize: DWord; var Data: Pointer; const LockFlags: DWord = 0): HResult;
begin
  Result := m_VB.Lock(LockOffset, LockSize, Data, LockFlags);
end;

function TG2VB.UnLock: HResult;
begin
  Result := m_VB.Unlock;
end;

procedure TG2VB.Release;
begin
  SafeRelease(m_VB);
end;

procedure TG2VB.SetToDevice;
begin
  m_Graphics.Device.SetStreamSource(0, m_VB, 0, m_Stride);
  m_Graphics.Device.SetFVF(m_FVF);
end;

function TG2VB.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Graphics := Core.Graphics;
  Result := grOk;
end;

function TG2VB.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Release;
  Result := grOk;
end;
//TG2VB END

//TG2IBMgr BEGIN
constructor TG2IBMgr.Create;
begin
  inherited Create;
end;

destructor TG2IBMgr.Destroy;
begin
  inherited Destroy;
end;

procedure TG2IBMgr.OnDeviceLost;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2IB(m_Resources[i]).OnDeviceLost;
end;

procedure TG2IBMgr.OnDeviceReset;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2IB(m_Resources[i]).OnDeviceReset;
end;

function TG2IBMgr.GetIB(const Index: Integer): TG2IB;
begin
  Result := TG2IB(m_Resources[Index]);
end;

function TG2IBMgr.CreateIndexBuffer(
      const Name: AnsiString;
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFormat: TD3DFormat;
      const NewPool: TD3DPool
    ): TG2IB;
begin
  Result := TG2IB.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if Result.Verify(
    NewSize,
    NewUsage,
    NewFormat,
    NewPool
  ) then
  AddResource(Result)
  else
  Result.Free;
end;

function TG2IBMgr.FindIB(const Name: AnsiString): TG2IB;    
begin
  Result := TG2IB(FindResource(Name));
end;

function TG2IBMgr.Initialize(const G2Core: TG2Core): TG2Result;   
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  Result := grOk;
end;

function TG2IBMgr.Finalize: TG2Result;   
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;
//TG2IBMgr END

//TG2IB BEGIN
constructor TG2IB.Create;
begin
  inherited Create;
  m_Size := 0;
  m_Usage := 0;
  m_Format := D3DFMT_INDEX16;
  m_Pool := D3DPOOL_DEFAULT;
end;

destructor TG2IB.Destroy;
begin
  inherited Destroy;
end;

function TG2IB.InitializeIB: Boolean;
var
  Stride: DWord;
begin
  case m_Format of
    D3DFMT_INDEX16: Stride := 2;
    D3DFMT_INDEX32: Stride := 4;
    else Stride := 0;
  end;
  Result := Succeeded(
    m_Graphics.Device.CreateIndexBuffer(
      m_Size * Stride,
      m_Usage,
      m_Format,
      m_Pool,
      m_IB,
      nil
    )
  );
end;

procedure TG2IB.OnDeviceLost;
begin
  if m_Pool <> D3DPOOL_MANAGED then
  begin
    Release;
    m_Suspended := True;
  end;
end;

procedure TG2IB.OnDeviceReset;
begin
  if m_Suspended then
  InitializeIB;
end;

function TG2IB.Verify(
      const NewSize: DWord;
      const NewUsage: DWord;
      const NewFormat: TD3DFormat;
      const NewPool: TD3DPool
    ): Boolean;
begin
  if (m_Size < NewSize)
  or (m_Usage <> NewUsage)
  or (m_Format <> NewFormat)
  or (m_Pool <> NewPool) then
  begin
    m_Size := NewSize;
    m_Usage := NewUsage;
    m_Format := NewFormat;
    m_Pool := NewPool;
    Result := InitializeIB;
  end
  else
  Result := True;
end;

function TG2IB.Lock(const LockOffset, LockSize: DWord; var Data: Pointer; const Flags: DWord = 0): HResult;
begin
  Result := m_IB.Lock(LockOffset, LockSize, Data, Flags);
end;

function TG2IB.UnLock: HResult;
begin
  Result := m_IB.Unlock;
end;

procedure TG2IB.Release;
begin
  SafeRelease(m_IB);
end;

procedure TG2IB.SetToDevice;
begin
  m_Graphics.Device.SetIndices(m_IB);
end;

function TG2IB.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Graphics := Core.Graphics;
  Result := grOk;
end;

function TG2IB.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2IB END

//TG2ScriptMgr BEGIN
constructor TG2ScriptMgr.Create;
begin
  inherited Create;
end;

destructor TG2ScriptMgr.Destroy;
begin
  inherited Destroy;
end;

function TG2ScriptMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2ScriptMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2ScriptMgr END

//TG2Script BEGIN
constructor TG2Script.Create;
begin
  inherited Create;
end;

destructor TG2Script.Destroy;
begin
  inherited Destroy;
end;

function TG2Script.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2Script.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2Script END

//TG2GUI BEGIN
constructor TG2GUI.Create;
begin
  inherited Create;
end;

destructor TG2GUI.Destroy;
begin
  inherited Destroy;
end;

procedure TG2GUI.WindowCreate(const WindowClass: CG2GUIWindowClass; const Parent: TG2GUIWindow; var Window);
var
  Instance: TG2GUIWindow;
begin
  Instance := TG2GUIWindow(WindowClass.NewInstance);
  TG2GUIWindow(Window) := Instance;
  Instance.Create;
  Instance.Initialize(Core);
  Instance.GUI := Self;
  if Assigned(Parent) then
  Instance.Parent := Parent
  else
  Instance.Parent := m_Root;
end;

procedure TG2GUI.WindowDestroy(var Window: TG2GUIWindow);
begin
  if Window <> m_Root then
  FreeAndNil(Window);
end;

procedure TG2GUI.Render;
begin
  Core.Graphics.RenderStates.ScissorTestEnable := True;
  m_Root.Draw;
  Core.Graphics.RenderStates.ScissorTestEnable := False;
end;

function TG2GUI.Initialize(const G2Core: TG2Core): TG2Result;
var
  ViewPort: TD3DViewPort9;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Root := TG2GUIWindow.Create;
  m_Root.Initialize(Core);
  m_Root.GUI := Self;
  m_Focus := m_Root;
  ViewPort := Core.Graphics.GetViewPort;
  m_Root.W := ViewPort.Width;
  m_Root.H := ViewPort.Height;
  Core.RequestPlug(TG2PlugInput, @m_PlugInput);
  m_PlugInput.OnMouseDown := m_Root.MouseDown;
  m_PlugInput.OnMouseUp := m_Root.MouseUp;
  m_PlugInput.OnMouseMove := m_Root.MouseMove;
  m_PlugInput.OnWheelMove := m_Root.MouseWheel;
  m_PlugInput.OnKeyDown := m_Root.KeyDown;
  m_PlugInput.OnKeyUp := m_Root.KeyUp;
  Result := grOk;
end;

function TG2GUI.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugInput);
  m_Root.Finalize;
  m_Root.Free;
  Result := grOk;
end;
//TG2GUI END

//TG2GUIWindow BEGIN
constructor TG2GUIWindow.Create;
begin
  inherited Create;
end;

destructor TG2GUIWindow.Destroy;
begin
  inherited Destroy;
end;

procedure TG2GUIWindow.SetParent(const Value: TG2GUIWindow);
begin
  if Assigned(m_Parent) then m_Parent.m_Children.Remove(Self);
  m_Parent := Value;
  if Assigned(m_Parent) then m_Parent.m_Children.Add(Self);
end;

procedure TG2GUIWindow.SetRect(const Value: TRect);
begin
  m_X := Value.Left;
  m_Y := Value.Top;
  m_W := Value.Right - Value.Left;
  m_H := Value.Bottom - Value.Top;
end;

function TG2GUIWindow.GetRect: TRect;
begin
  Result.Left := m_X;
  Result.Top := m_Y;
  Result.Right := m_X + m_W;
  Result.Bottom := m_Y + m_H;
end;

procedure TG2GUIWindow.SetClientRect(const Value: TRect);
begin
  m_MarginLeft := Max(Value.Left, 0);
  m_MarginTop := Max(Value.Top, 0);
  m_MarginRight := Min(m_W - Value.Left - Value.Right, 0);
  m_MarginBottom := Min(m_H - Value.Top - Value.Bottom, 0);
end;

function TG2GUIWindow.GetClientRect: TRect;
begin
  Result.Left := m_MarginLeft;
  Result.Top := m_MarginTop;
  Result.Right := m_W - m_MarginRight;
  Result.Bottom := m_H - m_MarginBottom;
end;

function TG2GUIWindow.GetDrawRect: TRect;
var
  ParentRect: TRect;
begin
  Result := GetRect;
  if Assigned(m_Parent) then
  begin
    ParentRect := m_Parent.ClientDrawRect;
    Result.Left := Max(Result.Left + m_Parent.X + m_Parent.MarginLeft, ParentRect.Left);
    Result.Top := Max(Result.Top + m_Parent.Y + m_Parent.MarginTop, ParentRect.Top);
    Result.Right := Min(Result.Right + m_Parent.X + m_Parent.MarginLeft, ParentRect.Right);
    Result.Bottom := Min(Result.Bottom + m_Parent.Y + m_Parent.MarginTop, ParentRect.Bottom);
  end;
end;

function TG2GUIWindow.GetClientDrawRect: TRect;
var
  ParentRect: TRect;
begin
  Result := GetClientRect;
  Result.Left := Result.Left + m_X;
  Result.Top := Result.Top + m_Y;
  Result.Right := Result.Right + m_X;
  Result.Bottom := Result.Bottom + m_Y;
  if Assigned(m_Parent) then
  begin
    ParentRect := m_Parent.ClientDrawRect;
    Result.Left := Max(Result.Left + m_Parent.X, ParentRect.Left);
    Result.Top := Max(Result.Top + m_Parent.Y, ParentRect.Top);
    Result.Right := Min(Result.Right + m_Parent.X, ParentRect.Right);
    Result.Bottom := Min(Result.Bottom + m_Parent.Y, ParentRect.Bottom);
  end;
end;

function TG2GUIWindow.GetFocused: Boolean;
begin
  Result := m_GUI.Focus = Self;
end;

procedure TG2GUIWindow.MouseDown(const Button: Byte);
var
  i: Integer;
begin
  for i := m_Children.Count - 1 downto 0 do
  TG2GUIWindow(m_Children[i]).MouseDown(Button);
  if IsMouseOver and (Button = 0) then
  m_DownInRect := True;
  CustomMouseDown(Button);
  if Assigned(m_OnMouseDown) then
  m_OnMouseDown(Button);
end;

procedure TG2GUIWindow.MouseUp(const Button: Byte);
var
  i: Integer;
begin
  for i := m_Children.Count - 1 downto 0 do
  TG2GUIWindow(m_Children[i]).MouseUp(Button);
  if Button = 0 then
  begin
    if IsPressed then
    MouseClick;
    m_DownInRect := False;
  end;
  CustomMouseUp(Button);
  if Assigned(m_OnMouseUp) then
  m_OnMouseUp(Button);
end;

procedure TG2GUIWindow.MouseClick;
begin
  CustomMouseClick;
  if Assigned(m_OnMouseClick) then
  m_OnMouseClick;
end;

procedure TG2GUIWindow.MouseMove(const Shift: TPoint);
var
  i: Integer;
begin
  for i := m_Children.Count - 1 downto 0 do
  TG2GUIWindow(m_Children[i]).MouseMove(Shift);
  CustomMouseMove(Shift);
  if Assigned(m_OnMouseMove) then
  m_OnMouseMove(Shift);
end;

procedure TG2GUIWindow.MouseWheel(const Shift: Integer);
var
  i: Integer;
begin
  for i := m_Children.Count - 1 downto 0 do
  TG2GUIWindow(m_Children[i]).MouseWheel(Shift);
  CustomMouseWheel(Shift);
  if Assigned(m_OnWheelMove) then
  m_OnWheelMove(Shift)
end;

procedure TG2GUIWindow.KeyDown(const Key: Byte);
var
  i: Integer;
begin
  for i := m_Children.Count - 1 downto 0 do
  TG2GUIWindow(m_Children[i]).KeyDown(Key);
  CustomKeyDown(Key);
  if Assigned(m_OnKeyDown) then
  m_OnKeyDown(Key);
end;

procedure TG2GUIWindow.KeyUp(const Key: Byte);
var
  i: Integer;
begin
  for i := m_Children.Count - 1 downto 0 do
  TG2GUIWindow(m_Children[i]).KeyUp(Key);
  CustomKeyDown(Key);
  if Assigned(m_OnKeyUp) then
  m_OnKeyUp(Key);
end;

function TG2GUIWindow.GetGlobalRect: TRect;
var
  ParentRect: TRect;
begin
  if Assigned(m_Parent) then
  begin
    ParentRect := m_Parent.GetGlobalRect;
    Result.Left := ParentRect.Left + m_X + m_Parent.MarginLeft;
    Result.Top := ParentRect.Top + m_Y + m_Parent.MarginTop;
    Result.Right := Result.Left + m_W;
    Result.Bottom := Result.Top + m_H;
  end
  else
  Result := GetRect;
end;

procedure TG2GUIWindow.PreRender;
var
  R: TRect;
begin
  R := GetDrawRect;
  Core.Graphics.Device.SetScissorRect(@R);
end;

procedure TG2GUIWindow.Render;
begin

end;

procedure TG2GUIWindow.PostRender;
var
  i: Integer;
begin
  for i := 0 to m_Children.Count - 1 do
  TG2GUIWindow(m_Children[i]).Draw;
end;

procedure TG2GUIWindow.Draw;
begin
  PreRender;
  Render;
  PostRender;
end;

procedure TG2GUIWindow.RenderBox(
      const DrawRect: TRect;
      const Lowered: Boolean = False;
      const ColNormal: DWord = $ffcccccc;
      const ColHighlight: DWord = $ffffffff;
      const ColShadow: DWord = $ff555555
    );
var
  Verts: PVertex0Array;
  Indices: PIndexArray;
  CurV, CurI: Integer;
  ColTL, ColBR, ColM: TG2Color;
  procedure AddVertex(const x, y: Single; const Col: TG2Color);
  begin
    Verts^[CurV].x := x; Verts^[CurV].y := y; Verts^[CurV].z := 0;
    Verts^[CurV].rhw := 1; Verts^[CurV].Col := Col;
    Inc(CurV);
  end;
  procedure AddIndex(const Ind: Word);
  begin
    Indices^[CurI] := Ind;
    Inc(CurI);
  end;
  procedure AddTri(const Ind1, Ind2, Ind3: Word);
  begin
    AddIndex(Ind1);
    AddIndex(Ind2);
    AddIndex(Ind3);
  end;
begin
  ColM := ColNormal;
  if Lowered then
  begin
    ColTL := ColShadow;
    ColBR := ColHighlight;
  end
  else
  begin
    ColTL := ColHighlight;
    ColBR := ColShadow;
  end;
  CurV := 0;
  CurI := 0;
  m_VB0.VB.Lock(0, SizeOf(TVertex0) * 10, Pointer(Verts), D3DLOCK_DISCARD);
  with DrawRect do
  begin
    AddVertex(Left, Top, ColTL);
    AddVertex(Right, Top, ColTL);
    AddVertex(Right, Top, ColBR);
    AddVertex(Right, Bottom, ColBR);
    AddVertex(Left, Bottom, ColBR);
    AddVertex(Left, Bottom, ColTL);
    AddVertex(Left + MarginLeft, Top + MarginTop, ColM);
    AddVertex(Right - MarginRight, Top + MarginTop, ColM);
    AddVertex(Right - MarginRight, Bottom - MarginBottom, ColM);
    AddVertex(Left + MarginLeft, Bottom - MarginBottom, ColM);
  end;
  m_VB0.VB.Unlock;
  m_VB0.SetToDevice;
  m_IB.IB.Lock(0, 2 * 30, Pointer(Indices), D3DLOCK_DISCARD);
  AddTri(0, 1, 6); AddTri(6, 1, 7); AddTri(2, 3, 7); AddTri(7, 3, 8);
  AddTri(8, 3, 4); AddTri(4, 9, 8); AddTri(0, 9, 5); AddTri(0, 6, 9);
  AddTri(6, 7, 9); AddTri(7, 8, 9);
  m_IB.IB.Unlock;
  m_IB.SetToDevice;
  Core.Graphics.Device.DrawIndexedPrimitive(
    D3DPT_TRIANGLELIST, 0, 0, 10, 0, 10
  );
end;

function TG2GUIWindow.IsPressed: Boolean;
begin
  Result := m_DownInRect and IsMouseOver;
end;

function TG2GUIWindow.IsMouseOver: Boolean;
begin
  Result := PtInRect(
    GetDrawRect,
    m_GUI.PlugInput.MousePos
  );
end;

function TG2GUIWindow.IsMouseDown: Boolean;
begin
  Result := m_GUI.PlugInput.MouseDown[0];
end;

procedure TG2GUIWindow.CustomMouseDown(const Button: Byte);
begin

end;

procedure TG2GUIWindow.CustomMouseUp(const Button: Byte);  
begin

end;

procedure TG2GUIWindow.CustomMouseClick;        
begin

end;

procedure TG2GUIWindow.CustomMouseMove(const Shift: TPoint);
begin

end;

procedure TG2GUIWindow.CustomMouseWheel(const Shift: Integer);   
begin

end;

procedure TG2GUIWindow.CustomKeyDown(const Key: Byte); 
begin

end;

procedure TG2GUIWindow.CustomKeyUp(const Key: Byte);  
begin

end;

function TG2GUIWindow.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Parent := nil;
  m_Children := TG2List.Create;
  m_X := 0;
  m_Y := 0;
  m_W := 64;
  m_H := 64;
  m_MarginLeft := 0;
  m_MarginTop := 0;
  m_MarginLeft := 0;
  m_MarginBottom := 0;
  m_DownInRect := False;
  m_VB0 := Core.Graphics.Shared.RequestVB(
    SizeOf(TVertex0),
    10,
    D3DUSAGE_WRITEONLY or D3DUSAGE_DYNAMIC,
    FVF0,
    D3DPOOL_DEFAULT
  );
  m_IB := Core.Graphics.Shared.RequestIB(
    30,
    D3DUSAGE_WRITEONLY or D3DUSAGE_DYNAMIC,
    D3DFMT_INDEX16,
    D3DPOOL_DEFAULT
  );
  Result := grOk;
end;

function TG2GUIWindow.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  m_Children.Free;
  Result := grOk;
end;
//TG2GUIWindow END

//TG2GUIPanel BEGIN
constructor TG2GUIPanel.Create;
begin
  inherited Create;
end;

destructor TG2GUIPanel.Destroy;
begin
  inherited Destroy;
end;

procedure TG2GUIPanel.Render;
begin
  RenderBox(GetGlobalRect);
end;

function TG2GUIPanel.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  MarginLeft := 3;
  MarginTop := 3;
  MarginRight := 3;
  MarginBottom := 3;
  Result := grOk;
end;

function TG2GUIPanel.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2GUIPanel END

//TG2GUIButton BEGIN
constructor TG2GUIButton.Create;
begin
  inherited Create;
end;

destructor TG2GUIButton.Destroy;
begin
  inherited Destroy;
end;

procedure TG2GUIButton.Render;
var
  R: TRect;
  fx, fy: Single;
  Lowered: Boolean;
  PrevMinFilter: DWord;
  PrevMagFilter: DWord;
begin
  Lowered := IsPressed;
  RenderBox(GetGlobalRect, Lowered);
  R := ClientDrawRect;
  Core.Graphics.Device.SetScissorRect(@R);
  fx := R.Left + ((R.Right - R.Left) - m_Font.GetTextWidth(m_Caption)) * 0.5;
  fy := R.Top + ((R.Bottom - R.Top) - m_Font.GetTextHeight(m_Caption)) * 0.5;
  if Lowered then fy := fy + 2;
  PrevMinFilter := Core.Graphics.SamplerStates.MinFilter[0];
  PrevMagFilter := Core.Graphics.SamplerStates.MagFilter[0];
  Core.Graphics.SamplerStates.MinFilter[0] := D3DTEXF_POINT;
  Core.Graphics.SamplerStates.MagFilter[0] := D3DTEXF_POINT;
  m_Font.Print(
    fx, fy, FontColor, m_Caption
  );
  Core.Graphics.SamplerStates.MinFilter[0] := PrevMinFilter;
  Core.Graphics.SamplerStates.MagFilter[0] := PrevMagFilter;
end;

function TG2GUIButton.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  MarginLeft := 6;
  MarginTop := 6;
  MarginRight := 6;
  MarginBottom := 6;
  m_Caption := 'Button';
  m_Font := Core.Graphics.Shared.RequestFont('Arial', 12);
  m_FontColor := $ff000000;
  Result := grOk;
end;

function TG2GUIButton.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2GUIButton END

//TG2MeshRender BEGIN
constructor TG2MeshRender.Create;
begin
  inherited Create;
end;

destructor TG2MeshRender.Destroy;
begin
  inherited Destroy;
end;

procedure TG2MeshRender.SetGlobals;
var
  i: Integer;
  v3: TG2Vec3;
  LightAmbient: TD3DXColor;
  LightCountPoint: Integer;
  LightPosPoint: array[0..15] of TD3DXVector4;
  LightColorPoint: array[0..15] of TD3DXColor;
  LightRangePoint: array[0..15] of Single;
  LightCountDirectional: Integer;
  LightDirDirectional: array[0..15] of TD3DXVector4;
  LightColorDirectional: array[0..15] of TD3DXColor;
begin
  LightCountPoint := 0;
  LightCountDirectional := 0;
  LightAmbient := D3DXColorFromDWord(Core.Graphics.RenderStates.Ambient);
  with Core.Graphics do
  for i := 0 to Lights.LightCount - 1 do
  if Lights[i].Enabled then
  begin
    case Lights[i].LightType of
      ltAmbient:
      begin
        D3DXColorAdd(LightAmbient, LightAmbient, Lights[i].Light.Ambient);
      end;
      ltPoint:
      begin
        v3 := Lights[i].Light.Position;
        LightPosPoint[LightCountPoint] := D3DXVector4(
          v3 * Transforms.V, 1
        );
        LightColorPoint[LightCountPoint] := Lights[i].Light.Diffuse;
        LightRangePoint[LightCountPoint] := Sqr(Lights[i].Light.Range);
        Inc(LightCountPoint);
      end;
      ltDirectional:
      begin
        v3 := Lights[i].Light.Direction;
        D3DXVec3TransformNormal(PG2Vec3Ref(@v3)^, v3, Transforms.V);
        v3 := -v3;
        v3.Normalize;
        LightDirDirectional[LightCountDirectional] := D3DXVector4(v3, 1);
        LightColorDirectional[LightCountDirectional] := Lights[i].Light.Diffuse;
        Inc(LightCountDirectional);
      end;
    end;
  end;
  m_Effect.SetVector(m_HndLightAmbient, PD3DXVector4(@LightAmbient)^);
  m_Effect.SetInt(m_HndLightCountPoint, LightCountPoint);
  m_Effect.SetVectorArray(m_HndLightPosPoint, @LightPosPoint[0], LightCountPoint);
  m_Effect.SetVectorArray(m_HndLightColorPoint, @LightColorPoint[0], LightCountPoint);
  m_Effect.SetFloatArray(m_HndLightRangePoint, @LightRangePoint[0], LightCountPoint);
  m_Effect.SetInt(m_HndLightCountDirectional, LightCountDirectional);
  m_Effect.SetVectorArray(m_HndLightDirDirectional, @LightDirDirectional[0], LightCountDirectional);
  m_Effect.SetVectorArray(m_HndLightColorDirectional, @LightColorDirectional[0], LightCountDirectional);
end;

function TG2MeshRender.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_Effect := Core.Graphics.ShaderLib.RequestEffect('fx_Meshes');
  m_VS := Core.Graphics.ShaderLib.RequestVertexShader('vs_Mesh');
  m_PS := Core.Graphics.ShaderLib.RequestPixelShader('ps_Mesh');
  m_HndWV := m_Effect.GetParameterByName(nil, 'WV');
  m_HndWVP := m_Effect.GetParameterByName(nil, 'WVP');
  m_HndSkinPallete := m_Effect.GetParameterByName(nil, 'SkinPallete');
  m_HndLightAmbient := m_Effect.GetParameterByName(nil, 'LightAmbient');
  m_HndLightCountPoint := m_Effect.GetParameterByName(nil, 'LightCountPoint');
  m_HndLightPosPoint := m_Effect.GetParameterByName(nil, 'LightPosPoint');
  m_HndLightColorPoint := m_Effect.GetParameterByName(nil, 'LightColorPoint');
  m_HndLightRangePoint := m_Effect.GetParameterByName(nil, 'LightRangePoint');
  m_HndLightCountDirectional := m_Effect.GetParameterByName(nil, 'LightCountDirectional');
  m_HndLightDirDirectional := m_Effect.GetParameterByName(nil, 'LightDirDirectional');
  m_HndLightColorDirectional := m_Effect.GetParameterByName(nil, 'LightColorDirectional');
  m_HndTexDiffuse := m_Effect.GetParameterByName(nil, 'TexDiffuse');
  m_HndTexSpecular := m_Effect.GetParameterByName(nil, 'TexSpecular');
  m_HndTexNormals := m_Effect.GetParameterByName(nil, 'TexNormals');
  Result := grOk;
end;

function TG2MeshRender.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

procedure TG2MeshRender.RenderArraySM3HLSL(const FirstInstance: PG2MeshInstance; const Count: Integer);
type
  PInstArray = ^TInstArray;
  TInstArray = array[0..0] of TG2MeshInstance;
  procedure SetTexture(const Handle: TD3DXHandle; const Texture: TG2TextureBase);
  begin
    if Assigned(Texture) then
    m_Effect.SetTexture(Handle, Texture.Texture)
    else
    m_Effect.SetTexture(Handle, nil);
  end;
var
  i, PassCount: DWord;
  g, Mat: Integer;
  Inst: TG2MeshInstance;
  W, WV, WVP: TG2Mat;
  Material: TG2MeshMaterial;
  CurTechnique, NewTechnique: TD3DXHandle;
  CurGeom: ID3DXMesh;
  VB: IDirect3DVertexBuffer9;
  IB: IDirect3DIndexBuffer9;
  Decl: IDirect3DVertexDeclaration9;
begin
  SetGlobals;
  CurTechnique := '';
  CurGeom := nil;
  for i := 0 to Count - 1 do
  begin
    Inst := TG2MeshInstance(Pointer(Cardinal(FirstInstance) + i * 4)^);
    with Inst.Mesh, Inst.Mesh.Core.Graphics do
    for g := 0 to GeomCount - 1 do
    begin
      NewTechnique := Geoms[g].Technique;
      if NewTechnique <> CurTechnique then
      begin
        m_Effect.Technique := NewTechnique;
        if Assigned(CurTechnique) then
        begin
          m_Effect.EndPass;
          m_Effect.EndEffect;
        end;
        CurTechnique := NewTechnique;
        m_Effect.BeginEffect(@PassCount, 0); //D3DXFX_DONOTSAVESTATE
        m_Effect.BeginPass(0);
      end;
      W := Inst.Transforms[Geoms[g].NodeID] * Inst.Transform * Transforms.W[0];
      WV := W * Transforms.V;
      WVP := WV * Transforms.P;
      m_Effect.SetMatrix(m_HndW, W);
      m_Effect.SetMatrix(m_HndWV, WV);
      m_Effect.SetMatrix(m_HndWVP, WVP);
      if Geoms[g].Skinned then
      m_Effect.SetMatrixPointerArray(
        m_HndSkinPallete,
        Inst.SkinTransformPointers[Geoms[g].SkinID],
        Skins[Geoms[g].SkinID].BoneCount
      );
      if Geoms[g].Geom <> CurGeom then
      begin
        CurGeom := Geoms[g].Geom;
        CurGeom.GetVertexBuffer(VB);
        CurGeom.GetIndexBuffer(IB);
        Decl := Geoms[g].Decl;
        Device.SetVertexDeclaration(Decl);
        Device.SetStreamSource(0, VB, 0, CurGeom.GetNumBytesPerVertex);
        Device.SetIndices(IB);
      end;
      if Geoms[g].MaterialCount > 0 then
      for Mat := 0 to Geoms[g].MaterialCount - 1 do
      begin
        Material := Materials[Geoms[g].MaterialIDs[Mat]];
        SetTexture(m_HndTexDiffuse, Material.Diffuse);
        SetTexture(m_HndTexSpecular, Material.Specular);
        SetTexture(m_HndTexNormals, Material.Normals);
        m_Effect.CommitChanges;
        Geoms[g].Geom.DrawSubset(Mat);
      end
      else
      begin
        SetTexture(m_HndTexDiffuse, nil);
        SetTexture(m_HndTexSpecular, nil);
        SetTexture(m_HndTexNormals, nil);
        m_Effect.CommitChanges;
        Geoms[g].Geom.DrawSubset(0);
      end;
    end;
  end;
  if Assigned(CurTechnique) then
  begin
    m_Effect.EndPass;
    m_Effect.EndEffect;
  end;
end;

procedure TG2MeshRender.RenderArraySM3ASM(const FirstInstance: PG2MeshInstance; const Count: Integer);
type
  TPMatrixArray = array[0..0] of PD3DXMatrix;
  PPMatrixArray = ^TPMatrixArray;
var
  i, g, b, Mat: Integer;
  Inst: TG2MeshInstance;
  W, WV, WVP, m: TG2Mat;
  v3: TG2Vec3;
  v4: TD3DXVector4;
  Material: TG2MeshMaterial;
  StageTextures: array[0..7] of IDirect3DBaseTexture9;
  procedure SetTexture(const Stage: Byte; const Tex: TG2TextureBase);
  begin
    if Assigned(Tex) then
    begin
      if StageTextures[Stage] <> Tex.Texture then
      begin
        Core.Graphics.Device.SetTexture(Stage, Tex.Texture);
        StageTextures[Stage] := Tex.Texture;
      end;
    end
    else
    Core.Graphics.Device.SetTexture(Stage, nil);
  end;
begin
  for i := 0 to 7 do
  StageTextures[i] := nil;
  m_VS.SetToDevice;
  m_PS.SetToDevice;
  for i := 0 to Count - 1 do
  begin
    Inst := TG2MeshInstance(Pointer(Cardinal(FirstInstance) + i * 4)^);
    with Inst.Mesh, Core.Graphics do
    for g := 0 to GeomCount - 1 do
    begin
      W := Inst.Transforms[Geoms[g].NodeID] * Inst.Transform * Transforms.W[0];
      WV := W * Transforms.V;
      v3 := G2Vec3(-10, 5, -20) * Transforms.V;
      WVP := (WV * Transforms.P).Transpose;
      WV := WV.Transpose;
      m_VS.SetConstantF(10, @WVP, 4);
      m_VS.SetConstantF(14, @WV, 3);
      v4 := D3DXVector4(v3.X, v3.Y, v3.Z, 1);
      m_VS.SetConstantF(17, @v4, 1);
      if Geoms[g].Skinned then
      for b := 0 to Skins[Geoms[g].SkinID].BoneCount - 1 do
      begin
        D3DXMatrixTranspose(PG2MatRef(@m)^, PPMatrixArray(Inst.SkinTransformPointers[Geoms[g].SkinID])^[b]^);
        m_VS.SetConstantF(20 + b * 3, @m, 3);
      end;
      for Mat := 0 to Geoms[g].MaterialCount - 1 do
      begin
        Material := Materials[Geoms[g].MaterialIDs[Mat]];
        SetTexture(0, Material.Diffuse);
        SetTexture(1, Material.Specular);
        SetTexture(2, Material.Normals);
        Geoms[g].Geom.DrawSubset(Mat);
      end;
    end;
  end;
  Core.Graphics.Device.SetVertexShader(nil);
  Core.Graphics.Device.SetPixelShader(nil);
end;
//TG2MeshRender END

//TG2RenderStates BEGIN
constructor TG2RenderStates.Create;
begin
  inherited Create;
end;

destructor TG2RenderStates.Destroy;
begin
  inherited Destroy;
end;

function TG2RenderStates.GetBoolean(const StateType: TD3DRenderStateType): Boolean;
var
  Value: DWord;
begin
  m_G2Graphics.Device.GetRenderState(StateType, Value);
  Result := Value > 0;
end;

procedure TG2RenderStates.SetBoolean(const StateType: TD3DRenderStateType; const Value: Boolean);
begin
  m_States[Byte(StateType)] := Byte(Value);
  m_G2Graphics.Device.SetRenderState(StateType, Byte(Value));
end;

function TG2RenderStates.GetDWord(const StateType: TD3DRenderStateType): DWord;
begin
  m_G2Graphics.Device.GetRenderState(StateType, Result);
end;

procedure TG2RenderStates.SetDWord(const StateType: TD3DRenderStateType; const Value: DWord);
begin
  m_States[Byte(StateType)] := Value;
  m_G2Graphics.Device.SetRenderState(StateType, Value);
end;

function TG2RenderStates.GetSingle(const StateType: TD3DRenderStateType): Single;
var
  Value: DWord;
begin
  m_G2Graphics.Device.GetRenderState(StateType, Value);
  Result := PSingle(@Value)^;
end;

procedure TG2RenderStates.SetSingle(const StateType: TD3DRenderStateType; const Value: Single);
begin
  m_States[Byte(StateType)] := PDWord(@Value)^;
  m_G2Graphics.Device.SetRenderState(StateType, PDWord(@Value)^);
end;

function TG2RenderStates.GetZEnable: Boolean;
begin
  Result := GetBoolean(D3DRS_ZENABLE);
end;

procedure TG2RenderStates.SetZEnable(const Value: Boolean);
begin
  SetBoolean(D3DRS_ZENABLE, Value);
end;

function TG2RenderStates.GetFillMode: DWord;
begin
  Result := GetDWord(D3DRS_FILLMODE);
end;

procedure TG2RenderStates.SetFillMode(const Value: DWord);     
begin
  SetDWord(D3DRS_FILLMODE, Value);
end;

function TG2RenderStates.GetShadeMode: DWord;                 
begin
  Result := GetDWord(D3DRS_SHADEMODE);
end;

procedure TG2RenderStates.SetShadeMode(const Value: DWord);     
begin
  SetDWord(D3DRS_SHADEMODE, Value);
end;

function TG2RenderStates.GetZWriteEnable: Boolean;               
begin
  Result := GetBoolean(D3DRS_ZWRITEENABLE);
end;

procedure TG2RenderStates.SetZWriteEnable(const Value: Boolean);  
begin
  SetBoolean(D3DRS_ZWRITEENABLE, Value);
end;

function TG2RenderStates.GetAlphaTestEnable: Boolean;               
begin
  Result := GetBoolean(D3DRS_ALPHATESTENABLE);
end;

procedure TG2RenderStates.SetAlphaTestEnable(const Value: Boolean);  
begin
  SetBoolean(D3DRS_ALPHATESTENABLE, Value);
end;

function TG2RenderStates.GetLastPixel: Boolean;                    
begin
  Result := GetBoolean(D3DRS_LASTPIXEL);
end;

procedure TG2RenderStates.SetLastPixel(const Value: Boolean);     
begin
  SetBoolean(D3DRS_LASTPIXEL, Value);
end;

function TG2RenderStates.GetSrcBlend: DWord;                      
begin
  Result := GetDWord(D3DRS_SRCBLEND);
end;

procedure TG2RenderStates.SetSrcBlend(const Value: DWord);        
begin
  SetDWord(D3DRS_SRCBLEND, Value);
end;

function TG2RenderStates.GetDestBlend: DWord;                     
begin
  Result := GetDWord(D3DRS_DESTBLEND);
end;

procedure TG2RenderStates.SetDestBlend(const Value: DWord);        
begin
  SetDWord(D3DRS_DESTBLEND, Value);
end;

function TG2RenderStates.GetCullMode: DWord;                      
begin
  Result := GetDWord(D3DRS_CULLMODE);
end;

procedure TG2RenderStates.SetCullMode(const Value: DWord);       
begin
  SetDWord(D3DRS_CULLMODE, Value);
end;

function TG2RenderStates.GetZFunc: DWord;                       
begin
  Result := GetDWord(D3DRS_ZFUNC);
end;

procedure TG2RenderStates.SetZFunc(const Value: DWord);           
begin
  SetDWord(D3DRS_ZFUNC, Value);
end;

function TG2RenderStates.GetAlphaRef: DWord;                     
begin
  Result := GetDWord(D3DRS_ALPHAREF);
end;

procedure TG2RenderStates.SetAlphaRef(const Value: DWord);      
begin
  SetDWord(D3DRS_ALPHAREF, Value);
end;

function TG2RenderStates.GetAlphaFunc: DWord;                      
begin
  Result := GetDWord(D3DRS_ALPHAFUNC);
end;

procedure TG2RenderStates.SetAlphaFunc(const Value: DWord);       
begin
  SetDWord(D3DRS_ALPHAFUNC, Value);
end;

function TG2RenderStates.GetDitherEnable: Boolean;                 
begin
  Result := GetBoolean(D3DRS_DITHERENABLE);
end;

procedure TG2RenderStates.SetDitherEnable(const Value: Boolean);   
begin
  SetBoolean(D3DRS_DITHERENABLE, Value);
end;

function TG2RenderStates.GetAlphaBlendEnable: Boolean;                 
begin
  Result := GetBoolean(D3DRS_ALPHABLENDENABLE);
end;

procedure TG2RenderStates.SetAlphaBlendEnable(const Value: Boolean);   
begin
  SetBoolean(D3DRS_ALPHABLENDENABLE, Value);
end;

function TG2RenderStates.GetFogEnable: Boolean;                     
begin
  Result := GetBoolean(D3DRS_FOGENABLE);
end;

procedure TG2RenderStates.SetFogEnable(const Value: Boolean);        
begin
  SetBoolean(D3DRS_FOGENABLE, Value);
end;

function TG2RenderStates.GetSpecularEnable: Boolean;                 
begin
  Result := GetBoolean(D3DRS_SPECULARENABLE);
end;

procedure TG2RenderStates.SetSpecularEnable(const Value: Boolean);   
begin
  SetBoolean(D3DRS_SPECULARENABLE, Value);
end;

function TG2RenderStates.GetFogColor: DWord;                       
begin
  Result := GetDWord(D3DRS_FOGCOLOR);
end;

procedure TG2RenderStates.SetFogColor(const Value: DWord);          
begin
  SetDWord(D3DRS_FOGCOLOR, Value);
end;

function TG2RenderStates.GetFogTableMode: DWord;                   
begin
  Result := GetDWord(D3DRS_FOGTABLEMODE);
end;

procedure TG2RenderStates.SetFogTableMode(const Value: DWord);      
begin
  SetDWord(D3DRS_FOGTABLEMODE, Value);
end;

function TG2RenderStates.GetFogVertexMode: DWord;                   
begin
  Result := GetDWord(D3DRS_FOGVERTEXMODE);
end;

procedure TG2RenderStates.SetFogVertexMode(const Value: DWord);    
begin
  SetDWord(D3DRS_FOGVERTEXMODE, Value);
end;

function TG2RenderStates.GetFogStart: Single;                      
begin
  Result := GetSingle(D3DRS_FOGSTART);
end;

procedure TG2RenderStates.SetFogStart(const Value: Single);       
begin
  SetSingle(D3DRS_FOGSTART, Value);
end;

function TG2RenderStates.GetFogEnd: Single;                          
begin
  Result := GetSingle(D3DRS_FOGEND);
end;

procedure TG2RenderStates.SetFogEnd(const Value: Single);             
begin
  SetSingle(D3DRS_FOGEND, Value);
end;

function TG2RenderStates.GetFogDensity: Single;                      
begin
  Result := GetSingle(D3DRS_FOGDENSITY);
end;

procedure TG2RenderStates.SetFogDensity(const Value: Single);      
begin
  SetSingle(D3DRS_FOGDENSITY, Value);
end;

function TG2RenderStates.GetRangeFogEnable: Boolean;              
begin
  Result := GetBoolean(D3DRS_RANGEFOGENABLE);
end;

procedure TG2RenderStates.SetRangeFogEnable(const Value: Boolean);    
begin
  SetBoolean(D3DRS_RANGEFOGENABLE, Value);
end;

function TG2RenderStates.GetStencilEnable: Boolean;                   
begin
  Result := GetBoolean(D3DRS_STENCILENABLE);
end;

procedure TG2RenderStates.SetStencilEnable(const Value: Boolean);    
begin
  SetBoolean(D3DRS_STENCILENABLE, Value);
end;

function TG2RenderStates.GetStencilFail: DWord;                    
begin
  Result := GetDWord(D3DRS_STENCILFAIL);
end;

procedure TG2RenderStates.SetStencilFail(const Value: DWord);         
begin
  SetDWord(D3DRS_STENCILFAIL, Value);
end;

function TG2RenderStates.GetStencilZFail: DWord;                  
begin
  Result := GetDWord(D3DRS_STENCILZFAIL);
end;

procedure TG2RenderStates.SetStencilZFail(const Value: DWord);     
begin
  SetDWord(D3DRS_STENCILZFAIL, Value);
end;

function TG2RenderStates.GetStencilPass: DWord;                   
begin
  Result := GetDWord(D3DRS_STENCILPASS);
end;

procedure TG2RenderStates.SetStencilPass(const Value: DWord);    
begin
  SetDWord(D3DRS_STENCILPASS, Value);
end;

function TG2RenderStates.GetStencilFunc: DWord;                 
begin
  Result := GetDWord(D3DRS_STENCILFUNC);
end;

procedure TG2RenderStates.SetStencilFunc(const Value: DWord);     
begin
  SetDWord(D3DRS_STENCILFUNC, Value);
end;

function TG2RenderStates.GetStencilRef: DWord;                     
begin
  Result := GetDWord(D3DRS_STENCILREF);
end;

procedure TG2RenderStates.SetStencilRef(const Value: DWord);    
begin
  SetDWord(D3DRS_STENCILREF, Value);
end;

function TG2RenderStates.GetStencilMask: DWord;                 
begin
  Result := GetDWord(D3DRS_STENCILMASK);
end;

procedure TG2RenderStates.SetStencilMask(const Value: DWord);   
begin
  SetDWord(D3DRS_STENCILMASK, Value);
end;

function TG2RenderStates.GetStencilWriteMask: DWord;           
begin
  Result := GetDWord(D3DRS_STENCILWRITEMASK);
end;

procedure TG2RenderStates.SetStencilWriteMask(const Value: DWord);  
begin
  SetDWord(D3DRS_STENCILWRITEMASK, Value);
end;

function TG2RenderStates.GetTwoSidedStencilMode: Boolean;           
begin
  Result := GetBoolean(D3DRS_TWOSIDEDSTENCILMODE);
end;

procedure TG2RenderStates.SetTwoSidedStencilMode(const Value: Boolean); 
begin
  SetBoolean(D3DRS_TWOSIDEDSTENCILMODE, Value);
end;

function TG2RenderStates.GetCCWStencilFail: DWord;                    
begin
  Result := GetDWord(D3DRS_CCW_STENCILFAIL);
end;

procedure TG2RenderStates.SetCCWStencilFail(const Value: DWord);       
begin
  SetDWord(D3DRS_CCW_STENCILFAIL, Value);
end;

function TG2RenderStates.GetCCWStencilZFail: DWord;                   
begin
  Result := GetDWord(D3DRS_CCW_STENCILZFAIL);
end;

procedure TG2RenderStates.SetCCWStencilZFail(const Value: DWord);    
begin
  SetDWord(D3DRS_CCW_STENCILZFAIL, Value);
end;

function TG2RenderStates.GetCCWStencilPass: DWord;                    
begin
  Result := GetDWord(D3DRS_CCW_STENCILPASS);
end;

procedure TG2RenderStates.SetCCWStencilPass(const Value: DWord);    
begin
  SetDWord(D3DRS_CCW_STENCILPASS, Value);
end;

function TG2RenderStates.GetCCWStencilFunc: DWord;                   
begin
  Result := GetDWord(D3DRS_CCW_STENCILFUNC);
end;

procedure TG2RenderStates.SetCCWStencilFunc(const Value: DWord);    
begin
  SetDWord(D3DRS_CCW_STENCILFUNC, Value);
end;

function TG2RenderStates.GetTextureFactor: DWord;                   
begin
  Result := GetDWord(D3DRS_TEXTUREFACTOR);
end;

procedure TG2RenderStates.SetTextureFactor(const Value: DWord);      
begin
  SetDWord(D3DRS_TEXTUREFACTOR, Value);
end;

function TG2RenderStates.GetWrap0: DWord;                          
begin
  Result := GetDWord(D3DRS_WRAP0);
end;

procedure TG2RenderStates.SetWrap0(const Value: DWord);        
begin
  SetDWord(D3DRS_WRAP0, Value);
end;

function TG2RenderStates.GetWrap1: DWord;                       
begin
  Result := GetDWord(D3DRS_WRAP1);
end;

procedure TG2RenderStates.SetWrap1(const Value: DWord);
begin
  SetDWord(D3DRS_WRAP1, Value);
end;

function TG2RenderStates.GetWrap2: DWord;                      
begin
  Result := GetDWord(D3DRS_WRAP2);
end;

procedure TG2RenderStates.SetWrap2(const Value: DWord);      
begin
  SetDWord(D3DRS_WRAP2, Value);
end;

function TG2RenderStates.GetWrap3: DWord;                  
begin
  Result := GetDWord(D3DRS_WRAP3);
end;

procedure TG2RenderStates.SetWrap3(const Value: DWord);     
begin
  SetDWord(D3DRS_WRAP3, Value);
end;

function TG2RenderStates.GetWrap4: DWord;                   
begin
  Result := GetDWord(D3DRS_WRAP4);
end;

procedure TG2RenderStates.SetWrap4(const Value: DWord);    
begin
  SetDWord(D3DRS_WRAP4, Value);
end;

function TG2RenderStates.GetWrap5: DWord;                 
begin
  Result := GetDWord(D3DRS_WRAP5);
end;

procedure TG2RenderStates.SetWrap5(const Value: DWord);     
begin
  SetDWord(D3DRS_WRAP5, Value);
end;

function TG2RenderStates.GetWrap6: DWord;                   
begin
  Result := GetDWord(D3DRS_WRAP6);
end;

procedure TG2RenderStates.SetWrap6(const Value: DWord);   
begin
  SetDWord(D3DRS_WRAP6, Value);
end;

function TG2RenderStates.GetWrap7: DWord;                  
begin
  Result := GetDWord(D3DRS_WRAP7);
end;

procedure TG2RenderStates.SetWrap7(const Value: DWord);     
begin
  SetDWord(D3DRS_WRAP7, Value);
end;

function TG2RenderStates.GetWrap8: DWord;                      
begin
  Result := GetDWord(D3DRS_WRAP8);
end;

procedure TG2RenderStates.SetWrap8(const Value: DWord);     
begin
  SetDWord(D3DRS_WRAP8, Value);
end;

function TG2RenderStates.GetWrap9: DWord;                      
begin
  Result := GetDWord(D3DRS_WRAP9);
end;

procedure TG2RenderStates.SetWrap9(const Value: DWord);      
begin
  SetDWord(D3DRS_WRAP9, Value);
end;

function TG2RenderStates.GetWrap10: DWord;                     
begin
  Result := GetDWord(D3DRS_WRAP10);
end;

procedure TG2RenderStates.SetWrap10(const Value: DWord);      
begin
  SetDWord(D3DRS_WRAP10, Value);
end;

function TG2RenderStates.GetWrap11: DWord;                     
begin
  Result := GetDWord(D3DRS_WRAP11);
end;

procedure TG2RenderStates.SetWrap11(const Value: DWord);    
begin
  SetDWord(D3DRS_WRAP11, Value);
end;

function TG2RenderStates.GetWrap12: DWord;                 
begin
  Result := GetDWord(D3DRS_WRAP12);
end;

procedure TG2RenderStates.SetWrap12(const Value: DWord);     
begin
  SetDWord(D3DRS_WRAP12, Value);
end;

function TG2RenderStates.GetWrap13: DWord;                    
begin
  Result := GetDWord(D3DRS_WRAP13);
end;

procedure TG2RenderStates.SetWrap13(const Value: DWord);    
begin
  SetDWord(D3DRS_WRAP13, Value);
end;

function TG2RenderStates.GetWrap14: DWord;                   
begin
  Result := GetDWord(D3DRS_WRAP14);
end;

procedure TG2RenderStates.SetWrap14(const Value: DWord);          
begin
  SetDWord(D3DRS_WRAP14, Value);
end;

function TG2RenderStates.GetWrap15: DWord;                     
begin
  Result := GetDWord(D3DRS_WRAP15);
end;

procedure TG2RenderStates.SetWrap15(const Value: DWord);         
begin
  SetDWord(D3DRS_WRAP15, Value);
end;

function TG2RenderStates.GetClipping: Boolean;                  
begin
  Result := GetBoolean(D3DRS_CLIPPING);
end;

procedure TG2RenderStates.SetClipping(const Value: Boolean);   
begin
  SetBoolean(D3DRS_CLIPPING, Value);
end;

function TG2RenderStates.GetLighting: Boolean;                 
begin
  Result := GetBoolean(D3DRS_LIGHTING);
end;

procedure TG2RenderStates.SetLighting(const Value: Boolean);   
begin
  SetBoolean(D3DRS_LIGHTING, Value);
end;

function TG2RenderStates.GetAmbient: DWord;                    
begin
  Result := GetDWord(D3DRS_AMBIENT);
end;

procedure TG2RenderStates.SetAmbient(const Value: DWord);      
begin
  SetDWord(D3DRS_AMBIENT, Value);
end;

function TG2RenderStates.GetColorVertex: Boolean;              
begin
  Result := GetBoolean(D3DRS_COLORVERTEX);
end;

procedure TG2RenderStates.SetColorVertex(const Value: Boolean); 
begin
  SetBoolean(D3DRS_COLORVERTEX, Value);
end;

function TG2RenderStates.GetLocalViewer: Boolean;                
begin
  Result := GetBoolean(D3DRS_LOCALVIEWER);
end;

procedure TG2RenderStates.SetLocalViewer(const Value: Boolean);     
begin
  SetBoolean(D3DRS_LOCALVIEWER, Value);
end;

function TG2RenderStates.GetNormalizeNormals: Boolean;              
begin
  Result := GetBoolean(D3DRS_NORMALIZENORMALS);
end;

procedure TG2RenderStates.SetNormalizeNormals(const Value: Boolean);  
begin
  SetBoolean(D3DRS_NORMALIZENORMALS, Value);
end;

function TG2RenderStates.GetDiffuseMaterialSource: DWord;              
begin
  Result := GetDWord(D3DRS_DIFFUSEMATERIALSOURCE);
end;

procedure TG2RenderStates.SetDiffuseMaterialSource(const Value: DWord);  
begin
  SetDWord(D3DRS_DIFFUSEMATERIALSOURCE, Value);
end;

function TG2RenderStates.GetSpecularMaterialSource: DWord;               
begin
  Result := GetDWord(D3DRS_SPECULARMATERIALSOURCE);
end;

procedure TG2RenderStates.SetSpecularMaterialSource(const Value: DWord);   
begin
  SetDWord(D3DRS_SPECULARMATERIALSOURCE, Value);
end;

function TG2RenderStates.GetAmbientMaterialSource: DWord;                  
begin
  Result := GetDWord(D3DRS_AMBIENTMATERIALSOURCE);
end;

procedure TG2RenderStates.SetAmbientMaterialSource(const Value: DWord);   
begin
  SetDWord(D3DRS_AMBIENTMATERIALSOURCE, Value);
end;

function TG2RenderStates.GetEmissiveMaterialSource: DWord;               
begin
  Result := GetDWord(D3DRS_EMISSIVEMATERIALSOURCE);
end;

procedure TG2RenderStates.SetEmissiveMaterialSource(const Value: DWord);  
begin
  SetDWord(D3DRS_EMISSIVEMATERIALSOURCE, Value);
end;

function TG2RenderStates.GetVertexBlend: DWord;                          
begin
  Result := GetDWord(D3DRS_VERTEXBLEND);
end;

procedure TG2RenderStates.SetVertexBlend(const Value: DWord);          
begin
  SetDWord(D3DRS_VERTEXBLEND, Value);
end;

function TG2RenderStates.GetClipPlaneEnable: DWord;                
begin
  Result := GetDWord(D3DRS_CLIPPLANEENABLE);
end;

procedure TG2RenderStates.SetClipPlaneEnable(const Value: DWord);     
begin
  SetDWord(D3DRS_CLIPPLANEENABLE, Value);
end;

function TG2RenderStates.GetPointSize: Single;                         
begin
  Result := GetSingle(D3DRS_POINTSIZE);
end;

procedure TG2RenderStates.SetPointSize(const Value: Single);           
begin
  SetSingle(D3DRS_POINTSIZE, Value);
end;

function TG2RenderStates.GetPointSizeMin: Single;                   
begin
  Result := GetSingle(D3DRS_POINTSIZE_MIN);
end;

procedure TG2RenderStates.SetPointSizeMin(const Value: Single);   
begin
  SetSingle(D3DRS_POINTSIZE_MIN, Value);
end;

function TG2RenderStates.GetPointSizeMax: Single;                   
begin
  Result := GetSingle(D3DRS_POINTSIZE_MAX);
end;

procedure TG2RenderStates.SetPointSizeMax(const Value: Single);       
begin
  SetSingle(D3DRS_POINTSIZE_MAX, Value);
end;

function TG2RenderStates.GetPointSpriteEnable: Boolean;             
begin
  Result := GetBoolean(D3DRS_POINTSPRITEENABLE);
end;

procedure TG2RenderStates.SetPointSpriteEnable(const Value: Boolean);
begin
  SetBoolean(D3DRS_POINTSPRITEENABLE, Value);
end;

function TG2RenderStates.GetPointScaleEnable: Boolean;               
begin
  Result := GetBoolean(D3DRS_POINTSCALEENABLE);
end;

procedure TG2RenderStates.SetPointScaleEnable(const Value: Boolean);  
begin
  SetBoolean(D3DRS_POINTSCALEENABLE, Value);
end;

function TG2RenderStates.GetPointScaleA: Single;                    
begin
  Result := GetSingle(D3DRS_POINTSCALE_A);
end;

procedure TG2RenderStates.SetPointScaleA(const Value: Single);   
begin
  SetSingle(D3DRS_POINTSCALE_A, Value);
end;

function TG2RenderStates.GetPointScaleB: Single;                   
begin
  Result := GetSingle(D3DRS_POINTSCALE_B);
end;

procedure TG2RenderStates.SetPointScaleB(const Value: Single);     
begin
  SetSingle(D3DRS_POINTSCALE_B, Value)
end;

function TG2RenderStates.GetPointScaleC: Single;                    
begin
  Result := GetSingle(D3DRS_POINTSCALE_C);
end;

procedure TG2RenderStates.SetPointScaleC(const Value: Single);     
begin
  SetSingle(D3DRS_POINTSCALE_C, Value);
end;

function TG2RenderStates.GetMultisampleAntialias: Boolean;         
begin
  Result := GetBoolean(D3DRS_MULTISAMPLEANTIALIAS);
end;

procedure TG2RenderStates.SetMultisampleAntialias(const Value: Boolean);  
begin
  SetBoolean(D3DRS_MULTISAMPLEANTIALIAS, Value);
end;

function TG2RenderStates.GetMultisampleMask: DWord;                
begin
  Result := GetDWord(D3DRS_MULTISAMPLEMASK);
end;

procedure TG2RenderStates.SetMultisampleMask(const Value: DWord);  
begin
  SetDWord(D3DRS_MULTISAMPLEMASK, Value);
end;

function TG2RenderStates.GetPatchEdgeStyle: TD3DPatchEdgeStyle;
begin
  Result := TD3DPatchEdgeStyle(GetDWord(D3DRS_PATCHEDGESTYLE));
end;

procedure TG2RenderStates.SetPatchEdgeStyle(const Value: TD3DPatchEdgeStyle);    
begin
  SetDWord(D3DRS_PATCHEDGESTYLE, DWord(Value));
end;

function TG2RenderStates.GetDebugMonitorToken: DWord;                  
begin
  Result := GetDWord(D3DRS_DEBUGMONITORTOKEN);
end;

procedure TG2RenderStates.SetDebugMonitorToken(const Value: DWord);    
begin
  SetDWord(D3DRS_DEBUGMONITORTOKEN, Value);
end;

function TG2RenderStates.GetIndexedVertexBlendEnable: Boolean;         
begin
  Result := GetBoolean(D3DRS_INDEXEDVERTEXBLENDENABLE);
end;

procedure TG2RenderStates.SetIndexedVertexBlendEnable(const Value: Boolean);  
begin
  SetBoolean(D3DRS_INDEXEDVERTEXBLENDENABLE, Value);
end;

function TG2RenderStates.GetColorWriteEnable: DWord;                     
begin
  Result := GetDWord(D3DRS_COLORWRITEENABLE);
end;

procedure TG2RenderStates.SetColorWriteEnable(const Value: DWord);     
begin
  SetDWord(D3DRS_COLORWRITEENABLE, Value);
end;

function TG2RenderStates.GetTweenFactor: Single;                      
begin
  Result := GetSingle(D3DRS_TWEENFACTOR);
end;

procedure TG2RenderStates.SetTweenFactor(const Value: Single);      
begin
  SetSingle(D3DRS_TWEENFACTOR, Value);
end;

function TG2RenderStates.GetBlendOp: DWord;                          
begin
  Result := GetDWord(D3DRS_BLENDOP);
end;

procedure TG2RenderStates.SetBlendOp(const Value: DWord);    
begin
  SetDWord(D3DRS_BLENDOP, Value);
end;

function TG2RenderStates.GetPositionDegree: TD3DDegreeType;
begin
  Result := TD3DDegreeType(GetDWord(D3DRS_POSITIONDEGREE));
end;

procedure TG2RenderStates.SetPositionDegree(const Value: TD3DDegreeType);  
begin
  SetDWord(D3DRS_POSITIONDEGREE, DWord(Value));
end;

function TG2RenderStates.GetNormalDegree: TD3DDegreeType;
begin
  Result := TD3DDegreeType(GetDWord(D3DRS_NORMALDEGREE));
end;

procedure TG2RenderStates.SetNormalDegree(const Value: TD3DDegreeType);
begin
  SetDWord(D3DRS_NORMALDEGREE, DWord(Value));
end;

function TG2RenderStates.GetScissorTestEnable: Boolean;                 
begin
  Result := GetBoolean(D3DRS_SCISSORTESTENABLE);
end;

procedure TG2RenderStates.SetScissorTestEnable(const Value: Boolean);   
begin
  SetBoolean(D3DRS_SCISSORTESTENABLE, Value);
end;

function TG2RenderStates.GetSlopeScaleDepthBias: Single;             
begin
  Result := GetSingle(D3DRS_SLOPESCALEDEPTHBIAS);
end;

procedure TG2RenderStates.SetSlopeScaleDepthBias(const Value: Single);  
begin
  SetSingle(D3DRS_SLOPESCALEDEPTHBIAS, Value);
end;

function TG2RenderStates.GetAntialiasedLineEnable: Boolean;           
begin
  Result := GetBoolean(D3DRS_ANTIALIASEDLINEENABLE);
end;

procedure TG2RenderStates.SetAntialiasedLineEnable(const Value: Boolean); 
begin
  SetBoolean(D3DRS_ANTIALIASEDLINEENABLE, Value)
end;

function TG2RenderStates.GetMinTessellationLevel: Single;                
begin
  Result := GetSingle(D3DRS_MINTESSELLATIONLEVEL);
end;

procedure TG2RenderStates.SetMinTessellationLevel(const Value: Single);   
begin
  SetSingle(D3DRS_MINTESSELLATIONLEVEL, Value);
end;

function TG2RenderStates.GetMaxTessellationLevel: Single;                
begin
  Result := GetSingle(D3DRS_MAXTESSELLATIONLEVEL);
end;

procedure TG2RenderStates.SetMaxTessellationLevel(const Value: Single);    
begin
  SetSingle(D3DRS_MAXTESSELLATIONLEVEL, Value);
end;

function TG2RenderStates.GetAdaptiveTessX: Single;                     
begin
  Result := GetSingle(D3DRS_ADAPTIVETESS_X);
end;

procedure TG2RenderStates.SetAdaptiveTessX(const Value: Single);      
begin
  SetSingle(D3DRS_ADAPTIVETESS_X, Value);
end;

function TG2RenderStates.GetAdaptiveTessY: Single;                   
begin
  Result := GetSingle(D3DRS_ADAPTIVETESS_Y);
end;

procedure TG2RenderStates.SetAdaptiveTessY(const Value: Single);    
begin
  SetSingle(D3DRS_ADAPTIVETESS_Y, Value);
end;

function TG2RenderStates.GetAdaptiveTessZ: Single;                 
begin
  Result := GetSingle(D3DRS_ADAPTIVETESS_Z);
end;

procedure TG2RenderStates.SetAdaptiveTessZ(const Value: Single);
begin
  SetSingle(D3DRS_ADAPTIVETESS_Z, Value);
end;

function TG2RenderStates.GetAdaptiveTessW: Single;                  
begin
  Result := GetSingle(D3DRS_ADAPTIVETESS_W);
end;

procedure TG2RenderStates.SetAdaptiveTessW(const Value: Single);  
begin
  SetSingle(D3DRS_ADAPTIVETESS_W, Value);
end;

function TG2RenderStates.GetEnableAdaptiveTessellation: Boolean;   
begin
  Result := GetBoolean(D3DRS_ENABLEADAPTIVETESSELLATION);
end;

procedure TG2RenderStates.SetEnableAdaptiveTessellation(const Value: Boolean); 
begin
  SetBoolean(D3DRS_ENABLEADAPTIVETESSELLATION, Value);
end;

function TG2RenderStates.GetColorWriteEnable1: DWord;                 
begin
  Result := GetDWord(D3DRS_COLORWRITEENABLE1);
end;

procedure TG2RenderStates.SetColorWriteEnable1(const Value: DWord);   
begin
  SetDWord(D3DRS_COLORWRITEENABLE1, Value);
end;

function TG2RenderStates.GetColorWriteEnable2: DWord;                 
begin
  Result := GetDWord(D3DRS_COLORWRITEENABLE2);
end;

procedure TG2RenderStates.SetColorWriteEnable2(const Value: DWord);   
begin
  SetDWord(D3DRS_COLORWRITEENABLE2, Value)
end;

function TG2RenderStates.GetColorWriteEnable3: DWord;               
begin
  Result := GetDWord(D3DRS_COLORWRITEENABLE3);
end;

procedure TG2RenderStates.SetColorWriteEnable3(const Value: DWord);  
begin
  SetDWord(D3DRS_COLORWRITEENABLE3, Value);
end;

function TG2RenderStates.GetBlendFactor: DWord;                     
begin
  Result := GetDWord(D3DRS_BLENDFACTOR);
end;

procedure TG2RenderStates.SetBlendFactor(const Value: DWord);         
begin
  SetDWord(D3DRS_BLENDFACTOR, Value);
end;

function TG2RenderStates.GetSRGBWriteEnable: Boolean;              
begin
  Result := GetBoolean(D3DRS_SRGBWRITEENABLE);
end;

procedure TG2RenderStates.SetSRGBWriteEnable(const Value: Boolean);   
begin
  SetBoolean(D3DRS_SRGBWRITEENABLE, Value);
end;

function TG2RenderStates.GetDepthBias: Single;                     
begin
  Result := GetSingle(D3DRS_DEPTHBIAS);
end;

procedure TG2RenderStates.SetDepthBias(const Value: Single);        
begin
  SetSingle(D3DRS_DEPTHBIAS, Value);
end;

function TG2RenderStates.GetSeparateAlphaBlendEnable: Boolean;       
begin
  Result := GetBoolean(D3DRS_SEPARATEALPHABLENDENABLE);
end;

procedure TG2RenderStates.SetSeparateAlphaBlendEnable(const Value: Boolean); 
begin
  SetBoolean(D3DRS_SEPARATEALPHABLENDENABLE, Value);
end;

function TG2RenderStates.GetSrcBlendAlpha: DWord;              
begin
  Result := GetDWord(D3DRS_SRCBLENDALPHA);
end;

procedure TG2RenderStates.SetSrcBlendAlpha(const Value: DWord);  
begin
  SetDWord(D3DRS_SRCBLENDALPHA, Value);
end;

function TG2RenderStates.GetDestBlendAlpha: DWord;             
begin
  Result := GetDWord(D3DRS_DESTBLENDALPHA);
end;

procedure TG2RenderStates.SetDestBlendAlpha(const Value: DWord); 
begin
  SetDWord(D3DRS_DESTBLENDALPHA, Value);
end;

function TG2RenderStates.GetBlendOpAlpha: DWord;           
begin
  Result := GetDWord(D3DRS_BLENDOPALPHA);
end;

procedure TG2RenderStates.SetBlendOpAlpha(const Value: DWord);   
begin
  SetDWord(D3DRS_BLENDOPALPHA, Value);
end;

procedure TG2RenderStates.SetDefaults;
begin
  ZEnable := False;
  FillMode := D3DFILL_SOLID;
  ShadeMode := D3DSHADE_GOURAUD;
  ZWriteEnable := True;
  AlphaTestEnable := False;
  LastPixel := True;
  SrcBlend := D3DBLEND_SRCALPHA;
  DestBlend := D3DBLEND_INVSRCALPHA;
  BlendOp := D3DBLENDOP_ADD;
  CullMode := D3DCULL_CCW;
  ZFunc := D3DCMP_LESSEQUAL;
  AlphaRef := 1;
  AlphaFunc := D3DCMP_GREATEREQUAL;
  DitherEnable := False;
  AlphaBlendEnable := True;
  FogEnable := False;
  SpecularEnable := False;
  FogColor := 0;
  FogTableMode := D3DFOG_NONE;
  FogVertexMode := D3DFOG_NONE;
  FogStart := 0;
  FogEnd := 1;
  FogDensity := 1;
  RangeFogEnable := False;
  StencilEnable := False;
  StencilFail := D3DSTENCILOP_KEEP;
  StencilZFail := D3DSTENCILOP_KEEP;
  StencilPass := D3DSTENCILOP_KEEP;
  StencilFunc := D3DCMP_ALWAYS;
  StencilRef := 0;
  StencilMask := $ffffffff;
  StencilWriteMask := $ffffffff;
  TextureFactor := $ffffffff;
  Wrap0 := 0;
  Wrap1 := 0;
  Wrap2 := 0;
  Wrap3 := 0;
  Wrap4 := 0;
  Wrap5 := 0;
  Wrap6 := 0;
  Wrap7 := 0;
  Wrap8 := 0;
  Wrap9 := 0;
  Wrap10 := 0;
  Wrap11 := 0;
  Wrap12 := 0;
  Wrap13 := 0;
  Wrap14 := 0;
  Wrap15 := 0;
  Clipping := True;
  Lighting := False;
  Ambient := 0;
  ColorVertex := True;
  LocalViewer := True;
  NormalizeNormals := True;
  DiffuseMaterialSource := D3DMCS_COLOR1;
  SpecularMaterialSource := D3DMCS_COLOR2;
  AmbientMaterialSource := D3DMCS_MATERIAL;
  EmissiveMaterialSource := D3DMCS_MATERIAL;
  VertexBlend := D3DVBF_DISABLE;
  ClipPlaneEnable := 0;
  PointSize := 4;
  PointSizeMin := 1;
  PointSpriteEnable := False;
  PointScaleEnable := False;
  PointScaleA := 0;
  PointScaleB := 0;
  PointScaleC := 0;
  MultisampleAntialias := True;
  MultisampleMask := $ffffffff;
  PatchEdgeStyle := D3DPATCHEDGE_DISCRETE;
  DebugMonitorToken := D3DDMT_DISABLE;
  IndexedVertexBlendEnable := False;
  ColorWriteEnable := $f;
  TweenFactor := 0;
  PositionDegree := D3DDEGREE_CUBIC;
  NormalDegree := D3DDEGREE_LINEAR;
  ScissorTestEnable := False;
  SlopeScaleDepthBias := 0;
  AntialiasedLineEnable := False;
  MinTessellationLevel := 1;
  MaxTessellationLevel := 1;
  AdaptiveTessX := 0;
  AdaptiveTessY := 0;
  AdaptiveTessZ := 1;
  AdaptiveTessW := 0;
  EnableAdaptiveTessellation := False;
  TwoSidedStencilMode := False;
  CCWStencilFail := D3DSTENCILOP_KEEP;
  CCWStencilZFail := D3DSTENCILOP_KEEP;
  CCWStencilPass := D3DSTENCILOP_KEEP;
  CCWStencilFunc := D3DCMP_ALWAYS;
  ColorWriteEnable1 := $f;
  ColorWriteEnable2 := $f;
  ColorWriteEnable3 := $f;
  BlendFactor := $ffffffff;
  SRGBWriteEnable := False;
  DepthBias := 0;
  SeparateAlphaBlendEnable := False;
  SrcBlendAlpha := D3DBLEND_SRCALPHA;
  DestBlendAlpha := D3DBLEND_DESTALPHA;
  BlendopAlpha := D3DBLENDOP_ADD;
end;

procedure TG2RenderStates.SetFromMemory;
  procedure ResetState(const State: TD3DRenderStateType);
  begin
    SetDWord(State, m_States[Byte(State)]);
  end;
begin
  ResetState(D3DRS_ZENABLE);
  ResetState(D3DRS_FILLMODE);
  ResetState(D3DRS_SHADEMODE);
  ResetState(D3DRS_ZWRITEENABLE);
  ResetState(D3DRS_ALPHATESTENABLE);
  ResetState(D3DRS_LASTPIXEL);
  ResetState(D3DRS_SRCBLEND);
  ResetState(D3DRS_DESTBLEND);
  ResetState(D3DRS_CULLMODE);
  ResetState(D3DRS_ZFUNC);
  ResetState(D3DRS_ALPHAREF);
  ResetState(D3DRS_ALPHAFUNC);
  ResetState(D3DRS_DITHERENABLE);
  ResetState(D3DRS_ALPHABLENDENABLE);
  ResetState(D3DRS_FOGENABLE);
  ResetState(D3DRS_SPECULARENABLE);
  ResetState(D3DRS_FOGCOLOR);
  ResetState(D3DRS_FOGTABLEMODE);
  ResetState(D3DRS_FOGSTART);
  ResetState(D3DRS_FOGEND);
  ResetState(D3DRS_FOGDENSITY);
  ResetState(D3DRS_RANGEFOGENABLE);
  ResetState(D3DRS_STENCILENABLE);
  ResetState(D3DRS_STENCILFAIL);
  ResetState(D3DRS_STENCILZFAIL);
  ResetState(D3DRS_STENCILPASS);
  ResetState(D3DRS_STENCILFUNC);
  ResetState(D3DRS_STENCILREF);
  ResetState(D3DRS_STENCILMASK);
  ResetState(D3DRS_STENCILWRITEMASK);
  ResetState(D3DRS_TEXTUREFACTOR);
  ResetState(D3DRS_WRAP0);
  ResetState(D3DRS_WRAP1);
  ResetState(D3DRS_WRAP2);
  ResetState(D3DRS_WRAP3);
  ResetState(D3DRS_WRAP4);
  ResetState(D3DRS_WRAP5);
  ResetState(D3DRS_WRAP6);
  ResetState(D3DRS_WRAP7);
  ResetState(D3DRS_CLIPPING);
  ResetState(D3DRS_LIGHTING);
  ResetState(D3DRS_AMBIENT);
  ResetState(D3DRS_FOGVERTEXMODE);
  ResetState(D3DRS_COLORVERTEX);
  ResetState(D3DRS_LOCALVIEWER);
  ResetState(D3DRS_NORMALIZENORMALS);
  ResetState(D3DRS_DIFFUSEMATERIALSOURCE);
  ResetState(D3DRS_SPECULARMATERIALSOURCE);
  ResetState(D3DRS_AMBIENTMATERIALSOURCE);
  ResetState(D3DRS_EMISSIVEMATERIALSOURCE);
  ResetState(D3DRS_VERTEXBLEND);
  ResetState(D3DRS_CLIPPLANEENABLE);
  ResetState(D3DRS_POINTSIZE);
  ResetState(D3DRS_POINTSIZE_MIN);
  ResetState(D3DRS_POINTSPRITEENABLE);
  ResetState(D3DRS_POINTSCALEENABLE);
  ResetState(D3DRS_POINTSCALE_A);
  ResetState(D3DRS_POINTSCALE_B);
  ResetState(D3DRS_POINTSCALE_C);
  ResetState(D3DRS_MULTISAMPLEANTIALIAS);
  ResetState(D3DRS_MULTISAMPLEMASK);
  ResetState(D3DRS_PATCHEDGESTYLE);
  ResetState(D3DRS_DEBUGMONITORTOKEN);
  ResetState(D3DRS_POINTSIZE_MAX);
  ResetState(D3DRS_INDEXEDVERTEXBLENDENABLE);
  ResetState(D3DRS_COLORWRITEENABLE);
  ResetState(D3DRS_TWEENFACTOR);
  ResetState(D3DRS_BLENDOP);
  ResetState(D3DRS_POSITIONDEGREE);
  ResetState(D3DRS_NORMALDEGREE);
  ResetState(D3DRS_SCISSORTESTENABLE);
  ResetState(D3DRS_SLOPESCALEDEPTHBIAS);
  ResetState(D3DRS_ANTIALIASEDLINEENABLE);
  ResetState(D3DRS_MINTESSELLATIONLEVEL);
  ResetState(D3DRS_MAXTESSELLATIONLEVEL);
  ResetState(D3DRS_ADAPTIVETESS_X);
  ResetState(D3DRS_ADAPTIVETESS_Y);
  ResetState(D3DRS_ADAPTIVETESS_Z);
  ResetState(D3DRS_ADAPTIVETESS_W);
  ResetState(D3DRS_ENABLEADAPTIVETESSELLATION);
  ResetState(D3DRS_TWOSIDEDSTENCILMODE);
  ResetState(D3DRS_CCW_STENCILFAIL);
  ResetState(D3DRS_CCW_STENCILZFAIL);
  ResetState(D3DRS_CCW_STENCILPASS);
  ResetState(D3DRS_CCW_STENCILFUNC);
  ResetState(D3DRS_COLORWRITEENABLE1);
  ResetState(D3DRS_COLORWRITEENABLE2);
  ResetState(D3DRS_COLORWRITEENABLE3);
  ResetState(D3DRS_BLENDFACTOR);
  ResetState(D3DRS_SRGBWRITEENABLE);
  ResetState(D3DRS_DEPTHBIAS);
  ResetState(D3DRS_WRAP8);
  ResetState(D3DRS_WRAP9);
  ResetState(D3DRS_WRAP10);
  ResetState(D3DRS_WRAP11);
  ResetState(D3DRS_WRAP12);
  ResetState(D3DRS_WRAP13);
  ResetState(D3DRS_WRAP14);
  ResetState(D3DRS_WRAP15);
  ResetState(D3DRS_SEPARATEALPHABLENDENABLE);
  ResetState(D3DRS_SRCBLENDALPHA);
  ResetState(D3DRS_DESTBLENDALPHA);
  ResetState(D3DRS_BLENDOPALPHA);
end;
//TG2RenderStates END

//TG2SamplerStates BEGIN
constructor TG2SamplerStates.Create;
begin
  inherited Create;
end;

destructor TG2SamplerStates.Destroy;
begin
  inherited Destroy;
end;

function TG2SamplerStates.GetDWord(const Sampler: Byte; const StateType: TD3DSamplerStateType): DWord;
begin
  Result := m_G2Graphics.Device.GetSamplerState(Sampler, StateType, Result);
end;

procedure TG2SamplerStates.SetDWord(const Sampler: Byte; const StateType: TD3DSamplerStateType; const Value: DWord);
begin
  m_States[Sampler, Byte(StateType)] := Value; 
  m_G2Graphics.Device.SetSamplerState(Sampler, StateType, Value);
end;

function TG2SamplerStates.GetSingle(const Sampler: Byte; const StateType: TD3DSamplerStateType): Single;
var
  Value: DWord;
begin
  m_G2Graphics.Device.GetSamplerState(Sampler, StateType, Value);
  Result := PSingle(@Value)^;
end;

procedure TG2SamplerStates.SetSingle(const Sampler: Byte; const StateType: TD3DSamplerStateType; const Value: Single); 
begin
  m_States[Sampler, Byte(StateType)] := PDWord(@Value)^; 
  m_G2Graphics.Device.SetSamplerState(Sampler, StateType, PDWord(@Value)^);
end;

function TG2SamplerStates.GetAddressU(const Index: Byte): DWord;      
begin
  Result := GetDWord(Index, D3DSAMP_ADDRESSU);
end;

procedure TG2SamplerStates.SetAddressU(const Index: Byte; const Value: DWord); 
begin
  SetDWord(Index, D3DSAMP_ADDRESSU, Value);
end;

function TG2SamplerStates.GetAddressV(const Index: Byte): DWord;              
begin
  Result := GetDWord(Index, D3DSAMP_ADDRESSV);
end;

procedure TG2SamplerStates.SetAddressV(const Index: Byte; const Value: DWord); 
begin
  SetDWord(Index, D3DSAMP_ADDRESSV, Value);
end;

function TG2SamplerStates.GetAddressW(const Index: Byte): DWord;                 
begin
  Result := GetDWord(Index, D3DSAMP_ADDRESSW);
end;

procedure TG2SamplerStates.SetAddressW(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DSAMP_ADDRESSW, Value);
end;

function TG2SamplerStates.GetBorderColor(const Index: Byte): DWord;                 
begin
  Result := GetDWord(Index, D3DSAMP_BORDERCOLOR);
end;

procedure TG2SamplerStates.SetBorderColor(const Index: Byte; const Value: DWord); 
begin
  SetDWord(Index, D3DSAMP_BORDERCOLOR, Value);
end;

function TG2SamplerStates.GetMagFilter(const Index: Byte): DWord;                
begin
  Result := GetDWord(Index, D3DSAMP_MAGFILTER);
end;

procedure TG2SamplerStates.SetMagFilter(const Index: Byte; const Value: DWord);     
begin
  SetDWord(Index, D3DSAMP_MAGFILTER, Value);
end;

function TG2SamplerStates.GetMinFilter(const Index: Byte): DWord;                 
begin
  Result := GetDWord(Index, D3DSAMP_MINFILTER);
end;

procedure TG2SamplerStates.SetMinFilter(const Index: Byte; const Value: DWord);     
begin
  SetDWord(Index, D3DSAMP_MINFILTER, Value);
end;

function TG2SamplerStates.GetMipFilter(const Index: Byte): DWord;                    
begin
  Result := GetDWord(Index, D3DSAMP_MIPFILTER);
end;

procedure TG2SamplerStates.SetMipFilter(const Index: Byte; const Value: DWord);     
begin
  SetDWord(Index, D3DSAMP_MIPFILTER, Value);
end;

function TG2SamplerStates.GetMipMapLODBias(const Index: Byte): Single;              
begin
  Result := GetSingle(Index, D3DSAMP_MIPMAPLODBIAS);
end;

procedure TG2SamplerStates.SetMipMapLODBias(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DSAMP_MIPMAPLODBIAS, Value);
end;

function TG2SamplerStates.GetMaxMipLevel(const Index: Byte): DWord;                 
begin
  Result := GetDWord(Index, D3DSAMP_MAXMIPLEVEL);
end;

procedure TG2SamplerStates.SetMaxMipLevel(const Index: Byte; const Value: DWord);     
begin
  SetDWord(Index, D3DSAMP_MAXMIPLEVEL, Value);
end;

function TG2SamplerStates.GetMaxAnisotropy(const Index: Byte): DWord;              
begin
  Result := GetDWord(Index, D3DSAMP_MAXANISOTROPY);
end;

procedure TG2SamplerStates.SetMaxAnisotropy(const Index: Byte; const Value: DWord); 
begin
  SetDWord(Index, D3DSAMP_MAXANISOTROPY, Value);
end;

function TG2SamplerStates.GetSRGBTexture(const Index: Byte): DWord;                 
begin
  Result := GetDWord(Index, D3DSAMP_SRGBTEXTURE);
end;

procedure TG2SamplerStates.SetSRGBTexture(const Index: Byte; const Value: DWord);   
begin
  SetDWord(Index, D3DSAMP_SRGBTEXTURE, Value);
end;

function TG2SamplerStates.GetElementIndex(const Index: Byte): DWord;                 
begin
  Result := GetDWord(Index, D3DSAMP_ELEMENTINDEX);
end;

procedure TG2SamplerStates.SetElementIndex(const Index: Byte; const Value: DWord);  
begin
  SetDWord(Index, D3DSAMP_ELEMENTINDEX, Value);
end;

function TG2SamplerStates.GetDMapOffset(const Index: Byte): DWord;                
begin
  Result := GetDWord(Index, D3DSAMP_DMAPOFFSET);
end;

procedure TG2SamplerStates.SetDMapOffset(const Index: Byte; const Value: DWord);   
begin
  SetDWord(Index, D3DSAMP_DMAPOFFSET, Value);
end;

procedure TG2SamplerStates.SetDefaults;
var
  i: Integer;
  MaxSamplers: Integer;
begin
  MaxSamplers := m_G2Graphics.Caps.MaxTextureBlendStages;
  for i := 0 to MaxSamplers - 1 do
  begin
    AddressU[i] := D3DTADDRESS_WRAP;
    AddressV[i] := D3DTADDRESS_WRAP;
    AddressW[i] := D3DTADDRESS_WRAP;
    BorderColor[i] := 0;
    MagFilter[i] := D3DTEXF_POINT;
    MinFilter[i] := D3DTEXF_POINT;
    MipFilter[i] := D3DTEXF_NONE;
    MipMapLODBias[i] := 0;
    MaxMipLevel[i] := 0;
    MaxAnisotropy[i] := 1;
    SRGBTexture[i] := 0;
    ElementIndex[i] := 0;
    DMapOffset[i] := 0;
  end;
end;

procedure TG2SamplerStates.SetFromMemory;
var
  i, j: Integer;
  MaxSamplers: Integer;
begin
  MaxSamplers := m_G2Graphics.Caps.MaxTextureBlendStages;
  for i := 0 to MaxSamplers - 1 do
  for j := 1 to 13 do
  SetDWord(i, TD3DSamplerStateType(j), m_States[i, j]);
end;
//TG2SamplerStates END

//TG2TextureStageStates BEGIN
constructor TG2TextureStageStates.Create;
begin
  inherited Create;
end;

destructor TG2TextureStageStates.Destroy;
begin
  inherited Destroy;
end;

function TG2TextureStageStates.GetDWord(const Index: Byte; const StageType: TD3DTextureStageStateType): DWord;
begin
  m_G2Graphics.Device.GetTextureStageState(Index, StageType, Result);
end;

procedure TG2TextureStageStates.SetDWord(const Index: Byte; const StageType: TD3DTextureStageStateType; const Value: DWord);
begin
  m_States[Index, Byte(StageType)] := Value;
  m_G2GRaphics.Device.SetTextureStageState(Index, StageType, Value);
end;

function TG2TextureStageStates.GetSingle(const Index: Byte; const StageType: TD3DTextureStageStateType): Single;
var
  Value: DWord;
begin
  m_G2Graphics.Device.GetTextureStageState(Index, StageType, Value);
  Result := PSingle(@Value)^;
end;

procedure TG2TextureStageStates.SetSingle(const Index: Byte; const StageType: TD3DTextureStageStateType; const Value: Single);
begin
  m_States[Index, Byte(StageType)] := PDWord(@Value)^;
  m_G2Graphics.Device.SetTextureStageState(Index, StageType, PDWord(@Value)^);
end;

function TG2TextureStageStates.GetColorOp(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_COLOROP);
end;

procedure TG2TextureStageStates.SetColorOp(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_COLOROP, Value);
end;

function TG2TextureStageStates.GetColorArg0(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_COLORARG0);
end;

procedure TG2TextureStageStates.SetColorArg0(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_COLORARG0, Value);
end;

function TG2TextureStageStates.GetColorArg1(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_COLORARG1);
end;

procedure TG2TextureStageStates.SetColorArg1(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_COLORARG1, Value);
end;

function TG2TextureStageStates.GetColorArg2(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_COLORARG2);
end;

procedure TG2TextureStageStates.SetColorArg2(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_COLORARG2, Value);
end;

function TG2TextureStageStates.GetAlphaOp(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_ALPHAOP);
end;

procedure TG2TextureStageStates.SetAlphaOp(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_ALPHAOP, Value);
end;

function TG2TextureStageStates.GetAlphaArg0(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_ALPHAARG0);
end;

procedure TG2TextureStageStates.SetAlphaArg0(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_ALPHAARG0, Value);
end;

function TG2TextureStageStates.GetAlphaArg1(const Index: Byte): DWord;                       
begin
  Result := GetDWord(Index, D3DTSS_ALPHAARG1);
end;

procedure TG2TextureStageStates.SetAlphaArg1(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_ALPHAARG1, Value);
end;

function TG2TextureStageStates.GetAlphaArg2(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_ALPHAARG2);
end;

procedure TG2TextureStageStates.SetAlphaArg2(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_ALPHAARG2, Value);
end;

function TG2TextureStageStates.GetBumpEnvMat00(const Index: Byte): Single;
begin
  Result := GetSingle(Index, D3DTSS_BUMPENVMAT00);
end;

procedure TG2TextureStageStates.SetBumpEnvMat00(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DTSS_BUMPENVMAT00, Value);
end;

function TG2TextureStageStates.GetBumpEnvMat01(const Index: Byte): Single;
begin
  Result := GetSingle(Index, D3DTSS_BUMPENVMAT01);
end;

procedure TG2TextureStageStates.SetBumpEnvMat01(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DTSS_BUMPENVMAT01, Value);
end;

function TG2TextureStageStates.GetBumpEnvMat10(const Index: Byte): Single;
begin
  Result := GetSingle(Index, D3DTSS_BUMPENVMAT10);
end;

procedure TG2TextureStageStates.SetBumpEnvMat10(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DTSS_BUMPENVMAT10, Value);
end;

function TG2TextureStageStates.GetBumpEnvMat11(const Index: Byte): Single;
begin
  Result := GetSingle(Index, D3DTSS_BUMPENVMAT11);
end;

procedure TG2TextureStageStates.SetBumpEnvMat11(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DTSS_BUMPENVMAT11, Value);
end;

function TG2TextureStageStates.GetTexCoordIndex(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_TEXCOORDINDEX);
end;

procedure TG2TextureStageStates.SetTexCoordIndex(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_TEXCOORDINDEX, Value);
end;

function TG2TextureStageStates.GetBumpEnvLScale(const Index: Byte): Single;
begin
  Result := GetSingle(Index, D3DTSS_BUMPENVLSCALE);
end;

procedure TG2TextureStageStates.SetBumpEnvLScale(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DTSS_BUMPENVLSCALE, Value);
end;

function TG2TextureStageStates.GetBumpEnvLOffset(const Index: Byte): Single;
begin
  Result := GetSingle(Index, D3DTSS_BUMPENVLOFFSET);
end;

procedure TG2TextureStageStates.SetBumpEnvLOffset(const Index: Byte; const Value: Single);
begin
  SetSingle(Index, D3DTSS_BUMPENVLOFFSET, Value);
end;

function TG2TextureStageStates.GetTextureTransformFlags(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_TEXTURETRANSFORMFLAGS);
end;

procedure TG2TextureStageStates.SetTextureTransformFlags(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_TEXTURETRANSFORMFLAGS, Value);
end;

function TG2TextureStageStates.GetResultArg(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_RESULTARG);
end;

procedure TG2TextureStageStates.SetResultArg(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_RESULTARG, Value);
end;

function TG2TextureStageStates.GetConstant(const Index: Byte): DWord;
begin
  Result := GetDWord(Index, D3DTSS_CONSTANT);
end;

procedure TG2TextureStageStates.SetConstant(const Index: Byte; const Value: DWord);
begin
  SetDWord(Index, D3DTSS_CONSTANT, Value);
end;

procedure TG2TextureStageStates.SetDefaults;
var
  i: Integer;
  MaxStages: Integer;
begin
  MaxStages := m_G2GRaphics.Caps.MaxTextureBlendStages;
  ColorOp[0] := D3DTOP_MODULATE;
  ColorArg0[0] := D3DTA_CURRENT;
  ColorArg1[0] := D3DTA_TEXTURE;
  ColorArg2[0] := D3DTA_DIFFUSE;
  AlphaOp[0] := D3DTOP_MODULATE;
  AlphaArg0[0] := D3DTA_CURRENT;
  AlphaArg1[0] := D3DTA_TEXTURE;
  AlphaArg2[0] := D3DTA_DIFFUSE;
  BumpEnvMat00[0] := 0;
  BumpEnvMat01[0] := 0;
  BumpEnvMat10[0] := 0;
  BumpEnvMat11[0] := 0;
  TexCoordIndex[0] := 0;
  BumpEnvLScale[0] := 0;
  BumpEnvLOffset[0] := 0;
  TextureTransformFlags[0] := D3DTTFF_DISABLE;
  ResultArg[0] := D3DTA_CURRENT;
  Constant[0] := 0;
  for i := 1 to MaxStages - 1 do
  begin
    ColorOp[i] := D3DTOP_DISABLE;
    ColorArg0[i] := D3DTA_CURRENT;
    ColorArg1[i] := D3DTA_TEXTURE;
    ColorArg2[i] := D3DTA_CURRENT;
    AlphaOp[i] := D3DTOP_DISABLE;
    AlphaArg0[i] := D3DTA_CURRENT;
    AlphaArg1[i] := D3DTA_DIFFUSE;
    AlphaArg2[i] := D3DTA_CURRENT;
    BumpEnvMat00[i] := 0;
    BumpEnvMat01[i] := 0;
    BumpEnvMat10[i] := 0;
    BumpEnvMat11[i] := 0;
    TexCoordIndex[i] := i;
    BumpEnvLScale[i] := 0;
    BumpEnvLOffset[i] := 0;
    TextureTransformFlags[i] := D3DTTFF_DISABLE;
    ResultArg[i] := D3DTA_CURRENT;
    Constant[i] := 0;
  end;
end;

procedure TG2TextureStageStates.SetFromMemory;
  procedure ResetState(const Index: Byte; const StageType: TD3DTextureStageStateType);
  begin
    SetDWord(Index, StageType, m_States[Index, Byte(StageType)]);
  end;
var
  i: Integer;
  MaxStages: Integer;
begin
  MaxStages := m_G2GRaphics.Caps.MaxTextureBlendStages;
  for i := 0 to MaxStages - 1 do
  begin
    ResetState(i, D3DTSS_COLOROP);
    ResetState(i, D3DTSS_COLORARG1);
    ResetState(i, D3DTSS_COLORARG2);
    ResetState(i, D3DTSS_ALPHAOP);
    ResetState(i, D3DTSS_ALPHAARG1);
    ResetState(i, D3DTSS_ALPHAARG2);
    ResetState(i, D3DTSS_BUMPENVMAT00);
    ResetState(i, D3DTSS_BUMPENVMAT01);
    ResetState(i, D3DTSS_BUMPENVMAT10);
    ResetState(i, D3DTSS_BUMPENVMAT11);
    ResetState(i, D3DTSS_TEXCOORDINDEX);
    ResetState(i, D3DTSS_BUMPENVLSCALE);
    ResetState(i, D3DTSS_BUMPENVLOFFSET);
    ResetState(i, D3DTSS_TEXTURETRANSFORMFLAGS);
    ResetState(i, D3DTSS_COLORARG0);
    ResetState(i, D3DTSS_ALPHAARG0);
    ResetState(i, D3DTSS_RESULTARG);
    ResetState(i, D3DTSS_CONSTANT);
  end;
end;
//TG2TextureStageStates END

//TG2SharedVB2D BEGIN
constructor TG2SharedVB2D.Create;
begin
  inherited Create;
  m_Size := 0;
end;

destructor TG2SharedVB2D.Destroy;
begin
  SafeRelease(m_VB);
  inherited Destroy;
end;

function TG2SharedVB2D.InitializeBuffer(const Size: Integer): TG2Result;
begin
  SafeRelease(m_VB);
  m_Size := Size;
  if Failed(
    m_G2Graphics.Device.CreateVertexBuffer(
      SizeOf(TG2SharedVertex2D) * m_Size,
      D3DUSAGE_DYNAMIC,
      TG2SharedVertex2DFVF,
      D3DPOOL_DEFAULT,
      m_VB,
      nil
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  Result := grOk;
end;

procedure TG2SharedVB2D.OnDeviceLost;
begin
  SafeRelease(m_VB);
end;

procedure TG2SharedVB2D.OnDeviceReset;
begin
  InitializeBuffer(m_Size);
end;

procedure TG2SharedVB2D.Initialize(const G2Graphics: TG2Graphics);
begin
  m_G2Graphics := G2Graphics;
  InitializeBuffer(256);
end;

procedure TG2SharedVB2D.Finalize;
begin
  SafeRelease(m_VB);
end;

procedure TG2SharedVB2D.SetToDevice;
begin
  m_G2Graphics.Device.SetFVF(TG2SharedVertex2DFVF);
  m_G2Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2SharedVertex2D));
end;

function TG2SharedVB2D.VerifySize(const Size: Integer): TG2Result;
begin
  if m_Size < Size then
  Result := InitializeBuffer(Size)
  else
  Result := grOk;
end;
//TG2SharedVB2D END

//TG2Redner BEGIN
constructor TG2Render.Create;
begin
  inherited Create;
end;

destructor TG2Render.Destroy;
begin
  inherited Destroy;
end;

function TG2Render.GetCanRender: Boolean;
begin
  Result := m_G2Graphics.CanRender;
end;

function TG2Render.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_G2Graphics := Core.Graphics;
  Result := grOk;
end;

function TG2Render.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2Render.RenderStart: TG2Result;
begin
  if Succeeded(m_G2Graphics.Device.BeginScene) then
  Result := grOk
  else
  Result := grFail;
end;

function TG2Render.RenderStop: TG2Result;
begin
  if Succeeded(m_G2Graphics.Device.EndScene) then
  Result := grOk
  else
  Result := grFail;
end;

function TG2Render.Present: TG2Result;
var
  hr: HResult;
begin
  if m_G2Graphics.m_CurSwapChain = nil then
  hr := m_G2Graphics.Device.Present(nil, nil, 0, nil)
  else
  hr := m_G2Graphics.m_CurSwapChain.SwapChain.Present(nil, nil, 0, nil, D3DPRESENT_DONOTWAIT);
  if Succeeded(hr) then
  Result := grOk
  else
  Result := grFail;
end;

procedure TG2Render.Clear(
      ClearStencil: Boolean;
      ClearZBuffer: Boolean;
      ClearTarget: Boolean;
      Color: TG2Color;
      Depth: Single = 1;
      Stencil: DWord = 0
    );
var
  ClearObject: byte;
begin
  ClearObject := 0;
  if ClearStencil then
  ClearObject := ClearObject or D3DCLEAR_STENCIL;
  if ClearZBuffer then
  ClearObject := ClearObject or D3DCLEAR_ZBUFFER;
  if ClearTarget then
  ClearObject := ClearObject or D3DCLEAR_TARGET;
  m_G2Graphics.Device.Clear(
    0,
    nil,
    ClearObject,
    Color,
    Depth,
    Stencil
  );
end;

procedure TG2Render.TextureClear(const Stage: Byte = 0);
begin
  m_G2Graphics.Device.SetTexture(Stage, nil);
end;

procedure TG2Render.TextureSet(const Texture: TG2TextureBase; const Stage: Byte = 0);
begin
  m_G2Graphics.Device.SetTexture(Stage, Texture.Texture);
end;
//TG2Render END

//TG2RenderModes BEGIN
constructor TG2RenderModes.Create;
begin
  inherited Create;
end;

destructor TG2RenderModes.Destroy;
begin
  inherited Destroy;
end;

procedure TG2RenderModes.BlendModeNormal;
begin
  with Core.Graphics do
  begin
    RenderStates.SrcBlend := D3DBLEND_SRCALPHA;
    RenderStates.DestBlend := D3DBLEND_INVSRCALPHA;
  end;
end;

procedure TG2RenderModes.BlendModeAdd;
begin
  with Core.Graphics do
  begin
    RenderStates.SrcBlend := D3DBLEND_SRCALPHA;
    RenderStates.DestBlend := D3DBLEND_DESTALPHA;
  end;
end;

procedure TG2RenderModes.FilteringPoint(const Stage: Byte = 0);
begin
  with Core.Graphics do
  begin
    SamplerStates.MagFilter[Stage] := D3DTEXF_POINT;
    SamplerStates.MinFilter[Stage] := D3DTEXF_POINT;
    SamplerStates.MipFilter[Stage] := D3DTEXF_POINT;
  end;
end;

procedure TG2RenderModes.FilteringLinear(const Stage: Byte = 0);
begin
  with Core.Graphics do
  begin
    SamplerStates.MagFilter[Stage] := D3DTEXF_LINEAR;
    SamplerStates.MinFilter[Stage] := D3DTEXF_LINEAR;
    SamplerStates.MipFilter[Stage] := D3DTEXF_LINEAR;
  end;
end;

procedure TG2RenderModes.FilteringAnisotropic(const Stage: Byte = 0; const MaxAnisotropy: Integer = 8);
begin
  with Core.Graphics do
  begin
    SamplerStates.MagFilter[Stage] := D3DTEXF_ANISOTROPIC;
    SamplerStates.MinFilter[Stage] := D3DTEXF_ANISOTROPIC;
    SamplerStates.MipFilter[Stage] := D3DTEXF_ANISOTROPIC;
    SamplerStates.MaxAnisotropy[Stage] := MaxAnisotropy;
  end;
end;

procedure TG2RenderModes.TexAddressClamp(const Stage: Byte = 0);
begin
  with Core.Graphics do
  begin
    SamplerStates.AddressU[Stage] := D3DTADDRESS_CLAMP;
    SamplerStates.AddressV[Stage] := D3DTADDRESS_CLAMP;
    SamplerStates.AddressW[Stage] := D3DTADDRESS_CLAMP;
  end;
end;

procedure TG2RenderModes.TexAddressWrap(const Stage: Byte = 0);
begin
  with Core.Graphics do
  begin
    SamplerStates.AddressU[Stage] := D3DTADDRESS_WRAP;
    SamplerStates.AddressV[Stage] := D3DTADDRESS_WRAP;
    SamplerStates.AddressW[Stage] := D3DTADDRESS_WRAP;
  end;
end;

procedure TG2RenderModes.TexAddressBorder(const Stage: Byte = 0);
begin
  with Core.Graphics do
  begin
    SamplerStates.AddressU[Stage] := D3DTADDRESS_BORDER;
    SamplerStates.AddressV[Stage] := D3DTADDRESS_BORDER;
    SamplerStates.AddressW[Stage] := D3DTADDRESS_BORDER;
  end;
end;

procedure TG2RenderModes.TexAddressMirror(const Stage: Byte = 0);
begin
  with Core.Graphics do
  begin
    SamplerStates.AddressU[Stage] := D3DTADDRESS_MIRROR;
    SamplerStates.AddressV[Stage] := D3DTADDRESS_MIRROR;
    SamplerStates.AddressW[Stage] := D3DTADDRESS_MIRROR;
  end;
end;

function TG2RenderModes.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2RenderModes.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2RenderModes END

//TG2Render2D BEGIN
constructor TG2Render2D.Create;
begin
  inherited Create;
  m_VBSize := 0;
end;

destructor TG2Render2D.Destroy;
begin
  inherited Destroy;
end;

function TG2Render2D.VerifyBuffer(const Size: Integer): TG2Result;
begin
  Result := grOk;
  if (Size > m_VBSize)
  or (m_VB = nil) then
  begin
    SafeRelease(m_VB);
    if Succeeded(
      m_G2Graphics.Device.CreateVertexBuffer(
        Size * SizeOf(TVertex),
        D3DUSAGE_DYNAMIC,
        FVF,
        D3DPOOL_DEFAULT,
        m_VB,
        nil
      )
    ) then
    begin
      m_VBSize := Size;
    end
    else
    Result := grFail;
  end;
end;

function TG2Render2D.VerifyBuffer2(const Size: Integer): TG2Result;
begin
  Result := grOk;
  if (Size > m_VB2Size)
  or (m_VB2 = nil) then
  begin
    SafeRelease(m_VB2);
    if Succeeded(
      m_G2Graphics.Device.CreateVertexBuffer(
        Size * SizeOf(TVertex2),
        D3DUSAGE_DYNAMIC,
        FVF2,
        D3DPOOL_DEFAULT,
        m_VB2,
        nil
      )
    ) then
    begin
      m_VB2Size := Size;
    end
    else
    Result := grFail;
  end;
end;

function TG2Render2D.VerifyIndices(const Size: Integer): TG2Result;
begin
  Result := grOk;
  if (Size > m_IBSize)
  or (m_IB = nil) then
  begin
    SafeRelease(m_IB);
    if Succeeded(
      m_G2Graphics.Device.CreateIndexBuffer(
        Size * SizeOf(Word),
        D3DUSAGE_DYNAMIC,
        D3DFMT_INDEX16,
        D3DPOOL_DEFAULT,
        m_IB,
        nil
      )
    ) then
    begin
      m_IBSize := Size;
    end
    else
    Result := grFail;
  end;
end;

procedure TG2Render2D.OnDeviceLost;
begin
  SafeRelease(m_VB);
  SafeRelease(m_VB2);
  SafeRelease(m_IB);
end;

procedure TG2Render2D.OnDeviceReset;
begin
  VerifyBuffer(m_VBSize);
  VerifyBuffer2(m_VB2Size);
  VerifyIndices(m_IBSize);
end;

function TG2Render2D.LoadBuffers: TG2Result;
var
  i: Integer;
  Vertices: PVertexArray;
  Indices: PG2Index16Array;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer(m_CurPos)) then Exit;
  if (m_CurTex < m_CurPos) then
  begin
    if Length(m_TexArr) < Length(m_PosArr) then
    SetLength(m_TexArr, Length(m_PosArr));
    FillChar(m_TexArr[m_CurTex], (m_CurPos - m_CurTex) * 8, 0);
  end;
  if (m_CurCol < m_CurPos) then
  begin
    if Length(m_ColArr) < Length(m_PosArr) then
    SetLength(m_ColArr, Length(m_PosArr));
    FillChar(m_ColArr[m_CurCol], (m_CurPos - m_CurCol) * 4, $ff);
  end;

  hr := m_VB.Lock(0, SizeOf(TVertex) * m_CurPos, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  try
    for i := 0 to m_CurPos - 1 do
    begin
      Move(m_PosArr[i].x, Vertices^[i].x, 8);
      Vertices^[i].z := 0;
      Vertices^[i].rhw := 1;
      Vertices^[i].Color := m_ColArr[i];
      Move(m_TexArr[i].x, Vertices^[i].tu, 8);
    end;
  finally
    hr := m_VB.Unlock;
  end;
  if Failed(hr) then Exit;

  if m_CurInd > 0 then
  begin
    if G2ResFail(VerifyIndices(m_CurInd)) then Exit;
    hr := m_IB.Lock(0, m_CurInd, Pointer(Indices), D3DLOCK_DISCARD);
    try
      Move(m_IndArr[0], Indices^[0], m_CurInd * 2);
      m_G2Graphics.Device.SetIndices(m_IB);
    finally
      hr := m_IB.Unlock;
    end;
    if Failed(hr) then Exit;
  end;

  hr := m_G2Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render2D.DrawPointList: TG2Result;
var
  hr: HResult;
begin
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_POINTLIST, 0, m_CurPos);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render2D.DrawLineList: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := m_G2Graphics.Device.DrawIndexedPrimitive(D3DPT_LINELIST, 0, 0, m_CurPos, 0, m_CurInd div 2)
  else
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_LINELIST, 0, m_CurPos div 2);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render2D.DrawLineStrip: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := m_G2Graphics.Device.DrawIndexedPrimitive(D3DPT_LINESTRIP, 0, 0, m_CurPos, 0, m_CurInd - 1)
  else
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_LINESTRIP, 0, m_CurPos - 1);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render2D.DrawTriangleList: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := m_G2Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurPos, 0, m_CurInd div 3)
  else
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_TRIANGLELIST, 0, m_CurPos div 3);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render2D.DrawTriangleStrip: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := m_G2Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLESTRIP, 0, 0, m_CurPos, 0, m_CurInd - 2)
  else
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, m_CurPos - 2);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render2D.DrawTriangleFan: TG2Result; 
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := m_G2Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLEFAN, 0, 0, m_CurPos, 0, m_CurInd - 2)
  else
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_TRIANGLEFAN, 0, m_CurPos - 2);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render2D.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_G2Graphics := Core.Graphics;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  VerifyBuffer(4);
  VerifyBuffer2(4);
  VerifyIndices(6);
  SetLength(m_PosArr, 4);
  SetLength(m_ColArr, 4);
  SetLength(m_TexArr, 4);
  SetLength(m_IndArr, 4);
  Result := grOk;
end;

function TG2Render2D.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  SafeRelease(m_VB2);
  SafeRelease(m_VB);
  Result := grOk;
end;

function TG2Render2D.DrawQuad(
      const v1, v2, v3, v4: TG2Vec2;
      const c1, c2, c3, c4: TG2Color;
      const Texture: TG2Texture2DBase;
      const tc1, tc2, tc3, tc4: TG2Vec2
    ): TG2Result;
var
  Vertices: PVertexArray;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer(4)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * 4, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  Vertices^[0].x := v1.X; Vertices^[0].y := v1.Y; Vertices^[0].z := 0;
  Vertices^[0].rhw := 1; Vertices^[0].Color := c1;
  Vertices^[0].tu := tc1.X; Vertices^[0].tv := tc1.Y;

  Vertices^[1].x := v2.X; Vertices^[1].y := v2.Y; Vertices^[0].z := 0;
  Vertices^[1].rhw := 1; Vertices^[1].Color := c2;
  Vertices^[1].tu := tc2.X; Vertices^[1].tv := tc2.Y;

  Vertices^[2].x := v3.X; Vertices^[2].y := v3.Y; Vertices^[0].z := 0;
  Vertices^[2].rhw := 1; Vertices^[2].Color := c3;
  Vertices^[2].tu := tc3.X; Vertices^[2].tv := tc3.Y;

  Vertices^[3].x := v4.X; Vertices^[3].y := v4.Y; Vertices^[0].z := 0;
  Vertices^[3].rhw := 1; Vertices^[3].Color := c4;
  Vertices^[3].tu := tc4.X; Vertices^[3].tv := tc4.Y;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;

  hr := m_G2Graphics.Device.SetTexture(0, Texture.Texture);
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render2D.DrawRect(
      const X, Y, Width, Height: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase
    ): TG2Result;
begin
  Result := DrawQuad(
    G2Vec2(X, Y), G2Vec2(X + Width, Y), G2Vec2(X, Y + Height), G2Vec2(X + Width, Y + Height),
    Color, Color, Color, Color,
    Texture,
    G2Vec2(Texture.DrawRect^.Left, Texture.DrawRect^.Top),
    G2Vec2(Texture.DrawRect^.Right, Texture.DrawRect^.Top),
    G2Vec2(Texture.DrawRect^.Left, Texture.DrawRect^.Bottom),
    G2Vec2(Texture.DrawRect^.Right, Texture.DrawRect^.Bottom)
  );
end;

function TG2Render2D.DrawRect(
      const X, Y, Width, Height: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const Rotation: Single;
      const ScaleX, ScaleY: Single;
      const FlipLeftRight: Boolean;
      const FlipTopBottom: Boolean
    ): TG2Result;
var
  v1, v2, v3, v4: TG2Vec2;
  tc1, tc2, tc3, tc4: TG2Vec2;
  m, mr, ms: TG2Mat2;
  hw, hh: Single;
  VShift: TG2Vec2;
begin
  ms.SetScaling(ScaleX, ScaleY);
  mr.SetRotation(Rotation);
  m := ms * mr;
  hw := Width * 0.5;
  hh := Height * 0.5;
  VShift := G2Vec2(hw + X, hh + Y);
  v1 := G2Vec2(-hw, -hh) * m + VShift;
  v2 := G2Vec2(hw, -hh) * m + VShift;
  v3 := G2Vec2(-hw, hh) * m + VShift;
  v4 := G2Vec2(hw, hh) * m + VShift;
  if FlipLeftRight then
  begin
    tc1.X := Texture.DrawRect^.Right; tc2.X := Texture.DrawRect^.Left;
    tc3.X := Texture.DrawRect^.Right; tc4.X := Texture.DrawRect^.Left;
  end
  else
  begin
    tc1.X := Texture.DrawRect^.Left; tc2.X := Texture.DrawRect^.Right;
    tc3.X := Texture.DrawRect^.Left; tc4.X := Texture.DrawRect^.Right;
  end;
  if FlipTopBottom then
  begin
    tc1.Y := Texture.DrawRect^.Bottom; tc3.Y := Texture.DrawRect^.Top;
    tc2.Y := Texture.DrawRect^.Bottom; tc4.Y := Texture.DrawRect^.Top;
  end
  else
  begin
    tc1.Y := Texture.DrawRect^.Top; tc3.Y := Texture.DrawRect^.Bottom;
    tc2.Y := Texture.DrawRect^.Top; tc4.Y := Texture.DrawRect^.Bottom;
  end;
  Result := DrawQuad(
    v1, v2, v3, v4,
    Color, Color, Color, Color,
    Texture,
    tc1, tc2, tc3, tc4
  );
end;

function TG2Render2D.DrawQuad2(
      const v1, v2, v3, v4: TG2Vec2;
      const c1, c2, c3, c4: TG2Color;
      const Texture0: TG2Texture2DBase;
      const t0c1, t0c2, t0c3, t0c4: TG2Vec2;
      const Texture1: TG2Texture2DBase;
      const t1c1, t1c2, t1c3, t1c4: TG2Vec2
    ): TG2Result;
var
  Vertices: PVertex2Array;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer2(4)) then Exit;
  hr := m_VB2.Lock(0, SizeOf(TVertex2) * 4, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  Vertices^[0].x := v1.X; Vertices^[0].y := v1.Y; Vertices^[0].z := 0;
  Vertices^[0].rhw := 1; Vertices^[0].Color := c1;
  Vertices^[0].tu1 := t0c1.X; Vertices^[0].tv1 := t0c1.Y;
  Vertices^[0].tu2 := t1c1.X; Vertices^[0].tv2 := t1c1.Y;

  Vertices^[1].x := v2.X; Vertices^[1].y := v2.Y; Vertices^[0].z := 0;
  Vertices^[1].rhw := 1; Vertices^[1].Color := c2;
  Vertices^[1].tu1 := t0c2.X; Vertices^[1].tv1 := t0c2.Y;
  Vertices^[1].tu2 := t1c2.X; Vertices^[1].tv2 := t1c2.Y;

  Vertices^[2].x := v3.X; Vertices^[2].y := v3.Y; Vertices^[0].z := 0;
  Vertices^[2].rhw := 1; Vertices^[2].Color := c3;
  Vertices^[2].tu1 := t0c3.X; Vertices^[2].tv1 := t0c3.Y;
  Vertices^[2].tu2 := t1c3.X; Vertices^[2].tv2 := t1c3.Y;

  Vertices^[3].x := v4.X; Vertices^[3].y := v4.Y; Vertices^[0].z := 0;
  Vertices^[3].rhw := 1; Vertices^[3].Color := c4;
  Vertices^[3].tu1 := t0c4.X; Vertices^[3].tv1 := t0c4.Y;
  Vertices^[3].tu2 := t1c4.X; Vertices^[3].tv2 := t1c4.Y;
  hr := m_VB2.Unlock;
  if Failed(hr) then Exit;

  hr := m_G2Graphics.Device.SetTexture(0, Texture0.Texture);
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.SetTexture(1, Texture1.Texture);
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.SetFVF(FVF2);
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.SetStreamSource(0, m_VB2, 0, SizeOf(TVertex2));
  if Failed(hr) then Exit;
  hr := m_G2Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render2D.DrawBegin(const PrimType: TG2PrimType): TG2Result;
begin
  if m_Drawing then
  begin
    Result := grInvalidCall;
    Exit;
  end;
  m_CurPos := 0;
  m_CurCol := 0;
  m_CurTex := 0;
  m_CurInd := 0;
  m_Drawing := True;
  m_PrimType := PrimType;
  Result := grOk;
end;

procedure TG2Render2D.AddPos(const p: TG2Vec2);
begin
  if High(m_PosArr) < m_CurPos then
  SetLength(m_PosArr, Length(m_PosArr) * 2);
  m_PosArr[m_CurPos] := p;
  Inc(m_CurPos);
end;

procedure TG2Render2D.AddCol(const c: TG2Color);
begin
  if High(m_ColArr) < m_CurCol then
  SetLength(m_ColArr, Length(m_ColArr) * 2);
  m_ColArr[m_CurCol] := c;
  Inc(m_CurCol);
end;

procedure TG2Render2D.AddTex(const t: TG2Vec2);
begin
  if High(m_TexArr) < m_CurTex then
  SetLength(m_TexArr, Length(m_TexArr) * 2);
  m_TexArr[m_CurTex] := t;
  Inc(m_CurTex);
end;

procedure TG2Render2D.AddInd(const i: Word);
begin
  if High(m_IndArr) < m_CurInd then
  SetLength(m_IndArr, Length(m_IndArr) * 2);
  m_IndArr[m_CurInd] := i;
  Inc(m_CurInd);
end;

function TG2Render2D.DrawEnd: TG2Result;
begin
  if not m_Drawing then
  begin
    Result := grInvalidCall;
    Exit;
  end;

  m_Drawing := False;

  Result := LoadBuffers;
  if G2ResOk(Result) then
  case m_PrimType of
    ptPointList: Result := DrawPointList;
    ptLineList: Result := DrawLineList;
    ptLineStrip: Result := DrawLineStrip;
    ptTriangleList: Result := DrawTriangleList;
    ptTriangleStrip: Result := DrawTriangleStrip;
    ptTriangleFan: Result := DrawTriangleFan;
  end;
end;
//TG2Render2D END

//TG2Render3D BEGIN
constructor TG2Render3D.Create;
begin
  inherited Create;
  m_VBSize := 0;
  m_IBSize := 0;
end;

destructor TG2Render3D.Destroy;
begin
  inherited Destroy;
end;

function TG2Render3D.VerifyVB(const Size: Integer): TG2Result;
begin
  if (Size <= m_VBSize)
  and Assigned(m_VB) then
  begin
    Result := grOk;
    Exit;
  end;
  m_VBSize := Size;
  SafeRelease(m_VB);
  if Failed(
    Core.Graphics.Device.CreateVertexBuffer(
      m_VBSize * SizeOf(TVertex),
      D3DUSAGE_DYNAMIC,
      FVF,
      D3DPOOL_DEFAULT,
      m_VB,
      nil
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  Result := grOk;
end;

function TG2Render3D.VerifyIB(const Size: Integer): TG2Result;
begin
  if (Size <= m_IBSize)
  and Assigned(m_IB) then
  begin
    Result := grOk;
    Exit;
  end;
  m_IBSize := Size;
  SafeRelease(m_IB);
  if Failed(
    Core.Graphics.Device.CreateIndexBuffer(
      m_IBSize * SizeOf(Word),
      D3DUSAGE_DYNAMIC,
      D3DFMT_INDEX16,
      D3DPOOL_DEFAULT,
      m_IB,
      nil
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  Result := grOk;
end;

function TG2Render3D.AddVertex(
      const X, Y, Z: Single;
      const Color: TG2Color;
      const NX, NY, NZ: Single;
      const TU: Single = 0;
      const TV: Single = 0
    ): Word;
begin
  m_Vertices^[m_CurV].x := X;
  m_Vertices^[m_CurV].y := Y;
  m_Vertices^[m_CurV].z := Z;
  m_Vertices^[m_CurV].Color := Color;
  m_Vertices^[m_CurV].nx := NX;
  m_Vertices^[m_CurV].ny := NY;
  m_Vertices^[m_CurV].nz := NZ;
  m_Vertices^[m_CurV].tu := TU;
  m_Vertices^[m_CurV].tv := TV;
  Result := m_CurV;
  Inc(m_CurV);
end;

procedure TG2Render3D.AddFace(
      const v1, v2, v3: Word
    );
begin
  m_Indices^[m_CurI] := v1;
  m_Indices^[m_CurI + 1] := v2;
  m_Indices^[m_CurI + 2] := v3;
  Inc(m_CurI, 3);
end;

procedure TG2Render3D.OnDeviceLost;
begin
  SafeRelease(m_VB);
  SafeRelease(m_IB);
end;

procedure TG2Render3D.OnDeviceReset;
begin
  VerifyVB(m_VBSize);
  VerifyIB(m_IBSize);
end;

function TG2Render3D.LoadBuffers: TG2Result;
var
  i: Integer;
  Vertices: PVertexArray;
  Indices: PG2Index16Array;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(m_CurPos)) then Exit;
  if (m_CurTex < m_CurPos) then
  begin
    if Length(m_TexArr) < Length(m_PosArr) then
    SetLength(m_TexArr, Length(m_PosArr));
    FillChar(m_TexArr[m_CurTex], (m_CurPos - m_CurTex) * 8, 0);
  end;
  if (m_CurCol < m_CurPos) then
  begin
    if Length(m_ColArr) < Length(m_PosArr) then
    SetLength(m_ColArr, Length(m_PosArr));
    FillChar(m_ColArr[m_CurCol], (m_CurPos - m_CurCol) * 4, $ff);
  end;
  if (m_CurNrm < m_CurPos) then
  begin
    if Length(m_NrmArr) < Length(m_PosArr) then
    SetLength(m_NrmArr, Length(m_PosArr));
    FillChar(m_NrmArr[m_CurNrm], (m_CurPos - m_CurNrm) * 12, 0);
  end;

  hr := m_VB.Lock(0, SizeOf(TVertex) * m_CurPos, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  try
    for i := 0 to m_CurPos - 1 do
    begin
      Move(m_PosArr[i].x, Vertices^[i].x, 12);
      Vertices^[i].Color := m_ColArr[i];
      Move(m_TexArr[i].x, Vertices^[i].tu, 8);
      Move(m_NrmArr[i].x, Vertices^[i].nx, 12);
    end;
  finally
    hr := m_VB.Unlock;
  end;
  if Failed(hr) then Exit;

  if m_CurInd > 0 then
  begin
    if G2ResFail(VerifyIB(m_CurInd)) then Exit;
    hr := m_IB.Lock(0, m_CurInd, Pointer(Indices), D3DLOCK_DISCARD);
    try
      Move(m_IndArr[0], Indices^[0], m_CurInd * 2);
      Core.Graphics.Device.SetIndices(m_IB);
    finally
      hr := m_IB.Unlock;
    end;
    if Failed(hr) then Exit;
  end;

  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render3D.DrawPointList: TG2Result;
var
  hr: HResult;
begin
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_POINTLIST, 0, m_CurPos);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render3D.DrawLineList: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_LINELIST, 0, 0, m_CurPos, 0, m_CurInd div 2)
  else
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_LINELIST, 0, m_CurPos div 2);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render3D.DrawLineStrip: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_LINESTRIP, 0, 0, m_CurPos, 0, m_CurInd - 1)
  else
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_LINESTRIP, 0, m_CurPos - 1);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render3D.DrawTriangleList: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurPos, 0, m_CurInd div 3)
  else
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLELIST, 0, m_CurPos div 3);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render3D.DrawTriangleStrip: TG2Result;
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLESTRIP, 0, 0, m_CurPos, 0, m_CurInd - 2)
  else
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, m_CurPos - 2);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render3D.DrawTriangleFan: TG2Result; 
var
  hr: HResult;
begin
  if m_CurInd > 0 then
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLEFAN, 0, 0, m_CurPos, 0, m_CurInd - 2)
  else
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLEFAN, 0, m_CurPos - 2);
  if Failed(hr) then Result := grFail else Result := grOk;
end;

function TG2Render3D.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  VerifyVB(256);
  VerifyIB(1024);
  SetLength(m_PosArr, 4);
  SetLength(m_ColArr, 4);
  SetLength(m_TexArr, 4);
  SetLength(m_NrmArr, 4);
  SetLength(m_IndArr, 4);
  m_BaseVertexIndex := 0;
  Result := grOk;
end;

function TG2Render3D.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;

function TG2Render3D.DrawTriangle(
      const v1, v2, v3: TG2Vec3;
      const Color: TG2Color;
      const tc1, tc2, tc3: TG2Vec2
    ): TG2Result;
begin
  Result := DrawTriangle3Col(
    v1, v2, v3, Color, Color, Color, tc1, tc2, tc3
  );
end;

function TG2Render3D.DrawTriangle3Col(
      const v1, v2, v3: TG2Vec3;
      const c1, c2, c3: TG2Color;
      const tc1, tc2, tc3: TG2Vec2
    ): TG2Result;
var
  hr: HResult;
  n: TG2Vec3;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(3)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * 3, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  n := G2TriangleNormal(v1, v2, v3);

  m_Vertices^[0].x := v1.X; m_Vertices^[0].y := v1.Y; m_Vertices^[0].z := v1.Z;
  m_Vertices^[0].nx := n.X; m_Vertices^[0].ny := n.Y; m_Vertices^[0].nz := n.Z;
  m_Vertices^[0].tu := tc1.X; m_Vertices^[0].tv := tc1.Y;
  m_Vertices^[0].Color := c1;

  m_Vertices^[1].x := v2.X; m_Vertices^[1].y := v2.Y; m_Vertices^[1].z := v2.Z;
  m_Vertices^[1].nx := n.X; m_Vertices^[1].ny := n.Y; m_Vertices^[1].nz := n.Z;
  m_Vertices^[1].tu := tc2.X; m_Vertices^[1].tv := tc2.Y;
  m_Vertices^[1].Color := c2;

  m_Vertices^[2].x := v3.X; m_Vertices^[2].y := v3.Y; m_Vertices^[2].z := v3.Z;
  m_Vertices^[2].nx := n.X; m_Vertices^[2].ny := n.Y; m_Vertices^[2].nz := n.Z;
  m_Vertices^[2].tu := tc3.X; m_Vertices^[2].tv := tc3.Y;
  m_Vertices^[2].Color := c3;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLELIST, 0, 1);
  if Failed(hr) then Exit;
  Result := grOk;  
end;

function TG2Render3D.DrawQuad(
      const v1, v2, v3, v4: TG2Vec3;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const TextureRect: PG2Rect = nil
    ): TG2Result;
begin
  Result := DrawQuad4Col(
    v1, v2, v3, v4,
    Color, Color, Color, Color,
    Texture, TextureRect
  );
end;

function TG2Render3D.DrawQuad4Col(
      const v1, v2, v3, v4: TG2Vec3;
      const c1, c2, c3, c4: TG2Color;
      const Texture: TG2Texture2DBase;
      const TextureRect: PG2Rect = nil
    ): TG2Result;
var
  hr: HResult;
  n1, n2, n3: TG2Vec3;
  tu0, tv0, tu1, tv1: Single;
  tr: PG2Rect;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(4)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * 4, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  if Assigned(Texture) then
  Core.Graphics.Device.SetTexture(0, Texture.Texture);
  if Assigned(TextureRect) then
  tr := TextureRect
  else
  tr := Texture.DrawRect;

  n1 := G2TriangleNormal(v1, v2, v3);
  n2 := G2TriangleNormal(v3, v2, v4);
  n3 := (n1 + n2);
  n3.Normalize;

  tu0 := tr^.Left;
  tv0 := tr^.Top;
  tu1 := tr^.Right;
  tv1 := tr^.Bottom;

  m_Vertices^[0].x := v1.X; m_Vertices^[0].y := v1.Y; m_Vertices^[0].z := v1.Z;
  m_Vertices^[0].nx := n1.X; m_Vertices^[0].ny := n1.Y; m_Vertices^[0].nz := n1.Z;
  m_Vertices^[0].tu := tu0; m_Vertices^[0].tv := tv0;
  m_Vertices^[0].Color := c1;

  m_Vertices^[1].x := v2.X; m_Vertices^[1].y := v2.Y; m_Vertices^[1].z := v2.Z;
  m_Vertices^[1].nx := n3.X; m_Vertices^[1].ny := n3.Y; m_Vertices^[1].nz := n3.Z;
  m_Vertices^[1].tu := tu1; m_Vertices^[1].tv := tv0;
  m_Vertices^[1].Color := c2;

  m_Vertices^[2].x := v3.X; m_Vertices^[2].y := v3.Y; m_Vertices^[2].z := v3.Z;
  m_Vertices^[2].nx := n3.X; m_Vertices^[2].ny := n3.Y; m_Vertices^[2].nz := n3.Z;
  m_Vertices^[2].tu := tu0; m_Vertices^[2].tv := tv1;
  m_Vertices^[2].Color := c3;

  m_Vertices^[3].x := v4.X; m_Vertices^[3].y := v4.Y; m_Vertices^[3].z := v4.Z;
  m_Vertices^[3].nx := n2.X; m_Vertices^[3].ny := n2.Y; m_Vertices^[3].nz := n2.Z;
  m_Vertices^[3].tu := tu1; m_Vertices^[3].tv := tv1;
  m_Vertices^[3].Color := c4;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
  if Failed(hr) then Exit;
  Result := grOk;  
end;

function TG2Render3D.DrawBox(
      const X, Y, Z: Single;
      const SizeX, SizeY, SizeZ: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase
    ): TG2Result;
var
  hr: HResult;
  MaxV: TG2Vec3;
  tu0, tv0, tu1, tv1: Single;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(24)) then Exit;
  if G2ResFail(VerifyIB(36)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * 24, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * 36, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  MaxV := G2Vec3(X + SizeX, Y + SizeY, Z + SizeZ);

  tu0 := Texture.DrawRect^.Left;
  tv0 := Texture.DrawRect^.Top;
  tu1 := Texture.DrawRect^.Right;
  tv1 := Texture.DrawRect^.Bottom;

  m_CurV := 0;
  m_CurI := 0;

  //Bottom
  AddVertex(X, Y, Z, Color, 0, -1, 0, tu0, tv0);
  AddVertex(MaxV.X, Y, Z, Color, 0, -1, 0, tu1, tv0);
  AddVertex(X, Y, MaxV.Z, Color, 0, -1, 0, tu0, tv1);
  AddVertex(MaxV.X, Y, MaxV.Z, Color, 0, -1, 0, tu1, tv1);
  AddFace(0, 1, 2); AddFace(2, 1, 3);

  //Top
  AddVertex(X, MaxV.Y, MaxV.Z, Color, 0, 1, 0, tu0, tv0);
  AddVertex(MaxV.X, MaxV.Y, MaxV.Z, Color, 0, 1, 0, tu1, tv0);
  AddVertex(X, MaxV.Y, Z, Color, 0, 1, 0, tu0, tv1);
  AddVertex(MaxV.X, MaxV.Y, Z, Color, 0, 1, 0, tu1, tv1);
  AddFace(4, 5, 6); AddFace(6, 5, 7);

  //Front
  AddVertex(X, MaxV.Y, Z, Color, 0, 0, -1, tu0, tv0);
  AddVertex(MaxV.X, MaxV.Y, Z, Color, 0, 0, -1, tu1, tv0);
  AddVertex(X, Y, Z, Color, 0, 0, -1, tu0, tv1);
  AddVertex(MaxV.X, Y, Z, Color, 0, 0, -1, tu1, tv1);
  AddFace(8, 9, 10); AddFace(10, 9, 11);

  //Back
  AddVertex(MaxV.X, MaxV.Y, MaxV.Z, Color, 0, 0, 1, tu0, tv0);
  AddVertex(X, MaxV.Y, MaxV.Z, Color, 0, 0, 1, tu1, tv0);
  AddVertex(MaxV.X, Y, MaxV.Z, Color, 0, 0, 1, tu0, tv1);
  AddVertex(X, Y, MaxV.Z, Color, 0, 0, 1, tu1, tv1);
  AddFace(12, 13, 14); AddFace(14, 13, 15);

  //Left
  AddVertex(X, MaxV.Y, MaxV.Z, Color, -1, 0, 0, tu0, tv0);
  AddVertex(X, MaxV.Y, Z, Color, -1, 0, 0, tu1, tv0);
  AddVertex(X, Y, MaxV.Z, Color, -1, 0, 0, tu0, tv1);
  AddVertex(X, Y, Z, Color, -1, 0, 0, tu1, tv1);
  AddFace(16, 17, 18); AddFace(18, 17, 19);

  //Right
  AddVertex(MaxV.X, MaxV.Y, Z, Color, 1, 0, 0, tu0, tv0);
  AddVertex(MaxV.X, MaxV.Y, MaxV.Z, Color, 1, 0, 0, tu1, tv0);
  AddVertex(MaxV.X, Y, Z, Color, 1, 0, 0, tu0, tv1);
  AddVertex(MaxV.X, Y, MaxV.Z, Color, 1, 0, 0, tu1, tv1);
  AddFace(20, 21, 22); AddFace(22, 21, 23);

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, 24, 0, 12);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render3D.DrawSphere(
      const X, Y, Z: Single;
      const Radius: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const VSegments: Integer = 32;
      const HSegments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j: Integer;
  g1, g2, gv, gh: Extended;
  v: Single;
  s, c: Extended;
  LastV: Word;
  VCount: Integer;
  ICount: Integer;
  v1, v2, v3, v4: Word;
  n: TG2Vec3;
  tu0, tv0, tu1, tv1: Single;
begin
  Result := grFail;
  VCount := (VSegments + 1) * (HSegments);
  ICount := VSegments * (HSegments - 1) * 6;
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  tu0 := Texture.DrawRect^.Left;
  tv0 := Texture.DrawRect^.Top;
  tu1 := Texture.DrawRect^.Right;
  tv1 := Texture.DrawRect^.Bottom;

  m_CurV := 0;
  m_CurI := 0;

  for j := 0 to VSegments - 1 do
  begin
    g1 := j / (VSegments - 1);
    SinCos(g1 * Pi, gh, gv);
    for i := 0 to HSegments do
    begin
      g2 := i / HSegments;
      SinCos(g2 * TwoPi, s, c);
      AddVertex(
        X + s * Radius * gh,
        Y + Radius * gv,
        Z + c * Radius * gh,
        Color,
        s * gh, gv, c * gh,
        G2LerpFloat(tu0, tu1, g2),
        G2LerpFloat(tv0, tv1, g1)
      );
    end;
  end;
  for j := 0 to VSegments - 2 do
  for i := 0 to HSegments - 1 do
  begin
    v1 := (j + 0) * (HSegments + 1) + (i + 0);
    v2 := (j + 0) * (HSegments + 1) + (i + 1);
    v3 := (j + 1) * (HSegments + 1) + (i + 0);
    v4 := (j + 1) * (HSegments + 1) + (i + 1);
    AddFace(v1, v3, v2); AddFace(v3, v4, v2);
  end;

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurV, 0, m_CurI div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render3D.DrawCylinder(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const Segments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j: Integer;
  g, gv, gh: Extended;
  v: Single;
  s, c: Extended;
  TopV, BottomV: Word;
  VCount: Integer;
  ICount: Integer;
  v1, v2, v3, v4: Word;
  n: TG2Vec3;
  vx, vz: Single;
  tur, tvr, tum, tvm: Single;
  tu0, tv0, tu1, tv1: Single;
begin
  Result := grFail;
  if Segments < 3 then Exit;
  VCount := (Segments + 1) * 4 + 2;
  ICount := Segments * 12;
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  m_CurV := 0;
  m_CurI := 0;

  tu0 := Texture.DrawRect^.Left;
  tv0 := Texture.DrawRect^.Top;
  tu1 := Texture.DrawRect^.Right;
  tv1 := Texture.DrawRect^.Bottom;
  tur := (tu1 - tu0) * 0.5;
  tvr := (tv1 - tv0) * 0.5;
  tum := tu0 + Texture.DrawRect^.Left;
  tvm := tv0 + Texture.DrawRect^.Top;

  for i := 0 to Segments do
  begin
    g := i / Segments;
    SinCos(g * TwoPi, s, c);
    vx := X + s * Radius;
    vz := Z + c * Radius;
    AddVertex(vx, Y + Height, vz, Color, 0, 1, 0, tum + c * tur, tvm + s * tvr);
    AddVertex(vx, Y + Height, vz, Color, s, 0, c, G2LerpFloat(tu0, tu1, g), tv0);
    AddVertex(vx, Y, vz, Color, s, 0, c, G2LerpFloat(tu0, tu1, g), tv1);
    AddVertex(vx, Y, vz, Color, 0, -1, 0, tum + s * tur, tvm + c * tvr);
  end;
  TopV := AddVertex(X, Y + Height, Z, Color, 0, 1, 0, tum, tvm);
  BottomV := AddVertex(X, Y, Z, Color, 0, -1, 0, tum, tvm);
  for i := 0 to Segments - 1 do
  begin
    AddFace(TopV, ((i + 0) * 4 + 0), ((i + 1) * 4 + 0));
    AddFace(((i + 0) * 4 + 1), ((i + 0) * 4 + 2), ((i + 1) * 4 + 1));
    AddFace(((i + 0) * 4 + 2), ((i + 1) * 4 + 2), ((i + 1) * 4 + 1));
    AddFace(BottomV, ((i + 1) * 4 + 3), ((i + 0) * 4 + 3));
  end;

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurV, 0, m_CurI div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render3D.DrawCapsule(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const VCapSegments: Integer = 8;
      const HSegments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j, v: Integer;
  g1, g2, gv, gh: Extended;
  s, c: Extended;
  TopV, BottomV: Word;
  VCount: Integer;
  ICount: Integer;
  n: TG2Vec3;
  vx, vz: Single;
  HalfHeight: Single;
  TotalHeight: Single;
  tu0, tv0, tu1, tv1: Single;
  tvc0, tvc1: Single;
begin
  Result := grFail;
  if (VCapSegments < 1) or (HSegments < 3) then Exit;
  VCount := (VCapSegments) * (HSegments + 1) * 2;
  ICount := 6 * HSegments * (VCapSegments * 2 - 1);
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  tu0 := Texture.DrawRect^.Left;
  tv0 := Texture.DrawRect^.Top;
  tu1 := Texture.DrawRect^.Right;
  tv1 := Texture.DrawRect^.Bottom;

  m_CurV := 0;
  m_CurI := 0;

  HalfHeight := Height * 0.5;
  TotalHeight := Height + Radius * 2;
  tvc0 := Radius / TotalHeight;
  tvc1 := (Radius + Height) / TotalHeight;

  for i := 0 to HSegments do
  begin
    g1 := i / HSegments;
    SinCos(g1 * TwoPi, s, c);
    for j := 0 to VCapSegments - 1 do
    begin
      g2 := j / (VCapSegments - 1);
      SinCos(g2 * HalfPi, gh, gv);
      vx := X + s * Radius * gh;
      vz := Z + c * Radius * gh;
      n := G2Vec3(s * gh, gv, c * gh);
      AddVertex(
        vx,
        Y + HalfHeight + Radius * gv,
        vz,
        Color,
        n.x, n.y, n.z,
        G2LerpFloat(tu0, tu1, g1),
        G2LerpFloat(tv0, tvc0, g2)
      );
      AddVertex(
        vx,
        Y - HalfHeight - Radius * gv,
        vz,
        Color,
        n.x, -n.y, n.z,
        G2LerpFloat(tu0, tu1, g1),
        G2LerpFloat(tv1, tvc1, g2)
      );
    end;
  end;
  v := (VCapSegments) * 2;
  for i := 0 to HSegments - 1 do
  begin
    AddFace(i * v + v - 2, i * v + v - 1, (i + 1) * v + v - 2);
    AddFace((i + 1) * v + v - 1, (i + 2) * v - 2, i * v + v - 1);
    for j := 0 to VCapSegments - 2 do
    begin
      AddFace(i * v + j * 2, (i + 1) * v + (j + 1) * 2, (i + 1) * v + j * 2);
      AddFace((i + 1) * v + (j + 1) * 2, i * v + j * 2, i * v + (j + 1) * 2);
      AddFace(i * v + j * 2 + 1, (i + 1) * v + j * 2 + 1, (i + 1) * v + (j + 1) * 2 + 1);
      AddFace((i + 1) * v + (j + 1) * 2 + 1, i * v + (j + 1) * 2 + 1, i * v + j * 2 + 1);
    end;
  end;

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurV, 0, m_CurI div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render3D.DrawTorus(
      const X, Y, Z: Single;
      const RadiusInt, RadiusExt: Single;
      const Color: TG2Color;
      const Texture: TG2Texture2DBase;
      const Sides: Integer = 16;
      const Segments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j: Integer;
  g1, g2, gv, gh: Extended;
  s, c, s1, c1: Extended;
  TopV, BottomV: Word;
  VCount: Integer;
  ICount: Integer;
  n: TG2Vec3;
  vx, vz: Single;
  v, v1, v2: TG2Vec3;
  fv1, fv2, fv3, fv4: Word;
  HalfHeight: Single;
  Radius1, Radius2: Single;
  tu0, tv0, tu1, tv1: Single;
begin
  Result := grFail;
  if (Sides < 3) or (Segments < 3) then Exit;
  VCount := (Segments + 1) * (Sides + 1);
  ICount := Sides * Segments * 6;
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TVertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  tu0 := Texture.DrawRect^.Left;
  tv0 := Texture.DrawRect^.Top;
  tu1 := Texture.DrawRect^.Right;
  tv1 := Texture.DrawRect^.Bottom;

  m_CurV := 0;
  m_CurI := 0;

  Radius1 := (RadiusExt - RadiusInt) * 0.5;
  Radius2 := RadiusInt + Radius1;

  for i := 0 to Segments do
  begin
    g1 := i / Segments;
    SinCos(g1 * TwoPi, s, c);
    v := G2Vec3(X + s * Radius2, Y, Z + c * Radius2);
    for j := 0 to Sides do
    begin
      g2 := j / Sides;
      SinCos(g2 * TwoPi, s1, c1);
      n := G2Vec3(s * c1, s1, c * c1);
      v1 := v + n * Radius1;
      AddVertex(v1.x, v1.Y, v1.z, Color, n.x, n.y, n.z, G2LerpFloat(tu0, tu1, g1), G2LerpFloat(tv0, tv1, g2));
    end;
  end;
  for i := 0 to Segments - 1 do
  for j := 0 to Sides - 1 do
  begin
    fv1 := i * (Sides + 1) + j;
    fv2 := (i + 1) * (Sides + 1) + j;
    fv3 := i * (Sides + 1) + (j + 1);
    fv4 := (i + 1) * (Sides + 1) + (j + 1);
    AddFace(fv1, fv2, fv3);
    AddFace(fv3, fv2, fv4);
  end;

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TVertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurV, 0, m_CurI div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Render3D.DrawBegin(const PrimType: TG2PrimType): TG2Result;
begin
  if m_Drawing then
  begin
    Result := grInvalidCall;
    Exit;
  end;
  m_CurPos := 0;
  m_CurCol := 0;
  m_CurTex := 0;
  m_CurNrm := 0;
  m_CurInd := 0;
  m_Drawing := True;
  m_PrimType := PrimType;
  Result := grOk;
end;

procedure TG2Render3D.AddPos(const p: TG2Vec3); 
begin
  if High(m_PosArr) < m_CurPos then
  SetLength(m_PosArr, Length(m_PosArr) * 2);
  m_PosArr[m_CurPos] := p;
  Inc(m_CurPos);
end;

procedure TG2Render3D.AddCol(const c: TG2Color); 
begin
  if High(m_ColArr) < m_CurCol then
  SetLength(m_ColArr, Length(m_ColArr) * 2);
  m_ColArr[m_CurCol] := c;
  Inc(m_CurCol);
end;

procedure TG2Render3D.AddTex(const t: TG2Vec2);  
begin
  if High(m_TexArr) < m_CurTex then
  SetLength(m_TexArr, Length(m_TexArr) * 2);
  m_TexArr[m_CurTex] := t;
  Inc(m_CurTex);
end;

procedure TG2Render3D.AddNrm(const n: TG2Vec3);  
begin
  if High(m_NrmArr) < m_CurNrm then
  SetLength(m_NrmArr, Length(m_NrmArr) * 2);
  m_NrmArr[m_CurNrm] := n;
  Inc(m_CurNrm);
end;

procedure TG2Render3D.AddInd(const i: Word);   
begin
  if High(m_IndArr) < m_CurInd then
  SetLength(m_IndArr, Length(m_IndArr) * 2);
  m_IndArr[m_CurInd] := i + m_BaseVertexIndex;
  Inc(m_CurInd);
end;

function TG2Render3D.DrawEnd: TG2Result;
begin
  if not m_Drawing then
  begin
    Result := grInvalidCall;
    Exit;
  end;

  m_Drawing := False;

  Result := LoadBuffers;
  if G2ResOk(Result) then
  case m_PrimType of
    ptPointList: Result := DrawPointList;
    ptLineList: Result := DrawLineList;
    ptLineStrip: Result := DrawLineStrip;
    ptTriangleList: Result := DrawTriangleList;
    ptTriangleStrip: Result := DrawTriangleStrip;
    ptTriangleFan: Result := DrawTriangleFan;
  end;
end;
//TG2Render3D END

//TG2Camera BEGIN
constructor TG2Camera.Create;
begin
  inherited Create;
end;

destructor TG2Camera.Destroy;
begin
  inherited Destroy;
end;

function TG2Camera.GetView: TG2Mat;
begin
  D3DXMatrixLookAtLH(
    PG2MatRef(@Result)^,
    m_Src, m_Dst, m_Up
  );
end;

function TG2Camera.GetProj: TG2Mat;
begin
  D3DXMatrixPerspectiveFovLH(
    PG2MatRef(@Result)^,
    m_FOV, m_Aspect, m_Near, m_Far
  );
end;

procedure TG2Camera.SetPerspective(const NewFOV, NewAspect, NewNear, NewFar: Single);
begin
  m_FOV := NewFOV;
  m_Aspect := NewAspect;
  m_Near := NewNear;
  m_Far := NewFar;
end;

procedure TG2Camera.SetPerspective;
begin
  m_FOV := QuatPi;
  m_Aspect := Core.Graphics.Params.Width / Core.Graphics.Params.Height;
  m_Near := 0.1;
  m_Far := 1000;
end;

procedure TG2Camera.SetView(const PosX, PosY, PosZ, TargetX, TargetY, TargetZ, UpX, UpY, UpZ: Single);
begin
  m_Src := G2Vec3(PosX, PosY, PosZ);
  m_Dst := G2Vec3(TargetX, TargetY, TargetZ);
  m_Up := G2Vec3(UpX, UpY, UpZ);
end;

function TG2Camera.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;

function TG2Camera.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2Camera END

//TG2Frastum BEGIN
constructor TG2Frastum.Create;
begin
  inherited Create;
end;

destructor TG2Frastum.Destroy;
begin
  inherited Destroy;
end;

function TG2Frastum.GetPlane(const Index: integer): PG2FrustumPlane;
begin
  Result := @m_Planes[Index];
end;

procedure TG2Frastum.Normalize;
var
  i: Integer;
  Rcp: Single;
begin
  for i := 0 to 5 do
  begin
    Rcp := 1 / m_Planes[i].N.Len;
    m_Planes[i].N.x := m_Planes[i].N.x * Rcp;
    m_Planes[i].N.y := m_Planes[i].N.y * Rcp;
    m_Planes[i].N.z := m_Planes[i].N.z * Rcp;
    m_Planes[i].D := m_Planes[i].D * Rcp;
  end;
end;

procedure TG2Frastum.Update;
var
  m: TG2Mat;
begin
  m := m_RefV^ * m_RefP^;
  //Left plane
  m_Planes[0].N.x := m.e03 + m.e00;
  m_Planes[0].N.y := m.e13 + m.e10;
  m_Planes[0].N.z := m.e23 + m.e20;
  m_Planes[0].D := m.e33 + m.e30;

  //Right plane
  m_Planes[1].N.x := m.e03 - m.e00;
  m_Planes[1].N.y := m.e13 - m.e10;
  m_Planes[1].N.z := m.e23 - m.e20;
  m_Planes[1].D := m.e33 - m.e30;

  //Top plane
  m_Planes[2].N.x := m.e03 - m.e01;
  m_Planes[2].N.y := m.e13 - m.e11;
  m_Planes[2].N.z := m.e23 - m.e21;
  m_Planes[2].D := m.e33 - m.e31;

  //Bottom plane
  m_Planes[3].N.x := m.e03 + m.e01;
  m_Planes[3].N.y := m.e13 + m.e11;
  m_Planes[3].N.z := m.e23 + m.e21;
  m_Planes[3].D := m.e33 + m.e31;

  //Near plane
  m_Planes[4].N.x := m.e02;
  m_Planes[4].N.y := m.e12;
  m_Planes[4].N.z := m.e22;
  m_Planes[4].D := m.e32;

  //Far plane
  m_Planes[5].N.x := m.e03 - m.e02;
  m_Planes[5].N.y := m.e13 - m.e12;
  m_Planes[5].N.z := m.e23 - m.e22;
  m_Planes[5].D := m.e33 - m.e32;
end;

function TG2Frastum.PointInFrustum(const V: TG2Vec3): Boolean;
var
  i: Integer;
  d: Single;
begin
  for i := 0 to 5 do
  begin
    d := DistanceToPoint(i, V);
    if d < 0 then
    begin
      Result := False;
      Exit;
    end;
  end;
  Result := True;
end;

function TG2Frastum.BoxInFrustum(const MinV, MaxV: TG2Vec3): Boolean;
var
  fc: TG2FrustumCheck;
begin
  fc := FrustumCheckBox(MinV, MaxV);
  Result := (fc = fcInside) or (fc = fcIntersect);
end;

function TG2Frastum.SphereInFrustum(const C: TG2Vec3; const R: Single): Boolean;
var
  fc: TG2FrustumCheck;
begin
  fc := FrustumCheckSphere(C, R);
  Result := (fc = fcInside) or (fc = fcIntersect);
end;

function TG2Frastum.FrustumCheckBox(const MinV, MaxV: TG2Vec3): TG2FrustumCheck;
var
  PtsIn: Integer;
  i, j: Integer;
  Box: array[0..7] of TG2Vec3;
begin
  Result := fcInside;
  Box[0] := G2Vec3(MinV.x, MinV.y, MinV.z);
  Box[1] := G2Vec3(MinV.x, MinV.y, MaxV.z);
  Box[2] := G2Vec3(MaxV.x, MinV.y, MaxV.z);
  Box[3] := G2Vec3(MaxV.x, MinV.y, MinV.z);
  Box[4] := G2Vec3(MinV.x, MaxV.y, MinV.z);
  Box[5] := G2Vec3(MinV.x, MaxV.y, MaxV.z);
  Box[6] := G2Vec3(MaxV.x, MaxV.y, MinV.z);
  Box[7] := G2Vec3(MaxV.x, MaxV.y, MaxV.z);
  for i := 0 to 5 do
  begin
    PtsIn := 0;
    for j := 0 to 7 do
    if DistanceToPoint(i, Box[j]) >= 0 then
    Inc(PtsIn)
    else
    Result := fcIntersect;
    if PtsIn = 0 then
    begin
      Result := fcOutside;
      Exit;
    end;
  end;
end;

function TG2Frastum.FrustumCheckSphere(const C: TG2Vec3; const R: Single): TG2FrustumCheck;
var
  i: Integer;
  d: Single;
begin
  Result := fcInside;
  for i := 0 to 5 do
  begin
    d := DistanceToPoint(i, C);
    if d < -R then
    begin
      Result := fcOutside;
      Exit;
    end;
    if d < R then
    Result := fcIntersect;
  end;
end;

function TG2Frastum.DistanceToPoint(const PlaneIndex: Integer; Pt: TG2Vec3): Single;
begin
  Result := m_Planes[PlaneIndex].N.Dot(Pt) + m_Planes[PlaneIndex].D;
end;

function TG2Frastum.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_RefV := @Core.Graphics.Transforms.V;
  m_RefP := @Core.Graphics.Transforms.P;
  Result := grOk;
end;

function TG2Frastum.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
end;
//TG2Frastum END

//TG2Primitives2D BEGIN
constructor TG2Primitives2D.Create;
begin
  inherited Create;
  m_VBSize := 0;
end;

destructor TG2Primitives2D.Destroy;
begin
  inherited Destroy;
end;

function TG2Primitives2D.VerifyBuffer(const Size: Integer): TG2Result;
begin
  if (Size <= m_VBSize)
  and Assigned(m_VB) then
  begin
    Result := grOk;
    Exit;
  end;
  m_VBSize := Size;
  SafeRelease(m_VB);
  if Failed(
    Core.Graphics.Device.CreateVertexBuffer(
      m_VBSize * SizeOf(TG2Vertex),
      D3DUSAGE_DYNAMIC,
      FVF,
      D3DPOOL_DEFAULT,
      m_VB,
      nil
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  Result := grOk;
end;

procedure TG2Primitives2D.OnDeviceLost;
begin
  SafeRelease(m_VB);
end;

procedure TG2Primitives2D.OnDeviceReset;
begin
  VerifyBuffer(m_VBSize);
end;

function TG2Primitives2D.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  VerifyBuffer(256);
  Result := grOk;
end;

function TG2Primitives2D.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;

function TG2Primitives2D.DrawLine(
      const v1, v2: TG2Vec2;
      const Color: TG2Color
    ): TG2Result;
begin
  Result := DrawLine2Col(v1, v2, Color, Color);
end;

function TG2Primitives2D.DrawLine2Col(
      const v1, v2: TG2Vec2;
      const c1, c2: TG2Color
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer(2)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * 2, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  Vertices^[0].x := v1.X; Vertices^[0].y := v1.Y; Vertices^[0].z := 0;
  Vertices^[0].rhw := 1; Vertices^[0].Color := c1;

  Vertices^[1].x := v2.X; Vertices^[1].y := v2.Y; Vertices^[1].z := 0;
  Vertices^[1].rhw := 1; Vertices^[1].Color := c2;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_LINESTRIP, 0, 1);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives2D.DrawLineStrip(
      const VArr: PG2Vec2Array;
      const VCount: Word;
      const Color: TG2Color
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  i: Integer;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer(VCount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  for i := 0 to VCount - 1 do
  begin
    Vertices^[i].x := VArr^[i].X; Vertices^[i].y := VArr^[i].Y; Vertices^[i].z := 0;
    Vertices^[i].rhw := 1; Vertices^[i].Color := Color;
  end;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_LINESTRIP, 0, VCount - 1);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives2D.DrawTriangle(
      const v1, v2, v3: TG2Vec2;
      const Color: TG2Color
    ): TG2Result;
begin
  Result := DrawTriangle3Col(
    v1, v2, v3,
    Color, Color, Color
  );
end;

function TG2Primitives2D.DrawTriangle3Col(
      const v1, v2, v3: TG2Vec2;
      const c1, c2, c3: TG2Color
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer(3)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * 3, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  Vertices^[0].x := v1.X; Vertices^[0].y := v1.Y; Vertices^[0].z := 0;
  Vertices^[0].rhw := 1; Vertices^[0].Color := c1;

  Vertices^[1].x := v2.X; Vertices^[1].y := v2.Y; Vertices^[1].z := 0;
  Vertices^[1].rhw := 1; Vertices^[1].Color := c2;

  Vertices^[2].x := v3.X; Vertices^[2].y := v3.Y; Vertices^[2].z := 0;
  Vertices^[2].rhw := 1; Vertices^[2].Color := c3; 

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLELIST, 0, 1);
  if Failed(hr) then Exit;
  Result := grOk;  
end;

function TG2Primitives2D.DrawRect(
      const X, Y, Width, Height: Single;
      const Color: TG2Color
    ): TG2Result;
begin
  Result := DrawRect4Col(
    X, Y, Width, Height,
    Color, Color, Color, Color
  );
end;

function TG2Primitives2D.DrawRect4Col(
      const X, Y, Width, Height: Single;
      const c1, c2, c3, c4: TG2Color
    ): TG2Result;
var
  x2, y2: Single;
begin
  x2 := X + Width;
  y2 := Y + Height;
  Result := DrawQuad4Col(
    G2Vec2(x, y), G2Vec2(x2, y),
    G2Vec2(x, y2), G2Vec2(x2, y2),
    c1, c2, c3, c4
  );
end;

function TG2Primitives2D.DrawQuad(
      const v1, v2, v3, v4: TG2Vec2;
      const Color: TG2Color
    ): TG2Result;
begin
  Result := DrawQuad4Col(v1, v2, v3, v4, Color, Color, Color, Color);
end;

function TG2Primitives2D.DrawQuad4Col(
      const v1, v2, v3, v4: TG2Vec2;
      const c1, c2, c3, c4: TG2Color
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  hr: HResult;
begin
  Result := grFail;
  if G2ResFail(VerifyBuffer(4)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * 4, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  Vertices^[0].x := v1.X; Vertices^[0].y := v1.Y; Vertices^[0].z := 0;
  Vertices^[0].rhw := 0; Vertices^[0].Color := c1;

  Vertices^[1].x := v2.X; Vertices^[1].y := v2.Y; Vertices^[1].z := 0;
  Vertices^[1].rhw := 0; Vertices^[1].Color := c2;

  Vertices^[2].x := v3.X; Vertices^[2].y := v3.Y; Vertices^[2].z := 0;
  Vertices^[2].rhw := 0; Vertices^[2].Color := c3;

  Vertices^[3].x := v4.X; Vertices^[3].y := v4.Y; Vertices^[3].z := 0;
  Vertices^[3].rhw := 0; Vertices^[3].Color := c4;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives2D.DrawCircle(
      const Center: TG2Vec2;
      const Radius: Single;
      const Color: TG2Color;
      const Segments: Word = 32
    ): TG2Result;                
begin
  Result := DrawCircle2Col(Center, Radius, Color, Color, Segments);
end;

function TG2Primitives2D.DrawCircle2Col(
      const Center: TG2Vec2;
      const Radius: Single;
      const ColInt, ColExt: TG2Color;
      const Segments: Word = 32
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  i, v: Integer;
  s, c: Extended;
  hr: HResult;
  VCount: Integer;
begin
  Result := grFail;
  if Segments < 3 then Exit;
  VCount := Segments + 2;
  if G2ResFail(VerifyBuffer(VCount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  Vertices^[0].x := Center.X; Vertices^[0].y := Center.Y;
  Vertices^[0].z := 0; Vertices^[0].rhw := 1; Vertices^[0].Color := ColInt;
  for i := 0 to Segments do
  begin
    v := i + 1;
    SinCos((i / (Segments)) * TwoPi, s, c);
    Vertices^[v].x := c * Radius + Center.X; Vertices^[v].y := s * Radius + Center.Y;
    Vertices^[v].z := 0; Vertices^[v].rhw := 1; Vertices^[v].Color := ColExt;
  end;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLEFAN, 0, Segments);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives2D.DrawCircleHollow(
      const Center: TG2Vec2;
      const RadiusInt, RadiusExt: Single;
      const Color: TG2Color;
      const Segments: Word = 32
    ): TG2Result;                    
begin
  Result := DrawCircleHollow2Col(Center, RadiusInt, RadiusExt, Color, Color, Segments);
end;

function TG2Primitives2D.DrawCircleHollow2Col(
      const Center: TG2Vec2;
      const RadiusInt, RadiusExt: Single;
      const ColInt, ColExt: TG2Color;
      const Segments: Word = 32
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  i, v1, v2: Integer;
  s, c: Extended;
  hr: HResult;
  VCount: Integer;
begin
  Result := grFail;
  if Segments < 3 then Exit;
  VCount := (Segments + 1) * 2;
  if G2ResFail(VerifyBuffer(VCount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  for i := 0 to Segments do
  begin
    v1 := i * 2;
    v2 := v1 + 1;
    SinCos((i / (Segments)) * TwoPi, s, c);
    Vertices[v1].x := c * RadiusInt + Center.X; Vertices[v1].y := s * RadiusInt + Center.Y;
    Vertices[v1].z := 0; Vertices[v1].rhw := 1; Vertices[v1].Color := ColInt;
    Vertices[v2].x := c * RadiusExt + Center.X; Vertices[v2].y := s * RadiusExt + Center.Y;
    Vertices[v2].z := 0; Vertices[v2].rhw := 1; Vertices[v2].Color := ColExt;
  end;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, Segments * 2);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives2D.DrawPolyConvex(
      const VArr: PG2Vec2Array;
      const VCount: Word;
      const Color: TG2Color
    ): TG2Result;
var
  Vertices: PG2VertexArray;
  i: Integer;
  hr: HResult;
begin
  Result := grFail;
  if VCount < 2 then Exit;
  if G2ResFail(VerifyBuffer(VCount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  for i := 0 to VCount - 1 do
  begin
    Vertices^[i].x := VArr^[i].x; Vertices^[i].y := VArr^[i].y;
    Vertices^[i].z := 0; Vertices^[i].rhw := 1; Vertices^[i].Color := Color;
  end;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLEFAN, 0, VCount - 2);
  if Failed(hr) then Exit;
  Result := grOk;
end;
//TG2Primitives2D END

//TG2Primitives3D BEGIN
constructor TG2Primitives3D.Create;
begin
  inherited Create;
  m_VBSize := 0;
  m_IBSize := 0;
end;

destructor TG2Primitives3D.Destroy;
begin
  inherited Destroy;
end;

function TG2Primitives3D.VerifyVB(const Size: Integer): TG2Result;
begin
  if (Size <= m_VBSize)
  and Assigned(m_VB) then
  begin
    Result := grOk;
    Exit;
  end;
  m_VBSize := Size;
  SafeRelease(m_VB);
  if Failed(
    Core.Graphics.Device.CreateVertexBuffer(
      m_VBSize * SizeOf(TG2Vertex),
      D3DUSAGE_DYNAMIC,
      FVF,
      D3DPOOL_DEFAULT,
      m_VB,
      nil
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  Result := grOk;
end;

function TG2Primitives3D.VerifyIB(const Size: Integer): TG2Result;
begin
  if (Size <= m_IBSize)
  and Assigned(m_IB) then
  begin
    Result := grOk;
    Exit;
  end;
  m_IBSize := Size;
  SafeRelease(m_IB);
  if Failed(
    Core.Graphics.Device.CreateIndexBuffer(
      m_IBSize * SizeOf(Word),
      D3DUSAGE_DYNAMIC,
      D3DFMT_INDEX16,
      D3DPOOL_DEFAULT,
      m_IB,
      nil
    )
  ) then
  begin
    Result := grFail;
    Exit;
  end;
  Result := grOk;
end;

function TG2Primitives3D.AddVertex(
      const X, Y, Z: Single;
      const Color: TG2Color;
      const NX, NY, NZ: Single
    ): Word;
begin
  m_Vertices^[m_CurV].x := X;
  m_Vertices^[m_CurV].y := Y;
  m_Vertices^[m_CurV].z := Z;
  m_Vertices^[m_CurV].Color := Color;
  m_Vertices^[m_CurV].nx := nx;
  m_Vertices^[m_CurV].ny := ny;
  m_Vertices^[m_CurV].nz := nz;
  Result := m_CurV;
  Inc(m_CurV);
end;

procedure TG2Primitives3D.AddFace(
      const v1, v2, v3: Word
    );
begin
  m_Indices^[m_CurI] := v1;
  m_Indices^[m_CurI + 1] := v2;
  m_Indices^[m_CurI + 2] := v3;
  Inc(m_CurI, 3);
end;

procedure TG2Primitives3D.OnDeviceLost;
begin
  SafeRelease(m_VB);
  SafeRelease(m_IB);
end;

procedure TG2Primitives3D.OnDeviceReset;
begin
  VerifyVB(m_VBSize);
  VerifyIB(m_IBSize);
end;

function TG2Primitives3D.DrawTriangle(
      const v1, v2, v3: TG2Vec3;
      const Color: TG2Color
    ): TG2Result;
begin
  Result := DrawTriangle3Col(
    v1, v2, v3, Color, Color, Color
  );
end;

function TG2Primitives3D.DrawTriangle3Col(
      const v1, v2, v3: TG2Vec3;
      const c1, c2, c3: TG2Color
    ): TG2Result;
var
  hr: HResult;
  n: TG2Vec3;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(3)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * 3, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  n := G2TriangleNormal(v1, v2, v3);

  m_Vertices^[0].x := v1.X; m_Vertices^[0].y := v1.Y; m_Vertices^[0].z := v1.Z;
  m_Vertices^[0].nx := n.X; m_Vertices^[0].ny := n.Y; m_Vertices^[0].nz := n.Z;
  m_Vertices^[0].Color := c1;

  m_Vertices^[1].x := v2.X; m_Vertices^[1].y := v2.Y; m_Vertices^[1].z := v2.Z;
  m_Vertices^[1].nx := n.X; m_Vertices^[1].ny := n.Y; m_Vertices^[1].nz := n.Z;
  m_Vertices^[1].Color := c2;

  m_Vertices^[2].x := v3.X; m_Vertices^[2].y := v3.Y; m_Vertices^[2].z := v3.Z;
  m_Vertices^[2].nx := n.X; m_Vertices^[2].ny := n.Y; m_Vertices^[2].nz := n.Z;
  m_Vertices^[2].Color := c3;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLELIST, 0, 1);
  if Failed(hr) then Exit;
  Result := grOk;  
end;

function TG2Primitives3D.DrawQuad(
      const v1, v2, v3, v4: TG2Vec3;
      const Color: TG2Color
    ): TG2Result;
begin
  Result := DrawQuad4Col(
    v1, v2, v3, v4,
    Color, Color, Color, Color
  );
end;

function TG2Primitives3D.DrawQuad4Col(
      const v1, v2, v3, v4: TG2Vec3;
      const c1, c2, c3, c4: TG2Color
    ): TG2Result;
var
  hr: HResult;
  n1, n2, n3: TG2Vec3;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(4)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * 4, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  n1 := G2TriangleNormal(v1, v2, v3);
  n2 := G2TriangleNormal(v3, v2, v4);
  n3 := (n1 + n2);
  n3.Normalize;

  m_Vertices^[0].x := v1.X; m_Vertices^[0].y := v1.Y; m_Vertices^[0].z := v1.Z;
  m_Vertices^[0].nx := n1.X; m_Vertices^[0].ny := n1.Y; m_Vertices^[0].nz := n1.Z;
  m_Vertices^[0].Color := c1;

  m_Vertices^[1].x := v2.X; m_Vertices^[1].y := v2.Y; m_Vertices^[1].z := v2.Z;
  m_Vertices^[1].nx := n3.X; m_Vertices^[1].ny := n3.Y; m_Vertices^[1].nz := n3.Z;
  m_Vertices^[1].Color := c2;

  m_Vertices^[2].x := v3.X; m_Vertices^[2].y := v3.Y; m_Vertices^[2].z := v3.Z;
  m_Vertices^[2].nx := n3.X; m_Vertices^[2].ny := n3.Y; m_Vertices^[2].nz := n3.Z;
  m_Vertices^[2].Color := c3;

  m_Vertices^[3].x := v4.X; m_Vertices^[3].y := v4.Y; m_Vertices^[3].z := v4.Z;
  m_Vertices^[3].nx := n2.X; m_Vertices^[3].ny := n2.Y; m_Vertices^[3].nz := n2.Z;
  m_Vertices^[3].Color := c4;

  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 2);
  if Failed(hr) then Exit;
  Result := grOk;  
end;

function TG2Primitives3D.DrawBox(
      const X, Y, Z: Single;
      const SizeX, SizeY, SizeZ: Single;
      const Color: TG2Color
    ): TG2Result;
var
  hr: HResult;
  MaxV: TG2Vec3;
begin
  Result := grFail;
  if G2ResFail(VerifyVB(24)) then Exit;
  if G2ResFail(VerifyIB(36)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * 24, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * 36, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  MaxV := G2Vec3(X + SizeX, Y + SizeY, Z + SizeZ);

  m_CurV := 0;
  m_CurI := 0;

  //Bottom
  AddVertex(X, Y, Z, Color, 0, -1, 0);
  AddVertex(MaxV.X, Y, Z, Color, 0, -1, 0);
  AddVertex(X, Y, MaxV.Z, Color, 0, -1, 0);
  AddVertex(MaxV.X, Y, MaxV.Z, Color, 0, -1, 0);
  AddFace(0, 1, 2); AddFace(2, 1, 3);

  //Top
  AddVertex(X, MaxV.Y, MaxV.Z, Color, 0, 1, 0);
  AddVertex(MaxV.X, MaxV.Y, MaxV.Z, Color, 0, 1, 0);
  AddVertex(X, MaxV.Y, Z, Color, 0, 1, 0);
  AddVertex(MaxV.X, MaxV.Y, Z, Color, 0, 1, 0);
  AddFace(4, 5, 6); AddFace(6, 5, 7);

  //Front
  AddVertex(X, MaxV.Y, Z, Color, 0, 0, -1);
  AddVertex(MaxV.X, MaxV.Y, Z, Color, 0, 0, -1);
  AddVertex(X, Y, Z, Color, 0, 0, -1);
  AddVertex(MaxV.X, Y, Z, Color, 0, 0, -1);
  AddFace(8, 9, 10); AddFace(10, 9, 11);

  //Back
  AddVertex(MaxV.X, MaxV.Y, MaxV.Z, Color, 0, 0, 1);
  AddVertex(X, MaxV.Y, MaxV.Z, Color, 0, 0, 1);
  AddVertex(MaxV.X, Y, MaxV.Z, Color, 0, 0, 1);
  AddVertex(X, Y, MaxV.Z, Color, 0, 0, 1);
  AddFace(12, 13, 14); AddFace(14, 13, 15);

  //Left
  AddVertex(X, MaxV.Y, MaxV.Z, Color, -1, 0, 0);
  AddVertex(X, MaxV.Y, Z, Color, -1, 0, 0);
  AddVertex(X, Y, MaxV.Z, Color, -1, 0, 0);
  AddVertex(X, Y, Z, Color, -1, 0, 0);
  AddFace(16, 17, 18); AddFace(18, 17, 19);

  //Right
  AddVertex(MaxV.X, MaxV.Y, Z, Color, 1, 0, 0);
  AddVertex(MaxV.X, MaxV.Y, MaxV.Z, Color, 1, 0, 0);
  AddVertex(MaxV.X, Y, Z, Color, 1, 0, 0);
  AddVertex(MaxV.X, Y, MaxV.Z, Color, 1, 0, 0);
  AddFace(20, 21, 22); AddFace(22, 21, 23);

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, 24, 0, 12);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives3D.DrawSphere(
      const X, Y, Z: Single;
      const Radius: Single;
      const Color: TG2Color;
      const VSegments: Integer = 32;
      const HSegments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j: Integer;
  gv, gh: Extended;
  v: Single;
  s, c: Extended;
  LastV: Word;
  VCount: Integer;
  ICount: Integer;
  v1, v2, v3, v4: Word;
  n: TG2Vec3;
begin
  Result := grFail;
  VCount := (VSegments - 1) * HSegments + 2;
  ICount := (VSegments - 2) * HSegments * 6 + HSegments * 6;
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  m_CurV := 0;
  m_CurI := 0;

  AddVertex(X, Y + Radius, Z, Color, 0, 1, 0);
  for j := 1 to VSegments - 1 do
  begin
    SinCos((j / (VSegments)) * Pi, gh, gv);
    v := gv * Radius + Y;
    for i := 0 to HSegments - 1 do
    begin
      SinCos((i / (HSegments)) * TwoPi, s, c);
      n := G2Vec3(s * gh, gv, c * gh);
      AddVertex(X + s * gh * Radius, v, Z + c * gh * Radius, Color, n.X, n.Y, n.Z);
    end;
  end;
  LastV := AddVertex(X, Y - Radius, Z, Color, 0, -1, 0);
  for i := 1 to HSegments - 1 do
  AddFace(0, i, i + 1);
  AddFace(0, HSegments, 1);
  for j := 0 to VSegments - 3 do
  begin
    for i := 1 to HSegments - 1 do
    begin
      v1 := (j + 0) * HSegments + (i + 0);
      v2 := (j + 1) * HSegments + (i + 0);
      v3 := (j + 0) * HSegments + (i + 1);
      v4 := (j + 1) * HSegments + (i + 1);
      AddFace(v1, v2, v3); AddFace(v3, v2, v4);
    end;
    i := HSegments;
    v1 := (j + 0) * HSegments + (i);
    v2 := (j + 1) * HSegments + (i);
    v3 := (j + 0) * HSegments + (1);
    v4 := (j + 1) * HSegments + (1);
    AddFace(v1, v2, v3); AddFace(v3, v2, v4);
  end;
  j := (VSegments - 2) * HSegments;
  for i := 1 to HSegments - 1 do
  AddFace(LastV, j + i + 1, j + i);
  AddFace(LastV, j + 1, j + HSegments);

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, VCount, 0, ICount div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives3D.DrawCylinder(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const Segments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i: Integer;
  s, c: Extended;
  TopV, BottomV: Word;
  VCount: Integer;
  ICount: Integer;
  vx, vz: Single;
begin
  Result := grFail;
  if Segments < 3 then Exit;
  VCount := Segments * 4 + 2;
  ICount := Segments * 12;
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  m_CurV := 0;
  m_CurI := 0;

  for i := 0 to Segments - 1 do
  begin
    SinCos((i / Segments) * TwoPi, s, c);
    vx := X + s * Radius;
    vz := Z + c * Radius;
    AddVertex(vx, Y + Height, vz, Color, 0, 1, 0);
    AddVertex(vx, Y + Height, vz, Color, s, 0, c);
    AddVertex(vx, Y, vz, Color, s, 0, c);
    AddVertex(vx, Y, vz, Color, 0, -1, 0);
  end;
  TopV := AddVertex(X, Y + Height, Z, Color, 0, 1, 0);
  BottomV := AddVertex(X, Y, Z, Color, 0, -1, 0);
  for i := 0 to Segments - 2 do
  begin
    AddFace(TopV, ((i + 0) * 4 + 0), ((i + 1) * 4 + 0));
    AddFace(((i + 0) * 4 + 1), ((i + 0) * 4 + 2), ((i + 1) * 4 + 1));
    AddFace(((i + 0) * 4 + 2), ((i + 1) * 4 + 2), ((i + 1) * 4 + 1));
    AddFace(BottomV, ((i + 1) * 4 + 3), ((i + 0) * 4 + 3));
  end;
  i := (Segments - 1) * 4;
  AddFace(TopV, i, 0);
  AddFace((i + 1), (i + 2), 1);
  AddFace((i + 2), 2, 1);
  AddFace(BottomV, 3, i + 3);

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, VCount, 0, ICount div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives3D.DrawCapsule(
      const X, Y, Z: Single;
      const Height, Radius: Single;
      const Color: TG2Color;
      const VCapSegments: Integer = 8;
      const HSegments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j, v: Integer;
  gv, gh: Extended;
  s, c: Extended;
  TopV, BottomV: Word;
  VCount: Integer;
  ICount: Integer;
  n: TG2Vec3;
  vx, vz: Single;
  HalfHeight: Single;
begin
  Result := grFail;
  if (VCapSegments < 1) or (HSegments < 3) then Exit;
  VCount := VCapSegments * HSegments * 2 + 2;
  ICount := 12 * (VCapSegments * HSegments);
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  m_CurV := 0;
  m_CurI := 0;

  HalfHeight := Height * 0.5;

  for i := 0 to HSegments - 1 do
  begin
    SinCos((i / HSegments) * TwoPi, s, c);
    for j := 1 to VCapSegments do
    begin
      SinCos((j / (VCapSegments)) * HalfPi, gh, gv);
      vx := X + s * Radius * gh;
      vz := Z + c * Radius * gh;
      n := G2Vec3(s * gh, gv, c * gh);
      AddVertex(
        vx,
        Y + HalfHeight + Radius * gv,
        vz,
        Color,
        n.x, n.y, n.z
      );
      AddVertex(
        vx,
        Y - HalfHeight - Radius * gv,
        vz,
        Color,
        n.x, -n.y, n.z
      );
    end;
  end;
  TopV := AddVertex(X, Y + HalfHeight + Radius, Z, Color, 0, 1, 0);
  BottomV := AddVertex(X, Y - HalfHeight - Radius, Z, Color, 0, -1, 0);
  v := (VCapSegments) * 2;
  for i := 0 to HSegments - 2 do
  begin
    AddFace(TopV, i * v, (i + 1) * v);
    AddFace(BottomV, (i + 1) * v + 1, i * v + 1);
    AddFace(i * v + v - 2, i * v + v - 1, (i + 1) * v + v - 2);
    AddFace((i + 1) * v + v - 1, (i + 2) * v - 2, i * v + v - 1);
    for j := 0 to VCapSegments - 2 do
    begin
      AddFace(i * v + j * 2, (i + 1) * v + (j + 1) * 2, (i + 1) * v + j * 2);
      AddFace((i + 1) * v + (j + 1) * 2, i * v + j * 2, i * v + (j + 1) * 2);
      AddFace(i * v + j * 2 + 1, (i + 1) * v + j * 2 + 1, (i + 1) * v + (j + 1) * 2 + 1);
      AddFace((i + 1) * v + (j + 1) * 2 + 1, i * v + (j + 1) * 2 + 1, i * v + j * 2 + 1);
    end;
  end;
  i := (HSegments - 1);
  AddFace(TopV, i * v, 0);
  AddFace(BottomV, 1, i * v + 1);
  AddFace(i * v + v - 2, i * v + v - 1, v - 2);
  AddFace(v - 1, v - 2, i * v + v - 1);
  for j := 0 to VCapSegments - 2 do
  begin
    AddFace(i * v + j * 2, (j + 1) * 2, j * 2);
    AddFace((j + 1) * 2, i * v + j * 2, i * v + (j + 1) * 2);
    AddFace(i * v + j * 2 + 1, j * 2 + 1, (j + 1) * 2 + 1);
    AddFace((j + 1) * 2 + 1, i * v + (j + 1) * 2 + 1, i * v + j * 2 + 1);
  end;

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurV, 0, m_CurI div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives3D.DrawTorus(
      const X, Y, Z: Single;
      const RadiusInt, RadiusExt: Single;
      const Color: TG2Color;
      const Sides: Integer = 16;
      const Segments: Integer = 32
    ): TG2Result;
var
  hr: HResult;
  i, j: Integer;
  gv, gh: Extended;
  s, c, s1, c1: Extended;
  TopV, BottomV: Word;
  VCount: Integer;
  ICount: Integer;
  n: TG2Vec3;
  vx, vz: Single;
  v, v1, v2: TG2Vec3;
  fv1, fv2, fv3, fv4: Word;
  HalfHeight: Single;
  Radius1, Radius2: Single;
begin
  Result := grFail;
  if (Sides < 3) or (Segments < 3) then Exit;
  VCount := Segments * Sides;
  ICount := Sides * Segments * 6;
  if G2ResFail(VerifyVB(VCount)) then Exit;
  if G2ResFail(VerifyIB(ICount)) then Exit;
  hr := m_VB.Lock(0, SizeOf(TG2Vertex) * VCount, Pointer(m_Vertices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;
  hr := m_IB.Lock(0, SizeOf(Word) * ICount, Pointer(m_Indices), D3DLOCK_DISCARD);
  if Failed(hr) then Exit;

  m_CurV := 0;
  m_CurI := 0;

  Radius1 := (RadiusExt - RadiusInt) * 0.5;
  Radius2 := RadiusInt + Radius1;

  for i := 0 to Segments - 1 do
  begin
    SinCos((i / Segments) * TwoPi, s, c);
    v := G2Vec3(X + s * Radius2, Y, Z + c * Radius2);
    for j := 0 to Sides - 1 do
    begin
      SinCos((j / Sides) * TwoPi, s1, c1);
      n := G2Vec3(s * c1, s1, c * c1);
      v1 := v + n * Radius1;
      AddVertex(v1.x, v1.Y, v1.z, Color, n.x, n.y, n.z);
    end;
  end;
  for i := 0 to Segments - 2 do
  begin
    for j := 0 to Sides - 2 do
    begin
      fv1 := i * Sides + j;
      fv2 := (i + 1) * Sides + j;
      fv3 := i * Sides + (j + 1);
      fv4 := (i + 1) * Sides + (j + 1);
      AddFace(fv1, fv2, fv3);
      AddFace(fv3, fv2, fv4);
    end;
    j := Sides - 1;
    fv1 := i * Sides + j;
    fv2 := (i + 1) * Sides + j;
    fv3 := i * Sides;
    fv4 := (i + 1) * Sides;
    AddFace(fv1, fv2, fv3);
    AddFace(fv3, fv2, fv4);
  end;
  i := Segments - 1;
  for j := 0 to Sides - 2 do
  begin
    fv1 := i * Sides + j;
    fv2 := j;
    fv3 := i * Sides + (j + 1);
    fv4 := (j + 1);
    AddFace(fv1, fv2, fv3);
    AddFace(fv3, fv2, fv4);
  end;
  j := Sides - 1;
  fv1 := i * Sides + j;
  fv2 := j;
  fv3 := i * Sides;
  fv4 := 0;
  AddFace(fv1, fv2, fv3);
  AddFace(fv3, fv2, fv4);

  hr := m_IB.Unlock;
  if Failed(hr) then Exit;
  hr := m_VB.Unlock;
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetFVF(FVF);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetIndices(m_IB);
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.SetStreamSource(0, m_VB, 0, SizeOf(TG2Vertex));
  if Failed(hr) then Exit;
  hr := Core.Graphics.Device.DrawIndexedPrimitive(D3DPT_TRIANGLELIST, 0, 0, m_CurV, 0, m_CurI div 3);
  if Failed(hr) then Exit;
  Result := grOk;
end;

function TG2Primitives3D.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnDeviceLost;
  m_PlugGraphics.OnDeviceReset := OnDeviceReset;
  VerifyVB(256);
  VerifyIB(1024);
  Result := grOk;
end;

function TG2Primitives3D.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;
//TG2Primitives3D END

//TG2ShaderMgr BEGIN
constructor TG2ShaderMgr.Create;
begin
  inherited Create;
end;

destructor TG2ShaderMgr.Destroy;
begin
  inherited Destroy;
end;

procedure TG2ShaderMgr.OnLostDevice;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2Shader(m_Resources[i]).OnLostDevice;
end;

procedure TG2ShaderMgr.OnResetDevice;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2Shader(m_Resources[i]).OnResetDevice;
end;

function TG2ShaderMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnLostDevice;
  m_PlugGraphics.OnDeviceReset := OnResetDevice;
  Result := grOk;
end;

function TG2ShaderMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;

function TG2ShaderMgr.CreateVertexShaderFromFile(const Name: AnsiString; const f: AnsiString): TG2VertexShader;
begin
  Result := TG2VertexShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFile(f)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreateVertexShaderFromFileCompiled(const Name: AnsiString; const f: String): TG2VertexShader;
begin
  Result := TG2VertexShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFileCompiled(f)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreateVertexShaderFromMemory(const Name: AnsiString; const Ptr: Pointer; const Size: DWord): TG2VertexShader;
begin
  Result := TG2VertexShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromMemory(Ptr, Size)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreateVertexShaderFromFunction(const Name: AnsiString; const Func: PDWord): TG2VertexShader;
begin
  Result := TG2VertexShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFunction(Func)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreatePixelShaderFromFile(const Name: AnsiString; const f: AnsiString): TG2PixelShader;
begin
  Result := TG2PixelShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFile(f)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreatePixelShaderFromFileCompiled(const Name: AnsiString; const f: String): TG2PixelShader;
begin
  Result := TG2PixelShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFileCompiled(f)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreatePixelShaderFromMemory(const Name: AnsiString; const Ptr: Pointer; const Size: DWord): TG2PixelShader;
begin
  Result := TG2PixelShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromMemory(Ptr, Size)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.CreatePixelShaderFromFunction(const Name: AnsiString; const Func: PDWord): TG2PixelShader;
begin
  Result := TG2PixelShader.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromFunction(Func)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2ShaderMgr.FindShader(const Name: AnsiString): TG2Shader;
begin
  Result := TG2Shader(FindResource(Name));
end;
//TG2ShaderMgr END

//TG2Shader BEGIN
constructor TG2Shader.Create;
begin
  inherited Create;
end;

destructor TG2Shader.Destroy;
begin
  inherited Destroy;
end;

function TG2Shader.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  m_ShaderFunction := nil;
end;

function TG2Shader.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Release;
end;

function TG2Shader.LoadFromFile(const f: AnsiString): TG2Result;
var
  ShaderBuffer: ID3DXBuffer;
  ErrorBuffer: ID3DXBuffer;
  ErrorLog: AnsiString;
begin
  Release;
  if Failed(
    D3DXAssembleShaderFromFileA(
      PAnsiChar(f),
      nil,
      nil,
      0,
      @ShaderBuffer,
      @ErrorBuffer
    )
  ) then
  begin
    Result := grFail;
    SetLength(ErrorLog, ErrorBuffer.GetBufferSize);
    Move(PChar(ErrorBuffer.GetBufferPointer)^, ErrorLog[1], ErrorBuffer.GetBufferSize);
    SafeRelease(ErrorBuffer);
    G2WriteLogTimed('(E) Shader compilation failed (' + Name + '): '#$D#$A + ErrorLog, 'Shaders');
    Exit;
  end;
  New(m_CompiledShader);
  SetLength(m_CompiledShader^, ShaderBuffer.GetBufferSize);
  Move(PByte(ShaderBuffer.GetBufferPointer)^, m_CompiledShader^[0], ShaderBuffer.GetBufferSize);
  SafeRelease(ShaderBuffer);
  Result := grOk;
end;

function TG2Shader.LoadFromFileCompiled(const f: String): TG2Result;
var
  fs: TFileStream;
begin
  Result := grOk;
  Release;
  New(m_CompiledShader);
  try
    fs := TFileStream.Create(f, fmOpenRead);
    try
      SetLength(m_CompiledShader^, fs.Size);
      fs.Position := 0;
      fs.ReadBuffer(m_CompiledShader^[0], fs.Size);
    finally
      fs.Free;
    end;
  except
    Result := grFail;
  end;
end;

function TG2Shader.LoadFromMemory(const Ptr: Pointer; const Size: DWord): TG2Result;
begin
  Release;
  New(m_CompiledShader);
  SetLength(m_CompiledShader^, Size);
  Move(PByte(Ptr)^, m_CompiledShader^[0], Size);
  Result := grOk;
end;

function TG2Shader.LoadFromFunction(const Func: PDWord): TG2Result;
begin
  Release;
  m_ShaderFunction := Func;
  Result := grOk;
end;

procedure TG2Shader.Release;
begin
  if m_CompiledShader <> nil then
  begin
    SetLength(m_CompiledShader^, 0);
    Dispose(m_CompiledShader);
    m_CompiledShader := nil;
  end;
end;

procedure TG2Shader.OnLostDevice;
begin

end;

procedure TG2Shader.OnResetDevice;
begin

end;
//TG2Shader END

//TG2VertexShader BEGIN
constructor TG2VertexShader.Create;
begin
  inherited Create;
end;

destructor TG2VertexShader.Destroy;
begin
  inherited Destroy;
end;

function TG2VertexShader.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(+) VertexShader Initialized: (' + Name + ').', 'Shaders');
end;

function TG2VertexShader.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(-) VertexShader Finalized: (' + Name + ').', 'Shaders');
end;

function TG2VertexShader.LoadFromFile(const f: AnsiString): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromFile(f);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreateVertexShader(
      @(m_CompiledShader^[0]),
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) VertexShader Loaded (' + Name + ').', 'Shaders');
end;

function TG2VertexShader.LoadFromFileCompiled(const f: String): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromFileCompiled(f);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreateVertexShader(
      @(m_CompiledShader^[0]),
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) VertexShader Loaded (' + Name + ').', 'Shaders');
end;

function TG2VertexShader.LoadFromMemory(const Ptr: Pointer; const Size: DWord): TG2Result;  
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromMemory(Ptr, Size);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreateVertexShader(
      @(m_CompiledShader^[0]),
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) VertexShader Loaded (' + Name + ').', 'Shaders');
end;

function TG2VertexShader.LoadFromFunction(const Func: PDWord): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromFunction(Func);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreateVertexShader(
      m_ShaderFunction,
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) VertexShader Loaded (' + Name + ').', 'Shaders');
end;

procedure TG2VertexShader.SetConstantF(const r: DWord; const c: PSingle; const F4Count: DWord);
begin
  Core.Graphics.Device.SetVertexShaderConstantF(r, c, F4Count);
end;

procedure TG2VertexShader.SetConstantI(const r: DWord; const c: PInteger; const I4Count: DWord);
begin
  Core.Graphics.Device.SetVertexShaderConstantI(r, c, I4Count);
end;

procedure TG2VertexShader.SetConstantB(const r: DWord; const c: PBool; const BCount: DWord);
begin
  Core.Graphics.Device.SetVertexShaderConstantB(r, c, BCount);
end;

procedure TG2VertexShader.SetToDevice;
begin
  Core.Graphics.Device.SetVertexShader(m_Shader);
end;

procedure TG2VertexShader.Release;
begin
  if Assigned(m_Shader) then
  G2WriteLogTimed('(<) VertexShader Released: (' + Name + ').', 'Shaders');
  SafeRelease(m_Shader);
  inherited Release;
end;

procedure TG2VertexShader.OnLostDevice;    
begin
  SafeRelease(m_Shader);
end;

procedure TG2VertexShader.OnResetDevice;   
begin
  if Assigned(m_ShaderFunction) then
  Core.Graphics.Device.CreateVertexShader(
    m_ShaderFunction,
    m_Shader
  )
  else if Assigned(m_CompiledShader) then
  Core.Graphics.Device.CreateVertexShader(
    @(m_CompiledShader^[0]),
    m_Shader
  );
end;
//TG2VertexShader END

//TG2PixelShader BEGIN
constructor TG2PixelShader.Create;
begin
  inherited Create;
end;

destructor TG2PixelShader.Destroy;
begin
  inherited Destroy;
end;                         

function TG2PixelShader.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(+) PixelShader Initialized: (' + Name + ').', 'Shaders');
end;

function TG2PixelShader.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(+) PixelShader Finalized: (' + Name + ').', 'Shaders');
end;

function TG2PixelShader.LoadFromFile(const f: AnsiString): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromFile(f);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreatePixelShader(
      @(m_CompiledShader^[0]),
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) PixelShader Loaded (' + Name + ').', 'Shaders');
end;

function TG2PixelShader.LoadFromFileCompiled(const f: String): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromFileCompiled(f);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreatePixelShader(
      @(m_CompiledShader^[0]),
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) PixelShader Loaded (' + Name +').', 'Shaders');
end;

function TG2PixelShader.LoadFromMemory(const Ptr: Pointer; const Size: DWord): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromMemory(Ptr, Size);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreatePixelShader(
      @(m_CompiledShader^[0]),
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) PixelShader Loaded (' + Name + ').', 'Shaders');
end;

function TG2PixelShader.LoadFromFunction(const Func: PDWord): TG2Result;
begin
  SafeRelease(m_Shader);
  Result := inherited LoadFromFunction(Func);
  if G2ResFail(Result) then Exit;
  if Failed(
    Core.Graphics.Device.CreatePixelShader(
      m_ShaderFunction,
      m_Shader
    )
  ) then
  Result := grFail
  else
  G2WriteLogTimed('(>) PixelShader Loaded (' + Name + ').', 'Shaders');
end;

procedure TG2PixelShader.SetConstantF(const c: DWord; const Value: PSingle; const F4Count: DWord);
begin
  Core.Graphics.Device.SetPixelShaderConstantF(c, Value, F4Count);
end;

procedure TG2PixelShader.SetConstantI(const c: DWord; const Value: PInteger; const I4Count: DWord);
begin
  Core.Graphics.Device.SetPixelShaderConstantI(c, Value, I4Count);
end;

procedure TG2PixelShader.SetConstantB(const c: DWord; const Value: PBool; const BCount: DWord);
begin
  Core.Graphics.Device.SetPixelShaderConstantB(c, Value, BCount);
end;

procedure TG2PixelShader.SetToDevice;
begin
  Core.Graphics.Device.SetPixelShader(m_Shader);
end;

procedure TG2PixelShader.Release;      
begin
  if Assigned(m_Shader) then
  G2WriteLogTimed('(<) PixelShader Released (' + Name + ').', 'Shaders');
  SafeRelease(m_Shader);
  inherited Release;
end;

procedure TG2PixelShader.OnLostDevice;   
begin
  SafeRelease(m_Shader);
end;

procedure TG2PixelShader.OnResetDevice;   
begin
  if Assigned(m_ShaderFunction) then
  Core.Graphics.Device.CreatePixelShader(
    m_ShaderFunction,
    m_Shader
  )
  else if m_CompiledShader <> nil then
  Core.Graphics.Device.CreatePixelShader(
    @(m_CompiledShader^[0]),
    m_Shader
  );
end;
//TG2PixelShader END

//TG2EffectMgr BEGIN
constructor TG2EffectMgr.Create;
begin
  inherited Create;
end;

destructor TG2EffectMgr.Destroy;
begin
  inherited Destroy;
end;                             

procedure TG2EffectMgr.OnLostDevice;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2Effect(m_Resources[i]).OnLostDevice;
end;

procedure TG2EffectMgr.OnResetDevice;
var
  i: Integer;
begin
  for i := 0 to m_Resources.Count - 1 do
  TG2Effect(m_Resources[i]).OnResetDevice;
end;

function TG2EffectMgr.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Core.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := OnLostDevice;
  m_PlugGraphics.OnDeviceReset := OnResetDevice;
  Result := grOk;
end;

function TG2EffectMgr.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleasePlug(@m_PlugGraphics);
  Result := grOk;
end;

function TG2EffectMgr.CreateEffectFromFile(const Name: AnsiString; f: AnsiString): TG2Effect;
begin
  Result := TG2Effect.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if FileExists(f) then
  if G2ResOk(Result.LoadFromFile(f)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2EffectMgr.CreateEffectFromMemory(const Name: AnsiString; const Ptr: Pointer; const Size: Integer): TG2Effect;
begin
  Result := TG2Effect.Create;
  Result.Name := Name;
  Result.Initialize(Core);
  if G2ResOk(Result.LoadFromMemory(Ptr, Size)) then
  AddResource(Result) else FreeAndNil(Result);
end;

function TG2EffectMgr.FindEffect(const Name: AnsiString): TG2Effect;
begin
  Result := TG2Effect(FindResource(Name));
end;
//TG2EffectMgr END

//TG2Effect BEGIN
constructor TG2Effect.Create;
begin
  inherited Create;
end;

destructor TG2Effect.Destroy;
begin
  inherited Destroy;
end;                            

function TG2Effect.GetCurTechnique: TD3DXHandle;
begin
  Result := m_Effect.GetCurrentTechnique;
end;

procedure TG2Effect.SetCurTechnique(const Value: TD3DXHandle);
begin
  m_Effect.SetTechnique(Value);
end;

function TG2Effect.BeginEffect(Passes: PLongWord; const Flags: DWORD = 0): TG2Result;
begin
  if Succeeded(m_Effect._Begin(Passes, Flags)) then
  Result := grOk else Result := grFail;
end;

function TG2Effect.EndEffect: TG2Result;
begin
  if Succeeded(m_Effect._End) then
  Result := grOk else Result := grFail;
end;

function TG2Effect.BeginPass(const Pass: LongWord): TG2Result;
begin
  if Succeeded(m_Effect.BeginPass(Pass)) then
  Result := grOk else Result := grFail;
end;

function TG2Effect.EndPass: TG2Result;
begin
  if Succeeded(m_Effect.EndPass) then
  Result := grOk else Result := grFail;
end;

function TG2Effect.CommitChanges: TG2Result;
begin
  if Succeeded(m_Effect.CommitChanges) then
  Result := grOk else Result := grFail;
end;

function TG2Effect.SetValue(hParameter: TD3DXHandle; pData: Pointer; Bytes: LongWord): HResult;
begin
  Result := m_Effect.SetValue(hParameter, pData, Bytes);
end;

function TG2Effect.GetValue(hParameter: TD3DXHandle; pData: Pointer; Bytes: LongWord): HResult;      
begin
  Result := m_Effect.GetValue(hParameter, pData, Bytes);
end;

function TG2Effect.SetBool(hParameter: TD3DXHandle; b: BOOL): HResult;                              
begin
  Result := m_Effect.SetBool(hParameter, b);
end;

function TG2Effect.GetBool(hParameter: TD3DXHandle; out pb: BOOL): HResult;                         
begin
  Result := m_Effect.GetBool(hParameter, pb);
end;

function TG2Effect.SetBoolArray(hParameter: TD3DXHandle; pb: PBOOL; Count: LongWord): HResult;       
begin
  Result := m_Effect.SetBoolArray(hParameter, pb, Count);
end;

function TG2Effect.GetBoolArray(hParameter: TD3DXHandle; pb: PBOOL; Count: LongWord): HResult;      
begin
  Result := m_Effect.GetBoolArray(hParameter, pb, Count);
end;

function TG2Effect.SetInt(hParameter: TD3DXHandle; n: Integer): HResult;                             
begin
  Result := m_Effect.SetInt(hParameter, n);
end;

function TG2Effect.GetInt(hParameter: TD3DXHandle; out pn: Integer): HResult;                         
begin
  Result := m_Effect.GetInt(hParameter, pn);
end;

function TG2Effect.SetIntArray(hParameter: TD3DXHandle; pn: PInteger; Count: LongWord): HResult;     
begin
  Result := m_Effect.SetIntArray(hParameter, pn, Count);
end;

function TG2Effect.GetIntArray(hParameter: TD3DXHandle; pn: PInteger; Count: LongWord): HResult;     
begin
  Result := m_Effect.GetIntArray(hParameter, pn, Count);
end;

function TG2Effect.SetFloat(hParameter: TD3DXHandle; f: Single): HResult;                            
begin
  Result := m_Effect.SetFloat(hParameter, f);
end;

function TG2Effect.GetFloat(hParameter: TD3DXHandle; out pf: Single): HResult;                      
begin
  Result := m_Effect.GetFloat(hParameter, pf);
end;

function TG2Effect.SetFloatArray(hParameter: TD3DXHandle; pf: PSingle; Count: LongWord): HResult;   
begin
  Result := m_Effect.SetFloatArray(hParameter, pf, Count);
end;

function TG2Effect.GetFloatArray(hParameter: TD3DXHandle; pf: PSingle; Count: LongWord): HResult;    
begin
  Result := m_Effect.GetFloatArray(hParameter, pf, Count);
end;

function TG2Effect.SetVector(hParameter: TD3DXHandle; const pVector: TD3DXVector4): HResult;         
begin
  Result := m_Effect.SetVector(hParameter, pVector);
end;

function TG2Effect.GetVector(hParameter: TD3DXHandle; out pVector: TD3DXVector4): HResult;           
begin
  Result := m_Effect.GetVector(hParameter, pVector);
end;

function TG2Effect.SetVectorArray(hParameter: TD3DXHandle; pVector: PD3DXVector4; Count: LongWord): HResult;  
begin
  Result := m_Effect.SetVectorArray(hParameter, pVector, Count);
end;

function TG2Effect.GetVectorArray(hParameter: TD3DXHandle; pVector: PD3DXVector4; Count: LongWord): HResult; 
begin
  Result := m_Effect.GetVectorArray(hParameter, pVector, Count);
end;

function TG2Effect.SetMatrix(hParameter: TD3DXHandle; const pMatrix: TD3DXMatrix): HResult;      
begin
  Result := m_Effect.SetMatrix(hParameter, pMatrix);
end;

function TG2Effect.GetMatrix(hParameter: TD3DXHandle; out pMatrix: TD3DXMatrix): HResult;     
begin
  Result := m_Effect.GetMatrix(hParameter, pMatrix);
end;

function TG2Effect.SetMatrixArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult;  
begin
  Result := m_Effect.SetMatrixArray(hParameter, pMatrix, Count);
end;

function TG2Effect.GetMatrixArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult;  
begin
  Result := m_Effect.GetMatrixArray(hParameter, pMatrix, Count);
end;

function TG2Effect.SetMatrixPointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult;   
begin
  Result := m_Effect.SetMatrixPointerArray(hParameter, ppMatrix, Count);
end;

function TG2Effect.GetMatrixPointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult;     
begin
  Result := m_Effect.GetMatrixPointerArray(hParameter, ppMatrix, Count);
end;

function TG2Effect.SetMatrixTranspose(hParameter: TD3DXHandle; const pMatrix: TD3DXMatrix): HResult;  
begin
  Result := m_Effect.SetMatrixTranspose(hParameter, pMatrix);
end;

function TG2Effect.GetMatrixTranspose(hParameter: TD3DXHandle; out pMatrix: TD3DXMatrix): HResult;    
begin
  Result := m_Effect.GetMatrixTranspose(hParameter, pMatrix);
end;

function TG2Effect.SetMatrixTransposeArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult;         
begin
  Result := m_Effect.SetMatrixTransposeArray(hParameter, pMatrix, Count);
end;

function TG2Effect.GetMatrixTransposeArray(hParameter: TD3DXHandle; pMatrix: PD3DXMatrix; Count: LongWord): HResult;        
begin
  Result := m_Effect.GetMatrixTransposeArray(hParameter, pMatrix, Count);
end;

function TG2Effect.SetMatrixTransposePointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult;
begin
  Result := m_Effect.SetMatrixTransposePointerArray(hParameter, ppMatrix, Count);
end;

function TG2Effect.GetMatrixTransposePointerArray(hParameter: TD3DXHandle; ppMatrix: PPD3DXMatrix; Count: LongWord): HResult;   
begin
  Result := m_Effect.GetMatrixTransposePointerArray(hParameter, ppMatrix, Count);
end;

function TG2Effect.SetString(hParameter: TD3DXHandle; pString: PAnsiChar): HResult;  
begin
  Result := m_Effect.SetString(hParameter, pString);
end;

function TG2Effect.GetString(hParameter: TD3DXHandle; out ppString: PAnsiChar): HResult;    
begin
  Result := m_Effect.GetString(hParameter, ppString);
end;

function TG2Effect.SetTexture(hParameter: TD3DXHandle; pTexture: IDirect3DBaseTexture9): HResult; 
begin
  Result := m_Effect.SetTexture(hParameter, pTexture);
end;

function TG2Effect.GetTexture(hParameter: TD3DXHandle; out ppTexture: IDirect3DBaseTexture9): HResult;  
begin
  Result := m_Effect.GetTexture(hParameter, ppTexture);
end;

function TG2Effect.GetPixelShader(hParameter: TD3DXHandle; out ppPShader: IDirect3DPixelShader9): HResult;  
begin
  Result := m_Effect.GetPixelShader(hParameter, ppPShader);
end;

function TG2Effect.GetVertexShader(hParameter: TD3DXHandle; out ppVShader: IDirect3DVertexShader9): HResult;
begin
  Result := m_Effect.GetVertexShader(hParameter, ppVShader);
end;

function TG2Effect.SetArrayRange(hParameter: TD3DXHandle; uStart, uEnd: LongWord): HResult;
begin
  Result := m_Effect.SetArrayRange(hParameter, uStart, uEnd);
end;

function TG2Effect.GetDesc(out pDesc: TD3DXEffectDesc): HResult;                                          
begin
  Result := m_Effect.GetDesc(pDesc);
end;

function TG2Effect.GetParameterDesc(hParameter: TD3DXHandle; out pDesc: TD3DXParameterDesc): HResult;    
begin
  Result := m_Effect.GetParameterDesc(hParameter, pDesc);
end;

function TG2Effect.GetTechniqueDesc(hTechnique: TD3DXHandle; out pDesc: TD3DXTechniqueDesc): HResult;   
begin
  Result := m_Effect.GetTechniqueDesc(hTechnique, pDesc);
end;

function TG2Effect.GetPassDesc(hPass: TD3DXHandle; out pDesc: TD3DXPassDesc): HResult;                 
begin
  Result := m_Effect.GetPassDesc(hPass, pDesc);
end;

function TG2Effect.GetFunctionDesc(hShader: TD3DXHandle; out pDesc: TD3DXFunctionDesc): HResult;     
begin
  Result := m_Effect.GetFunctionDesc(hShader, pDesc);
end;

function TG2Effect.GetParameter(hParameter: TD3DXHandle; Index: LongWord): TD3DXHandle;               
begin
  Result := m_Effect.GetParameter(hParameter, Index);
end;

function TG2Effect.GetParameterByName(hParameter: TD3DXHandle; pName: PAnsiChar): TD3DXHandle;           
begin
  Result := m_Effect.GetParameterByName(hParameter, pName);
end;

function TG2Effect.GetParameterBySemantic(hParameter: TD3DXHandle; pSemantic: PAnsiChar): TD3DXHandle;    
begin
  Result := m_Effect.GetParameterBySemantic(hParameter, pSemantic);
end;

function TG2Effect.GetParameterElement(hParameter: TD3DXHandle; Index: LongWord): TD3DXHandle;          
begin
  Result := m_Effect.GetParameterElement(hParameter, Index);
end;

function TG2Effect.GetTechnique(Index: LongWord): TD3DXHandle;                                          
begin
  Result := m_Effect.GetTechnique(Index);
end;

function TG2Effect.GetTechniqueByName(pName: PAnsiChar): TD3DXHandle;                                     
begin
  Result := m_Effect.GetTechniqueByName(pName);
end;

function TG2Effect.GetPass(hTechnique: TD3DXHandle; Index: LongWord): TD3DXHandle;               
begin
  Result := m_Effect.GetPass(hTechnique, Index);
end;

function TG2Effect.GetPassByName(hTechnique: TD3DXHandle; pName: PAnsiChar): TD3DXHandle;   
begin
  Result := m_Effect.GetPassByName(hTechnique, pName);
end;

function TG2Effect.GetFunction(Index: LongWord): TD3DXHandle;                             
begin
  Result := m_Effect.GetFunction(Index);
end;

function TG2Effect.GetFunctionByName(pName: PAnsiChar): TD3DXHandle;                    
begin
  Result := m_Effect.GetFunctionByName(pName);
end;

function TG2Effect.GetAnnotation(hObject: TD3DXHandle; Index: LongWord): TD3DXHandle;         
begin
  Result := m_Effect.GetAnnotation(hObject, Index);
end;

function TG2Effect.GetAnnotationByName(hObject: TD3DXHandle; pName: PAnsiChar): TD3DXHandle;   
begin
  Result := m_Effect.GetAnnotationByName(hObject, pName);
end;

function TG2Effect.Initialize(const G2Core: TG2Core): TG2Result;
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  Result := grOk;
  G2WriteLogTimed('(+) Effect Initialized: (' + Name + ').', 'Shaders');
end;

function TG2Effect.Finalize: TG2Result;
begin
  Result := inherited Finalize;                       
  if G2ResFail(Result) then Exit;
  Release;
  Result := grOk;
  G2WriteLogTimed('(-) Effect Finalized: (' + Name + ').', 'Shaders');
end;

function TG2Effect.LoadFromFile(f: AnsiString): TG2Result;
var
  ErrorBuffer: ID3DXBuffer;
  ErrorStr: AnsiString;
begin
  Release;
  if FAILED(
    D3DXCreateEffectFromFileA(
      Core.Graphics.Device,
      PAnsiChar(f),
      nil,
      nil,
      0,
      nil,
      m_Effect,
      @ErrorBuffer
    )
  ) then
  begin
    SetLength(ErrorStr, ErrorBuffer.GetBufferSize);
    Move(PChar(ErrorBuffer.GetBufferPointer)^, ErrorStr[1], ErrorBuffer.GetBufferSize);
    SafeRelease(ErrorBuffer);
    G2WriteLogTimed('(E) Failed to load effect(' + Name + '): '#$D#$A + ErrorStr, 'Shaders');
    Result := grFail;
    Exit;
  end;
  Result := grOk;
  G2WriteLogTimed('(>) Effect Loaded (' + Name + ').', 'Shaders');
end;

function TG2Effect.LoadFromMemory(const Ptr: Pointer; const Size: Integer): TG2Result;
var
  ErrorBuffer: ID3DXBuffer;
  ErrorStr: AnsiString;
begin
  Release;
  if Failed(
    D3DXCreateEffect(
      Core.Graphics.Device,
      Ptr,
      Size,
      nil,
      nil,
      0,
      nil,
      m_Effect,
      @ErrorBuffer
    )
  ) then
  begin
    SetLength(ErrorStr, ErrorBuffer.GetBufferSize);
    Move(PChar(ErrorBuffer.GetBufferPointer)^, ErrorStr[1], ErrorBuffer.GetBufferSize);
    SafeRelease(ErrorBuffer);
    G2WriteLogTimed('(E) Faield to load effect(' + Name + '): '#$D#$A + ErrorStr, 'Shaders');
    Result := grFail;
    Exit;
  end;
  Result := grOk;
  G2WriteLogTimed('(>) Effect Loaded (' + Name + ').', 'Shaders');
end;

procedure TG2Effect.Release;
begin
  if Assigned(m_Effect) then
  G2WriteLogTimed('(<) Effect Released (' + Name + ').', 'Shaders');
  SafeRelease(m_Effect);
end;

procedure TG2Effect.OnLostDevice;
begin
  m_Effect.OnLostDevice;
end;

procedure TG2Effect.OnResetDevice;
begin
  m_Effect.OnResetDevice;
end;
//TG2Effect END

//TG2ShaderLib BEGIN
constructor TG2ShaderLib.Create;
begin
  inherited Create;
end;

destructor TG2ShaderLib.Destroy;
begin
  inherited Destroy;
end;

function TG2ShaderLib.Initialize(const G2Core: TG2Core): TG2Result;
{$include Gen2ShaderLibH.inc}
begin
  Result := inherited Initialize(G2Core);
  if G2ResFail(Result) then Exit;
  {$include Gen2ShaderLibB.inc}
  Core.RequestMod(TG2ShaderMgr, @m_VertexShaders);
  Core.RequestMod(TG2ShaderMgr, @m_PixelShaders);
  Core.RequestMod(TG2EffectMgr, @m_Effects);
  Result := grOk;
end;

function TG2ShaderLib.Finalize: TG2Result;
begin
  Result := inherited Finalize;
  if G2ResFail(Result) then Exit;
  Core.ReleaseMod(@m_Effects);
  Core.ReleaseMod(@m_PixelShaders);
  Core.ReleaseMod(@m_VertexShaders);
  Result := grOk;
end;

procedure TG2ShaderLib.CreateShaderBin(const Name: AnsiString; const Ptr: Pointer; const Size: DWord);
var
  ShaderBin: TG2ShaderBin;
begin
  if Assigned(FindResource(Name)) then Exit;
  ShaderBin := TG2ShaderBin.Create;
  ShaderBin.Name := Name;
  ShaderBin.LoadBuffer(Ptr, Size);
  AddResource(ShaderBin);
  G2WriteLogTimed('Binary Shader Added: ' + Name, 'ShaderLib');
end;

procedure TG2ShaderLib.CreateShaderBin(const Name: AnsiString; const Func: PDWord);
var
  ShaderBin: TG2ShaderBin;
begin
  if Assigned(FindResource(Name)) then Exit;
  ShaderBin := TG2ShaderBin.Create;
  ShaderBin.Name := Name;
  ShaderBin.LoadFunction(Func);
  AddResource(ShaderBin);
  G2WriteLogTimed('Binary Shader Added: ' + Name, 'ShaderLib');
end;

function TG2ShaderLib.RequestVertexShader(const Name: AnsiString): TG2VertexShader;
var
  ShaderBin: TG2ShaderBin;
begin
  Result := TG2VertexShader(m_VertexShaders.FindShader(Name));
  if not Assigned(Result) then
  begin
    ShaderBin := TG2ShaderBin(FindResource(Name));
    if Assigned(ShaderBin) then
    begin
      if Assigned(ShaderBin.Func) then
      Result := m_VertexShaders.CreateVertexShaderFromFunction(
        Name,
        ShaderBin.Func
      )
      else
      Result := m_VertexShaders.CreateVertexShaderFromMemory(
        Name,
        ShaderBin.Buffer,
        ShaderBin.Size
      );
    end
    else
    G2WriteLogTimed('(E)' + Name + ' is not in the shader library.', 'ShaderLib');
  end;
end;

function TG2ShaderLib.RequestPixelShader(const Name: AnsiString): TG2PixelShader;
var
  ShaderBin: TG2ShaderBin;
begin
  Result := TG2PixelShader(m_PixelShaders.FindShader(Name));
  if not Assigned(Result) then
  begin
    ShaderBin := TG2ShaderBin(FindResource(Name));
    if Assigned(ShaderBin) then
    begin
      if Assigned(ShaderBin.Func) then
      Result := m_PixelShaders.CreatePixelShaderFromFunction(
        Name,
        ShaderBin.Func
      )
      else
      Result := m_PixelShaders.CreatePixelShaderFromMemory(
        Name,
        ShaderBin.Buffer,
        ShaderBin.Size
      )
    end
    else
    G2WriteLogTimed('(E)' + Name + ' is not in the shader library.', 'ShaderLib');
  end;
end;

function TG2ShaderLib.RequestEffect(const Name: AnsiString): TG2Effect;
var
  ShaderBin: TG2ShaderBin;
begin
  Result := TG2Effect(m_Effects.FindEffect(Name));
  if not Assigned(Result) then
  begin
    ShaderBin := TG2ShaderBin(FindResource(Name));
    if Assigned(ShaderBin) then
    Result := m_Effects.CreateEffectFromMemory(
      Name,
      ShaderBin.Buffer,
      ShaderBin.Size
    )
    else
    G2WriteLogTimed('(E)' + Name + ' is not in the shader library.', 'ShaderLib');
  end;
end;
//TG2ShaderLib END

//TG2ShaderBin BEGIN
constructor TG2ShaderBin.Create;
begin
  inherited Create;
end;

destructor TG2ShaderBin.Destroy;
begin
  inherited Destroy;
end;

function TG2ShaderBin.GetBuffer: Pointer;
begin
  Result := @m_Buffer[0];
end;

function TG2ShaderBin.GetSize: Integer;
begin
  Result := Length(m_Buffer);
end;

procedure TG2ShaderBin.LoadBuffer(const Ptr: Pointer; const Size: DWord);
begin
  SetLength(m_Buffer, Size);
  Move(Ptr^, m_Buffer[0], Size);
  m_Func := @m_Buffer[0];
end;

procedure TG2ShaderBin.LoadFunction(const NewFunc: PDWord);
begin
  m_Func := NewFunc;
end;
//TG2ShaderBin END

//TG2App BEGIN
constructor TG2App.Create;
begin
  inherited Create;
  m_g2 := TG2Core.Create;
  m_Gfx := m_g2.Graphics;
  m_Sfx := m_g2.Audio;
  m_Inp := m_g2.Input;
  m_Net := m_g2.Network;
  m_Tmr := m_g2.Timer;
  m_Pause := False;
  m_AppTime := 0;
end;

destructor TG2App.Destroy;
begin
  Finalize;
  m_g2.Free;
  inherited Destroy;
end;

procedure TG2App.Initialize;
begin
  m_g2.Initialize;
  m_g2.RequestPlug(TG2PlugTimer, @m_PlugTimer);
  m_PlugTimer.OnTimer := AppTimer;
  m_PlugTimer.OnUpdate := AppUpdate;
  m_PlugTimer.OnRender := AppRender;
  m_g2.RequestPlug(TG2PlugGraphics, @m_PlugGraphics);
  m_PlugGraphics.OnDeviceLost := AppDeviceLost;
  m_PlugGraphics.OnDeviceReset := AppDeviceReset;
  m_g2.RequestPlug(TG2PlugInput, @m_PlugInput);
  m_PlugInput.OnKeyDown := AppKeyDown;
  m_PlugInput.OnKeyUp := AppKeyUp;
  m_PlugInput.OnMouseDown := AppMouseDown;
  m_PlugInput.OnMouseUp := AppMouseUp;
  m_PlugInput.OnMouseMove := AppMouseMove;
  m_PlugInput.OnWheelMove := AppWheelMove;
  m_g2.RequestMod(TG2Render, @m_Render);
  m_g2.RequestMod(TG2Render2D, @m_Render2D);
  m_g2.RequestMod(TG2Render3D, @m_Render3D);
  m_g2.RequestMod(TG2Primitives2D, @m_Prim2D);
  m_g2.RequestMod(TG2Primitives3D, @m_Prim3D);
  m_g2.RequestMod(TG2RenderModes, @m_RenderModes);
  m_g2.RequestMod(TG2Camera, @m_Cam);
  m_Cam.SetPerspective;
end;

procedure TG2App.Finalize;
begin
  m_g2.ReleaseMod(@m_Cam);
  m_g2.ReleaseMod(@m_RenderModes);
  m_g2.ReleaseMod(@m_Prim3D);
  m_g2.ReleaseMod(@m_Prim2D);
  m_g2.ReleaseMod(@m_Render3D);
  m_g2.ReleaseMod(@m_Render2D);
  m_g2.ReleaseMod(@m_Render);
  m_g2.ReleasePlug(@m_PlugInput);
  m_g2.ReleasePlug(@m_PlugGraphics);
  m_g2.ReleasePlug(@m_PlugTimer);
  m_g2.Finalize;
end;

procedure TG2App.SetHandle(const Value: HWnd);
begin
  m_g2.Handle := Value;
end;

function TG2App.GetHandle: HWnd;
begin
  Result := m_g2.Handle;
end;

procedure TG2App.AppTimer;
begin
  OnTimer;
end;

procedure TG2App.AppRender;
begin
  if m_Render.CanRender then
  OnRender;
end;

procedure TG2App.AppUpdate;
begin
  if not m_Pause then
  m_AppTime := m_AppTime + Round(1000 / m_g2.Timer.TargetUPS);
  OnUpdate;
end;

procedure TG2App.AppDeviceLost;
begin
  OnDeviceLost;
end;

procedure TG2App.AppDeviceReset;
begin
  OnDeviceReset;
end;

procedure TG2App.AppKeyDown(const Key: Byte);
begin
  OnKeyDown(Key);
end;

procedure TG2App.AppKeyUp(const Key: Byte);   
begin
  OnKeyUp(Key);
end;

procedure TG2App.AppMouseDown(const Button: Byte);   
begin
  OnMouseDown(Button);
end;

procedure TG2App.AppMouseUp(const Button: Byte);      
begin
  OnMouseUp(Button);
end;

procedure TG2App.AppMouseMove(const Shift: TPoint);   
begin
  OnMouseMove(Shift);
end;

procedure TG2App.AppWheelMove(const Shift: Integer);   
begin
  OnWheelMove(Shift);
end;

procedure TG2App.OnTimer;
begin

end;

procedure TG2App.OnRender;
begin

end;

procedure TG2App.OnUpdate;
begin

end;

procedure TG2App.OnDeviceLost;
begin

end;

procedure TG2App.OnDeviceReset;
begin

end;

procedure TG2App.OnKeyDown(const Key: Byte);
begin

end;

procedure TG2App.OnKeyUp(const Key: Byte);    
begin

end;

procedure TG2App.OnMouseDown(const Button: Byte);  
begin

end;

procedure TG2App.OnMouseUp(const Button: Byte);   
begin

end;

procedure TG2App.OnMouseMove(const Shift: TPoint);    
begin

end;

procedure TG2App.OnWheelMove(const Shift: Integer);   
begin

end;
//TG2App END

//Uyility Functions BEGIN
function G2ResOk(const Res: TG2Result): Boolean;
begin
  Result := Res in TG2ResSuccess;
end;

function G2ResFail(const Res: TG2Result): Boolean;
begin
  Result := not (Res in TG2ResSuccess);
end;

procedure SafeRelease(var i);
begin
  if IUnknown(i) <> nil then IUnknown(i) := nil;
end;

function WideStringToString(const WS: WideString; codePage: Word = CP_ACP): AnsiString;
var
  l: integer;
begin
  if WS = '' then
  Result := ''
  else 
  begin
    l := WideCharToMultiByte(
      CodePage,
      WC_COMPOSITECHECK or WC_DISCARDNS or WC_SEPCHARS or WC_DEFAULTCHAR,
      @WS[1], - 1, nil, 0, nil, nil
    );
    SetLength(Result, l - 1);
    if l > 1 then
    WideCharToMultiByte(
      CodePage,
      WC_COMPOSITECHECK or WC_DISCARDNS or WC_SEPCHARS or WC_DEFAULTCHAR,
      @WS[1], - 1, @Result[1], l - 1, nil, nil
    );
  end;
end;

function StringToWideString(const S: AnsiString; codePage: Word = CP_ACP): WideString;
var
  l: integer;
begin
  if s = '' then
  Result := ''
  else 
  begin
    l := MultiByteToWideChar(CodePage, MB_PRECOMPOSED, PAnsiChar(@s[1]), - 1, nil, 0);
    SetLength(Result, l - 1);
    if l > 1 then
    MultiByteToWideChar(
      CodePage,
      MB_PRECOMPOSED,
      PAnsiChar(@S[1]),
      - 1,
      PWideChar(@Result[1]),
      l - 1
    );
  end;
end;

function G2Param(const Str: AnsiString; const Separator: AnsiString; const Param: Integer): AnsiString;
var
  i: Integer;
  j: Integer;
  CurParam: Integer;
  PrevParamIndex: Integer;
  b: Boolean;
begin
  Result := '';
  b := False;
  CurParam := 0;
  PrevParamIndex := 1;
  for i := 1 to Length(Str) do
  begin
    for j := 1 to Length(Separator) do
    begin
      if Str[i + j] <> Separator[j] then
      Break
      else
      begin
        if j = Length(Separator) then
        begin
          if CurParam = Param then
          begin
            b := True;
            SetLength(Result, i - PrevParamIndex + 1);
            move(Str[PrevParamIndex], Result[1], Length(Result));
          end
          else
          begin
            CurParam := CurParam + 1;
            PrevParamIndex := i + Length(Separator) + 1;
          end;
        end;
      end;
    end;
    if b then Break;
    if (i = Length(Str)) and (CurParam = Param) then
    begin
      SetLength(Result, i - PrevParamIndex + 1);
      Move(Str[PrevParamIndex], Result[1], Length(Result));
    end;
  end;
end;

function G2ParamCount(const Str: AnsiString; const Separator: AnsiString): Integer;
var
  i, j: Integer;
  DoInc: Boolean;
begin
  if Length(Str) <= 0 then
  begin
    Result := 0;
    Exit;
  end;
  Result := 1;
  for i := 1 to Length(Str) - Length(Separator) do
  begin
    DoInc := True;
    for j := 1 to Length(Separator) do
    if Str[i + j - 1] <> Separator[j] then
    begin
      DoInc := False;
      Break;
    end;
    if DoInc then
    Result := Result + 1;
  end;
end;

function G2StrInStr(const Str: AnsiString; SubStr: AnsiString): Integer;
var
  i: Integer;
begin
  if Length(SubStr) > 0 then
  begin
    for i := 1 to Length(Str) + 1 - Length(SubStr) do
    if CompareMem(@Str[i], @SubStr[1], Length(SubStr)) then
    begin
      Result := i;
      Exit;
    end;
  end;
  Result := 0;
end;

function G2Color(const R, G, B: Byte; const A: Byte = 255): TG2Color;
begin
  Result.b := B;
  Result.g := G;
  Result.r := R;
  Result.a := A;
end;

function G2Color(const Color: DWord): TG2Color;
begin
  Result := PG2Color(@Color)^;
end;

function G2MatLerp(const Mat1, Mat2: TG2Mat; const s: Single): TG2Mat;
var
  i, j: Integer;
  mr: TD3DXMatrix absolute Result;
  m1: TD3DXMatrix absolute Mat1;
  m2: TD3DXMatrix absolute Mat2;
begin
  for i := 0 to 3 do
  for j := 0 to 3 do
  mr.m[i, j] := G2LerpFloat(m1.m[i, j], m2.m[i, j], s);
end;

function G2MatSLerp(const Mat1, Mat2: TG2Mat; const s: Single): TG2Mat;
var
  Scale, Scale1, Scale2: TD3DXVector3;
  Rotation, Rotation1, Rotation2: TD3DXQuaternion;
  Translation, Translation1, Translation2: TD3DXVector3;
  MatRotation, MatScaling, MatTranslation: TG2Mat;
begin
  Mat1.Decompose(@Scale1, @Rotation1, @Translation1);
  Mat2.Decompose(@Scale2, @Rotation2, @Translation2);
  D3DXVec3Lerp(Scale, Scale1, Scale2, s);
  D3DXQuaternionNormalize(Rotation1, Rotation1);
  D3DXQuaternionNormalize(Rotation2, Rotation2);
  D3DXQuaternionSlerp(Rotation, Rotation1, Rotation2, s);
  D3DXVec3Lerp(Translation, Translation1, Translation2, s);
  MatRotation.SetRotation(Rotation);
  MatScaling.SetScaling(Scale.x, Scale.y, Scale.z);
  MatTranslation.SetTranslation(Translation);
  Result := MatScaling * MatRotation * MatTranslation;
end;

function G2MatRefine(const Pos: TG2Vec3; const MatUnref, ParentUnref: PG2Mat): TG2Mat;
var
  m, m1: TG2Mat;
begin
  if Assigned(ParentUnref) then
  begin
    m := ParentUnref^.Inverse;
    m1 := MatUnref^ * m;
    m.SetTranslation(Pos);
    m := m.Inverse;
    m1 := m1 * m;
    m.SetTranslation(-Pos);
    m := m.Inverse;
    Result := m * m1;
  end
  else
  Result := MatUnref^;
end;

function G2Rect(const Left, Top, Right, Bottom: Single): TG2Rect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Right := Right;
  Result.Bottom := Bottom;
end;

function G2FormatSize(const Format: TD3DFormat): DWord;
begin
  case Format of
    D3DFMT_R8G8B8: Result := 3;
    D3DFMT_A8R8G8B8: Result := 4;
    D3DFMT_X8R8G8B8: Result := 4;
    D3DFMT_R5G6B5: Result := 2;
    D3DFMT_X1R5G5B5: Result := 2;
    D3DFMT_A1R5G5B5: Result := 2;
    D3DFMT_A4R4G4B4: Result := 2;
    D3DFMT_R3G3B2: Result := 1;
    D3DFMT_A8: Result := 1;
    D3DFMT_A8R3G3B2: Result := 2;
    D3DFMT_X4R4G4B4: Result := 2;
    D3DFMT_A2B10G10R10: Result := 4;
    D3DFMT_A8B8G8R8: Result := 4;
    D3DFMT_X8B8G8R8: Result := 4;
    D3DFMT_G16R16: Result := 4;
    D3DFMT_A2R10G10B10: Result := 4;
    D3DFMT_A16B16G16R16: Result := 8;
    D3DFMT_A8P8: Result := 2;
    D3DFMT_P8: Result := 1;
    D3DFMT_L8: Result := 1;
    D3DFMT_A8L8: Result := 2;
    D3DFMT_A4L4: Result := 1;
    D3DFMT_V8U8: Result := 2;
    D3DFMT_L6V5U5: Result := 2;
    D3DFMT_X8L8V8U8: Result := 4;
    D3DFMT_Q8W8V8U8: Result := 4;
    D3DFMT_V16U16: Result := 4;
    D3DFMT_A2W10V10U10: Result := 4;
    D3DFMT_D16_LOCKABLE: Result := 2;
    D3DFMT_D32: Result := 4;
    D3DFMT_D15S1: Result := 2;
    D3DFMT_D24S8: Result := 4;
    D3DFMT_D24X8: Result := 4;
    D3DFMT_D24X4S4: Result := 4;
    D3DFMT_D16: Result := 2;
    D3DFMT_D32F_LOCKABLE: Result := 4;
    D3DFMT_D24FS8: Result := 4;
    D3DFMT_L16: Result := 2;
    D3DFMT_INDEX16: Result := 2;
    D3DFMT_INDEX32: Result := 4;
    D3DFMT_Q16W16V16U16: Result := 8;
    D3DFMT_R16F: Result := 2;
    D3DFMT_G16R16F: Result := 4;
    D3DFMT_A16B16G16R16F: Result := 8;
    D3DFMT_R32F: Result := 4;
    D3DFMT_G32R32F: Result := 8;
    D3DFMT_A32B32G32R32F: Result := 16;
  else
    Result := 0;
  end;
end;

function G2FormatToString(const Format: TD3DFormat): AnsiString;
begin
  case Format of
    D3DFMT_R8G8B8: Result := 'R8G8B8';
    D3DFMT_A8R8G8B8: Result := 'A8R8G8B8';
    D3DFMT_X8R8G8B8: Result := 'X8R8G8B8';
    D3DFMT_R5G6B5: Result := 'R5G6B5';
    D3DFMT_X1R5G5B5: Result := 'X1R5G5B5';
    D3DFMT_A1R5G5B5: Result := 'A1R5G5B5';
    D3DFMT_A4R4G4B4: Result := 'A4R4G4B4';
    D3DFMT_R3G3B2: Result := 'R3G3B2';
    D3DFMT_A8: Result := 'A8';
    D3DFMT_A8R3G3B2: Result := 'A8R3G3B2';
    D3DFMT_X4R4G4B4: Result := 'X4R4G4B4';
    D3DFMT_A2B10G10R10: Result := 'A2B10G10R10';
    D3DFMT_A8B8G8R8: Result := 'A8B8G8R8';
    D3DFMT_X8B8G8R8: Result := 'X8B8G8R8';
    D3DFMT_G16R16: Result := 'G16R16';
    D3DFMT_A2R10G10B10: Result := 'A2R10G10B10';
    D3DFMT_A16B16G16R16: Result := 'A16B16G16R16';
    D3DFMT_A8P8: Result := 'A8P8';
    D3DFMT_P8: Result := 'P8';
    D3DFMT_L8: Result := 'L8';
    D3DFMT_A8L8: Result := 'A8L8';
    D3DFMT_A4L4: Result := 'A4L4';
    D3DFMT_V8U8: Result := 'V8U8';
    D3DFMT_L6V5U5: Result := 'L6V5U5';
    D3DFMT_X8L8V8U8: Result := 'X8L8V8U8';
    D3DFMT_Q8W8V8U8: Result := 'Q8W8V8U8';
    D3DFMT_V16U16: Result := 'V16U16';
    D3DFMT_A2W10V10U10: Result := 'A2W10V10U10';
    D3DFMT_A8X8V8U8: Result := 'A8X8V8U8';
    D3DFMT_L8X8V8U8: Result := 'L8X8V8U8';
    D3DFMT_UYVY: Result := 'UYVY';
    D3DFMT_RGBG: Result := 'RGBG';
    D3DFMT_YUY2: Result := 'YUY2';
    D3DFMT_GRGB: Result := 'GRGB';
    D3DFMT_DXT1: Result := 'DXT1';
    D3DFMT_DXT2: Result := 'DXT2';
    D3DFMT_DXT3: Result := 'DXT3';
    D3DFMT_DXT4: Result := 'DXT4';
    D3DFMT_DXT5: Result := 'DXT5';
    D3DFMT_D16_LOCKABLE: Result := 'D16_LOCKABLE';
    D3DFMT_D32: Result := 'D32';
    D3DFMT_D15S1: Result := 'D15S1';
    D3DFMT_D24S8: Result := 'D24S8';
    D3DFMT_D24X8: Result := 'D24X8';
    D3DFMT_D24X4S4: Result := 'D24X4S4';
    D3DFMT_D16: Result := 'D16';
    D3DFMT_D32F_LOCKABLE: Result := 'D32F_LOCKABLE';
    D3DFMT_D24FS8: Result := 'D24FS8';
    D3DFMT_L16: Result := 'L16';
    D3DFMT_VERTEXDATA: Result := 'VERTEXDATA';
    D3DFMT_INDEX16: Result := 'INDEX16';
    D3DFMT_INDEX32: Result := 'INDEX32';
    D3DFMT_Q16W16V16U16: Result := 'Q16W16V16U16';
    D3DFMT_MULTI2_ARGB8: Result := 'MULTI2_ARGB8';
    D3DFMT_R16F: Result := 'R16F';
    D3DFMT_G16R16F: Result := 'G16R16F';
    D3DFMT_A16B16G16R16F: Result := 'A16B16G16R16F';
    D3DFMT_R32F: Result := 'R32F';
    D3DFMT_G32R32F: Result := 'G32R32F';
    D3DFMT_A32B32G32R32F: Result := 'A32B32G32R32F';
    D3DFMT_CxV8U8: Result := 'CxV8U8';
    D3DFMT_FORCE_DWORD: Result := 'FORCE_DWORD';
  else
    Result := 'Unknown';
  end;
end;

function G2SysInfo: TG2SysInfo;
var
  Reg: TRegistry;
  dd: TDisplayDeviceA;
  i: Integer;
begin
  Result.CPUCount := 0;
  SetLength(Result.CPUs, 0);
  ZeroMemory(@Result.Memory, SizeOf(Result.Memory));
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    i := 0;
    while Reg.OpenKey('\Hardware\Description\System\CentralProcessor\' + IntToStr(i), False) do
    begin
      SetLength(Result.CPUs, i + 1);
      Result.CPUs[i].Name := Reg.ReadString('ProcessorNameString');
      Result.CPUs[i].Identifier := Reg.ReadString('Identifier');
      Result.CPUs[i].Vendor := Reg.ReadString('VendorIdentifier');
      Result.CPUs[i].MHz := Reg.ReadInteger('~MHz');
      Inc(i);
    end;
    Result.CPUCount := Length(Result.CPUs);
    Result.Memory.dwLength := SizeOf(Result.Memory);
    GlobalMemoryStatus(Result.Memory);
    i := 0;
    dd.cb := SizeOf(dd);
    while EnumDisplayDevicesA(nil, i, dd, 0) do
    begin
      if dd.StateFlags and DISPLAY_DEVICE_PRIMARY_DEVICE > 0 then
      Result.DisplayDevice := dd.DeviceString;
      Inc(i);
    end;
  finally
    Reg.Free;
  end;
end;

function G2PiTime(Amp: Single = 1000): Single;
begin
  Result := (GetTickCount mod Round(TwoPi * Amp)) / (Amp);
end;

function G2TimeInterval(Interval: DWord = 1000): Single;
begin
  Result := (GetTickCount mod Interval) / Interval;
end;

function G2RandomPi: Single;
begin
  Result := Random(Round(Pi * 1000)) / 1000;
end;

function G2Random2Pi: Single;
begin
  Result := Random(Round(TwoPi * 1000)) / 1000;
end;

function G2TriangleNormal(v1, v2, v3: TG2Vec3): TG2Vec3;
begin
  Result := (v2 - v1).Cross(v3 - v1);
  Result.Normalize;
end;

function D3DTS_TEXTUREMATRIX(const Index: Byte): TD3DTransformStateType;
begin
  Result := TD3DTransformStateType(16 + Index);
end;

function D3DVertexElement(
    Stream:     Word;
    Offset:     Word;
    _Type:      TD3DDeclType;
    Method:     TD3DDeclMethod;
    Usage:      TD3DDeclUsage;
    UsageIndex: Byte
  ): TD3DVertexElement9;
begin
  Result.Stream := Stream;
  Result.Offset := Offset;
  Result._Type := _Type;
  Result.Method := Method;
  Result.Usage := Usage;
  Result.UsageIndex := UsageIndex;
end;

function G2DefWndProc(Wnd: HWnd; Msg: UInt; wParam: WPARAM; lParam: LPARAM): LResult; stdcall;
begin
  case Msg of
    WM_DESTROY, WM_QUIT, WM_CLOSE:
    begin
      PostQuitMessage(0);
      Result := 0;
      Exit;
    end;
  end;
  Result := DefWindowProcA(Wnd, Msg, wParam, lParam);
end;
//Utility Functions END

//Unit Functions BEGIN
procedure G2RegMeshLoader(const LoaderClass: CG2MeshLoaderClass);
begin
  SetLength(G2MeshLoaders, Length(G2MeshLoaders) + 1);
  G2MeshLoaders[High(G2MeshLoaders)] := LoaderClass;
  G2WriteLogTimed('Mesh Loader Registered (' + LoaderClass.GetDifinition + ')', 'Globals');
end;

procedure G2WriteLog(const Log: AnsiString);
var
  LogHandle: HFile;
  BytesWritten: DWord;
  LogStr: AnsiString;
const
  FILE_APPEND_DATA = $00000004;
begin
  {$IFDEF G2_WRITE_LOG}
  LogStr := Log + #$D#$A;
  LogHandle := CreateFileA(
    PAnsiChar(AppPath + 'G2Log.txt'),
    FILE_APPEND_DATA,
    FILE_SHARE_READ or FILE_SHARE_WRITE or FILE_SHARE_DELETE,
    nil,
    OPEN_ALWAYS,
    FILE_FLAG_RANDOM_ACCESS,
    0
  );
  if LogHandle = INVALID_HANDLE_VALUE then Exit;
  try
    if WriteFile(
      LogHandle,
      LogStr[1],
      Length(LogStr),
      BytesWritten,
      nil
    ) then
    WaitForSingleObject(LogHandle, INFINITE);
  finally
    CloseHandle(LogHandle);
  end;
  {$ENDIF}
end;

procedure G2WriteLogTimed(const Log: AnsiString; const Module: AnsiString = '');
var
  t, h, m, s: DWord;
  LogStr, ModStr, sh, sm, ss: AnsiString;
const
  TSec = 1000;
  TMin = TSec * 60;
  THrs = TMin * 60;
  ModuleStringSize = 12;
begin
  {$IFDEF G2_WRITE_LOG}
  {$Warnings off}
  t := GetTickCount - AppTime;
  h := t div THrs;
  m := (t - (h * THrs)) div TMin;
  s := (t - (h * THrs) - (m * TMin)) div TSec;
  if s < 10 then ss := '0' + IntToStr(s) else ss := IntToStr(s);
  if m < 10 then sm := '0' + IntToStr(m) else sm := IntToStr(m);
  if h < 10 then sh := '0' + IntToStr(h) else sh := IntToStr(h);
  LogStr := '[' + sh + ':' + sm + ':' + ss + '] ';
  if Length(Module) > 0 then
  begin
    SetLength(ModStr, ModuleStringSize);
    FillChar(ModStr[1], ModuleStringSize, Ord('='));
    Move(Module[1], ModStr[(ModuleStringSize - Length(Module)) div 2 + 1], Min(Length(Module), ModuleStringSize));
    LogStr := LogStr + '[' + ModStr + '] - ';
  end;
  LogStr := LogStr + Log;
  G2WriteLog(LogStr);
  {$Warnings on}
  {$ENDIF}
end;

procedure LogStart;
{$IFDEF G2_WRITE_LOG}
var
  SysInfo: TG2SysInfo;
  s: String;
{$ENDIF}
begin
  {$Warnings off}
  DeleteFile(AppPath + 'G2Log.txt');
  G2WriteLog('Gen2 v' + IntToStr((G2Version shr 8) and $ff) + '.' + IntToStr(G2Version and $ff) + ' Log');
  G2WriteLog('Application Compiler: ' + AppCompiler);
  G2WriteLog('Gen2 Config Options:');
  {$IFDEF G2_WRITE_LOG}
  G2WriteLog('  Write Log - ON');
  {$ELSE}
  G2WriteLog('  Write Log - OFF');
  {$ENDIF}
  {$IFDEF G2_REPORT_LEAKS}
  G2WriteLog('  Report Memory Leaks - ON');
  {$ELSE}
  G2WriteLog('  Report Memory Leaks - OFF');
  {$ENDIF}
  {$IFDEF G2_PERFHUD}
  G2WriteLog('  Enable PerfHUD - ON');
  {$ELSE}
  G2WriteLog('  Enable PerfHUD - OFF');
  {$ENDIF}
  {$IFDEF G2_USE_INLINE}
  G2WriteLog('  Use Inline - ON');
  {$ELSE}
  G2WriteLog('  Use Inline - OFF');
  {$ENDIF}
  {$IFDEF G2_WRITE_LOG}
  SysInfo := G2SysInfo;
  G2WriteLog('System Specs:');
  G2WriteLog('  CPU: ');
  G2WriteLog('    Name: ' + SysInfo.CPUs[0].Name);
  G2WriteLog('    Identifier: ' + SysInfo.CPUs[0].Identifier);
  G2WriteLog('    Vendor: ' + SysInfo.CPUs[0].Vendor);
  G2WriteLog('    Speed: ' + IntToStr(SysInfo.CPUs[0].MHz) + 'MHz');
  G2WriteLog('    Core Count: ' + IntToStr(SysInfo.CPUCount));
  if SysMMX or SysSSE or SysSSE2 then
  begin
    s := '    Extensions: ';
    if SysMMX then
    s := s + '[MMX]';
    if SysSSE then
    s := s + '[SSE]';
    if SysSSE2 then
    s := s + '[SSE2]';
    G2WriteLog(s);
  end;
  G2WriteLog('  Memory:');
  G2WriteLog('    Total: ' + IntToStr(SysInfo.Memory.dwTotalPhys div 1048576) + 'Mb');
  G2WriteLog('    Available: ' + IntToStr(SysInfo.Memory.dwAvailPhys div 1048576) + 'Mb');
  G2WriteLog('    ' + IntToStr(SysInfo.Memory.dwMemoryLoad) + '% in use');
  G2WriteLog('  Display Device: ' + SysInfo.DisplayDevice);
  G2WriteLogTimed('Application started.');
  {$ENDIF}
  {$Warnings on}
end;

procedure LogStop;
begin
  G2WriteLogTimed('Application closed.');
end;

procedure CPUExtensions;
var
  TmpEBX: DWord;
asm
  mov [TmpEBX], EBX
  mov [SysSSE2], 0
  mov [SysSSE], 0
  mov [SysMMX], 0
  mov eax, 1
  cpuid
  test edx, 04000000h
  jz @CheckSSE
  mov [SysSSE2], 1
@CheckSSE:
  test edx, 02000000h
  jz @CheckMMX
  mov [SysSSE], 1
@CheckMMX:
  test edx, 00800000h
  jz @Done
  mov [SysMMX], 1
@Done:
  mov EBX, [TmpEBX]
end;
//Unit Functions END

initialization
  {$Warnings off}
  CPUExtensions;
  AppTime := GetTickCount;
  AppPath := ExtractFilePath(ParamStr(0));
  AppCompiler := 'Unidentified.';
  {$IFDEF VER80} AppCompiler := 'Delphi 1'; {$ENDIF}
  {$IFDEF VER90} AppCompiler := 'Delphi 2'; {$ENDIF}
  {$IFDEF VER100} AppCompiler := 'Delphi 3'; {$ENDIF}
  {$IFDEF VER120} AppCompiler := 'Delphi 4'; {$ENDIF}
  {$IFDEF VER130} AppCompiler := 'Delphi 5'; {$ENDIF}
  {$IFDEF VER140} AppCompiler := 'Delphi 6'; {$ENDIF}
  {$IFDEF VER150} AppCompiler := 'Delphi 7'; {$ENDIF}
  {$IFDEF VER160} AppCompiler := 'Delphi 8'; {$ENDIF}
  {$IFDEF VER170} AppCompiler := 'Delphi 2005'; {$ENDIF}
  {$IFDEF VER180} AppCompiler := 'Delphi 2006'; {$ENDIF}
  {$IFDEF VER185} AppCompiler := 'Delphi 2007'; {$ENDIF}
  {$IFDEF VER200} AppCompiler := 'Delphi 2009'; {$ENDIF}
  {$IFDEF G2_REPORT_LEAKS}
  ReportMemoryLeaksOnShutdown := True;
  {$ENDIF}
  {$IFDEF G2_WRITE_LOG}
  LogStart;
  {$ENDIF}
  CoInitialize(nil);
  {$Warnings on}

finalization
  CoUnInitialize;
  {$IFDEF G2_WRITE_LOG}
  LogStop;
  {$ENDIF}

end.